//
//  ImitateBestNeighbor.java
//  BoundedDegreeNetwork
//
//  Created by Jason Alexander on Mon Sep 02 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//
import java.util.*;

public class ImitateBestNeighbor implements LearningRule {
    
    public int nextStrategy(Agent agent) {
		
        LinkedList top_scorers = new LinkedList();
		
        double score_to_beat = agent.getScore();

        Iterator i = agent.constructUpdateNeighborhood().iterator();
        
        while (i.hasNext()) {
            Agent n = (Agent)i.next();

            if (n.getScore() > score_to_beat) {
                score_to_beat = n.score;
                top_scorers.clear();
                top_scorers.add(n);
            }
            else if (n.getScore() == score_to_beat) 
                top_scorers.add(n);
        }

        if (score_to_beat > agent.getScore()) {
			int size = top_scorers.size();
			int randomInt = agent.parentModel.random.nextInt( size );
            return ((Agent)top_scorers.get(randomInt)).getStrategy();
		}
        else 
            return agent.getStrategy();
    }    
}
