//
//  ImitateBestNormalizedScore.java
//  BoundedDegreeNetwork
//
//  Created by Jason Alexander on Tue Sep 10 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//
import java.util.*;

public class ImitateBestNormalizedScore implements LearningRule {

    public int nextStrategy(Agent agent) {
        int N = agent.getPayoffMatrix().getNumberOfStrategies();
    
        Iterator itr = agent.constructUpdateNeighborhood().iterator();

        LinkedList top_strategies = new LinkedList();
        
        double max_average = Double.NEGATIVE_INFINITY;
        // Sum up the cumulative averages
        while (itr.hasNext()) {
            Agent n = (Agent)itr.next();
            double d = (n.getScore()/(n.getInteractionNeighborsAsCollection().size()));
            if (d > max_average) {
                top_strategies.clear();
                top_strategies.add(new Integer(n.getStrategy()));
                max_average = d;
            }
            else if (d == max_average) {
                top_strategies.add(new Integer(n.getStrategy()));
            }
        }

		int size = top_strategies.size();
		int randomInt = agent.parentModel.random.nextInt( size );
        return ((Integer)top_strategies.get(randomInt)).intValue();
    }    
}
