(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    103252,       1741]*)
(*NotebookOutlinePosition[    104140,       1773]*)
(*  CellTagsIndexPosition[    104069,       1767]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell[TextData[{
  StyleBox["Local Interaction Models with ",
    FontSize->40],
  StyleBox["Mathematica",
    FontSize->40,
    FontSlant->"Italic"],
  StyleBox[" and Java",
    FontSize->40]
}], "Title",
  FontFamily->"Times",
  CellTags->"b:4"],

Cell[GraphicsData["PostScript", "\<\
%!PS-Adobe-2.0 EPSF-1.2
%%BoundingBox: 26 7 504 84
%%HiResBoundingBox: 26 7 504 84
%%Creator: (Mathematica 5.0 for Macintosh)
%%CreationDate: (Friday, March 5, 2004) (12:27:53)
%%Title: Clipboard
%%DocumentNeededResources: (atend)
%%DocumentFonts: (atend)
%%DocumentNeededFonts: (atend)
%%EndComments
0 91 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MacintoshRomanEncoding [
\t/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef
\t/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef
\t/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef
\t/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef
\t/space/exclam/quotedbl/numbersign/dollar/percent/ampersand/quotesingle
\t/parenleft/parenright/asterisk/plus/comma/hyphen/period/slash
\t/zero/one/two/three/four/five/six/seven
\t/eight/nine/colon/semicolon/less/equal/greater/question
\t/at/A/B/C/D/E/F/G
\t/H/I/J/K/L/M/N/O
\t/P/Q/R/S/T/U/V/W
\t/X/Y/Z/bracketleft/backslash/bracketright/asciicircum/underscore
\t/grave/a/b/c/d/e/f/g
\t/h/i/j/k/l/m/n/o
\t/p/q/r/s/t/u/v/w
\t/x/y/z/braceleft/bar/braceright/asciitilde/.notdef
\t/Adieresis/Aring/Ccedilla/Eacute/Ntilde/Odieresis/Udieresis/aacute
\t/agrave/acircumflex/adieresis/atilde/aring/ccedilla/eacute/egrave
\t/ecircumflex/edieresis/iacute/igrave/icircumflex/idieresis/ntilde/oacute
\t/ograve/ocircumflex/odieresis/otilde/uacute/ugrave/ucircumflex/udieresis
\t/dagger/degree/cent/sterling/section/bullet/paragraph/germandbls
\t/registered/copyright/trademark/acute/dieresis/.notdef/AE/Oslash
\t/.notdef/plusminus/.notdef/.notdef/yen/.notdef/.notdef/.notdef
\t/.notdef/.notdef/.notdef/ordfeminine/ring/.notdef/ae/oslash
\t/questiondown/exclamdown/logicalnot/.notdef/florin/.notdef/.notdef/\
guillemotleft
\t/guillemotright/ellipsis/.notdef/Agrave/Atilde/Otilde/OE/oe
\t/endash/emdash/quotedblleft/quotedblright/quoteleft/quoteright/divide/.\
notdef
\t/ydieresis/Ydieresis/.notdef/currency/guilsinglleft/guilsinglright/.notdef/.\
notdef
\t/daggerdbl/dotaccent/quotesinglbase/quotedblbase/perthousand/Acircumflex/\
Ecircumflex/Aacute
\t/Edieresis/Egrave/Iacute/Icircumflex/Idieresis/Igrave/Oacute/Ocircumflex
\t/.notdef/Ograve/Uacute/Ucircumflex/Ugrave/dotlessi/circumflex/tilde
\t/macron/.notdef/.notdef/.notdef/ogonek/.notdef/.notdef/.notdef
] def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding MacintoshRomanEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

%%MathematicaCell
%Cell[BoxData[GridBox[{
%        {Cell[GraphicsData[\"PICT\", \\
%\"\\<\\
%9C00000004/0B`0A0_l<0?on0000B00004P000000000B`1;\\
%0000000N00402X01
%P05oogoo09X0003oPB`0000004/0B`0000@0000004P000180000400P00@02000
%02002oR807obX0000000B`1;0000001;04/0@008POo[okHc]S@08H7ol?l7o_on
%ool`<SC0<PTc<S@b=30c<C0f_cCm<P4a=00@]_l1o_jho`0]]c<1;bfh=00M]_l0
%o[Oo02fo<`Pb<S0b<c0c<bnm=0Da<S@a=3@08kKo0?jgo`8]<SC1<P0coS86<c8c
%<bl`=/4b1c@d<S8d<S@d026fo`3n]ol1;C;0<`Td<c8b<c8c<bl``3@7=S@b<S@b
%=3@08[Koo_k0o`7no_co0Rdd=L0c0C@doS83<c<_<[ldo381=3@0:;Ko0_kno<7o
%oOkmo`8]<cC1<`Xe=3Dd<S8c<bl]=/0d0C8doS81=3@0HKKo0?kfooknkOl0o^Wo
%0?cko`Cnooono_ko0Rdb<_Tc1C8d<c@b<_0coS@1<S3b<o`d0C0dnc<9=C8c<S@b
%<c<_<_Pd0SDb;Ohbl3@4=S8f=37b=?`f0CLfn3@4=C8b=3@0?[Ko0?kDo`3ll_l0
%o_go0?kno`Kno_oo;C8beS<0<?8c03Cm<`Te<S<b=3@c<blbeC@0<O8d03;i=0<b
%<S@d03Vfo`3nd?l0o_7o1?koookno_l2;C8bdS<0=?<c2c8`=C8c<S@b<c<_<]4d
%03;b=00aoS@4=C8b=3@0<;Ko0?k1o`3no?l6o_koobdb</lcoS;h<`/e<c<b<c8d
%=3<c;c;>=?hblS@3<S8d=01A]_l0o_Oo0OkngOl1o_cmo_;o0Okno_l2;C8bnC<2
%=2d`jS<1=33g<`4b=?dblS<6<S@b<c<_<_Pd0S/k=nXd0CHgmc@1=CKm=O8d13Db
%<S@d03Vfo`3nd_ono^go1_knool]<S;L<`0`mc?i<P0/nC<8<S<b=3@c<blbfc@0
%<OXdoRgi<_Dd0c8b=3@0MkKo0?keo`;nooono_;o0Ognm_l2o_cen?kfo`7no_ko
%0Rdb<_Lc1BdT92/];ODc0c@c<S7f<`@`;C0Z9?T[0B`/oC<;<3<c<S<b=38c<blb
%mS@0;ohZ0Bl_mC@4=S@b<Rgg=0@a;c4/<OTZnc@0<Odd13Db<S@d08Nfo`3nmol6
%o_ogm_[kn_;o2Oglo?Gjno_in?klo`7kn_Okm_l6o_koobdb<_Tc1SDcKZBBVI;h
%<`ld<c<d=3<a<2I:MhNI/GldoS<3;3>7X?NI03;h<`Hb=3@c<blbmS@4KJ2=Uhgh
%=0lf=3@f=S@b<BA<MhRG[Ghbo3@1R9ggUoHd0c8b=3@0]kKo0?keo`Wlo?ooo?on
%ooknnolAoOooo_clm_glnOcom_ooo_onoOl8o_oio_koo?cin_l4o_ooo_kno`8]
%<S;g<`bUooonlS<]<S@d<c8doS<B<S8d:bIHY>Cooocn_3<c<S<]<oko1Oknookl
%o_konS<9=C<c<S@b<c<_<_Hd1ZWjoo_]=2on<P8d=3Kn=18e=CHZ95BPhoooo_jm
%=3@e=2ldo_l5oO_joO_ko_[g=0@e<S8d=02[]_l0o_Go2Ocno_olookoo_kloa;n
%oogno_[nloolnOkon_ooo_onmOl0o?[o0?kno`Kno_oo;C8bnC<2<S>Uo_h8lS<]
%<S@d<c8doS<B<3P[99;_ookoookl/c<b<S<[<oko0Oknn_oj<`Te<c<b=3@c<blb
%n3@8<SBYoOookC@_oS8H=3@f=3@]<C@Z<Hg_o__jn_gn/c@`=C@Z=?ko0O_kn_of
%=0<b<S@d0;Rfo`3nmOl9o?cno_coo_ono_ko5?kmo_gnm?[mooomloWooo[oo_ko
%o_co1oWonOcoookcmol1o_kno`8]<S;i<b@b<jGoo_kb<bdb=3@c<S@e<C<h<c:[
%n_cnn_oon_jc<S<b<b/co_l5o_onooono_og<`Hb=38c<blbn3@8<3BYn_ookC@_
%oS8H=3@f=38]=2ddZ_KnooKnoook/c@]=C@Z=?ko2?_jnooonoooo_Ld13Db<S@d
%0:Rfo`3nmOl9o?cooocoo_ono_ko2?kmookenOgllogo0_Kmn_go0?keo`3mm_l6
%o_koobdb<_Tc5c8cYOooo_8c;C8d=3<b=3Db=3<ZW_[ooocn1oZh<c8d<b/co_l0
%o?[o0OXbnS<8<S<b=3@c<blbn3@8<SBYn_ookC@_oS8H=3@f=3Df;BbPm_[nno_o
%noCf]C@`=S@Z=?ko0?kjo`7f<_Ld0c8b=3@0YkKo0?kgo`_noocnooolookoo_kn
%o`onoooln?koo?cooocimoknoOl0o_co0?_`o`7no_ko0Rdb<_Tc93@cYOkoo_8c
%;C8d=3<b=3Db<RIUo?[ooocmcgePFThc<S@b:c?no`7nc?8c238c<S@b<c<_<_Pd
%238dZOgoondd;ohb63@d=S@b=2AWnoojn_kmd85MG58d<3Hd:SCno`7kbo0d13Db
%<S@d0:nfo`3nmOl9o?kooocoo_ono_kooOh@no?om_onn_klo?klo_koooklo`3k
%o?l0o_Go1_knool]<S;i<b@b<jGno_cb<bdb=3@c<S@e<c<]bOono_[[MbdV9R/`
%<S@d<R/co_l1n[_l<`4[<_Tc238c<S@d<c<_<_Pd238dZOgoo^dd;ohb63@d=S@]
%;Bo6o__donag;b@T:S4e<SHd:SCmo`2jo3@1:SGf=0<b<S@d0:Zfo`3nmOl0noko
%1Ocoo_ono_ko3okooOkloooio_OloOgnoOcmo`3noOl1o_Gco`Cnooono_ko0Rdb
%<_Tc:C8cXoono?8c;C8d=3<b=3Dd:e[bo_kojehV:cPd>3<c<S@b:c?oooknbO<c
%2CDb<c8d<S<c;c;h=0Pb=:?oook]=2on<QPd=3Hd=RALkOokn^aP92@d<S@a=30f
%=2Xdo_l1oL?`=0@e<S8d=02h]_l0o_Go2Ocnooolookoo_kno`_nn_kko?cooo_l
%o_Wlo`?nooono?l0mOco0?kjo`7no_ko1_knool]<S;i<`8b<jGnoRGb<bdb=3@c
%<S@e<B^IooojoXLV<cHb<38`<c<b<R/cooonn/8c<?Hc2S@e<S<b=3@c<blbn3@8
%<SBYoOookC@_oS8H=3@f=3HZUo[joon892df=c4g=c@]=c@Z=?go0/<d=ohd02gj
%=00boC@3<S8d=02f]_l0o_Go2Ocnooklookoo_kno`Wnoo[eo_onmo_nnol4o_on
%ooklo`;lookno`3lnOl4o_ooo_kno`8]<S;i<a/b<jGnookb<bdb=CDc<S@e<c72
%o_clkTl]<S<boS@@=C8b<b/cooono/<c=3<c<SCi<`Te<S<b=38c<blbn3@8<SBY
%oOookC@_o3@==S@d=/?mo__TC2ld=3;n=PDd<3Dd:SCmo`K3=38d=30fmS@4=C8b
%=3@0]kKo0?keo`Wlo_ooo?onookno_l8o_oeo?knooGioOl7oOooo_onooklo`Kl
%ookoo?olnOl0o_ko1_knool]<S;i<a8b<jGnookb<bdb=CDc<S@e<c_No_hIgSH`
%<S<b<C8c=C8b<b/cooono/<c=38d<SCi<`Te<S<b=3@c<blbn3@8<SBYoOookC@_
%o3@:=S@d?=cmoo_H=S7n=0Pb<S@d<3Dd:SCmo`K3=38b=S0fmC@3<S8d=02c]_l0
%o_Go2Ocnooklookoo_kno`Snookloo[lm?kho`;nooklo`Klookoo?olnOl4o_oo
%o_kno`8]<S;i<blb<jGnookb<bdb=CDc<S@e<dkboO[oe2d`<38c<S<d<c8b<b/c
%ooono/<c=38d<SCi<`Te<S<b=38c<blbn3@8<SBYoOookC@_o3@F=S@dD^gmoO[C
%;c4a=3@b=3Hd<3Dd:SCmo`K3=38d=S0fmS@4=C8b=3@0/;Ko0?keo`Wlo_ooo?on
%ookno_l7o_onm_olnOcgo`;nooklo`Klo?koo?olnOl0o_ko1_knool]<S;i<a/b
%<jGnookb<bdb=CDc<S@e<dknn_oodc0`<S8coS@@<c8b<b/cooono/<V=38d<SCi
%<`Te<S<b=3@c<blbn3@8<SBYoOookC@_o3@4=S@dD_Cno`;B<C7n=?hf1C@`=C@Z
%=?go1/<T<S8f<3Ke=0<b<S@d0;Nfo`3nmOl9o?koo_coo_ono_ko3?koo?cno_Wm
%oOcoooglo`;nooklo`Klo?koo?olnOl4o_ooo_kno`8]<S;i<blb<jGnookb<bdb
%=CDc<S@d<dSbo_ooi44`=3@a<c@c<c8b<b/cooono/<V=38d<SCi<`Te<S<b=38c
%<blbn3@8<SBYoOookC@_o3@F=S8dA>gooo[S@c4f=S8d=S@d<3Dd:SCmo`K3938d
%=S0fmS@4=C8b=3@0];Ko0?keo`Wlo_ooo?onookno_l:o_omn_klo?kgmOkjo`;n
%ooklo`Klo?koo?olnOl0o_ko1_knool]<S;i<blb<jGnookb<bdb=CDc<S@e<cSA
%oocoo6hZ<S@b<c<b=38b<b/cooono/<V=38d<SCi<`Te<S<b=3@c<blbn3@8<SBY
%oOookC@_o3@0=_hd4/kno_[kKB`e=S8d=38f<3Dd:SCmo`K3938b=S0fmC@3<S8d
%=02d]_l0o_Go2Ocnooklookoo_knookn1o[oo?olmOcln_l2o_ono?l6o?cnooco
%o?Wo1?koookno_l2;C8bnC<_<S>Uo_onlS<]<SDe<c8d=C@[Zokoo_n/<30c=3@c
%=3<b<S<[<oooo_k39S@b=38dnC<9=C8c<S@b<c<_<_Pd238dZOgoondd;o`d5SHd
%<RZZnookoj`a<C@f=S@f=30e=2XdoOl6`b@b=3H`=_Hd13Db<S@d0;Nfo`3nmOl9
%o?kooocoo_ono_ko3OkooOSnnOoio_gooOomoOl2o_ono?l6o?cnoocoo?Wo0?kn
%o`Kno_oo;C8bnC<N<S>Uo_onlS<]<SDe<c8d=C<[Oocoo_o[>c<a=34b<ohb3C<[
%<oooo_k39S@b=38dnC<9=C8c<S@d<c<_<_Pd238dZOgoondd;o`d5SHd=2Annook
%on`k=38f<S8d<S0e=2XdoOl6`b@b<SH`=_Dd0c8b=3@0[kKo0?keo`Wlo?ono?on
%ooknoOl9o_gno?koooWjo_[o0_goo_co0_Gmo_Ko1Oknooono_ko0Rdb<_Tc:S8c
%YOooo_8c;C8d=3<b=3@e:dkQoo[ooi8]<38b<c<`<S8c:c?oookn`R_e<`Xd=C8c
%<S@b<c<_<_Pd238dZO[oondd;ohb1c@d=SHd95;NoOl<SBla<S0d=3L`=C@Z=?ko
%0o_392gf=00boS@4=C8b=3@0`kKo0?keo`Wlo?ooo?onookno_l;o_oomOWlooko
%oOgnnol2oOono?l0o?co0Okno_l0o_ko0?kno`Kno_oo;C8bnC=1<S>UooonlS<]
%<S@d<c8d=C8c:[7oo_koj4@[<S8c<c0b<S<[<oooo_[392`c<b`c;C8c<cDc<c8e
%<S<b=3@c<blbn3@8<SBYn_ookC@_oS8H=3@f=38d;:goo_ooiT/Z=c8d=34`=C@Z
%=?go0L<ZoC@1;Bok=00`oC@3<S8d=032]_l0o_Go2Oclooklookoo_kno`3no_l8
%moconOkcn_cjo_l4oOomookmo`7lo?Go1_goo_ooo_kno`8]<S;i<bTb<jGoookb
%<bdb=3@c<S@e<S<TG_CjooWoX2Ha<S<c>38b<b/cooonol?m<`4b<_dc3C8c>30e
%<S<b=38c<blbn3@8<SBYn_ookC@_oS8@=3@f=30d:V3`ooohoYdT=SOn=0T`=C@Z
%=?ooo_[3oC@1<S;m=0<`=3@aoS@4=C8b=3@0_kKo0?keo`Wlo?ooo?onookno_l0
%o_ko2?Gio?cnookloOco0_goo_go2?cno?_emOcjno[o0?kno`Kno_oo;C8bnC<K
%<S>UooonlS<]<S@d<c8d=C8c<2Zaooonn^mH:odc438b<b/cooonooG6c<g=cm6I
%nc<:<SDb<c8d=3<c;c;h=0Pb=:Wjooo]=2on<Pld=3Hd<3@g;:gooogoke@ToC@4
%<3Dd:SCmo`Oial_:b]3>Uo/d03;m=0<b<S@d0<>fo`3nmOl9o?coo_coo_ono_ko
%0?kno`7mo_kl1_kon_goookmo`3no?l7o?gio?koo?Gjo`Cnooono_ko0Rdb<_Tc
%<38cYOooo_8c;C8d=3<b=3Dd<c@[C_;lookj^2/c<S<c<S<c:c?oookloo[oookl
%olWk<`Xb=C8c<S@b<c<_<_Pd238dZO[oondd;ohb63@d=S@f=3HTD^gnn_go]B@d
%=bdd<3@d:SCno`Snn_Kjooonol?k=00goS@4=C8b=3@0_[Ko0?keo`Wlo?ooo?on
%ookno_l?o_koo?oon_Wno?ojn_coo?go0?kmookl1Oooo_oim_[o0?kno`Kno_oo
%;C8bnC<W<S>UooonlS<]<S@d<c8d=CDc<c8TS_olookjMbHb<38b<c<[<oooo_go
%1?cno_nlnc<:<3Db<c8d=3<c;c;h=0Pb=:Wjooo]=2on<P8d=3Kn=18a=2Z@n__j
%ooeg93@a<S0d=2Xdnol5o_kmoonmnc@0=odd0c8b=3@0`KKo0?keo`Wlo?ono?on
%ookno_l8o_koo_goo__oo_`3oO_noOgo0?kmo`SnooWooocooo_jo`Cnooono_ko
%0Rdb<_Tc5c8cYOooo_8c;C8d=3<b=3Dd<c<a<SC9o_ko2Ma2:cPb<S<c:c?mo`3l
%oOl2o_jknc<:<SDb<c8d<S<c;c;h=0Pb=:Wjooo]=2on<QPd=3Hd<S@]<S0ba_kj
%oooC?BXd<30d=2XdoOl0o_ko0o[knk[k=00eoS@4=C8b=3@0`kKo0?keo`Wlo?oo
%o?onookno_l8o_koookoooSco_l4o_[mo?cno`3noOl8o_oio_kin_cfn_l0o_ko
%1_knool]<S;i<b@b<jGoookb<bdb=3@c<S@e=C0c=C<cIOono?[nX2/d=38c<b/c
%o_l8o_conOWon_nlnc<:<SDb<c8d=3<c;c;h=0Pb=:Wjooo]=2on<PDd=3Hd=37m
%=01Wo_h:oofM93Hf<3@d:SCno`Smo_ohn?omokgk=00boC@3<S8d=02^]_l0o_Go
%0?_no`Glookoo_kno`3nn_l<nOooo?Wno_goo_ooo_go0_kmo_Go1Ocnooono_ko
%0Rdb<_Tc438cXokoo?8c;C8e=C<b=3Dbo3<>;;7on_oomDh[<S@c<b/co_l2o]I>
%nC<>=30c<c@e<S<b=38c<blbmS@6Xo_oo^dd;o`d0SHd<?/d0:gmo`SiDR@g<S@d
%:SCno`;nee;i=0@f<C@d=_hd13Db<S@d0:^fo`3nmOl9nocoo_coo_ono_ko0?kk
%o`gno?koo?konOgoo_ooo_go0_cko?[o0?kho`Kno_oo;C8bnC<@<S>SooonlS<]
%<SDe<c8d=C;l<`hTF>_nooco/B/b=3<c:c?mo`6k9_Xc13Dd<S<doC<6<S@d<c<_
%<_Hd1Z?joog]=2ol=00fnS@><EC/oookojdT=c8d=2Xdo_l2n[XTnC@3=S@d=_`d
%0c8b=3@0Y[Ko0?kgo`;no?_no`Glookoo_kno`3nnol:o_ofooconOWko_kjo`Kf
%mOonooknmOl1o_kno`8]<S;i<a0b9Z?noocb<bdb=CDc<S@e=?`c2RdTY?coo_oi
%CbddoC?no`Gn`S<]<3Cd<`Hb=38c<blbn3@8=BBSnoonkC@_o3@2=S@fo3@:;bZP
%o_[kooU<;c;m=0Woookd`c@_<C8]mC@4=C8b=3@0XkKo0?kfo`[lnocoo_coo_on
%o_ko0OknnOl6oOono?kko?So1?coooklnOl0oOco1_knool]<S;i<a0b9Z?oookb
%<bdb=CDc<S@e=OTc0NSno_l2VBHboC?no`Gn`c<b=3Ck<`dd<c4c<c8c<S@d<c<_
%<_Ld1bBSn_omkC@_o3@0=_Ld1nKko_ooUb@`oCCmo`C3=3Lk=_/d0SHd<_`d0c8b
%=3@0Y;Ko0?kgo`;no?_no`Glookoo_kno`3nn?l6nOkiookmoOWo1?klooonn_l1
%o_clo`7no_ko0Rdb<_Tc3c8VXokoo?8c;C8e=C<b=3Gh<`^XooonnN@k<3<b<c?n
%o`Cn`c<c=?Xc03Gm<`Pb<c8d<S<c;c;h=0Pe9:?kook]=2ol=00fmc@7Y_oonoSS
%>c7m=?ko1?g3=3@bnC@0<O`d13Db<S@d09Bfo`3nm_l:o?_looklookoo_kdo`Ol
%oocoooggo_Wo0?c_o`Kno_oo;C8bnC<><RJSooonlS<]<SDe<c8dmc<;F?[oo_oj
%H2db<S<co_l1o/?h<`hd<c<d=3<b<c8d=3<c;c;g=0LTXo[ooNdd;o`d03Kg=0QD
%oooko_IM;cOn=?ko0O_3n3@4=S@d=SKm=0<b<S@d09Nfo`3nmol2o_cko_l5o?on
%ooknm?l7o__ooocnnoklo`?lookllol4o_ooo_kno`8]<S;i<`hb9Z?noocb<bdb
%=CDc<SCg<`/]c?knooV7:c8b<c?mo`33mS<<=3@c=C<c<S@b<c<_<_Pd23DTXo_o
%o^dd;o`d03Kg=0P_bookooR8:SGn=?go0<?f=04f=_dd13Db<S@d0:2fo`3nm_l:
%o?_looklookoo_kio`3noOl7o__nooonn_Glo`?looolm?l0o_go1_knool]<S;i
%<`hb9Z?oookb<bdb=CDc<SCl<`4d=?hc2bBIo_ojo98Z<S8c<oko0Ok3mc<3<S<c
%=Ohc1S8d=3<c;c;g=0LTXo[ooNdd;o`d03Kl=04b=_hd236GoOoonhd/=ohdo_l1
%nl?_=0<b<S@d0:>fo`3nmol2o_cko_l2o?onmOl=o_gno_oknOcoo?cnookno`?n
%oooll?l1o_kno`8]<S;i<`Pd9Z?oookb<bgn<P<c<c@boC<@<S<h=3</JOooo?nU
%:c8b<c?mo`?3<c8bmC<8<S<b=38c<blbn3@2<RBSo_l2kC@_oS83=3@f=Odd430]
%=38]=77on_koZBXg=C@doOl3`c@b<_<d13Db<S@d09Zfo`3nmol2o_clo_l2o?on
%l_l8o_oknOWlo_Kno?l7o_ooo?klookgo`3no_l6o_koobdb<_Tc23@VYOkoo_8c
%:o`b0C<bnC<<=BAYoooloj@[<S8c<oko1Ok3:c0b=OLc2CDb<c8d=3<c;c;h=0Pb
%9:Wkooo]=2[l<P4d<_Pd22Yan_[loZ0Z=ohdo_l4nl<Z<C;b=0<b<S@d0::fo`3n
%mol2o_cko_l2o?onlOl:oOOoo?ocnokoooklo`Klo_ooo?onnOl4o_ooo_kno`8]
%<S;i<`Pd9Z?oookb<bgn<P8c<cCg<`/[K_koo_nI:c8b:c?no`On`b/c<S@c<_Tc
%2CDb<c8d<S<c;c;h=08b9:?no`;]=2on<P8d=3Kg=0/TKO_onojG:SLd:SCmo`K3
%:S@b=S@emS@4=C8b=3@0UkKo0?kgo`;no?cno`3lkol:o?_mo?oinOgoooklo`7l
%o_Co0?kno`Kno_oo;C8bnC<8=2JUo_onlS<coS83<c8c<_Pc2bJ7n_cnogd[<S<[
%<oko1?k3:c8bmS<9=C8c<S@d<c<_<_Pd238TZO_oondd=?hb0c@b=3;h=0/TR?Kl
%non193Ld:SCno`Ck`bXb<_8d0c8b=3@0W[Ko0?kgo`;no?_no`3lo?l0o_Oo1?kn
%ooGio_l0moko0?klo`7lo_Co1?koookno_l2;C8bnC<8=2JSooonlS<coS80=OXc
%03;m<`HTbOolo?mPoS<1:c?no`Cn`b/b<_Hc2CDb<c8d<S<c;c;h=08b9:?no`;]
%=3Cn<_Td2c8d=2d]:/?oo_koGOhd0BXdoOl3`bXb<?<d13Db<S@d0:>fo`3nmol2
%o_clo_l0o?co0?kko`3no_l8o_ogo?Wooogmo_l0o_co0Ocnm?l0o_ko1_knool]
%<S;i<`Pd9ZGnookb<c?n<P0eo3<=<S<b<c<d96klookng47n<`4[<ogo0/<[<_Dc
%2CDb<c8d=3<c;c;h=0Pb9:Wkooo]=3Cn<_/d0C8]oS@8<RY]o_okom=3oS@1:SCm
%o`;3:S;a=0<b<S@d09jfo`3nmOl0noko0?cno`3no_`1oogko`Snm_Slo?oloo[m
%o`3no?l1o?cdo`Cnooono_ko0Rdb<_Lc1j?oookb<c<`oC<1<S7k<`hT8fGQoo[o
%oZ0c<c@b:c?mo`;39S;e<`Te<S<b=38c<blbmS@0Xoko1>dd=34]oS41<S;k=0ha
%<6ONooojoYdd=3Hb:SCmo`;393;b=0@e<S8d=02Z]_l0o_Oo0_koo?ko0ocoo_om
%o_ko0?kno`Snmo[mo_kiooklo`Snooonooolo_keo`3no_l6o_koobdb<_Tc2S@c
%YOkoo_8c;C<doSD?=3@b=C<c<3APZo[oo?onlO`c22/cookool<[=ODc2CDb<c8d
%=3<c;c;h=0Xb=:Wkooo]=2ld<_hd0SHf=ohd2C4kGJ[foO_jno7l=0LZ=?omooo3
%:_0d0c8b=3@0`;Ko0?kgoaCnooKnooonoO_ko?_ko?[mookomOCno0Gio_oloO_l
%o`gnooolooolm?Glo?_ko?[o1?koookno_l2;C8bnC<E=3>To_oonMK9c<o9c==g
%:c8c<l;Ddogo0o[onXOm<`8b:c?mo`Obe<g?clc<do/c2S0e<S<b=38c<blbn3@2
%<SBPo_l?n=O6bm36bm9g930]=<?Cd_kj1?oon_J8o3@1:SCmo`O]dl[@d<_;d_/d
%03On=0@e<S8d=02Q]_l0o_Go0O_nmol0nokn2oonoooiooono_oko_co0?klo`7l
%o?Go0Ogno_l6o_koobdb<_Tc0c0cXoWhoa3lQb/d;C?_o_koo_koo_jS=O`c0b/c
%ookno`3lo?l0o_/c2S/d<S<b=3@c<blbn3@3=cBSn?So3oj8:S/_=>oknooonooo
%nj?k=0<Z=?oko_l0o?co0?_k=04k<_hd0c8b=3@0W;Ko0?keo`?kooolnol@o_Wk
%o_kooocioo[looofnokko`3nm_l4o?[ooocno`Gno_ooo_kno`8]<S;g<`2Sm_l1
%Qb_n<`WbookjoocjoYTdo3<2<R/cm_lAnS<c<3<c<S<e<S<b=38c<blbmS@3Xooo
%n_Wo3XPZ;C@dkO[koO[nooBG>o/d0BXdm_l3oC@d<Ohd02gn=0@e<S8d=02A]_l0
%o_Go0?Klo`7lo_go3_Kmo_oonOolo?oln__eo_go0?k`o`3noOl0o_ko1_knool]
%<S;g<`2ToOl0o__o3XX[=3<cnOkloocodFTZ;Odc03Cn<oGo0S<c=Odc2C@b<c8d
%=3<c;c;f=02Pm_l>QR@b=3Cinokoo_[>LB`_oC@0<_hdmOoj=00boS@3<S8d=02[
%]_l0o_Go3?[foOgfoOgeoOGmoOSmo`;eo?gnn`;noogio`7nn_gm0?ckoOOo0Okn
%o_l2;C8bmc<=T^?Mfn?FgMkLg]gFNbcn<`W9hMc<XfT]93PdnS<?==7Lfm_MhMgK
%gMgKg3<c<_`c238c<S@b<c<_<_Hd38gPh=[Pen3HdmSPegcm=0W3g]?;Xg4k:S@f
%nS@?</kCf][Pg^3Jh>3Jdc@d<?Xd13Db<S@d03Nfo`3ng?l0o^7o1_knool]<S;[
%<`0dmS<1<2gT<`Pb<c8d=3<c;c;Z=00fmS@1<BoQ=0<b<S@d05:fo`3nj?l3oOoo
%o?Wo0Oknl?l1o_kfo`7no_ko0Rdb<^Xc03_l<`0/jC<1;B_h<`Pb<c8d<S<c;c;Y
%=0<k=3@anC@1;Bg`=04_:_Hd13Db<S@d042fo`3nmol0o_3o0?kmo`3ngOl6o_ko
%obdb<^Hc03;m<`0bgS<5=3@c<blbn3@0;O0d0BdboS@1;CON=0<b<S@d01jfo`3n
%^ol0o_ko0Rdb<[dc1C@b<c<_<[`d0c8b=3@08KKo0?jko`Kno_oo;C8b`3<8<S<b
%=3@c<blb_3@3<S8d=00S]_l0o[co0Okno_l2;C8b`3<8<S<b=38c<blb_C@4=C8b
%=3@09[Ko0?joo`3no_l6o_koobdb</4c2CDb<c8d=3<c;c:l=0<b<S@d02Nfo`3n
%_ol4o_ooo_kno`8]<S;1<`Te<S<b=38c<blb_C@4=C8b=3@09[Ko0?joo`3no_l6
%o_koobdb</4c2CDb<c8d=3<c;c:l=0<b<S@d02Nfo`3n_ol4o_ooo_kno`8]<S;1
%<`Te<S<b=38c<blb_C@4=C8b=3@09[Ko0?joo`3no_l6o_koobdb</4c2CDb<c8d
%=3<c;c:l=0<b<S@d02Jfo`3n_ol1o_ono_ko0Rdb</4c2CDb=C8d<S<c;c:m=0@e
%<S8d=00@]_l0o[Oo0Bdb^3<1;c:h=00U]_l2o_ko`?h9ookoo_koobdd<l0e23<e
%<cDd<c<_<[/d0S8d=000o`\\>\"], \"Graphics\",
%            ImageSize->{75, 75},
%            ImageMargins->{{0, 0}, {0, 0}},
%            ImageRegion->{{0, 1}, {0, 1}}], 
%          RowBox[{
%            StyleBox[
%              RowBox[{
%                RowBox[{\"J\", \".\", \" \", \"McKenzie\"}], \" \", \\
%\"Alexander\"}],
%              \"Text\",
%              FontFamily->\"Helvetica\",
%              FontSize->18,
%              FontWeight->\"Plain\"], 
%            StyleBox[\"\\[IndentingNewLine]\",
%              \"Text\",
%              FontFamily->\"Helvetica\",
%              FontSize->18,
%              FontWeight->\"Plain\"], 
%            StyleBox[
%              RowBox[{
%                RowBox[{\"Department\", \" \", \"of\", \" \", \\
%\"Philosophy\"}], \",\", \" \", 
%                RowBox[{\"Logic\", \" \", \"and\", \" \", \"Scientific\", \" \
\", \\
%\"Method\"}]}],
%              \"Text\",
%              FontFamily->\"Helvetica\",
%              FontSize->16,
%              FontWeight->\"Plain\"], 
%            StyleBox[\"\\[IndentingNewLine]\",
%              \"Text\",
%              FontFamily->\"Helvetica\",
%              FontSize->16,
%              FontWeight->\"Plain\"], 
%            StyleBox[
%              RowBox[{
%                RowBox[{\"jalex\", \"@\", \"lse\"}], \".\", \"ac\", \".\", \
\\
%\"uk\"}],
%              \"Text\",
%              FontFamily->\"Helvetica\",
%              FontSize->16,
%              FontWeight->\"Plain\"]}]}
%        }]], \"Input\",
%  CellMargins->{{26, Inherited}, {Inherited, Inherited}},
%  TextAlignment->Left,
%  ImageSize->{488, 77},
%  ImageMargins->{{0, 0}, {0, 0}},
%  ImageRegion->{{0, 1}, {0, 1}},
%  GridBoxOptions->{RowAlignments->Center}]
%%EndMathematicaCell
gsave
newpath
 28.000 83.000 moveto
 103.000 83.000 lineto
 103.000 8.000 lineto
 28.000 8.000 lineto
 28.000 83.000 lineto
closepath
clip newpath
0.000 0.000 0.000 setrgbcolor
gsave
28 83 translate
75 -75 scale
1 string
75 75 8 [75 0 0 75 0 0] {
 currentfile
  1 index
   readhexstring
    pop
    } false 3 colorimage
FE2D2FFE3432FF3334FE3534FE3534FE3534FE3534FE3534FE3534FE3534
FE3534FE3534FE3534FE3534FE3534FE3534FE3534FE3534FE3534FE3534
FE3534FE3534FE3534FE3534FE3534FE3534FE3534FE3534FE3534FE3534
FE3534FE3534FE3534FE3534FE3534FE3534FE3534FE3534FE3534FE3534
FE3534FE3534FE3534FE3534FE3534FE3534FE3534FE3534FE3534FE3534
FE3534FE3534FE3534FE3534FE3534FE3534FE3534FE3534FE3534FE3534
FE3534FE3534FE3534FE3534FE3534FE3534FE3534FE3534FF3334FE3534
FF3334FE3534FE3432FF3334FF3334
FE2D2FFF3232FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3534FF3234FE3534
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3534FF3234FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3534FF3234FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3534FF3234FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3534FF3234FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3534FF3234FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3234FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3234FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FE332DFF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE332D
FF3232FF3334FF3334FF3334FE332DFF3237FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FD3B3BFF3334FF3334FC3331
FF3334FF3334FF2C34FF3334FF3334FF3334FF3334FF3334FE332DFE332D
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE2D2FFE2B2AFF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3234FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3436FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3031FE2D2FFF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3234FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FA928DF6E3E0FDDDE0FDDBDAF6E3E0FDD6D7FDDDE0
F5DED8FDDCD3F5DED8FDDDE0FDD6D7F87B7CFF2C34FF3334FF3334FF3334
F5C9C3FCE1DEFDDCD3FBCCCBFBA3A3FB6971FE2D3BFF242AFD3834FF3436
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3432FAD1CEFDDCD3
FDDBDAFDDBDAFDDDE0FCE1DEFDDDE0FDDBDAFDDDE0FDDDE0FDDBDAFDDCD3
FF3334FF3334FF3230FF3334FF3334FF3334FF3334FF3334FF3234FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334F6A4A0FFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFCFFFF
FEFFFFFFFFFFFFFFFFFFFFFFFFFFFFF68A86FD2B24FE3432FF3334FF3334
F9F9F9FFFEFBFCFCFEFCFFFFFFFCFEFCFFFAFAD1CEFB6971F52A2CFE2D2F
FF3334FF3334FF3334FF3334FE3432FF3334FF3334FF3334FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FF3334FF3334FE3534FF3334FF3334FF3334FF3334FE3432FF3234FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FBA3A3FFFFFFFFFFFFFCFFFAFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFEFFFFF9FFFFFB8788FE2B2AFE332DFF3334FF3334
FCF2EDF9FFFAFFFEFBFAFAFDFCFFFAFFFCFEFFFAFFF6FEF4FB9997FE343B
FF3334FF3334FF3334FF3334FF3334FF3234FE2B2AFF3334FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFFFAFAFD
FF3334FF3334FC3031FF3334FF3334FF3234FE332DFE3534FF3234FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3037FF3334FBA3A3FEF9F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFCFEFB8788FE2B2AFE343BFE2D2FFF3334
FEEFEFFFFEFBFFFEFBF9FFFFFFFEFFFFFEFBFEFFFFFEFEFFFFFEFBFBA3A3
FE3534FF3334FF3334FF3334FF3334FF3334FE2B2AFF3334FFFFFFFFFEFB
FFFFFFFFFFFFFCFFFFFCFCFCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFB
FF3334FF3334FF3334FF3334FF3334FF3334FD3B3BFE3432FF3234FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FE3432FF3334F6A4A0FEFEFFFFFFFFFFFFFFFEF9F8FDD6D7FBC9C6
FBCCCBFCCFD0FBC9C6FBCCCBFCD3D2FA7777FD2B24FF3230FE332DFF3334
F5C2C3F4D4D3FCD3D2FCFFFAFCFFFAF9FFFAFEFFFFFFFAFFFCFFFAFDFAF6
FB8788FF3334FF3334FF3334FF3334FF3234FE2B2AFF3334FFFFFFFCFFFF
FFFFFFFFFFFFFCF2EDF4D4D3F5CDCAFCCFD0FCCFD0FBCCCBFBCCCBFCD3D2
FF3334FF3334FF3334FF3334FF3334FF3334FF3037FE3534FF3234FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FE3432FF3334FCA5A9FFFEFBFFFFFFFFFEFFFCF2EDFF3334FE2D2F
FF3334FE3432FE3534FE3534FE3534FF3436FF3436FF3237FE3534FF3334
FF3334FF3031FE343BF7605DFAABAAFDFAF6FEFFFDFEFCFBF9FFFAFFFEFB
FEF1F1FF3334FF3334FF3334FF3334FF3334FE2B2AFF3334FFFFFFFEFEFD
FFFFFFFFFFFFFCC3C3FE2B2AFE3534FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3534FF3234FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FBA3A3FFFFFFFFFFFFFFFEFFFCF2EDFF3334FF3334
FF3031FE332DFC3331FC3331FC3331FF3232FD3132FF3334FF3334FF3334
FF3334FF3334FF3334FE2431F62330F86567FCE1DEFCFFFFFFFAFFFCFFFA
FFFEFEFAA09DFF3334FF3334FF3436FF3232FE2B2AFF3334FFFFFFFFFFFF
FFFFFFFFFFFFFCC3C3FC2624FF3232FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3534FF3234FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FE3432FC2624FCA5A9FFFEFBFFFFFFFFFEFFFCF2EDFF3334FF3334
FF3232FF3232FF3232FE3534FF3334FF3334FF3334FF3334FF3334FF3232
FE332DFF3234FF3334FF3334FE3432FF242AF76E6DFCFCFEF9FFFFFFFEFB
FFFEFFFDDCD3FD4143FF3334FF3334FF3334FE2B2AFF3334FFFFFFFFFFFF
FFFFFFFFFFFFFCC3C3FE2B2AFF3232FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3534FF3234FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FE3432FC2624FBA3A3FFFFFFFFFFFFFFFEFFFCF2EDFF3334FF3334
FF3232FF3232FF3232FE3534FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3232FF3334FF3334FE332DFE332DFF242AF5C9C3F9FFFFFFFCFE
FFFCFEFFFFFFF7605DFF3334FF3334FF3334FE2B2AFF3334FFFFFFFFFFFF
FFFFFFFFFEFFFCC3C3FE2B2AFF3232FF3230FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3534FF3234FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FE3432FC2624FCA5A9FFFEFBFFFFFFFFFEFFFCF2EDFF3334FF3334
FF3232FF3232FF3232FF3334FF3232FF3334FF3232FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FC2624FB8788FDFAF6FCFCFC
FFFEFBF9FFFFF97D81FD2B24FF3237FF3334FE2B2AFF3334FFFFFFFFFFFF
FFFFFFFFFEFBFCC3C3FE2B2AFF3232FF3232FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3534FF3234FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FE3432FC2624FBA3A3FFFFFFFFFFFFFFFEFFFCF2EDFF3334FE2D2F
FF3232FF3232FF3232FF3334FF3334FF3436FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FD2B24F76E6DFFFEFBFCFFFF
FFFEFBF3FFFEFB9997FE2B2AFF3237FF3234FE2B2AFF3334FFFFFFFFFFFF
FFFFFFFFFEFFFCC3C3FE2B2AFF3334FF3232FC3436FF3334FE3235FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3534FF3234FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FE3432FC2624FCA5A9FFFEFBFFFFFFFFFEFFFCF2EDFF3334FE2B2A
FF3232FF3232FF3232FF3232FF3232FF3334FF3232FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FE3534FF242AFB6971F9FFFAF9FFFA
FCFCFCFEFFFEF6A4A0FE2B2AFF3237FF3234FF3334FF3334FFFFFFFEFFFF
FFFFFFFFFEFBFCC3C3FE2B2AFC3031FF3232FE3534FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3534FF3234FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FE3432FC2624FBA3A3FFFFFFFFFFFFFFFEFFFCF2EDFF3334FE2D2F
FF3232FF3232FF3232FF3334FF3334FF3436FF3235FF3334FF3334FF3334
FF3334FF3230FE332DFD3834FE3432FE332DFF2C34FB6971F9FFFFFCFFFA
FFFCFEFCFFFFFCA5A9FE2B2AFF3237FE3235FF3334FF3334FFFFFFFEFFFF
FFFFFFFFFFFFFCC3C3FF3334FF3232FF3232FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3234FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3234FC2624FBA3A3FCFFFAFFFFFFFEFEFDFCF2EDFF3334FE2D2F
FF3234FE3534FE3534FF3334FF3234FF3436FF3334FF3334FF3334FF3334
FF3334FE3432FF3436FF3334FF3334FF3334FE2431FB9997FEFEFDFFFFFF
FFFAFFFEFCFBFA928DF52A2CFF3237FF3234FF3334FF3334FFFFFFFCFFFF
FFFFFFFFFEFBFCC3C3FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3234FF3334FF3334FE3534FF3334FF3334FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FE3235FC2624FBA3A3FFFEFBFFFFFFFFFCFEFCF2EDFF3334FE2D2F
FF3234FE3534FE3534FF3334FF3234FF3436FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FE2D2FFBCCCBFFFEFFFFFEFB
FCFFFFFEF9F8FB8788FE2B2AFF3235FF3234FF3334FF3334FFFFFFFCFFFF
FFFFFFFEFFFFFCC3C3FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3436FF3436FF3334FE3534FF3334FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3234FC2624FBA3A3FCFFFAFFFFFFFEFEFDFCF2EDFF3334FE2D2F
FF3234FE3534FE3534FF3334FF3234FF3436FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FC5854FFFAFFFCFFFFFFFEFB
FFFFFEFDFAF6F7605DFE2D2FFF3237FF3234FF3334FF3334FFFFFFFFFFFF
FFFFFFFFFEFBFCC3C3FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3436FF3334FF3334FF3436FF3436FF3334FF3234FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FE3235FC2624FBA3A3FFFEFBFFFFFFFFFCFEFCF2EDFF3334FE2D2F
FF3234FE3534FE3534FF3334FF3234FF3436FE3534FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334F9A8A6FEFFFFF9FFFFFFFEFB
FEF9F8FDE4E3FD3B3BFF3031FF3334FF3234FF3334FF3334FFFFFFFFFFFF
FFFFFFFEFEFDFCC3C3FF3334FF3334FE3432FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FE3534FC3331FF3334FF3334FF3334FF3234FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3234FC2624FBA3A3FCFFFAFFFFFFFEFEFDFCF2EDFF3334FE2D2F
FF3234FE3534FE3534FF3334FF3234FF3436FE3534FE3534FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FDE8E6FFFEFBFEFFFEFCFFFF
FEFFFFFB9997FC2624FF3230FF3334FF3334FF3334FF3334FFFFFFFFFFFF
FFFFFFFFFEFFFCC3C3FF3334FF3237FE343BFC3436FF3334FF3334FF3334
FF3334FF3334FF3334FF3436FF3334FD3132FF3334FF3334FF3234FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FE3235FC2624FBA3A3FFFEFBFFFFFFFFFCFEFCF2EDFF3334FE2D2F
FF3234FE3534FE3534FF3334FF3234FF3436FE3534FF3436FF3334FF3334
FF3334FF3334FF3334FE2D2FFF242AF6A4A0FFFCFEFCFFFAFFFEFBF9FFFF
F9F9F9FB4F4CFE2D2FFE3432FF3334FF3334FF3334FF3334FFFFFFFFFFFF
FFFFFEF6FEF4F5C2C3FF3334FE2D2FFF3031FE3432FE332DFF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3234FF3334FBA3A3FCFFFAFFFFFFFEFEFDFCF2EDFF3334FE2D2F
FF3234FE3534FE3534FF3334FF3234FF3436FE3534FF3234FF3334FF3334
FF3334FF3334FF3334FE2431FC5854FEEBECFFFEFFFCFFFFFEFCFBFFFFFF
F9B1ADFD2B24FF3237FE3432FF3334FF3334FE2B2AFF3334FFFFFFFFFFFF
FFFFFFFCFFFAFBBBBAFC2624FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FE3534FF3436FF3234FF3334FF3436FF3334FF3334FF3334FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3234FF3334FBA3A3FFFEFBFFFFFFFFFCFEFCF2EDFF3334FE2D2F
FF3234FE3534FE3534FF3334FF3234FF3436FE3534FF3230FF3334FF3334
FF3334FF3334FF3334FF2C34F9B1ADFFFFFFFFFAFFFCFFFFF9FFFFFEF5F9
FE4E52FD2B24FF3237FE3432FF3334FF3334FE2B2AFF3334FFFFFFFFFFFF
FFFFFFFEFEFEFDD6D7FE4E52FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3436FF3031FF3334FF3334FC3436FE3534FF3234FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3232FF3334FCA5A9FCFFFAFFFFFFFFFEFFFCF2EDFF3334FE2D2F
FF3232FE3432FE3432FF3334FF3234FF3436FE3534FE3534FF3031FF3334
FE3534FF3334FF3334F86567F3FFFEFFFEFEFFFCFEFFFAFFFEFEFDFAA09D
FD2B24FC3436FC3436FF3230FF3334FF3334FE2B2AFF3334FFFFFFFFFFFF
FFFFFFFEFEFDFFFCFEF9FFFFFEF9F8FEF9F8F9FFFFFAFAFDFCFFFFF6BCBD
FF3334FF3334FF3334FF3334FF3334FF3334FF3232FE3534FF3234FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3232FF3334FCA5A9FCFFFAFFFFFFFEFEFFFCF2EDFF3334FE2D2F
FF3232FE3432FE3432FF3334FF3234FF3436FE3534FE3432FF3334FE332D
FD3132FF3230FE3432FBC9C6FFFEFEFCFFFAFCFFFFFCFFFFFDDCD3FB423D
FE2B2AFD3834FF3230FF3230FF3334FF3334FE2B2AFF3334FFFFFFFFFFFF
FFFFFFFEFFFFFFFCFEF9FFFFFFFFFFFFFFFFFCFFFAFFFEFBFFFEFBFBBBBA
FF3334FF3334FF3334FF3334FF3334FF3334FF3235FE3534FF3234FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3232FF3334FCA5A9FCFFFAFFFFFFFFFEFFFCF2EDFF3334FE2D2F
FF3232FE3432FE3432FF3334FF3234FF3436FE3534FE3534FF3334FC3331
FF3234FF242AFA8E90F9FFFAFEFCFBFCFFFAFFFEFFFAFAFDFA7777FC2624
FF3234FC3031FF3232FF3230FF3334FF3334FE2B2AFF3334FFFFFFFFFFFF
FFFEFFFCFFFFFCFFFFFCFFFFFFFFFEFFFCFEFEFEFDFFFEFFF9FFFFF6BCBD
FF3334FF3334FF3334FF3334FF3334FF3334FF3037FE3534FF3234FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3232FF3334FCA5A9FCFFFAFFFFFFFEFEFFFCF2EDFF3334FE2D2F
FF3232FE3432FE3432FF3334FF3234FF3436FE3534FF3436FF3334FF3436
FD2B24FE4E52FCF2EDFCFCFEFCFFFAFEFEFDFFFAFFFAB8B5FD2B24FF3334
FF3237FE332DFF3334FF3230FF3334FF3334FE2B2AFF3334FFFFFFFFFFFF
FFFEFFFFFCFEFCFFFAFDFAF6F9FFFAFCFFFFFEFEFFFFFCFEFCFFFFF5C9C3
FF3334FF3334FF3334FF3334FF3334FF3334FF3237FE3534FF3234FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3232FF3334FCA5A9FCFFFAFFFFFFFFFEFFFCF2EDFF3334FE2D2F
FF3232FE3432FE3432FF3334FF3234FF3436FE3534FF3230FF3334FF3037
F52A2CF9B1ADFCFFFFFCFFFFFEFEFDFFFAFFFEEFEFFC5854FD2B24FF3334
FF3334FF3334FF3334FF3230FD3235FF3334FE2B2AFF3334FFFFFFFFFFFF
FFFEFFFCFFFFFEF5F9FCC6C7FBCCCBF5CDCAF5CDCAFCCFD0FAD1CEFB9997
FF3334FF3334FF3334FF3334FF3334FF3334FF3232FE3534FF3234FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3232FF3334FCA5A9FCFFFAFFFFFFFEFEFFFCF2EDFF3334FE2D2F
FF3232FE3432FE3432FF3334FF3234FF3436FE3534FF3230FF3334FF242A
F75E60FCF4F0FFFAFFF9FFFFFEF9F8F3FFFEFAA09DFC2624FA3136FF3237
FF3334FF3334FD3834FF3230FD3235FF3334FE2B2AFF3334FFFFFFFFFFFF
FFFEFEFCFFFAFCC3C3FF3334FF3334FF3334FF3334FF3232FF3232FF3334
FF3334FF3334FF3334FF3230FF3334FD3834FF3031FE3534FF3234FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3232FF3334FCA5A9FCFFFAFFFFFFFFFEFFFCF2EDFF3334FE2D2F
FF3232FE3432FE3432FF3334FF3234FF3436FE3534FF3232FF3334F52A2C
F9B1ADFCFFFFFFFEFEFEFEFFFFFFFFFDE8E6FD444BFE2B2AFF3237FF3232
FF3334FF3334FF3031FF3230FD3235FF3334FE2B2AFF3334FFFFFFFFFFFF
FFFEFFFFFAFFFCC3C3FF242AFF2C34FF3334FF3334FF2C34FE332DFE2D2F
FF3234FF3334FF3334FE3534FF3334FF3334FF3230FE3534FF3234FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3232FF3334FCA5A9FCFFFAFFFFFFFEFEFFFCF2EDFF3334FE2D2F
FF3232FE3432FE3432FF3334FF3234FF3436FF3436FE3534FD2B24FE4E52
FCE1DEFEFFFFFFFAFFFFFFFFF9FFFFFA928DFE2D2FFF3031FF3232FF3230
FF3334FF3334FF3037FF3230FD3235FF3334FE2B2AFF3334FFFFFFFFFFFF
FFFEFFFFFEFBF5C2C3FD2B24FE332DFF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FE3432FE3534FF3234FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3232FF3334FCA5A9FEFEFDFFFFFFFFFEFFFCF2EDFF3334FE2D2F
FF3234FE3534FE3534FF3334FF3234FF3436FE3534FF3334FD2B24F87F7E
FEFCFBF9FFFFFFFEFBF9FFFFFEEBECFD3B3BFF3334FD3132FF3436FD3132
FF3232FF3334FF3232FF3230FE3235FF3334FE2B2AFF3334FFFFFFFFFFFF
FFFEFFFFFEFFFCC3C3FC2624FE3432FF3232FC3436FF3230FC3436FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3534FF3234FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3232FF3334FCA5A9FEFEFDFFFFFFFEFEFFFCF2EDFF3334FE2D2F
FF3234FE3534FE3534FF3334FF3234FF3436FE3534FE3432FE2B2AFAABAA
FFFEFBFCFFFFFFFEFBFCFFFFF5ACACFC3031FC3031FF3334FF3436FF3436
FF3334FF3436FF3334FF3230FE3235FF3334FE2B2AFF3334FFFFFFFFFFFF
FFFEFFFFFEFFFCC3C3FC2624FE3432FF3234FC3436FF3230FC3436FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3534FF3234FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3232FF3334FCA5A9FEFEFDFFFFFFFFFEFFFCF2EDFF3334FE2D2F
FF3234FE3534FE3534FF3334FF3234FF3436FE3534FF3334FD3834FAD1CE
FEFFFEFCFCFEFCFFFAFEFCFBF76E6DF52A2CFE3235FF3436FF3232FF3334
FF3334FF3232FF3436FF3230FE3235FF3334FE2B2AFF3334FFFFFFFFFFFF
FFFEFFFFFEFFFCC3C3FC2624FE3432FF3232FC3436FF3230FC3436FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3534FF3234FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3232FF3334FCA5A9FEFEFDFFFFFFFEFEFFFCF2EDFF3334FE2D2F
FF3234FE3534FE3534FF3334FF3234FF3436FE3432FF3334FC4844FCF2ED
FEFEFFFEFFFFF9FFFAFDE4E3FD4143FC3031FF3436FF3436FD3132FF3334
FF3436FF3334FF3334FF3230FE3235FF3334FE2B2AFF3334FFFFFFFFFFFF
FFFEFFFFFEFFFCC3C3FC2624FE3432FF3234FC3436FF3230FC3436FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3534FF3234FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3232FF3334FCA5A9FEFEFDFFFFFFFFFEFFFCF2EDFF3334FE2D2F
FF3234FE3534FE3534FF3334FF3234FF3436FE3534FF3334FE4E52F6FEF4
FFFAFFFCFFFFF9FFFFFCD3D2FF3031FF3031FF3234FF3234FF3334FF3436
FF3436FF3436FF3334FF3230FE3235FF3334FE2B2AFF3334FFFFFFFFFFFF
FFFEFFFFFEFFFCC3C3FC2624FE3432FF3232FC3436FF3230FC3436FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3534FF3234FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3232FF3334FCA5A9FEFEFDFFFFFFFEFEFFFCF2EDFF3334FE2D2F
FF3234FE3534FE3534FF3334FF3234FF3436FE3534FF3334FE4E52FCF2ED
FFFDFDFAFAFDFCFFFAF4D4D3FE2D2FFF3031FF3031FF3234FF3334FF3232
FF3334FF3436FF3334FF3230FE3235FF3334FE2B2AFF3334FFFFFFFFFFFF
FFFEFFFFFEFFFCC3C3FF3334FE3432FF3234FC3436FF3230FC3436FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3534FF3234FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3232FF3334FCA5A9FEFEFDFFFFFFFFFEFFFCF2EDFF3334FE2D2F
FF3234FE3534FE3534FF3334FF3234FF3436FE3534FF3334F53B3CFCDEDC
FEFEFDFEFEFFFFFEFBF5DED8F93636FF3031FF3234FF3334FF3234FD3132
FF3232FF3334FE3534FF3230FE3235FF3334FE2B2AFF3334FFFFFFFFFFFF
FFFEFFFFFEFFFCC3C3FF3334FE3432FF3232FC3436FF3230FC3436FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3534FF3234FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3232FF3334FCA5A9FEFEFDFFFFFFFEFEFFFCF2EDFF3334FE2D2F
FF3234FE3534FE3534FF3334FF3234FF3436FE3534FF3334FA3136F5C2C3
FEFEFDFFFCFEFEFCFBF7EEE4FB4F4CFE2D2FFF3234FF3334FF3232FF3436
FF3436FF3436FE3534FF3230FE3235FF3334FE2B2AFF3334FFFFFFFFFFFF
FFFEFFFFFEFFFCC3C3FF3334FE3432FF3334FF3334FF3230FC3436FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3534FF3234FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3232FF3334FCA5A9FEFEFDFFFEFFFFFEFFFCF2EDFF3334FE2D2F
FF3232FE3432FE3432FF3334FF3234FF3436FE3534FA3136FE2B2AFB9997
FCFFFAFCFFFAFFFAFFFFFEFFFB8788FC2624FE332DF93636FF3237FF3031
FF3237FF3037FF3334FE332DFF3237FF3234FE2B2AFF3334FFFFFFFFFFFF
FFFEFFFFFAFFF5C2C3FF3334FF3037FF3334FF3334FF3334FE332DFF3334
FF3334FF3334FF3334FF3334FF3334FF3334FE3432FE3534FF3234FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3232FF3334FBA3A3FFFFFFFFFEFFFFFCFEFCF2EDFF3334FE2D2F
FF3232FE3432FE3432FF3334FF3234FF3436FE3534FF3436FD2B24FE5A5C
FCF2EDFFFEFFFFFEFBF9FFFAFEEBECF75E60FC2624FD2B24FD3834FE3432
FD3834FC3331FF3334FF3230FF3436FF3234FE2B2AFF3334FFFFFFFFFFFF
FFFEFFFEFEFDF5C9C3FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3534FF3234FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3232FF3334FCA5A9FEFEFDFFFEFFFFFCFEFCF2EDFF3334FE2D2F
FF3232FE3432FE3432FF3334FF3234FF3436FE3534FE332DFE332DFE2D2F
FBC9C6F3FFFEFFFEFBF6FEF4FFFAFFFEEBECFA7777FE2D2FFC2624FC2624
FE2B2AFC3031FE3235FE3432FF3436FF3234FE2B2AFF3334FFFFFFFFFFFF
FFFFFFFFFAFFFBBBBAFF3334FF3334FF3334FF3334FF3334FE2B2AFF3235
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3234FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FE3432FF3334FCA5A9FEFEFDFFFFFFFFFEFFFCF2EDFF3334FE2D2F
FF3232FE3432FE3432FF3334FF3234FF3436FE3534FF3232FF3234FC2624
F86567FEFCFBFFFAFFFCFFFAFCFFFAFFFCFEFFFDFDFCCFD0F97D81F7605D
FE5A5CFE4E52FF3334FF3230FF3436FF3234FE2B2AFF3334FFFFFFFFFFFF
FFFFFFFFFEFBFBCCCBFF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3234FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3232FF3334FCA5A9FCFFFAFFFFFFFFFEFFFCF2EDFF3334FE2D2F
FF3232FE3432FE3432FF3334FF3234FF3436FE3534FD3235FF3436FE332D
F52A2CF99EA0FDFAF6FCFFFAF3FFFEFFFEFBFFFEFBFFFEFFFFFEFBF6FEF4
FDFAF6FAB8B5FF3334FF3230FF3436FF3334FE2B2AFF3334FFFFFFFFFFFF
FFFFFFFFFCFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFAF6
FF3232FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3234FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3230FF3334FCA5A9FCFFFAFEFEFFFEFEFFFCF2EDFF3334FE2D2F
FF3232FE3432FE3432FF3334FF3234FF3436FE3534FD3132FE332DFD3834
FE332DF43234FAABAAFDFAF6FFFCFEFFFEFFFDFAF6F3FFFEF9FFFFFFFAFF
FFFEFBFAB3B3FF3234FE332DFE3235FF3334FE2B2AFF3334FFFFFFFFFFFF
FFFFFFFFFEFBF9FFFAFFFEFBF9FFFFFCFFFFFFFEFBFFFFFFFEFFFFF3FFFE
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3232FF3334FCA5A9FEFEFDFEFEFFFFFEFFFCF2EDFF3334FE2D2F
FF3232FE3432FE3432FF3334FF3234FF3436FF3334FF3334FE332DFF3031
FD3834FE2B2AFE2431FA928DFEEFEFF3FFFEFFFEFBFCFFFAF9FFFAFEFEFD
FFFCFEFAB3B3FF3334FF3230FE3235FF3334FE2B2AFF3334FFFFFFFFFFFF
FFFFFFFFFEFBFFFEFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCFFFF
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3534FF3334FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FCA5A9FCFFFAFFFFFFFFFEFBFCF2EDFF3334FE2D2F
FF3232FE3432FE3432FF3334FF3234FF3436FF3334FF3334FF3334FD3235
FF3235FF3436FE2B2AFC2624FC5854F6A4A0FDE4E3FCFFFFF9FFFFFCFCFE
FFFEFEF6BCBDFF3334FF3334FE3235FF3334FE2D2FFF3334FFFFFFFFFFFF
FFFFFFFEFEFDFFFEFBF9FFFAFEFEFDFEFCFBFFFEFBFCFFFAFCFFFAF9FFFA
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3534FF3334FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FE3534FF3334F76E6DF6A4A0FA928DFB9997FA928DFF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3436FF3334FF3334
FF3436FF3436FF3334FD3132FC3031FC2624F54A4CFA7777FB8788FB9997
F9B1ADF87F7EFE3432FF3334FF3334FF3334FF2C34FF3334FB8788FAA09D
FB9997FB9997FB9997FB9997FB9997FB9997FB9997FB9997FB9997FB9997
FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FE2D2FFF242AFF242AFE2B2AFE2D2FFE2D2FFF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3436FF3334FF3232FD3132FE332DFF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3031FE2D2FFC3031F52A2C
FE2431FE2B2AFE2B2AFE2B2AFE2B2AFE2B2AFE2B2AFE2B2AFE2B2AFF2C34
FF2C34FF3334FF3334FF3334FF3334FF3031FF3334FF3334FF3234FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3031FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE332DFE332D
FE332DFF3232FF3232FF3232FF3232FF3232FF3232FF3232FF3232FF2C34
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3234FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FE343BFE2D3BFF3037FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3436FF3037FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3235
FC3436FE3235FE3235FE3235FE3235FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3232FF3232FF3232FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FE3534FF3334FF3334FF3234FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FE3432FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3234FF3031FE3534FF3234FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FC3031FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FE3432FF3334FF3334FF3334FF3334FE3534FF3234FF3334
FF3234FE3432FE3432FF3334FF3334
FE2D2FFF3232FF3234FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3235FE3432FE332DFE3432FF3232FF3232FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3436FE3432FF3436FF3234FF3031FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3436FF3436FF3436FF3436FF3436FF3037
FC3436FF3334FF3334FF3334FF3334FF3334FF3334FE3534FF3234FF3334
FE3235FE3432FF3232FF3334FF3334
FE2D2FFE332DFC3436FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3534FE3432FE3534
FE3432FF3232FF3232FF3334FF3334
FE2D2FFE3432FE3534FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FE3432FE3432
FF3232FF3232FF3232FF3334FF3334
FE2D2FFF3230FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3436FF3334FF3232
FF3232FF3334FF3232FF3334FF3334
FE2D2FFF3230FF3436FF3232FF3232FF3232FF3232FF3232FF3232FF3232
FF3232FF3232FF3232FF3232FF3232FF3232FF3232FF3232FF3232FF3232
FF3232FF3232FF3232FF3232FF3232FF3232FF3232FF3232FF3232FF3232
FF3232FF3232FF3232FF3232FF3232FF3232FF3232FF3232FF3232FF3232
FF3232FF3232FF3232FF3232FF3232FF3232FF3232FF3232FF3232FF3232
FF3232FF3232FF3232FF3232FF3232FF3232FF3232FF3232FF3232FF3232
FF3232FF3232FF3232FF3232FF3232FF3232FF3232FF3334FF3234FF3232
FF3232FF3334FF3232FF3334FF3334
FE2D2FFF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3234FF3234FF3031
FF3232FF3334FF3031FF3334FF3334
FE2D2FFE332DFF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334
FF3031FF3230FF3436FF3234FF3234FF3234FF3234FF3234FF3234FF3234
FF3234FF3234FF3234FF3234FF3234FF3234FF3234FF3234FF3234FF3234
FF3234FF3234FF3234FF3234FF3234FF3234FF3234FF3234FF3234FF3234
FF3234FF3234FF3234FF3234FF3234FF3234FF3234FF3234FF3234FF3234
FF3234FF3234FF3234FF3234FF3234FF3234FF3234FF3234FF3234FF3234
FF3234FF3234FF3234FF3234FF3234FF3234FF3234FF3234FF3234FF3234
FF3234FF3234FF3234FF3234FF3234FF3234FF3234FF3234FF3334FF3232
FE3432FF3232FE3432FF3031FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334FF3334
FF3334FF3334FF3334FF3334FF3334
pop
grestore
grestore
113.625 31.562 moveto
%%BeginResource: font Helvetica-MISO
%%BeginFont: Helvetica-MISO
/Helvetica /Helvetica-MISO MISOfy
%%EndFont
%%EndResource
/Helvetica-MISO findfont 18.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(J) show
122.625 31.562 moveto
/Helvetica-MISO findfont 18.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
131.000 31.562 moveto
/Helvetica-MISO findfont 18.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(McKenzie) show
213.250 31.562 moveto
(Alexander) show
294.125 31.562 moveto
/Helvetica-MISO findfont 18.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
113.625 50.250 moveto
/Helvetica-MISO findfont 16.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Department) show
200.000 50.250 moveto
(of) show
216.312 50.250 moveto
(Philosophy) show
294.312 50.250 moveto
/Helvetica-MISO findfont 16.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
306.188 50.250 moveto
/Helvetica-MISO findfont 16.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Logic) show
347.312 50.250 moveto
(and) show
376.938 50.250 moveto
(Scientific) show
443.688 50.250 moveto
(Method) show
496.938 50.250 moveto
/Helvetica-MISO findfont 16.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
113.938 69.000 moveto
/Helvetica-MISO findfont 16.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(jalex) show
148.188 69.000 moveto
/Mathematica1 findfont 16.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\236) show
160.625 69.000 moveto
/Helvetica-MISO findfont 16.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(lse) show
181.000 69.000 moveto
/Helvetica-MISO findfont 16.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
185.438 69.000 moveto
/Helvetica-MISO findfont 16.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(ac) show
202.312 69.000 moveto
/Helvetica-MISO findfont 16.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(.) show
206.750 69.000 moveto
/Helvetica-MISO findfont 16.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(uk) show
0.000 0.000 0.000 setrgbcolor
1.000 setlinewidth
%%Trailer
%%EOF
\
\>"], "Input",
  CellMargins->{{26, Inherited}, {Inherited, Inherited}},
  Evaluatable->False,
  TextAlignment->Left,
  ImageSize->{478, 77},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  GridBoxOptions->{RowAlignments->Center},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007N0000CB000`400?l00000o`00003ooooooooO
ooooo`000_ooool00`3n;Bl0oS@b0?lc=0110?he=0050?lc=03n=C@0oc<d0?he=03n=3800P3o<cCo
oooooi;ooooo0002ooooo`030?h];`3o<S80oc<d04P0oc<doooooonBooooo`000_ooool00`3n;Bl0
oc8b0?lb=0100?lc=0060?he=03o<S@0oSDd0?hb=@3n=380oc8b0P3o<cCooooooi;ooooo0002oooo
o`030?h];`3o<S80oc8d0400oc<d00@0oSDd0?lb=03o<c@0oc8d0P3n=3820?lc=?ooooooT_ooool0
00;ooooo00<0oRd_0?lb<P3o<S@0@03o<c@01P3n=C@0oc8d0?lc=03n<SD0oS@b0?lb<P80oc<doooo
oonBooooo`000_ooool00`3n;Bl0oc8b0?lb=0100?lc=0040?he=03o<S@0oc<d0?lb=080oS@b0P3o
<cCooooooi;ooooo0002ooooo`030?h];`3o<S80oc8d0400oc<d00H0oSDd0?lb=03o<c@0oS8e0?hd
<P3o<S820?lc=?ooooooT_ooool000;ooooo00<0oRd_0?lb<P3o<S@0@03o<c@0103n=C@0oc8d0?lc
=03o<S@20?hd<P80oc<doooooonBooooo`000_ooool00`3n;Bl0oc8b0?lb=0110?lc=0050?lb=03o
<c@0oS8e0?hd<P3o<S800P3o<cCooooooi;ooooo0002ooooo`030?h];`3o<S80oc8d0440oc<d00<0
oc8d0?lc=03o<S@00P3n=3820?lc=?ooooooT_ooool000;ooooo00<0oRd_0?lb<P3o<S@0A03o<c@0
103n=380oc8b0?lc=03o<cCooooooi;ooooo0002ooooo`030?h];`3o<S80oc8d00P0oc<d00<0oS<]
0?lc=03o<c@03`3o<c@00`3n<bd0oc8b0?lc=0020?lc=0030?hc;@3o<SL0oc<d0280oc<d0P3n=382
0?lc=0[ooooo00?o0000ogMgMoooool0oooooon5ooooo`000_ooool00`3n;Bl0oc8b0?lb=00G0?lc
=0040?dk>`3o<c@0oc<d0?`c<@80oc<d00<0ob`d0?lc=03o<c@00`3o<c@20?hc;A40oc<d00<0oRd_
0?h[:P3o<c@0203o<c@01@3o<S@0oc<d0?hb=@3n=380oc8b0080oc<d2_ooool00oo^k^ko0000oooo
o`3oooooohGooooo0002ooooo`030?h];`3o<S80oc8d01H0oc<d00<0oc@f0?lc=03o<c@02@3o<c@0
0`3o<340oRd_0?lc=00L0?lc=0030?lb=03o<c@0oc8d0080oS@b0P3o<c@;ooooo`03o`000?oooooo
oooo0?ooooooQ?ooool000;ooooo00<0oRd_0?lb<P3o<S@02P3o<c@03P3jTXd0m^?P0?gMh03mfmX0
m^?P0?gFe`3mgN00mMkH0?gLd`3eg]P0oMgP0?gFe`3hNg`0ob`d0`3o<c@02P3ebL<0o>7N0?gLd`3k
c</0nj>S0?]YL@3n;C/0ob@Z0?dh=03o=3H70?lc=0030?hd<P3jdLh0oMcC0080oM_J00@0oMgP0?cQ
gP3mgN00oM_J0P3mgN001@3mfmX0oMcC0?lc=03o<c@0oc8`00D0oc<d00D0oc8d0?lc=03n<SD0oS@b
0?lb<P020?lc=0_ooooo00Co0000ooooooooooooV9RH0ol000001_m4A4Co^[Zjoc8b<_l0003ooooo
o`0000?ooooo00?oV9RHo`000?l000000_l000001OnHV9Soooooooooooo<c<co410@00Cooooo00?o
k^k^o`000?o<c<`00oooool00ooMgMgoEEEEoa0@4002o`000003oeEEEOoMgMgooooo00?ooooo00Co
0000ooooooooooooV9RH1Ol000001OnHV9SoooooooooooooooooV9RH00Co000000CoV9RHoooooooo
oooo00000oooool02?nHV9So0000o`000?l0003oA4A4okZj^_lb<S;o00000_ooool01OnHV9So0000
o`000?l0003oV9RH00;ooooo00Ko0000ooooooooooooooooonk^k_m4A4@2o`000003ob4Q8Onj^[[o
000000;ooooo00Ko0000ooooooooooooooooogMgMom4A4Cooooooa_ooooo0002ooooo`030?h];`3o
<S80oc8d00X0oc<d00<0mZBP0?ooo`3oool00P3oool00`3oo_l0o?oo0?koo`040?ooo`030?J:QP3m
:b@0oS@b0080oc<d00X0nOWi0?onn`3lo?h0o?oo0?oloP3looX0n]7>0?]YL@3e:R`0oRd_103o<c@0
103n=380oc<d0?lc=03o<c@<0?ooo`80oc<d00<0oSDd0?lc=03o<c@00P3o<c@0103n=380oc8d0?lc
=03o<S@20?hd<P80oc<d2oooool01Ol0003oooooooooool0003oV9RH00;ooooo00?oZJVYob4Q8Ol0
00000_ooool01_l0003ooooooooooonHV9So0000oiRHV0;ooooo00?oV9RHo`000?nHV9P00_ooool2
ogMgM`?ooooo0_mgMgL3ooooo`04olc<c?lQ8B7oV9RHomgMg@;ooooo00?oV9RHodA4A?ooool00ooo
ool01Ol0003oooooooooool0003oV9RH00?ooooo00OoV9RHo`000?oooooooooooiRHV?l0003oV9RH
00;ooooo00?oV9RHo`000?nHV9P01Oooool01ol0003oV9RHooooooooooooZJVYob4Q8Ol000000_oo
ool01onHV9So0000oiRHV?ooooooV9RHo`000?nHV9P01Oooool01Om4A4CoMgMgooooooooooooZJVY
00;o00000_ooool01_l0003oooooooooooo^k^ko410@onk^k_oooooo6oooool000;ooooo00<0oRd_
0?lb<P3o<S@02P3o<c@0103kXj<0oooo0?ooo`3looX60?ooo`050?koo`3iool0nhN80?h[:P3n<bd0
0P3o<c@02P3ll^d0nOoj0?onn`3jn_d0o?oj0?oloP3on_l0m_kd0?^IU`3n=3/50?lc=0030?lb=03n
:bX0oc<d00X0oooo00D0o?oo0?[jo@3o<c@0oc<d0?``<@020?lc=0080?lb=03n<bd0oSDd0?lb=03o
<c@0oS8e0?hd<P3o<S820?lc=0_ooooo00Co0000oooooooooooo00001?ooool01OoMgMgo0000oooo
oooooooo000000;ooooo00?o0000oiRHV?ooool00oooool00onHV9So0000ooooo`02ooooo`05ob4Q
8Oo<c<coooooomgMgOlQ8B401?ooool02OlQ8B7ogMgMoiRHV?l0003oEEEEoc8b<_l0003o<S8bonk^
kP03ooooo`04o`000?ooooooooooo`0000Gooooo00Go0000oooooooooooo0000oiRHV004ooooo`03
oiRHV?l0003ooooo00Cooooo00?o0000ooooooooool00_ooool01_oMgMgo0000oooooooooooo0000
oiRHV0?ooooo00?oV9RHo`000?ooool01?ooool00ol0003oooooooooo`02ooooo`05oiRHV?l0003o
ooooooooool000000_ooool00omEEEGoQhN7ooooo`3ooooooa_ooooo0002ooooo`030?h];`3o<S80
oc8d00P0oc<d00@0oc0g0?lc=03kXj<0o_Wh2@3oool01`3oo?h0nhN80?h[:P3n=3/0oRd_0?lc=03n
knl00P3oo_/0203iool0ooko0?onn`3nool0o_ko0?onn`3kXj<0oSDd1@3o<c@0103n:bX0oc<d0?oo
o`3oo_/20?ooo`030?coo`3lo?`0oooo00@0oooo00<0ookk0?lc=03o<c@0103o<c@01@3m>c/0oS@b
0?lb=03o<c@0oc8d0080oS@b0P3o<c@;ooooo`05o`000?oooooooooooc8b<_mgMgL01?ooool01?l0
003oooooooooool00002ooooo`03o`000?oooooooooo00Sooooo00Goc<c<ob4Q8Ooooooo<S8bolc<
c004ooooo`09oa0@4?oooooo0000onk^k_nj^[[o0000omgMgOmgMgOo<S8b00?ooooo00?o0000oooo
ooooool01?ooool00onj^[[oA4A4ob4Q8@02ooooo`03o`000?oooooooooo00[ooooo00?o<S8bogMg
Moooool00oooool01?l0003oooooooooool0000;ooooo`03o`000?oooooooooo00;ooooo00Sok^k^
o`000?ooooooooooo`000?o<c<co^[Zjoc8b<_oooooo7Oooool000;ooooo00<0oRd_0?lb<P3o<S@0
203o<c@0103n=380oc<d0?JTX03no_l20?ooo`0@0?kin03me]L0nlW60?_<b`3lcm00nlW60?_<b`3l
dm80nWMg0?d[903o<S00oS<]0?lc=03e`/<0m=CC0?cCdP80o?oj00H0nOoj0?koo`3on_l0o?oj0?gj
mP3kQhP40?lc=0050?lb=03n:bX0oc<d0?ooo`3lool00P3oool00`3ll^d0m=CC0?G=bP020?c?d080
nlc;00<0o=?B0?lc=03o<c@0103o<c@01`3o<3L0oSDd0?lb=03o<c@0oS8e0?hd<P3o<S800P3o<c@;
ooooo`05o`000?ooooooooooonk^k_mEEED00_l@4102oc8b<P04o`000?ooooooooooo`0000;ooooo
2?l00004ooooo`03ofIVI_mEEEGoIVIV00Gooooo00Wo0000ooooool@413oc<c<oooooom4A4CoQhN7
onk^k_l000000oooool02Ol0003oooooooooooooooooZJVYofIVI_lb<S;oEEEEohN7Q`03ooooo`So
00001Oooool01?o^k^koEEEEoa0@4?l@4102oc8b<P04o`000?ooooooooooo`0000_ooooo00?o0000
ooooooooool00oooool01?l0003oooooooooool00002oc8b<P03omgMgOoooooooooo0?oooooo6ooo
ool000;ooooo00<0oRd_0?lb<P3o<S@0203o<c@02`3n=380oc<d0?bUZ@3oo_/0oooo0?ono`3ll^d0
oc<d0?h];`3o<c@0oS@b00<0oSDd0P3o=3H03P3o<SL0oSDd0?lc=03o<c@0oc0a0?hd>`3gH5d0nZ^Z
0?gjmP3nood0o_ck0?WonP3oo_/0o_7a1@3o<c@0103n:bX0oc<d0?ooo`3no_d20?ooo`030?c3``3n
:bX0oSDd00`0oc<d00@0oSDd0?lb=03o<c@0oc8d0P3n=3820?lc=0_ooooo00?o0000ooooooooool0
1?ooool00oo<c<coZJVYo`000002ooooo`04o`000?ooooooooooo`0000Kooooo00Wo0000oooooooo
ooooooooomgMgOlQ8B7ogMgMob4Q8OoMgMd01?ooool02Ol@413oZJVYojVYZOlQ8B7ogMgMofIVI_m4
A4Coooooo`000003ooooo`06o`000?oooooooooooeEEEOlQ8B7oV9RH1_ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00Oooooo00?oc<c<ojVYZOl000000_ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00?ooooo00Oo0000oooooooooooo0000olc<c?l@413oc<c<0?oo
oooo7Oooool000;ooooo00<0oRd_0?lb<P3o<S@02P3o<c@01@3kXj<0oooo0?ooo`3oo_l0o?;]0080
oc<d00<0oc0a0?hc;@3l<c400P3l<c400`3o<S80oC4b0?lc=0050?lc=0090?hT<@3f8c00n6EW0?cQ
gP3lool0oo[o0?conP3oo_h0nZ2M0080oc<d00@0oc@f0?lb<P3n:bX0oc<d103oool00`3l`l<0o2HT
0?lb<P0<0?lc=0060?he=03o<S@0oc<d0?hb=@3n=380oc8b0P3o<c@;ooooo`04o`000?oooooooooo
o`0000Gooooo00Co0000oooooooooooo00000_ooool00ol0003oV9RHooooo`03ooooo`03oiRHV?l0
003ooooo00;ooooo00Go<S8bokZj^_oooooo^[Zjoc8b<P04ooooo`09ojVYZOlQ8B7ok^k^ohN7Qol0
003o8B4Qo`000?n7QhOo8B4Q00?ooooo00Go0000oooooooooooo0000onk^kP04ooooo`05o`000?oo
ooooooooo`000?nHV9P01?ooool00onHV9So0000ooooo`04ooooo`03o`000?oooooooooo00?ooooo
00Go0000oooooooooooo0000oiRHV004ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool00oooool02?l0003oooooooooool0003oooooolc<c?lb<S;ok^k^oooooolLooooo`000_ooool0
0`3n;Bl0oc8b0?lb=0080?lc=0070?hd<P3l9R@0o:FY0?onn`3oool0ooko0?cbk@020?lc=0<0oc8b
00<0oSDd0?lc=03o<c@00`3o<c@00`3o<S80oS<]0?lb=0020?lc=0090?hd<P3o92X0mfi]0?cloP3i
ool0ookk0?ono`3mg=<0oD5300<0oc<d00<0oR/Z0?lc=03oool00`3oool00`3l`l<0oR/Z0?lb<P0<
0?lc=0040?he=03o<S@0oc<d0?lb=080oS@b0P3o<c@;ooooo`05o`000?ooooooooooo`000?nHV9P0
0oooool01OnHV9So0000oooooooooooo000000;ooooo00?oV9RHo`000?nHV9P00_ooool00onHV9So
0000oiRHV002ooooo`03ohN7QomVIVKooooo00;ooooo00?oIVIVohN7Qoooool00oooool00omgMgOo
8B4QojVYZ@02ooooo`03oiRHV?l0003oZJVY00?ooooo00Go0000oooooooooooo0000oiRHV003oooo
o`07oiRHV?l0003ooooooooooonHV9So0000oiRHV002ooooo`03oiRHV?l0003oV9RH00Gooooo00?o
0000oiRHV?ooool00_ooool01onHV9So0000ooooooooooooV9RHo`000?nHV9P00_ooool00onHV9So
0000ooooo`04ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00000_ooool00oo<
c<co<S8bonk^kP3ooooooa_ooooo0002ooooo`030?h];`3o<S80oc8d00P0oc<d00<0oS@b0?`V903k
Xj<00P3oool0103oo_l0o?;]0?lc=03o<c@30?lb<P030?he=03o<c@0oc<d00D0oc<d00<0oc8b0?lc
=03o<c@00P3n<bd00`3o92X0mLW30?Woo`020?oloP030?ooo`3gH5d0oc<d0080oc<d00<0oR/Z0?lc
=03oool00P3oool01@3oo_l0o<?30?h[:P3o<S80oc8`00/0oc<d00H0oSDd0?lb=03o<c@0oS8e0?hd
<P3o<S820?lc=0_ooooo00Co0000ooooooooooooV9RH1Ol000001?nHV9Soooooooooool00003oooo
o`03oiRHV?l0003o000000;o000000KoV9RHooooooooooooc<c<oa0@4?o^k^h3ooooo`03onk^k_lQ
8B7oc<c<00Cooooo00Ko^[ZjodA4A?l0003o0000ob4Q8Onj^[X4ooooo`04o`000?oooooooooooiRH
V0Go000000GoV9RHoooooooooooooooooiRHV004o`000003oiRHV?oooooooooo00Cooooo00?oV9RH
o`000?l000000ol000001OnHV9SoooooooooooooooooV9RH00Co000000?oV9RHooooooooool00ooo
ool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`0000?ooooo00?oZJVYob4Q8Oo^k^h0
oooooolJooooo`000_ooool00`3n;Bl0oc8b0?lb=0080?lc=0070?hd<P3l9R@0o:FY0?onn`3oool0
ooko0?cbk@020?lc=0<0oc8b00@0oc<d0?lb<P3o<c@0oc8b2@3o<c@0303l9R@0nhN80?gjmP3lo?`0
ookk0?Woo`3iOH40oB/T0?lb=`3o<c@0oR/Z0?lc=0<0oooo00<0ookk0?c3``3n:bX00P3o<S8;0?lc
=0040?he=03o<S@0oc<d0?lb=080oS@b0P3o<c@Gooooo`03o`000?oooooooooo023ooooo00?o0000
ooooooooool0=?ooool00ol0003oooooooooo`3ooooooakooooo0002ooooo`030?h];`3o<S80oc8d
00P0oc<d00<0oS@b0?`V903kXj<00P3oool0103oo_l0o?;]0?lc=03n;Bl30?lb<P80oc<d00<0oc@f
0?lc=03o<c@0203o<c@0303m:b@0mfi]0?onn`3lool0ookk0??ooP3kVIL0oR/Z0?lb=`3o<S@0oR/Z
0?lc=0<0oooo00P0ooko0?c3``3n:bX0oc<d0?lb<P3l=3H0oc<d0?hb=@P0oc<d00H0oSDd0?lb=03o
<c@0oS8e0?hd<P3o<S820?lc=1Oooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0d
ooooo`03o`000?oooooooooo0?oooooo7_ooool000;ooooo00<0oRd_0?lb<P3o<S@0203o<c@02@3n
=380o2HT0?bUZ@3oo_/0oooo0?ono`3ll^d0oc<d0?h[:P050?lb<P030?lc=03o<S80oc<d00L0oc<d
00<0oSDd0?lT:P3kJG400P3iooX01P3lo?`0o_on0?JTX03n:bX0oc8g0?lb=080oc<d00T0oooo0?ko
o`3oool0ookk0?c3``3n:bX0o30a0?lb<P3n=C@02P3o<c@0103n=C@0oc8d0?lc=03o<S@20?hd<P80
oc<d2oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo023ooooo00?o0000oooooooo
ool0=?ooool00ol0003oooooooooo`3ooooooakooooo0002ooooo`030?h];`3o<S80oc8d00P0oc<d
00<0oS@b0?`V903kXj<00P3oool0103oo_l0o?;]0?lc=03n;Bl30?lb<P80oc<d00<0oc@f0?lb=@3o
<c@00`3o<c@03`3o<S00oS<]0?dh=03n=380oS<]0?l/=03kJG40nOoo0?conP3oo?h0o?oo0?bUZ@3n
:bX0oc8g0?hb=@020?lc=0060?ooo`3nool0oooo0?ooo`3l`l<0oc<d0P3o<S8<0?lc=0050?lb=03o
<c@0oS8e0?hd<P3o<S800P3o<cCooooooi;ooooo0002ooooo`030?h];`3o<S80oc8d00P0oc<d00X0
oc8d0?`V903kXj<0o?oj0?ooo`3no_d0o?;]0?lc=03n;Bl0oc8d0P3n=C@00`3o<c@0oc8d0?ld=P05
0?lc=0030?hd<P3o=3H0oc<d0080oc<d00X0oR@a0?^IU`3no_d0oooo0?ojo`3no?/0nY:=0?DZ;03o
<SL0oc8d0P3o<c@01@3oool0o?oo0?ooo`3oo_/0o<?300X0oc<d00@0oc8d0?lc=03o<c@0oSDd0`3o
<c@00`3o<S@0oS@b0?hd<P020?lc=?ooooooT_ooool000;ooooo00<0oRd_0?lb<P3o<S@0203o<c@0
2P3n<SD0o2HT0?^SX`3oo_/0oooo0?oloP3ll^d0oc<d0?h];`3o<S@20?he=0030?lc=03o<S@0oc@f
00X0oc<d00X0oRd_0?_<b`3oo_l0ookk0?coo`3nnOP0nhN80?h[:P3o<SD0oc8d0P3o<c@01@3oool0
o?oo0?ooo`3nool0o<?300/0oc<d0P3o=3H01`3o<c@0oSDd0?lc=03o<c@0oS8e0?hd<P3o<S800P3o
<cCooooooi;ooooo0002ooooo`030?h];`3o<S80oc8d00P0oc<d00X0oc8d0?`V903kXj<0o?oj0?oo
o`3no_d0o?;]0?lc=03n;Bl0oc8d0P3n=C@00`3o<c@0oc8d0?ld=P0:0?lc=00:0?aHE03on_l0o?oo
0?onn`3oooh0oO[f0?MPG@3n;Bl0oc8g0?lb=080oc<d0`3oool00`3oo_/0o<?30?lc=0080?lc=003
0?ld=P3o<c@0oc<d0080oc@f00@0oc<d0?lb=03o<c@0oc8d0P3n=3820?lc=?ooooooT_ooool000;o
oooo00<0oRd_0?lb<P3o<S@0203o<c@02P3n<SD0o2HT0?^SX`3oo_/0oooo0?oloP3ll^d0oc<d0?h]
;`3o<S@20?he=0040?lc=03o<S@0oc@f0?he=0T0oc<d00X0nJRV0?koo`3iool0ookk0?kin03mi><0
oC/k0?l`<@3o<c@0oc8d0P3o<c@30?ooo`050?kno@3l`l<0oc<d0?lc=03n=3801`3o<c@00`3n=C@0
o3<a0?lc=0020?lc=0050?lb=03o<c@0oS8e0?hd<P3o<S800P3o<c@Pooooo`03o`000?oooooooooo
08Gooooo00?o0000ooooooooool03oooool2o`000003oiRHV?oooooooooo01oooooo00KoV9RHo`00
0?l0003o0000oa0@4?n7QhN]ooooo`000_ooool00`3n;Bl0oc8b0?lb=0080?lc=00:0?lb=03l9R@0
nj>S0?conP3oool0o_km0?cbk@3o<c@0oRd_0?lb=080oSDd00<0oc<d0?lb=03o=3H00P3n=C@80?lc
=0080?gXiP3oo_/0o_on0?coo`3nool0niVG0?`V903o<S040?lc=0<0oooo00H0ooko0?c3``3o<c@0
oc8g0?hd>`3l=3H60?lc=0030?ld=P3o<c@0oC4b0080oc<d00<0oc8d0?lc=03o<S@00P3n=3820?lc
=23ooooo00?o0000ooooooooool0QOooool00ol0003oooooooooo`0?ooooo`;ok^k^00Go410@olc<
c?ooooooooooofIVIP0Mooooo`07o`000?nHV9Soooooooooooo<c<co<S8bojVYZ@2/ooooo`000_oo
ool00`3n;Bl0oc8b0?lb=0080?lc=00:0?hb=@3l9R@0nj>S0?onn`3oool0oocn0?cbk@3o<c@0oRd_
0?lb=080oSDd00D0oc<d0?lb=03o=3H0oSDd0?ld=P050?lc=00;0?h];`3o92X0mZBP0?oloP3looX0
ookk0?Woo`3inOT0ndm<0?h];`3n=380103o<c@20?ooo`080?oooP3fo_@0mL;30?lc=03n;Bl0oc0a
0?hd<P3n<bd<0?lc=0030?hb=@3n=380oc8b0080oc<d8?ooool00ol0003oooooooooo`25ooooo`03
o`000?oooooooooo017ooooo00GoV9RHodA4A?ooooooooooo`00000Rooooo`03omgMgOlQ8B7ooooo
0:_ooooo0002ooooo`030?h];`3o<S80oc8d00P0oc<d00X0oc8d0?lc=03kXj<0o?oj0?ooo`3no_d0
o?;]0?lc=03n;Bl0oc8d0P3n=C@01@3o<c@0oc8d0?ld=P3n=C@0oc8d00D0oc<d00/0oR@a0?aHE03n
jn`0ooko0?coo`3no?/0oooo0?Va[@3m:b@0oc8g0?hd<P020?lc=0030?h[:P3o<c@0oooo0080oooo
00<0o?oj0?^k^P3l9R@01`3o<c@01@3n=C@0oc@f0?lb=03o<c@0oc@f00@0oc<d00<0oc8d0?hd<P3n
=3800P3o<c@;ooooo`Ko000000?oV9RHooooooooool00oooool00onHV9So0000o`000002o`000007
oiRHV?ooooooooooooooool0003oV9RHoa0@4002o`000005oiRHV?oooooooooooooooonHV9P00ol0
00001_m4A4Co^[Zjoc8b<_l0003oooooo`0000Cooooo00?oMgMgo`000?l000000_ooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00Go0000oooooooooooooooooiRHV004o`00
0005oiRHV?ooooooooooooooool000001Oooool01?l0003ooooooooooomgMgL2o`0000Cooooo00?o
V9RHo`000?l000000_l000001OnHV9Sooooooooooooooooo000000Gooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`0000;ooooo00Go0000oooooooo
oooooooooiRHV004o`000005oiRHV?oooooooooooooooonHV9P01Ol000001OnHV9Sooooooooooooo
ooooV9RH00Co000000OoV9RHooooooooooooooooo`000?nHV9So410@00;o000000GoV9RHoooooooo
ooooooooo`000005ooooo`03o`000?oooooooooo00;ooooo00Go^[Zjo`000?oMgMgoooooo`00000;
ooooo`Oo00000_ooool00onHV9So0000o`000002o`000003oiRHV?oooooooooo00;ooooo00KoV9RH
o`000?l0003o410@oiRHV?l00002ooooo`05o`000?oooooooooooooooonHV9P00ol000000onHV9So
ooooooooo`03ooooo`0:oiRHV?l0003o0000o`000?m4A4Co^[Zjoc8b<_l0003oooooo`0000Gooooo
00Go0000oooooooooooooooooiRHV002o`000003ob4Q8OnYZJWo000000Cooooo00?oV9RHo`000?l0
00001Ol000001OnHV9SoooooooooooooooooV9RH00?o000000CoV9RHoooooooooooo00000oooool0
0onHV9So0000o`000002o`000005oiRHV?ooooooooooooooool000001Oooool01?l0003ooooooooo
oomgMgL2o`0000;ooooo00Co0000oooooooooooo00000oooool01Ol0003oooooooooooooooooV9RH
00?o000000?oV9RHooooooooool00oooool01ol0003oooooooooooooooook^k^o`000?o^k^h00ooo
ool01Ol0003oooooooooooooooooV9RH00Co000000GoV9RHooooooooooooooooogMgM`02o`0000;o
oooo00?o0000ooooooooool00oooool01Ol0003oooooooooooooooooV9RH00Co000000?oV9RHoooo
ooooool00_ooool01_nHV9So0000o`000?lQ8B7oZJVYo`0000Kooooo0002ooooo`030?h];`3o<S80
oc8d00P0oc<d00X0oc8d0?lc=03kXj<0ookk0?ooo`3oo?h0o?;]0?lc=03n;Bl0oc8d0P3n=C@01@3o
<c@0oc8d0?ld=P3n=C@0oc8`00D0oc<d00/0ob`d0?Va[@3oool0oo[o0?coo`3iool0o_Gi0?i>DP3m
:b@0oc8g0?hd<P020?lc=0030?h[:P3o<c@0oooo0080oooo00<0o_kn0?gFe`3nCU80203o<c@02`3o
=3H0oc0a0?lc=03o<c@0o3@f0?he=03o<S@0oc<d0?hb=@3n=380oc8b0080oc<d2oooool00ol0003o
ooooooooo`02ooooo`03oiRHV?l0003oV9RH00?ooooo00?oV9RHo`000?nHV9P00_ooool00onHV9So
0000oiRHV002ooooo`07o`000?lQ8B7o^[ZjoooooonHV9So0000oiRHV002ooooo`07o`000?nHV9So
oooooooooonYZJWo8B4Qo`000002ooooo`03o`000?oooooooooo00;ooooo00?o0000omgMgOooool0
0_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00Ko0000oooooooooooo
V9RHo`000?nHV9P2ooooo`03oiRHV?l0003oV9RH00;ooooo00?o0000ooooooooool00oooool01Ol0
003oooooooooool0003ogMgM00Cooooo00?oV9RHo`000?nHV9P00_ooool00onHV9So0000oiRHV002
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`03
ooooo`04o`000?ooooooooooo`0000;ooooo00Ko0000ooooooooooooV9RHo`000?nHV9P2ooooo`03
oiRHV?l0003oV9RH00;ooooo00?o0000oiRHV?ooool00_ooool01onHV9So0000ooooooooooooV9RH
o`000?nHV9P00_ooool00onHV9So0000oiRHV002ooooo`07o`000?lQ8B7o^[ZjoooooonHV9So0000
oiRHV002ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00omVIVKo0000
ofIVIP0=ooooo`03o`000?oooooooooo00Gooooo00?oV9RHo`000?nHV9P00_ooool00onHV9So0000
oiRHV002ooooo`05oiRHV?l0003oV9RHoooooonj^[X00_l00002ooooo`0:o`000?oooooooooooiRH
V?l0003oV9RHoooooonHV9So0000oiRHV0Cooooo00Oo0000oiRHV?ooooooooooojVYZOlQ8B7o0000
00;ooooo00?o0000ooooooooool00oooool02?l0003ooooooooooonHV9So0000oiRHV?oooooo^[Zj
0_l00004ooooo`03o`000?nHV9Sooooo00Cooooo00goV9RHo`000?oooooooooooiRHV?l0003oV9RH
oooooonHV9So0000oiRHV?oooooo000000;ooooo00?oV9RHo`000?nHV9P00_ooool00onHV9So0000
oiRHV002ooooo`03o`000?oooooooooo00?ooooo00Go0000oooooooooooo0000omgMg@03ooooo`04
o`000?ooooooooooo`0000?ooooo00[o0000ooooooooooooV9RHo`000?nHV9SooooooiRHV?l0003o
V9RH1?ooool01ol0003oooooooooooooooooQhN7o`000?n7QhL00oooool01_l0003ooooooooooonH
V9So0000oiRHV0;ooooo00?oV9RHo`000?nHV9P00_ooool00ol0003ogMgMooooo`02ooooo`03o`00
0?oooooooooo00?ooooo00Ko0000ooooooooooooV9RHo`000?nHV9P2ooooo`03oiRHV?l0003oV9RH
00;ooooo00GoV9RHo`000?nHV9SooooookZj^P02o`0000Kooooo0002ooooo`030?h];`3o<S80oc8d
00P0oc<d00X0oc8b0?lc=03lYJT0o?oj0?ooo`3oo_l0o?;]0?lc=03n;Bl0oc8b0P3n=3800`3o<c@0
oc8d0?ld=P020?he=0030?l`<@3o<c@0oSDd0080oc<d00P0n6EW0??ooP3oo_h0oocn0?ojo`3no_d0
nZ2M0?d[9080o3@f00D0oc8`0?lc=03o<c@0oR/Z0?lc=0030?ooo`030?kno@3oo?h0nOoo0080o_Wh
00@0nOoo0?[jo@3lool0m[bm1P3o<c@01@3o<S80oSDd0?lb=03o<c@0oc8d0080oS@b0P3o<c@;oooo
o`03o`000?oooooooooo00?ooooo00?oV9RHo`000?nHV9P00_ooool00ol0003oV9RHooooo`03oooo
o`06oiRHV?l0003oooooooooool0003oZJVY0oooool01OnHV9So0000oooooooooooo000000Cooooo
00GogMgMo`000?ooooooooooo`000004ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooo`000?nHV9P01?ooool01OnH
V9So0000oooooooooooo000000Gooooo00Co0000oooooooooooo00001Oooool00ol0003oV9RHoooo
o`03ooooo`05oiRHV?l0003oooooooooool000001Oooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo00?ooooo00Co0000oooooooooooo00000_ooool01Ol0003oooooooooool0003oV9RH
00Cooooo00GoV9RHo`000?ooooooooooo`000005ooooo`05o`000?ooooooooooo`000?nHV9P01?oo
ool01_nHV9So0000oooooooooooo0000ojVYZ@?ooooo00GoV9RHo`000?ooooooooooo`000005oooo
o`03o`000?oooooooooo00;ooooo00?o410@oiRHV?l@41003Oooool00ol0003oooooooooo`05oooo
o`03o`000?nHV9Sooooo00?ooooo00KoV9RHo`000?ooooooooooo`000?nHV9P3ooooo`05oiRHV?l0
003oooooooooool000000_ooool00ol0003oV9RHooooo`02ooooo`03oiRHV?l0003ooooo00?ooooo
00?o0000ooooooooool00_ooool01OoMgMgo0000oooooooooooo000000Gooooo00Go0000oooooooo
oooo0000oiRHV003ooooo`03oiRHV?l0003ooooo00?ooooo00?o0000ooooooooool01Oooool01Ol0
003oooooooooool0003oV9RH00?ooooo00CoV9RHo`000?oooooo00000_ooool00ol0003oV9RHoooo
o`03ooooo`05oiRHV?l0003oooooooooool000001Oooool01?l0003oooooooooool00004ooooo`04
o`000?ooooooooooo`0000?ooooo00Go0000oooooooooooo0000oiRHV003ooooo`03oiRHV?l0003o
oooo00?ooooo00Oo0000ooooooooooooooooob4Q8OnHV9So8B4Q00?ooooo00Go0000oooooooooooo
0000oiRHV004ooooo`05oiRHV?l0003oooooooooool000001?ooool00ol0003oooooooooo`03oooo
o`05o`000?ooooooooooo`000?nHV9P01?ooool01_nHV9So0000oooooooooooo0000oiRHV0?ooooo
00?oV9RHo`000?ooool01Oooool000;ooooo00<0oRd_0?lb<P3o<S@0203o<c@02P3o<S80oc<d0?bU
Z@3looX0oooo0?kno`3ll^d0oc<d0?h];`3o<S820?hd<P0=0?lc=03o<S@0oc@f0?he=03n=380oc<d
0?hc;@3m<C80oc8`0?hd<P3kbLH0ookn0?conP020?coo`040?gLd`3k@Sd0oR/Z0?dh=080oc8`0P3o
<c@00`3n:bX0oc<d0?ooo`020?ooo`030?koo`3oo?h0nOoo0080oooo00@0o?oj0?onn`3oo_/0nk^j
1P3o<c@01`3o<SD0oSDd0?lb=03o<c@0oS8e0?hd<P3o<S800P3o<c@;ooooo`03o`000?oooooooooo
00Cooooo00GoV9RHo`000?ooooooooooo`000009ooooo`03o`000?oooooooooo00?ooooo00Go0000
oooooooooooo<S8bogMgM`04ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo
00002Oooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`0000Gooooo00?o0000oooo
ooooool01?ooool01?l0003oooooooooool00005ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool00oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000Kooooo
00?o0000ooooooooool01?ooool00onj^[[oA4A4ob4Q8@02ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooo00001Oooool01?l0003oooooooooool00005ooooo`09o`000?oooooooooo
ooooooo<c<co410@ooooool@413ogMgM00cooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`04ooooo`04o`000?ooooooooooo`0000Cooooo00Gok^k^o`000?ooooooooooo`000002oooo
o`03o`000?oooooooooo00Sooooo00?o<S8bogMgMoooool00oooool01?l0003oooooooooool00005
ooooo`04o`000?ooooooooooo`0000Cooooo00?ok^k^o`000?ooool00oooool00ol0003ooooooooo
o`05ooooo`04o`000?ooooooooooo`0000Oooooo00Co0000oooooooooooo00002Oooool00ol0003o
ooooooooo`03ooooo`04o`000?ooooooooooo`0000Cooooo00Co0000oooooooooooo00000oooool0
1?l0003oooooooooool0000:ooooo`08o`000?ooooooooooomgMgOlQ8B7ooooooa0@4?oMgMd2oooo
o`04o`000?ooooooooooo`0000Wooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03
ooooo`04o`000?ooooooooooo`0000Kooooo00Co0000oooooooooooo00001?ooool00oo^k^ko0000
ooooo`05ooooo`000_ooool00`3n;Bl0oc8b0?lb=0080?lc=00:0?lb<P3o<c@0o:FY0?conP3oool0
ooko0?cbk@3o<c@0oRd_0?lb<P80oS@b00<0oc<d0?lb=03o=3H00P3n=C@0403o<c@0o3<a0?lb=03o
92X0nXj@0?WonP3no?/0o?oj0?ono`3jn_d0nWMg0?`V903o<S@0o30a0?lb<P3o<S020?lc=0050?h[
:P3o<c@0oooo0?ooo`3oo_l00`3lool01P3oooh0oocn0?kno@3oo_l0nOoo0?Jl_@H0oc<d00D0oc0g
0?he=03o<S@0oc<d0?lb=0020?hd<P80oc<d2oooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00So00000_ooool00ol0003oooooooooo`03ooooo`05o`000?ooooooooooonk^k_mEEED0
0_l@4102oc8b<P04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool02?l00002ooooo`03
o`000?oooooooooo00?ooooo00Co0000oooooooooooo00001Oooool00ol0003oooooooooo`04oooo
o`04o`000?ooooooooooo`0000Gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`03
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00001_ooool02Ol0003ooooo
ooooooooooooZJVYofIVI_lb<S;oEEEEohN7Q`03ooooo`03o`000?oooooooooo00Cooooo00Co0000
oooooooooooo00001Oooool01?l0003oooooooooool00005ooooo`09o`000?oooooooooooooooomg
MgOoIVIVoooooomVIVKoV9RH00cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04
ooooo`04o`000?ooooooooooo`0000Gooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`08ooooo`04onk^k_mEEEGo410@oa0@40;o<S8b00Co0000oooooooooooo00001Oooool01?l0
003oooooooooool00005ooooo`03o`000?oooooooooo00Wooooo00Go^[Zjoa0@4?ooooooooooo`00
0007ooooo`03o`000?oooooooooo00So00000_ooool00ol0003oooooooooo`03ooooo`04o`000?oo
ooooooooo`0000Cooooo00Co0000oooooooooooo00000oooool01?l0003oooooooooool0000:oooo
o`08o`000?ooooooooooofIVI_n7QhOoooooohN7QomVIVH2ooooo`03o`000?oooooooooo00So0000
0_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo
00001_ooool01?l0003oooooooooool00005ooooo`03o`000?oooooooooo00Cooooo0002ooooo`03
0?h];`3o<S80oc8d00P0oc<d00X0oc8b0?lc=03lYJT0o?oj0?ooo`3no_l0o?;]0?lc=03n;Bl0oc8b
0P3n=3805@3o<c@0oc8d0?ld=P3n=C@0oc@f0?lc=03o=3H0oB/T0?i>DP3ll^d0o?cn0?conP3no_d0
oo[o0?Zh]@3m:b@0oc<d0?lb=`3n<bd0oc<d0?lb<0020?lc=00>0?h[:P3o<c@0oooo0?ooo`3oo_l0
oocn0?conP3mn_H0nOoj0?coo`3no_l0oocn0?coo`3ebL<60?lc=0070?lb=`3n=C@0oc8d0?lc=03n
<SD0oS@b0?lb<P020?lc=0_ooooo00?o0000ooooooooool01Oooool01?l0003oooooooooool00006
ooooo`05o`000?ooooooooooo`000?o^k^h01?ooool00ol0003oooooooooo`04ooooo`03olc<c?nY
ZJWo000000;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00006ooooo`04o`00
0?ooooooooooo`0000Gooooo00Co0000oooooooooooo00001Oooool00ol0003oooooooooo`04oooo
o`04o`000?ooooooooooo`0000Gooooo1_l000001Om4A4Cok^k^oooooooooooo000000Gooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool00006ooooo`06o`000?oooooooooooeEE
EOlQ8B7oV9RH1_ooool00ol0003oooooooooo`04ooooo`05o`000?ooooooooooo`000?o^k^h01?oo
ool01?l0003oooooooooool00005ooooo`09o`000?oooooooooooooooolQ8B7o^[Zjooooooo<c<co
A4A400cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`04o`000?oooooo
ooooo`0000Cooooo00Gok^k^o`000?ooooooooooo`000002ooooo`03o`000?oooooooooo00cooooo
00?oc<c<ojVYZOl000000_ooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`0000Go
oooo00?o0000ooooooooool01_ooool01Oo<c<coQhN7odA4A?l0003oZJVY00;ooooo00?o0000oooo
ooooool01Oooool01?l0003oooooooooool00006ooooo`04o`000?ooooooooooo`0000Gooooo00Co
0000oooooooooooo00001?ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`00
00[ooooo00So0000oooooooooooo410@omgMgOoooooogMgMoa0@40;ooooo00Co0000oooooooooooo
00001_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo00?ooooo00Co0000oooo
oooooooo00001_ooool01?l0003oooooooooool00005ooooo`03o`000?oooooooooo00Cooooo0002
ooooo`030?h];`3o<S80oc8d00P0oc<d00X0oc8b0?lc=03lYJT0o?oj0?ooo`3oo_l0o?;]0?lc=03n
;Bl0oc8b0P3n=3802@3o<c@0oc8d0?ld=P3n=C@0oc8`0?lc=03o<3L0mBX/0?Va[@020?coo`050?kn
o@3on_l0o^o_0?aHE03m:b@0103o<c@01@3o<S00oC8e0?lc=03n:bX0oc<d0080oooo00D0ooko0?co
o`3nmOT0o<K70?_<b`020?G=bP030?c?d03jdLh0niVG00H0oc<d00D0oc8b0?he=03o<S@0oc<d0?lb
=0020?hd<P80oc<d2oooool00ol0003oooooooooo`05ooooo`05o`000?ooooooooooo`000?nHV9P0
1?ooool01_nHV9So0000oooooooooooo0000oiRHV0?ooooo00GoV9RHo`000?ooooooooooo`000005
ooooo`05o`000?ooooooooooo`000?nj^[X00oooool00ol0003oooooooooo`02ooooo`03o`000?nj
^[[ooooo00;ooooo00?o0000omgMgOooool00_ooool01Ol0003oooooooooool0003oV9RH00Cooooo
00KoV9RHo`000?ooooooooooo`000?nj^[X3ooooo`05onk^k_l0003oooooooooool000001Oooool0
0ol0003oV9RHooooo`03ooooo`05oiRHV?l0003oooooooooool000001Oooool00ol0003ooooooooo
o`02ooooo`03onk^k_mgMgOoEEEE00;ooooo00?o0000ojVYZOooool00_ooool01Oo^k^ko0000oooo
oooooooo000000;ooooo00Go0000oooooooooooo0000oiRHV004ooooo`06oiRHV?l0003ooooooooo
ool0003ok^k^1?ooool01Ol0003oooooooooool0003oV9RH00Cooooo00KoV9RHo`000?oooooooooo
o`000?nHV9P3ooooo`06oiRHV?l0003oooooooooool0003oZJVY0oooool01_o^k^ko0000oooooooo
oooogMgMo`0000?ooooo00?o0000onk^k_ooool02_ooool00ol0003oooooooooo`05ooooo`03o`00
0?nHV9Sooooo00?ooooo00KoV9RHo`000?ooooooooooo`000?nHV9P3ooooo`05ojVYZOl0003ooooo
ooooool000000_ooool00ol0003oV9RHooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00oooool01Ol0003oooooooooool0003o^[Zj00?ooooo00Kok^k^o`000?oooooooooo
o`000?nHV9P3ooooo`03ojVYZOl0003ooooo00Cooooo00Oo^[ZjofIVI_l@413o410@ofIVI_nHV9So
k^k^00?ooooo00?o0000oiRHV?ooool00oooool00ol0003oooooo`000002ooooo`03o`000?nHV9So
oooo00?ooooo00KoV9RHo`000?ooooooooooo`000?nj^[X3ooooo`05onk^k_l0003oooooooooool0
00001?ooool01?l0003oooooooooool00003ooooo`05o`000?ooooooooooo`000?nHV9P01?ooool0
0ol0003oooooooooo`02ooooo`04o`000?oooooo^[Zjob4Q8@?ooooo00Co8B4QokZj^_oooooo0000
0_ooool00ol0003oV9RHooooo`03ooooo`05oiRHV?l0003oooooooooool000001?ooool00ol0003o
ZJVYooooo`02ooooo`06onk^k_l0003oooooooooool0003oV9RH1?ooool01_nHV9So0000oooooooo
oooo0000oiRHV0?ooooo00?oZJVYo`000?ooool01Oooool000;ooooo00<0oRd_0?lb<P3o<S@0203o
<c@02P3o<S80oc<d0?bUZ@3looX0oooo0?kno`3ll^d0oc<d0?h];`3o<S820?hd<P0A0?lc=03o<S@0
oc@f0?he=03o<S00oc<d0?lT:P3gGV00o?C`0?ojo`3iool0o_Wh0??ooP3jX9d0o2HT0?Xa=P3o<SL0
0P3o<c@01P3m>3@0oc8`0?db=@3o<c@0oR/Z0?lc=080oooo00<0ookn0?conP3l`l<0103o<c@20?lb
<P@0oc<d00X0oc8`0?lc=03m>3@0oc0a0?he=03o<S@0oc<d0?hb=@3n=380oc8b0P3o<c@;ooooo`03
o`000?oooooooooo00Gooooo00Ko0000ooooooooooooV9RHo`000?nHV9P2ooooo`03oiRHV?l0003o
V9RH00;ooooo0_l000001Onj^[[ooooooiRHV?l0003oV9RH00;ooooo00?o0000oiRHV?ooool00_oo
ool01onHV9So0000oooooooooooo0000ob4Q8OoMgMd00_ooool00ol0003oooooooooo`02ooooo`0;
o`000?lQ8B7o^[Zjoooooon7QhOo0000ob4Q8OoMgMgoooooohN7Qom4A4@00_ooool00onHV9So0000
oiRHV002ooooo`03oiRHV?l0003oV9RH00;ooooo0_l000001OnYZJWoooooonk^k_mEEEGoMgMg00;o
oooo00?o0000ooooooooool00oooool00onHV9So0000oiRHV002ooooo`03oiRHV?l0003oV9RH00;o
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03oc8b<_oooooooooo00;o
000000GoZJVYooooooo^k^koEEEEogMgM`02ooooo`04o`000?ooooooooooo`0000;ooooo00?oV9RH
o`000?nHV9P00_ooool00onHV9So0000oiRHV002ooooo`03o`000?nHV9Sooooo00;ooooo00OoV9RH
o`000?oooooooooooiRHV?l0003oV9RH00;ooooo00?oV9RHo`000?nHV9P00_ooool2o`000005okZj
^_ooooooV9RHo`000?nHV9P00_ooool2o`000005ojVYZOooooook^k^oeEEEOmgMgL00_ooool00on7
QhOoEEEEooooo`02ooooo`03oeEEEOnHV9Sooooo00[ooooo00?o0000ooooooooool01Oooool00onH
V9So0000oiRHV002ooooo`03oiRHV?l0003oV9RH00;ooooo00GoV9RHo`000?nHV9SooooookZj^P02
o`0000;ooooo00Ko0000ooooooooooooV9RHo`000?nHV9P2ooooo`03oiRHV?l0003ooooo00?ooooo
00?o0000oiRHV?ooool00_ooool01?nHV9So0000ooooooooool2o`000005ojVYZOooooook^k^oeEE
EOmgMgL00_ooool01OnHV9So0000oiRHV?oooooo^[Zj00;o00001?ooool01?mVIVKo8B4QoiRHV?oM
gMd7ooooo`03oiRHV?l0003oV9RH00;ooooo00CoV9RHo`000?oooooo00000_ooool00onHV9So0000
oiRHV002ooooo`03oiRHV?l0003oV9RH00;ooooo0_l000001OnYZJWoooooonk^k_mEEEGoMgMg00;o
oooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00003ooooo`06o`000?oooooooooo
oiRHV?l0003oV9RH0_ooool00onHV9So0000ooooo`03ooooo`04o`000?ooooooEEEEoiRHV0?ooooo
00CoV9RHoeEEEOoooooo00000_ooool00onHV9So0000oiRHV002ooooo`03oiRHV?l0003oV9RH00;o
oooo00?o0000ooooooooool00_ooool2o`000005ojVYZOooooook^k^oeEEEOmgMgL00_ooool00onH
V9So0000oiRHV002ooooo`03oiRHV?l0003oV9RH00;ooooo00GoV9RHo`000?nHV9SooooookZj^P02
o`0000Kooooo0002ooooo`030?h];`3o<S80oc8d00P0oc<d00X0oc8b0?lc=03lYJT0o?oj0?ooo`3o
o_l0o?;]0?lc=03n;Bl0oc8b0P3n=3804@3o<c@0oc8d0?ld=P3n=C@0oc8b0?lc=03e:R`0nK6]0?co
o`3oo_h0o_ko0?ooo`3mj>H0oDA;0?h[:P3o<SL0oc8b0080oc<d00H0oc0a0?lb<03m<SD0oc<d0?h[
:P3o<c@20?ooo`050?ono`3on_l0o<?30?lT:P3o;3@00P3o<c@0103o;3@0oS<]0?h];`3o<S@20?lc
=0080?he=03o<c@0oc<d0?lb<03n=C@0oc8d0?lc=03o<S@20?hd<P80oc<d2oooool00ol0003ooooo
ooooo`04ooooo`03oiRHV?l0003ooooo00;ooooo00?oV9RHo`000?l000000_l000001onHV9Sooooo
oooooooooooo0000ojVYZOl@41000_l000001OnHV9SoooooooooooooooooV9RH00Go000000KoV9RH
oooooooooooo0000ojVYZOl@4105o`0000;ooooo00Oo0000ojVYZOl@413o0000oa0@4?nHV9SoMgMg
00;o000000?o<S8bolc<c?ooool00_ooool00onHV9So0000o`000002o`00000:oiRHV?oooooooooo
ooooool0003o^[Zjob4Q8Ol0003o410@ogMgM`;ooooo1?l00004ooooo`03oiRHV?l0003o000000;o
000000?oV9RHooooooooool01?l00003ooooo`03o`000?oooooooooo00Cooooo00Wo<S8boooooooo
oooo0000ojVYZOlQ8B7o0000oa0@4?nHV9P00oooool01?l0003oooooooooool00003ooooo`03oiRH
V?l0003o000000;o000000GoV9RHoooooooooooooooooiRHV005o`000005oiRHV?oooooooooooooo
oonHV9P01?l000001onHV9Sooooooooooooooooo0000ojVYZOl@41000_l000002_nHV9Sooooooooo
oooooooo0000ojVYZOlQ8B7o0000oa0@4?nHV9P3ooooo`03odA4A?nYZJWooooo00;ooooo00?oZJVY
odA4A?ooool02_ooool00ol0003oooooooooo`06ooooo`03oiRHV?l0003o000000;o000000?oV9RH
ooooooooool00_ooool01_nHV9So0000o`000?l@413oV9RHo`0000;ooooo00Go0000oooooooooooo
oooooiRHV004o`000003oiRHV?oooooooooo00;ooooo00?oV9RHo`000?l000000ol000002OnHV9So
ooooooooool0003o^[Zjob4Q8Ol0003o410@ogMgM`04ooooo`06oiRHV?l0003o0000oa0@4?nHV9So
00001?ooool00ol0003ok^k^ooooo`05ooooo`05o`000?oooooooooooooooonHV9P01?l000000onH
V9Soooooo`000003ooooo`03oiRHV?l0003o000000;o000000[oV9RHooooooooooooooooo`000?nj
^[[o8B4Qo`000?l@413oMgMg0_ooool4o`0000;ooooo00?o0000ooooool000000ol000000ooooooo
0000ooooo`02ooooo`03oiRHV?l0003o000000;o000000?oV9RHooooooooool00_ooool01?l0003o
ooooo`000?o^k^h3ooooo`04onk^k_l0003oooooo`0000?ooooo00?oV9RHo`000?l000000_l00000
0onHV9Soooooooooo`04o`0000;ooooo00Ko0000ojVYZOlQ8B7o0000oa0@4?nHV9P4ooooo`03oiRH
V?l0003o000000;o000000?oV9RHooooooooool00_ooool01_nHV9So0000o`000?l@413oV9RHo`00
00Kooooo0002ooooo`030?h];`3o<S80oc8d00P0oc<d00X0oc8b0?lc=03lYJT0o?oj0?ooo`3no_l0
o?;]0?lc=03n;Bl0oc8b0P3n=3804@3o<c@0oc8d0?ld=P3o=3H0oSDd0?d[903nCU80o>7N0?koo`3o
n_l0oooo0?Woo`3jTXd0oRd_0?l`<@3o<S80oc8`0080oc<d00H0oc0g0?lb<03m<SD0oc<d0?h[:P3o
<c@20?ooo`050?ono`3oo_/0mL;30?d[903n<bd02`3o<c@01`3n=380oSDd0?lb=03o<c@0oS8e0?hd
<P3o<S800P3o<c@;ooooo`03o`000?oooooooooo00?ooooo00?oV9RHo`000?nHV9P08oooool00ol0
003oooooooooo`0Rooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`04ooooo`04oc8b<_ooooooooooo`0000_ooooo00?o0000ooooooooool09_ooool0
0ol0003oooooooooo`0Hooooo`03o`000?oooooooooo03kooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`0?ooooo`03o`000?nHV9SoA4A400Gooooo00?oA4A4oiRHV?l000003?ooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool01?ooool0
00;ooooo00<0oRd_0?lb<P3o<S@0203o<c@02P3o<S80oc<d0?bUZ@3no_d0oooo0?ono`3ll^d0oc<d
0?h];`3o<S@20?he=00I0?lc=03o<S@0oc@f0?he=03o<c@0oB/T0?QoOP3no?/0nOoo0?onn`3iool0
o^_/0?dk>`3o<c@0oC4b0?ld=P3m<C80oc8b0?lc=03o<S80oc8`0?hb=@3o<c@0oR/Z0?lc=0020?oo
o`80ooko00L0o<?30?`V903n=380oc8b0?`d=P3o<S00o3@f00P0oc<d00@0oSDd0?lb=03o<c@0oc8d
0P3n=3820?lc=0_ooooo00?o0000ooooooooool00_ooool00onHV9So0000oiRHV00Tooooo`03o`00
0?oooooooooo02;ooooo00?o0000ooooooooool03Oooool00ol0003oc<c<ooooo`03ooooo`03o`00
0?oooooooooo00;ooooo00?ogMgMogMgMomEEED00_ooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo02Kooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0nooooo`03o`00
0?oooooooooo00;ooooo00?o0000oiRHV?ooool01?ooool00onHV9So0000ooooo`0Oooooo`03o`00
0?oooooooooo00Gooooo00?o0000olc<c?ooool03oooool00ol0003oA4A4oiRHV005ooooo`03oiRH
V?m4A4Co000000cooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0Fooooo`03o`00
0?oooooooooo00Cooooo0002ooooo`030?h];`3o<S80oc8d00P0oc<d00X0oc8b0?lc=03lYJT0o_km
0?ooo`3no_l0o?;]0?lc=03n;Bl0oc8d0P3n=C@0303o<c@0oc8d0?ld=P3n=C@0oS@b0?h[:P3jZjX0
ookk0?coo`3oo_/0o?oo0?F/[080o30a00/0oc<d0?ld=P3o=3H0oc<d0?ld=P3o<c@0oc8`0?hb=@3o
<c@0oR/Z0?lc=0020?ooo`80ooko00L0o<?30?`V903n=380oc8d0?`d=P3o<S00o3@f00P0oc<d00H0
oSDd0?lb=03o<c@0oS8e0?hd<P3o<S820?lc=0_ooooo1_l000000onHV9Soooooooooo`1Hooooo`03
ohN7Qol0003o000000?ooooo1_l000001Olb<S;ok^k^oooooooooooo000000Sooooo00Co0000oooo
oooooooo0000:?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo01Sooooo00?o0000
ooooooooool08oooool00ol0003oooooooooo`02ooooo`03oiRHV?l0003o000000Go000000?oV9RH
ooooooooool02?ooool00ol0003oooooooooo`0Hooooo`04o`000?ooooooooooohN7Q`;o000000?o
ooooo`000?ooool03?ooool2o`0000Kooooo00?ok^k^o`000?l000004Oooool00ol0003ooooooooo
o`0Fooooo`03o`000?oooooooooo00Cooooo0002ooooo`030?h];`3o<S80oc8d00P0oc<d00X0oc8b
0?lc=03lYJT0o_km0?ooo`3oo_l0o?;]0?lc=03n;Bl0oc8d0P3n=C@0403o<c@0oc8d0?ld=P3n=C@0
oc<d0?dh=03jdLh0o_on0?cloP3looX0o_ck0?M^K@3e:R`0oS8e0?ld=P3o<S820?lc=0070?lb<P3o
=3H0oc8`0?hb=@3o<c@0oR/Z0?lc=0020?ooo`80ooko00L0o<?30?`V903n=380oc8b0?`d=P3o<S00
o3@f00P0oc<d00@0oSDd0?lb=03o<c@0oc8d0P3n=3820?lc=?ooooooT_ooool000;ooooo00<0oRd_
0?lb<P3o<S@0203o<c@02P3o<S80oc<d0?bUZ@3no_d0oooo0?kno`3ll^d0oc<d0?h];`3o<S@20?he
=00=0?lc=03o<S@0oc@f0?hd<P3o<c@0o4Q40?cbk@3no_l0o_oo0?WonP3mi><0oD530?``<@020?ld
=P030?da<P3o<c@0oc@f0080oc<d00D0oc8`0?hb=@3o<c@0oR/Z0?lc=0020?ooo`80ooko00L0o<?3
0?`V903n=380oc8d0?`d=P3o<S00o3@f00P0oc<d00H0oSDd0?lb=03o<c@0oS8e0?hd<P3o<S820?lc
=?ooooooT_ooool000;ooooo00<0oRd_0?lb<P3o<S@0203o<c@02P3o<S80oc<d0?bUZ@3no_d0oooo
0?ono`3ll^d0oc<d0?h];`3o<S@20?he=00;0?lc=03o<S@0oc@f0?he=03o<c@0oTiB0?Knm03on_l0
o?oo0?Woo`3ldm800P3o<3420?lb=00:0?lc=03o=3H0oc@f0?ld=P3o<c@0oc8`0?hb=@3o<c@0oR/Z
0?lc=080oooo0P3oo_l01`3l`l<0o2HT0?hd<P3o<S80o3@f0?lb<03l=3H0203o<c@0103n=C@0oc8d
0?lc=03o<S@20?hd<P80oc<doooooonBooooo`000_ooool00`3n;Bl0oc8b0?lb=0080?lc=00:0?lb
<P3o<c@0o:FY0?kno@3oool0o_ko0?cbk@3o<c@0oRd_0?lb=080oSDd00`0oc<d0?lb=03o=3H0oSDd
0?lc=03nCU80o?;]0?omo@3jn_d0o?oj0?CDd`3n;Bl20?l`<@0;0?lb=03o<c@0oc8b0?lc=03o=3H0
oc<d0?lb<03n<SD0oc<d0?h[:P3o<c@00P3oool20?ono`070?c3``3o<c@0oS@b0?lb=03l=3H0oc8`
0?`d=P080?lc=0060?he=03o<S@0oc<d0?hb=@3n=380oc8b0P3o<cCooooooi;ooooo0002ooooo`03
0?h];`3o<S80oc8d00P0oc<d00X0oc8b0?lc=03lYJT0o_km0?ooo`3oo_l0o?;]0?lc=03n;Bl0oc8d
0P3n=C@06@3o<c@0oc8d0?ld=P3n=C@0oc<d0?Dk?03lg]`0o_km0?kno`3oo_/0mMkH0?Tf=P3o<340
oc8d0?lc=03o<S@0oC4b0?lb<P3o<c@0oSDd0?lb<03n<SD0oc<d0?h[:P3o<c@00P3oool20?ono`07
0?c3``3o<c@0oS@b0?lb<P3l=3H0oc8`0?`d=P080?lc=0040?he=03o<S@0oc<d0?lb=080oS@b0P3o
<cCooooooi;ooooo0002ooooo`030?h];`3o<S80oc8d00P0oc<d00X0oc8b0?lc=03lYJT0o_km0?oo
o`3no_l0o?;]0?lc=03n;Bl0oc8d0P3n=C@0403o<c@0oc8d0?ld=P3n=C@0oc<d0?Xa=P3e`/<0o_km
0?oloP3no?/0mnkT0?]?C03n;Bl0oc8d0?lc=03o<S830?ld=P060?he=03o<S00oS8e0?lc=03n:bX0
oc<d0P3oool20?ono`030?c3``3o<c@0oS@b0080oc<d00<0oc8`0?`d=P3o<c@01`3o<c@01P3n=C@0
oc8d0?lc=03n<SD0oS@b0?lb<P80oc<doooooonBooooo`000_ooool00`3n;Bl0oc8b0?lb=0080?lc
=0040?lb<P3o<c@0o:FY0?kno@80ooko00@0o?;]0?lc=03n;Bl0oc8b0P3n=3801`3o<c@0oc8d0?ld
=P3n=C@0nS4f0?h[:P3kVIL00P3looX0403on_l0ooko0?^7R03l9R@0oS<]0?Tf=P3o<SL0oc0a0?lb
=`3o<3L0oc<d0?hc;@3o<SL0oc8d0?h[:P3o<c@20?ooo`050?ono`3on_l0mL;30?lc=03o<3L00`3o
<c@00`3n<bd0oc<d0?lc=0050?lc=0050?hd<P3n=C@0oc8d0?lc=03o<S@00P3n=3820?lc=?oooooo
T_ooool000;ooooo00<0oRd_0?lb<P3o<S@0203o<c@02P3o<S80oc<d0?^SX`3oool0ooko0?oloP3l
l^d0oc<d0?h];`3o<S820?hd<P0I0?lc=03o<S@0oc@f0?he=03o=3H0oB/T0?iJG03ll^d0ooko0?on
n`3iooX0o^_/0?MNH03l9R@0oB/T0?dh=03n=380oCPd0?`c<@3o<c@0oc8`0?ld=P3o<S@0oR/Z0?lc
=0020?ooo`030?ono`3no_d0mLW300h0oc<d00H0oSDd0?lb=03o<c@0oS8e0?hd<P3o<S820?lc=0_o
oooo1Ol00004ooooo`;o00001oooool2o`0000?ooooo0ol00003ooooo`;o00001?ooool4o`0000?o
oooo0_l00006ooooo`;o00001?ooool5o`0000Cooooo0_l00004ooooo`;o00000_ooool8o`0000;o
oooo0_l00004ooooo`Go00001?ooool2o`0000Oooooo0_l00003ooooo`;o00001?ooool5o`0000Co
oooo0_l00004ooooo`;o00000oooool4o`000005ooooool0003o0000o`000?ooool00_l00004oooo
o`;o00001?ooool3o`000003ooooool0003o000000Cooooo1Ol00004ooooo`;o0000d?ooool000;o
oooo00<0oRd_0?lb<P3o<S@0203o<c@02P3o<S80oc<d0?bUZ@3no_d0ooko0?oloP3ll^d0oc<d0?h]
;`3o<S820?hd<P040?lc=03o<S@0oc@f0?he=080oS<]00T0oRd_0?_9aP3cooh0ookk0?Knm03on_l0
o^_/0?YgM`3n;Bl00P3l9R@0203n:bX0o30a0?hb=@3n=380oc@f0?lb=03n:bX0oc<d0`3oool00`3o
n_l0nk^j0?lc=0040?lc=0030?h[:P3o<SD0oc<d00L0oc<d00<0oc8d0?lc=03o<S@00P3n=3820?lc
=0[ooooo0_l00003ooooo`;o00000oooool2o`0000Oooooo0_l00003ooooo`?o00000oooool2o`00
00?ooooo0_l00002ooooo`;o00000_ooool2o`0000Gooooo0ol00003ooooo`;o00000oooool2o`00
00?ooooo0_l00004ooooo`;o00000_ooool3o`0000Oooooo0_l00003ooooo`;o00000oooool2o`00
00?ooooo0_l00007ooooo`;o00000oooool2o`0000?ooooo0_l00003ooooo`;o00001?ooool2o`00
00;ooooo0_l00003ooooo`;o00000oooool3o`0000;ooooo0_l00004ooooo`;o00000oooool2o`00
00;ooooo0ol00003ooooo`;o00000oooool2o`0000?ooooo0_l0003@ooooo`000_ooool00`3n;Bl0
oc8b0?lb=0080?lc=00:0?hd<P3o<c@0o:FY0?kno@3oool0ooko0?cbk@3o<c@0oRd_0?lb<P80oS@b
00X0oc<d0?lb=03o=3H0oSDd0?lb<P3o<S@0o2HT0?QUI`3no?/0oo[o0P3looX03@3oo?h0oogm0?c?
d03iOH40mf1M0?iJG03nCU80oc<d0?lb<03o=3H0oc8d0?h[:P3o<c@00`3oool00`3oo_/0nlc;0?lc
=00>0?lc=0050?lb=03o<c@0oS8e0?hd<P3o<S800P3o<c@:ooooo`;o00000oooool2o`0000cooooo
0_l00003ooooo`03o`000?oooooo000000?ooooo0_l00002ooooo`;o00001?ooool2o`000003oooo
ool0003o000000Gooooo0_l00003ooooo`;o00001Oooool2o`0000;ooooo0_l00004ooooo`;o0000
0oooool2o`0000Oooooo0_l00002ooooo`;o00001Oooool2o`0000;ooooo0_l00007ooooo`;o0000
0oooool2o`0000;ooooo0_l00005ooooo`;o00000oooool2o`0000;ooooo0_l00003ooooo`;o0000
1?ooool2o`0000;ooooo0_l00004ooooo`;o00000_ooool2o`0000Cooooo0_l00002ooooo`;o0000
1Oooool2o`0000;ooooo0_l0003@ooooo`000_ooool00`3n;Bl0oc8b0?lb=0080?lc=00:0?lb<P3o
<c@0o:FY0?conP3oool0ooko0?cbk@3o<c@0oRd_0?lb<P80oS@b00`0oc<d0?lb=03o=3H0oSDd0?db
=@3o=3H0oS<]0?DZ;03iWZ00oO[f0?conP3cooh20?onn`0;0?ono`3oo_/0m_kd0?gjmP3j^;D0oc<d
0?lb<03o=3H0oc<d0?h[:P3o<c@00`3oool00`3oo?h0oooo0?ooo`050?ooo`030?gjmP3o<S80oc<d
00H0oc<d00<0oc8d0?lc=03o<S@00P3n=3820?lc=0[ooooo0_l00003ooooo`;o00003?ooool2o`00
00;ooooo0_l000000ooooooo0000o`000002ooooo`;o00000_ooool2o`0000Cooooo0_l000000ooo
oooo0000o`000004ooooo`;o00001?ooool2o`0000Wooooo0_l00004ooooo`;o00001?ooool2o`00
00Kooooo0_l00002ooooo`;o00002_ooool2o`0000Gooooo0_l00004ooooo`;o00000_ooool2o`00
00_ooooo1?l00004ooooo`;o00001?ooool2o`0000;ooooo0_l00004ooooo`;o00000_ooool2o`00
00Cooooo0_l00002ooooo`;o00002Oooool2o`000=3ooooo0002ooooo`030?h];`3o<S80oc8d00P0
oc<d00@0oc8`0?lc=03lYJT0o?oj0P3no_l0103ll^d0oc<d0?h];`3o<S820?hd<P0I0?lc=03o<S@0
oc@f0?he=03m<C80oS<]0?dh=03n<bd0m38d0?Z[ZP3mn_H0oocn0?ono`3mn_H0loon0?Woo`3on_l0
ookk0?Zc/`3o<S@0oS<]0?hb=@3o<c@0oR/Z0?lc=0030?ooo`090?onn`3iooX0ookk0?Woo`3lool0
ookk0?ooo`3nool0loon00X0oc<d00<0oS8e0?hd<P3o<S800P3o<c@?ooooo`;o00003?ooool2o`00
00;ooooo0_l000000ooooooo0000o`000002ooooo`;o00000_ooool2o`0000Oooooo0_l00003oooo
o`?o00001?ooool2o`0000Wooooo0_l00004ooooo`;o00001Oooool2o`0000Gooooo0_l00002oooo
o`;o00002_ooool9o`0000Cooooo0_l00002ooooo`;o00003?ooool2o`0000Gooooo0ol00003oooo
o`;o00000_ooool2o`0000Cooooo0_l00002ooooo`;o00001?ooool2o`0000;ooooo0_l00009oooo
o`;o0000d?ooool000;ooooo00<0oRd_0?lb<P3o<S@0203o<c@02P3o<S80oc<d0?bUZ@3no_d0o_ko
0?ono`3ll^d0oc<d0?h];`3o<S820?hd<P030?lc=03o<S@0oc@f0080oc<d01@0oS<]0?l`<@3m>3@0
oR/Z0?hT<@3jTXd0o^o_0??ooP3oo_/0o?oj0?WonP3no_d0oocn0?Zc/`3o<c@0oc8`0?hb=@3o<c@0
oR/Z0?lc=0<0oooo0P3oo_/60?ooo`030?coo`3o<c@0oc<d00D0oc<d00@0oSDd0?lc=03o<c@0oc8d
0P3n=3820?lc=0oooooo0_l0000<ooooo`;o00000_ooool01Ol0003ooooooooooooooooo000000;o
oooo0_l00002ooooo`;o00001oooool3o`0000;ooooo0_l00005ooooo`Wo00000_ooool2o`0000Co
oooo0_l00005ooooo`;o00001Oooool2o`0000;ooooo2Ol00003ooooo`;o00001Oooool2o`0000Co
oooo0_l00002ooooo`Wo00001Oooool2o`0000Oooooo1_l00002ooooo`;o00001?ooool2o`0000;o
oooo0_l00004ooooo`;o00000_ooool9o`0000;ooooo0_l0003@ooooo`000_ooool00`3n;Bl0oc8b
0?lb=00:0?lc=0080?bUZ@3looX0oooo0?onn`3ll^d0oc<d0?h];`3o<S820?hd<P030?lc=03o<S@0
oc@f00<0oc<d00d0oC8e0?lb=@3o=3H0oR/Z0?`V903lF5@0mZBP0?gTh`3lool0nOoo0?cloP3oo_h0
m[bm0080oc<d00@0oS8e0?lc=03n;Bl0oc<d0`3oool01P3no_d0ookk0?WonP3no_d0o_ck0?onn`80
o?oj00<0nOoj0?lc=03o<c@01@3o<c@01P3n=C@0oc<d0?lc=03n<SD0oS@b0?lb<P80oc<d3oooool2
o`0000cooooo0_l000000ooooooo0000o`000003ooooo`;o000000?oooooo`000?l000000_ooool2
o`0000Oooooo1_l00006ooooo`;o00001Oooool2o`0000;ooooo0_l00004ooooo`;o00001_ooool2
o`0000Cooooo0_l00002ooooo`;o00001Oooool2o`0000Cooooo0_l00003ooooo`;o00001Oooool2
o`0000;ooooo0_l00005ooooo`;o00001?ooool4o`0000[ooooo0_l00002ooooo`;o00001?ooool2
o`0000;ooooo0_l00004ooooo`;o00000_ooool2o`0000Gooooo0_l00002ooooo`;o0000d?ooool0
00;ooooo00<0oRd_0?lb<P3o<S@0203o<c@01`3n=C@0oc<d0?M^K@3fY:00nY:=0?^IU`3jTXd02@3o
<c@00`3o=3H0oc<d0?lc=0020?ld=P0;0?lc=03m<C80o30a0?`V903eBT`0nWMg0?^7R03kVIL0nK6]
0?QoOP3n=3800`3o<c@0103o;3@0oc<d0?^7R03jX9d:0?^IU`030?lb=03o<c@0oc<d00L0oc<d00<0
oc8d0?hd<P3n=3800P3o<c@?ooooo`;o00003?ooool2o`000003ooooool0003o000000?ooooo0_l0
00000ooooooo0000o`000002ooooo`;o00001?ooool2o`000004ooooool0003o0000ooooo`?o0000
1_ooool2o`0000Gooooo0_l00002ooooo`;o00001?ooool2o`0000Oooooo0_l00003ooooo`;o0000
0_ooool2o`0000Gooooo0_l00004ooooo`;o00000oooool2o`0000Gooooo0_l00002ooooo`;o0000
1Oooool2o`0000?ooooo0_l00002ooooo`;o00001?ooool2o`0000?ooooo0_l00002ooooo`;o0000
1?ooool2o`0000;ooooo0_l00004ooooo`;o00000_ooool2o`0000Gooooo0_l00002ooooo`?o0000
coooool000;ooooo00<0oRd_0?lb<P3o<S@02P3o<c@0103n;Bl0ob@Z0?lT:P3n:bX20?h];``0oc<d
00D0oc@f0?lc=03o<S80oC4b0?hc;@0:0?lc=0050?l`<@3n;Bl0o30a0?DZ;03n9340203n:bX20?l/
=0@0oc<d00P0oc0a0?lc=03o<c@0oc8d0?lc=03n<SD0oS@b0?lb<P80oc<d3oooool2o`0000cooooo
0_l000000ooooooo0000ooooo`04ooooo`04o`000?oooooo0000o`0000?ooooo0_l00002ooooo`;o
00000_ooool2o`0000;ooooo0_l00007ooooo`;o00000oooool2o`0000?ooooo0ol00002ooooo`?o
00001oooool3o`0000;ooooo0_l00003ooooo`;o00000oooool2o`0000Kooooo0_l000000ooooooo
0000o`000006ooooo`;o00000oooool2o`0000?ooooo0_l00004ooooo`;o00000_ooool2o`0000Co
oooo0_l00003ooooo`;o00000_ooool3o`0000;ooooo0ol00003ooooo`;o00000_ooool3o`0000?o
oooo0_l00003ooooo`;o00000oooool5o`000<gooooo0002ooooo`030?h];`3o<S80oc8d02D0oc<d
00<0oc0a0?lc=03o<c@01@3o<c@30?hc;@P0oc8b00<0ob`d0?lc=03o<c@01P3o<c@00`3o<S@0oc<d
0?lb=0020?hd<P80oc<d3oooool2o`0000cooooo1?l00005ooooo`Co00001?ooool4o`0000?ooooo
0_l00003ooooo`;o00001oooool5o`0000Cooooo0_l000000ooooooo0000o`000002o`0000Cooooo
1ol00002ooooo`;o00001?ooool5o`0000Oooooo0_l000000ooooooo0000o`000006ooooo`;o0000
1?ooool5o`0000Cooooo0_l00004ooooo`;o00001?ooool5o`0000?ooooo0_l000000ooooooo0000
o`000002o`0000Gooooo0ol000000ooooooo0000o`000004ooooo`Go00001?ooool2o`000003oooo
ool0003o00000<gooooo0002ooooo`030?h];`3o<S80oc8d00P0oc<d00<0oS@k0?h]>`3o<3L05`3o
<c@00`3o=3H0oc0g0?lc=0090?lc=0030?hb=@3l=3H0oS8e00<0oS8e3`3o<c@00`3n<SD0oS@b0?lb
<P020?lc=0oooooo0_l0000<ooooo`Co00001Oooool4o`0000_ooooo0_l00004ooooo`;o0000=Ooo
ool2o`000003ooooool0003o000000Kooooo0_l0000aooooo`;o0000goooool000;ooooo00<0oRd_
0?lb<P3o<S@0<P3o<c@30?lb<PT0oc<d00H0oSDd0?lc=03o<c@0oc8d0?lc=03o<S@20?hd<P80oc<d
3oooool2o`0000cooooo0ol00007ooooo`?o00002oooool2o`0000Gooooo0_l0000Rooooo`;o0000
4Oooool3o`0000Oooooo0_l0000aooooo`;o0000goooool000;ooooo00<0oRd_0?lb<P3o<S@0;`3o
<c@00`3n=380oc<d0?lc=00<0?lc=0080?lb=03o<340oSDd0?lb=03o<c@0oS8e0?hd<P3o<S820?lc
=0oooooo0_l0000<ooooo`?o00001oooool3o`0000_ooooo0_l00006ooooo`;o00008Oooool2o`00
017ooooo0ol00007ooooo`;o0000<Oooool2o`000=oooooo0002ooooo`030?h];`3o<S80oc8d02/0
oc<d00<0o30a0?lc=03o<c@03@3o<c@00`3n=380oc<d0?lc=0020?lc=0040?he=03o<S@0oc<d0?lb
=080oS@b0P3o<cCooooooi;ooooo0002ooooo`030?h];`3o<S80oc8d00P0oc<d00@0oc8e0?hd<P3n
<bd0oS@b0P3o<S8A0?lc=0050?ld=P3n=380oc@f0?lb=03o<3403`3o<c@50?ld=P030?l`=`3l=3H0
oc<d00D0oc<d00H0oSDd0?lb=03o<c@0oS8e0?hd<P3o<S820?lc=?ooooooT_ooool000;ooooo00<0
oRd_0?hc;@3l=3H0@03o<c@0103n=C@0oS@b0?he=03n=3820?lb<P80oc<doooooonBooooo`000_oo
ool00`3n;Bl0oS@b0?he=0110?lc=080oS@b0`3o<S820?lc=?ooooooT_ooool000;ooooo00<0oRd_
0?lb<03o<c@0@03o<c@01P3o=3H0oc<d0?lb<P3o<S80oc<d0?lb<P80oc<doooooonBooooo`000_oo
ool00`3n;Bl0oc8`0?ld=P100?lb<P060?lc=03o<S@0oc8b0?lb<P3o<c@0oc8b0P3o<cCooooooi;o
oooo0002ooooo`030?h];`3o<c@0oc<d0400oc<d0P3o<S@0103o<340oc8b0?lc=03o<3420?lc=?oo
ooooT_ooool000;ooooo00<0oRd_0?hc;@3o<c@0B03o<cCooooooi;ooooo0002ooooo`030?l`<@3o
<S00oc@f0440oc8d00L0oc<d0?lb<P3n=380oc8b0?hd<P3o<340oc<d0?ooooooT_ooool000;ooooo
B`3o<cCooooooi;ooooo003oooooomoooooo0000\
\>"],
  CellTags->"b:4"],

Cell[CellGroupData[{

Cell["Installation instructions", "Section"],

Cell[TextData[{
  StyleBox["1.",
    FontWeight->"Bold"],
  " Copy ",
  StyleBox["LocalInteractions.jar",
    FontWeight->"Bold"],
  " to the directory returned when you evaluate the following:"
}], "Text"],

Cell[BoxData[
    \($UserBaseDirectory\)], "Input"],

Cell[TextData[{
  StyleBox["2.",
    FontWeight->"Bold"],
  " Copy the ",
  StyleBox["LocalInteractions",
    FontWeight->"Bold"],
  " folder to the directory returned when you evaluate the following:"
}], "Text"],

Cell[BoxData[
    \($UserBaseDirectory <> "\</Applications/\>"\)], "Input"],

Cell[TextData[{
  StyleBox["3. ",
    FontWeight->"Bold"],
  "Select \"Rebuild Help Index\" under the Help menu."
}], "Text"],

Cell[CellGroupData[{

Cell["Initialization cells", "Subsection"],

Cell["\<\
If the above installation was successful, evaluating the cells \
below should work without any errors.\
\>", "Text"],

Cell[BoxData[{
    \(\(<< LocalInteractions`LocalInteractions`;\)\), "\n", 
    \(\(<< LocalInteractions`Graphs`;\)\)}], "Input",
  Background->RGBColor[0.984192, 1, 0.723949]],

Cell[BoxData[
    \(\(?HexGraph\)\)], "Input"],

Cell[BoxData[
    \(\(ShowGraph[\[IndentingNewLine]HexGraph[5, 
          5]\[IndentingNewLine]];\)\)], "Input"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"5.0 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 700}},
WindowSize->{669, 564},
WindowMargins->{{Automatic, 196}, {Automatic, 35}}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "b:4"->{
    Cell[1776, 53, 246, 10, 144, "Title",
      CellTags->"b:4"],
    Cell[2025, 65, 99894, 1616, 89, 55322, 1059, "GraphicsData", 
    "PostScript", "Input",
      Evaluatable->False,
      CellTags->"b:4"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"b:4", 103834, 1756}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 246, 10, 144, "Title",
  CellTags->"b:4"],
Cell[2025, 65, 99894, 1616, 89, 55322, 1059, "GraphicsData", "PostScript", \
"Input",
  Evaluatable->False,
  CellTags->"b:4"],

Cell[CellGroupData[{
Cell[101944, 1685, 44, 0, 69, "Section"],
Cell[101991, 1687, 206, 7, 32, "Text"],
Cell[102200, 1696, 51, 1, 27, "Input"],
Cell[102254, 1699, 213, 7, 32, "Text"],
Cell[102470, 1708, 75, 1, 27, "Input"],
Cell[102548, 1711, 125, 4, 32, "Text"],

Cell[CellGroupData[{
Cell[102698, 1719, 42, 0, 38, "Subsection"],
Cell[102743, 1721, 126, 3, 32, "Text"],
Cell[102872, 1726, 176, 3, 59, "Input"],
Cell[103051, 1731, 46, 1, 27, "Input"],
Cell[103100, 1734, 112, 2, 59, "Input"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

