(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    338506,       7093]*)
(*NotebookOutlinePosition[    592026,      15930]*)
(*  CellTagsIndexPosition[    591937,      15924]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["UpdateNeighborhood", "ObjectName",
  CellTags->"LocalInteractions:42"],

Cell[TextData[{
  "\[Bullet] UpdateNeighborhood[ ",
  StyleBox["model ",
    FontSlant->"Italic"],
  "] gives the update neighborhood of ",
  StyleBox["model ",
    FontSlant->"Italic"],
  "as a ",
  StyleBox["Combinatorica",
    FontSlant->"Italic"],
  " graph."
}], "Usage",
  CellTags->"LocalInteractions:42"],

Cell[CellGroupData[{

Cell["Example", "ExampleSection",
  CellTags->"LocalInteractions:42"],

Cell[BoxData[
    \(\(m = 
        LocalInteractionModel[\[IndentingNewLine]InteractionNeighborhood \
\[Rule] GridGraph[10, 10], \[IndentingNewLine]UpdateNeighborhood \[Rule] 
            MakeSimple[
              GraphPower[GridGraph[10, 10], 
                2]]\[IndentingNewLine]];\)\)], "Input",
  CellLabel->"In[18]:=",
  CellTags->"LocalInteractions:42"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g = UpdateNeighborhood[m]\)], "Input",
  CellLabel->"In[19]:=",
  CellTags->"LocalInteractions:42"],

Cell[BoxData[
    InterpretationBox[\("\[SkeletonIndicator]Graph:<"\[InvisibleSpace]502\
\[InvisibleSpace]", "\[InvisibleSpace]100\[InvisibleSpace]", "\
\[InvisibleSpace]"Undirected"\[InvisibleSpace]">\[SkeletonIndicator]"\),
      SequenceForm[ 
      "\[SkeletonIndicator]Graph:<", 502, ", ", 100, ", ", "Undirected", 
        ">\[SkeletonIndicator]"],
      Editable->False]], "Output",
  CellLabel->"Out[19]=",
  CellTags->"LocalInteractions:42"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(ShowGraph[g];\)\)], "Input",
  CellLabel->"In[20]:=",
  CellTags->"LocalInteractions:42"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0454545 0.909091 0.0454545 0.909091 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 0 0 r
.005 w
[ ] 0 setdash
.04545 .04545 m
.14646 .04545 L
s
.04545 .04545 m
.24747 .04545 L
s
.04545 .04545 m
.04545 .14646 L
s
.04545 .04545 m
.14646 .14646 L
s
.04545 .04545 m
.04545 .24747 L
s
.14646 .04545 m
.24747 .04545 L
s
.14646 .04545 m
.34848 .04545 L
s
.14646 .04545 m
.04545 .14646 L
s
.14646 .04545 m
.14646 .14646 L
s
.14646 .04545 m
.24747 .14646 L
s
.14646 .04545 m
.14646 .24747 L
s
.24747 .04545 m
.34848 .04545 L
s
.24747 .04545 m
.44949 .04545 L
s
.24747 .04545 m
.14646 .14646 L
s
.24747 .04545 m
.24747 .14646 L
s
.24747 .04545 m
.34848 .14646 L
s
.24747 .04545 m
.24747 .24747 L
s
.34848 .04545 m
.44949 .04545 L
s
.34848 .04545 m
.55051 .04545 L
s
.34848 .04545 m
.24747 .14646 L
s
.34848 .04545 m
.34848 .14646 L
s
.34848 .04545 m
.44949 .14646 L
s
.34848 .04545 m
.34848 .24747 L
s
.44949 .04545 m
.55051 .04545 L
s
.44949 .04545 m
.65152 .04545 L
s
.44949 .04545 m
.34848 .14646 L
s
.44949 .04545 m
.44949 .14646 L
s
.44949 .04545 m
.55051 .14646 L
s
.44949 .04545 m
.44949 .24747 L
s
.55051 .04545 m
.65152 .04545 L
s
.55051 .04545 m
.75253 .04545 L
s
.55051 .04545 m
.44949 .14646 L
s
.55051 .04545 m
.55051 .14646 L
s
.55051 .04545 m
.65152 .14646 L
s
.55051 .04545 m
.55051 .24747 L
s
.65152 .04545 m
.75253 .04545 L
s
.65152 .04545 m
.85354 .04545 L
s
.65152 .04545 m
.55051 .14646 L
s
.65152 .04545 m
.65152 .14646 L
s
.65152 .04545 m
.75253 .14646 L
s
.65152 .04545 m
.65152 .24747 L
s
.75253 .04545 m
.85354 .04545 L
s
.75253 .04545 m
.95455 .04545 L
s
.75253 .04545 m
.65152 .14646 L
s
.75253 .04545 m
.75253 .14646 L
s
.75253 .04545 m
.85354 .14646 L
s
.75253 .04545 m
.75253 .24747 L
s
.85354 .04545 m
.95455 .04545 L
s
.85354 .04545 m
.75253 .14646 L
s
.85354 .04545 m
.85354 .14646 L
s
.85354 .04545 m
.95455 .14646 L
s
.85354 .04545 m
.85354 .24747 L
s
.95455 .04545 m
.85354 .14646 L
s
.95455 .04545 m
.95455 .14646 L
s
.95455 .04545 m
.95455 .24747 L
s
.04545 .14646 m
.14646 .14646 L
s
.04545 .14646 m
.24747 .14646 L
s
.04545 .14646 m
.04545 .24747 L
s
.04545 .14646 m
.14646 .24747 L
s
.04545 .14646 m
.04545 .34848 L
s
.14646 .14646 m
.24747 .14646 L
s
.14646 .14646 m
.34848 .14646 L
s
.14646 .14646 m
.04545 .24747 L
s
.14646 .14646 m
.14646 .24747 L
s
.14646 .14646 m
.24747 .24747 L
s
.14646 .14646 m
.14646 .34848 L
s
.24747 .14646 m
.34848 .14646 L
s
.24747 .14646 m
.44949 .14646 L
s
.24747 .14646 m
.14646 .24747 L
s
.24747 .14646 m
.24747 .24747 L
s
.24747 .14646 m
.34848 .24747 L
s
.24747 .14646 m
.24747 .34848 L
s
.34848 .14646 m
.44949 .14646 L
s
.34848 .14646 m
.55051 .14646 L
s
.34848 .14646 m
.24747 .24747 L
s
.34848 .14646 m
.34848 .24747 L
s
.34848 .14646 m
.44949 .24747 L
s
.34848 .14646 m
.34848 .34848 L
s
.44949 .14646 m
.55051 .14646 L
s
.44949 .14646 m
.65152 .14646 L
s
.44949 .14646 m
.34848 .24747 L
s
.44949 .14646 m
.44949 .24747 L
s
.44949 .14646 m
.55051 .24747 L
s
.44949 .14646 m
.44949 .34848 L
s
.55051 .14646 m
.65152 .14646 L
s
.55051 .14646 m
.75253 .14646 L
s
.55051 .14646 m
.44949 .24747 L
s
.55051 .14646 m
.55051 .24747 L
s
.55051 .14646 m
.65152 .24747 L
s
.55051 .14646 m
.55051 .34848 L
s
.65152 .14646 m
.75253 .14646 L
s
.65152 .14646 m
.85354 .14646 L
s
.65152 .14646 m
.55051 .24747 L
s
.65152 .14646 m
.65152 .24747 L
s
.65152 .14646 m
.75253 .24747 L
s
.65152 .14646 m
.65152 .34848 L
s
.75253 .14646 m
.85354 .14646 L
s
.75253 .14646 m
.95455 .14646 L
s
.75253 .14646 m
.65152 .24747 L
s
.75253 .14646 m
.75253 .24747 L
s
.75253 .14646 m
.85354 .24747 L
s
.75253 .14646 m
.75253 .34848 L
s
.85354 .14646 m
.95455 .14646 L
s
.85354 .14646 m
.75253 .24747 L
s
.85354 .14646 m
.85354 .24747 L
s
.85354 .14646 m
.95455 .24747 L
s
.85354 .14646 m
.85354 .34848 L
s
.95455 .14646 m
.85354 .24747 L
s
.95455 .14646 m
.95455 .24747 L
s
.95455 .14646 m
.95455 .34848 L
s
.04545 .24747 m
.14646 .24747 L
s
.04545 .24747 m
.24747 .24747 L
s
.04545 .24747 m
.04545 .34848 L
s
.04545 .24747 m
.14646 .34848 L
s
.04545 .24747 m
.04545 .44949 L
s
.14646 .24747 m
.24747 .24747 L
s
.14646 .24747 m
.34848 .24747 L
s
.14646 .24747 m
.04545 .34848 L
s
.14646 .24747 m
.14646 .34848 L
s
.14646 .24747 m
.24747 .34848 L
s
.14646 .24747 m
.14646 .44949 L
s
.24747 .24747 m
.34848 .24747 L
s
.24747 .24747 m
.44949 .24747 L
s
.24747 .24747 m
.14646 .34848 L
s
.24747 .24747 m
.24747 .34848 L
s
.24747 .24747 m
.34848 .34848 L
s
.24747 .24747 m
.24747 .44949 L
s
.34848 .24747 m
.44949 .24747 L
s
.34848 .24747 m
.55051 .24747 L
s
.34848 .24747 m
.24747 .34848 L
s
.34848 .24747 m
.34848 .34848 L
s
.34848 .24747 m
.44949 .34848 L
s
.34848 .24747 m
.34848 .44949 L
s
.44949 .24747 m
.55051 .24747 L
s
.44949 .24747 m
.65152 .24747 L
s
.44949 .24747 m
.34848 .34848 L
s
.44949 .24747 m
.44949 .34848 L
s
.44949 .24747 m
.55051 .34848 L
s
.44949 .24747 m
.44949 .44949 L
s
.55051 .24747 m
.65152 .24747 L
s
.55051 .24747 m
.75253 .24747 L
s
.55051 .24747 m
.44949 .34848 L
s
.55051 .24747 m
.55051 .34848 L
s
.55051 .24747 m
.65152 .34848 L
s
.55051 .24747 m
.55051 .44949 L
s
.65152 .24747 m
.75253 .24747 L
s
.65152 .24747 m
.85354 .24747 L
s
.65152 .24747 m
.55051 .34848 L
s
.65152 .24747 m
.65152 .34848 L
s
.65152 .24747 m
.75253 .34848 L
s
.65152 .24747 m
.65152 .44949 L
s
.75253 .24747 m
.85354 .24747 L
s
.75253 .24747 m
.95455 .24747 L
s
.75253 .24747 m
.65152 .34848 L
s
.75253 .24747 m
.75253 .34848 L
s
.75253 .24747 m
.85354 .34848 L
s
.75253 .24747 m
.75253 .44949 L
s
.85354 .24747 m
.95455 .24747 L
s
.85354 .24747 m
.75253 .34848 L
s
.85354 .24747 m
.85354 .34848 L
s
.85354 .24747 m
.95455 .34848 L
s
.85354 .24747 m
.85354 .44949 L
s
.95455 .24747 m
.85354 .34848 L
s
.95455 .24747 m
.95455 .34848 L
s
.95455 .24747 m
.95455 .44949 L
s
.04545 .34848 m
.14646 .34848 L
s
.04545 .34848 m
.24747 .34848 L
s
.04545 .34848 m
.04545 .44949 L
s
.04545 .34848 m
.14646 .44949 L
s
.04545 .34848 m
.04545 .55051 L
s
.14646 .34848 m
.24747 .34848 L
s
.14646 .34848 m
.34848 .34848 L
s
.14646 .34848 m
.04545 .44949 L
s
.14646 .34848 m
.14646 .44949 L
s
.14646 .34848 m
.24747 .44949 L
s
.14646 .34848 m
.14646 .55051 L
s
.24747 .34848 m
.34848 .34848 L
s
.24747 .34848 m
.44949 .34848 L
s
.24747 .34848 m
.14646 .44949 L
s
.24747 .34848 m
.24747 .44949 L
s
.24747 .34848 m
.34848 .44949 L
s
.24747 .34848 m
.24747 .55051 L
s
.34848 .34848 m
.44949 .34848 L
s
.34848 .34848 m
.55051 .34848 L
s
.34848 .34848 m
.24747 .44949 L
s
.34848 .34848 m
.34848 .44949 L
s
.34848 .34848 m
.44949 .44949 L
s
.34848 .34848 m
.34848 .55051 L
s
.44949 .34848 m
.55051 .34848 L
s
.44949 .34848 m
.65152 .34848 L
s
.44949 .34848 m
.34848 .44949 L
s
.44949 .34848 m
.44949 .44949 L
s
.44949 .34848 m
.55051 .44949 L
s
.44949 .34848 m
.44949 .55051 L
s
.55051 .34848 m
.65152 .34848 L
s
.55051 .34848 m
.75253 .34848 L
s
.55051 .34848 m
.44949 .44949 L
s
.55051 .34848 m
.55051 .44949 L
s
.55051 .34848 m
.65152 .44949 L
s
.55051 .34848 m
.55051 .55051 L
s
.65152 .34848 m
.75253 .34848 L
s
.65152 .34848 m
.85354 .34848 L
s
.65152 .34848 m
.55051 .44949 L
s
.65152 .34848 m
.65152 .44949 L
s
.65152 .34848 m
.75253 .44949 L
s
.65152 .34848 m
.65152 .55051 L
s
.75253 .34848 m
.85354 .34848 L
s
.75253 .34848 m
.95455 .34848 L
s
.75253 .34848 m
.65152 .44949 L
s
.75253 .34848 m
.75253 .44949 L
s
.75253 .34848 m
.85354 .44949 L
s
.75253 .34848 m
.75253 .55051 L
s
.85354 .34848 m
.95455 .34848 L
s
.85354 .34848 m
.75253 .44949 L
s
.85354 .34848 m
.85354 .44949 L
s
.85354 .34848 m
.95455 .44949 L
s
.85354 .34848 m
.85354 .55051 L
s
.95455 .34848 m
.85354 .44949 L
s
.95455 .34848 m
.95455 .44949 L
s
.95455 .34848 m
.95455 .55051 L
s
.04545 .44949 m
.14646 .44949 L
s
.04545 .44949 m
.24747 .44949 L
s
.04545 .44949 m
.04545 .55051 L
s
.04545 .44949 m
.14646 .55051 L
s
.04545 .44949 m
.04545 .65152 L
s
.14646 .44949 m
.24747 .44949 L
s
.14646 .44949 m
.34848 .44949 L
s
.14646 .44949 m
.04545 .55051 L
s
.14646 .44949 m
.14646 .55051 L
s
.14646 .44949 m
.24747 .55051 L
s
.14646 .44949 m
.14646 .65152 L
s
.24747 .44949 m
.34848 .44949 L
s
.24747 .44949 m
.44949 .44949 L
s
.24747 .44949 m
.14646 .55051 L
s
.24747 .44949 m
.24747 .55051 L
s
.24747 .44949 m
.34848 .55051 L
s
.24747 .44949 m
.24747 .65152 L
s
.34848 .44949 m
.44949 .44949 L
s
.34848 .44949 m
.55051 .44949 L
s
.34848 .44949 m
.24747 .55051 L
s
.34848 .44949 m
.34848 .55051 L
s
.34848 .44949 m
.44949 .55051 L
s
.34848 .44949 m
.34848 .65152 L
s
.44949 .44949 m
.55051 .44949 L
s
.44949 .44949 m
.65152 .44949 L
s
.44949 .44949 m
.34848 .55051 L
s
.44949 .44949 m
.44949 .55051 L
s
.44949 .44949 m
.55051 .55051 L
s
.44949 .44949 m
.44949 .65152 L
s
.55051 .44949 m
.65152 .44949 L
s
.55051 .44949 m
.75253 .44949 L
s
.55051 .44949 m
.44949 .55051 L
s
.55051 .44949 m
.55051 .55051 L
s
.55051 .44949 m
.65152 .55051 L
s
.55051 .44949 m
.55051 .65152 L
s
.65152 .44949 m
.75253 .44949 L
s
.65152 .44949 m
.85354 .44949 L
s
.65152 .44949 m
.55051 .55051 L
s
.65152 .44949 m
.65152 .55051 L
s
.65152 .44949 m
.75253 .55051 L
s
.65152 .44949 m
.65152 .65152 L
s
.75253 .44949 m
.85354 .44949 L
s
.75253 .44949 m
.95455 .44949 L
s
.75253 .44949 m
.65152 .55051 L
s
.75253 .44949 m
.75253 .55051 L
s
.75253 .44949 m
.85354 .55051 L
s
.75253 .44949 m
.75253 .65152 L
s
.85354 .44949 m
.95455 .44949 L
s
.85354 .44949 m
.75253 .55051 L
s
.85354 .44949 m
.85354 .55051 L
s
.85354 .44949 m
.95455 .55051 L
s
.85354 .44949 m
.85354 .65152 L
s
.95455 .44949 m
.85354 .55051 L
s
.95455 .44949 m
.95455 .55051 L
s
.95455 .44949 m
.95455 .65152 L
s
.04545 .55051 m
.14646 .55051 L
s
.04545 .55051 m
.24747 .55051 L
s
.04545 .55051 m
.04545 .65152 L
s
.04545 .55051 m
.14646 .65152 L
s
.04545 .55051 m
.04545 .75253 L
s
.14646 .55051 m
.24747 .55051 L
s
.14646 .55051 m
.34848 .55051 L
s
.14646 .55051 m
.04545 .65152 L
s
.14646 .55051 m
.14646 .65152 L
s
.14646 .55051 m
.24747 .65152 L
s
.14646 .55051 m
.14646 .75253 L
s
.24747 .55051 m
.34848 .55051 L
s
.24747 .55051 m
.44949 .55051 L
s
.24747 .55051 m
.14646 .65152 L
s
.24747 .55051 m
.24747 .65152 L
s
.24747 .55051 m
.34848 .65152 L
s
.24747 .55051 m
.24747 .75253 L
s
.34848 .55051 m
.44949 .55051 L
s
.34848 .55051 m
.55051 .55051 L
s
.34848 .55051 m
.24747 .65152 L
s
.34848 .55051 m
.34848 .65152 L
s
.34848 .55051 m
.44949 .65152 L
s
.34848 .55051 m
.34848 .75253 L
s
.44949 .55051 m
.55051 .55051 L
s
.44949 .55051 m
.65152 .55051 L
s
.44949 .55051 m
.34848 .65152 L
s
.44949 .55051 m
.44949 .65152 L
s
.44949 .55051 m
.55051 .65152 L
s
.44949 .55051 m
.44949 .75253 L
s
.55051 .55051 m
.65152 .55051 L
s
.55051 .55051 m
.75253 .55051 L
s
.55051 .55051 m
.44949 .65152 L
s
.55051 .55051 m
.55051 .65152 L
s
.55051 .55051 m
.65152 .65152 L
s
.55051 .55051 m
.55051 .75253 L
s
.65152 .55051 m
.75253 .55051 L
s
.65152 .55051 m
.85354 .55051 L
s
.65152 .55051 m
.55051 .65152 L
s
.65152 .55051 m
.65152 .65152 L
s
.65152 .55051 m
.75253 .65152 L
s
.65152 .55051 m
.65152 .75253 L
s
.75253 .55051 m
.85354 .55051 L
s
.75253 .55051 m
.95455 .55051 L
s
.75253 .55051 m
.65152 .65152 L
s
.75253 .55051 m
.75253 .65152 L
s
.75253 .55051 m
.85354 .65152 L
s
.75253 .55051 m
.75253 .75253 L
s
.85354 .55051 m
.95455 .55051 L
s
.85354 .55051 m
.75253 .65152 L
s
.85354 .55051 m
.85354 .65152 L
s
.85354 .55051 m
.95455 .65152 L
s
.85354 .55051 m
.85354 .75253 L
s
.95455 .55051 m
.85354 .65152 L
s
.95455 .55051 m
.95455 .65152 L
s
.95455 .55051 m
.95455 .75253 L
s
.04545 .65152 m
.14646 .65152 L
s
.04545 .65152 m
.24747 .65152 L
s
.04545 .65152 m
.04545 .75253 L
s
.04545 .65152 m
.14646 .75253 L
s
.04545 .65152 m
.04545 .85354 L
s
.14646 .65152 m
.24747 .65152 L
s
.14646 .65152 m
.34848 .65152 L
s
.14646 .65152 m
.04545 .75253 L
s
.14646 .65152 m
.14646 .75253 L
s
.14646 .65152 m
.24747 .75253 L
s
.14646 .65152 m
.14646 .85354 L
s
.24747 .65152 m
.34848 .65152 L
s
.24747 .65152 m
.44949 .65152 L
s
.24747 .65152 m
.14646 .75253 L
s
.24747 .65152 m
.24747 .75253 L
s
.24747 .65152 m
.34848 .75253 L
s
.24747 .65152 m
.24747 .85354 L
s
.34848 .65152 m
.44949 .65152 L
s
.34848 .65152 m
.55051 .65152 L
s
.34848 .65152 m
.24747 .75253 L
s
.34848 .65152 m
.34848 .75253 L
s
.34848 .65152 m
.44949 .75253 L
s
.34848 .65152 m
.34848 .85354 L
s
.44949 .65152 m
.55051 .65152 L
s
.44949 .65152 m
.65152 .65152 L
s
.44949 .65152 m
.34848 .75253 L
s
.44949 .65152 m
.44949 .75253 L
s
.44949 .65152 m
.55051 .75253 L
s
.44949 .65152 m
.44949 .85354 L
s
.55051 .65152 m
.65152 .65152 L
s
.55051 .65152 m
.75253 .65152 L
s
.55051 .65152 m
.44949 .75253 L
s
.55051 .65152 m
.55051 .75253 L
s
.55051 .65152 m
.65152 .75253 L
s
.55051 .65152 m
.55051 .85354 L
s
.65152 .65152 m
.75253 .65152 L
s
.65152 .65152 m
.85354 .65152 L
s
.65152 .65152 m
.55051 .75253 L
s
.65152 .65152 m
.65152 .75253 L
s
.65152 .65152 m
.75253 .75253 L
s
.65152 .65152 m
.65152 .85354 L
s
.75253 .65152 m
.85354 .65152 L
s
.75253 .65152 m
.95455 .65152 L
s
.75253 .65152 m
.65152 .75253 L
s
.75253 .65152 m
.75253 .75253 L
s
.75253 .65152 m
.85354 .75253 L
s
.75253 .65152 m
.75253 .85354 L
s
.85354 .65152 m
.95455 .65152 L
s
.85354 .65152 m
.75253 .75253 L
s
.85354 .65152 m
.85354 .75253 L
s
.85354 .65152 m
.95455 .75253 L
s
.85354 .65152 m
.85354 .85354 L
s
.95455 .65152 m
.85354 .75253 L
s
.95455 .65152 m
.95455 .75253 L
s
.95455 .65152 m
.95455 .85354 L
s
.04545 .75253 m
.14646 .75253 L
s
.04545 .75253 m
.24747 .75253 L
s
.04545 .75253 m
.04545 .85354 L
s
.04545 .75253 m
.14646 .85354 L
s
.04545 .75253 m
.04545 .95455 L
s
.14646 .75253 m
.24747 .75253 L
s
.14646 .75253 m
.34848 .75253 L
s
.14646 .75253 m
.04545 .85354 L
s
.14646 .75253 m
.14646 .85354 L
s
.14646 .75253 m
.24747 .85354 L
s
.14646 .75253 m
.14646 .95455 L
s
.24747 .75253 m
.34848 .75253 L
s
.24747 .75253 m
.44949 .75253 L
s
.24747 .75253 m
.14646 .85354 L
s
.24747 .75253 m
.24747 .85354 L
s
.24747 .75253 m
.34848 .85354 L
s
.24747 .75253 m
.24747 .95455 L
s
.34848 .75253 m
.44949 .75253 L
s
.34848 .75253 m
.55051 .75253 L
s
.34848 .75253 m
.24747 .85354 L
s
.34848 .75253 m
.34848 .85354 L
s
.34848 .75253 m
.44949 .85354 L
s
.34848 .75253 m
.34848 .95455 L
s
.44949 .75253 m
.55051 .75253 L
s
.44949 .75253 m
.65152 .75253 L
s
.44949 .75253 m
.34848 .85354 L
s
.44949 .75253 m
.44949 .85354 L
s
.44949 .75253 m
.55051 .85354 L
s
.44949 .75253 m
.44949 .95455 L
s
.55051 .75253 m
.65152 .75253 L
s
.55051 .75253 m
.75253 .75253 L
s
.55051 .75253 m
.44949 .85354 L
s
.55051 .75253 m
.55051 .85354 L
s
.55051 .75253 m
.65152 .85354 L
s
.55051 .75253 m
.55051 .95455 L
s
.65152 .75253 m
.75253 .75253 L
s
.65152 .75253 m
.85354 .75253 L
s
.65152 .75253 m
.55051 .85354 L
s
.65152 .75253 m
.65152 .85354 L
s
.65152 .75253 m
.75253 .85354 L
s
.65152 .75253 m
.65152 .95455 L
s
.75253 .75253 m
.85354 .75253 L
s
.75253 .75253 m
.95455 .75253 L
s
.75253 .75253 m
.65152 .85354 L
s
.75253 .75253 m
.75253 .85354 L
s
.75253 .75253 m
.85354 .85354 L
s
.75253 .75253 m
.75253 .95455 L
s
.85354 .75253 m
.95455 .75253 L
s
.85354 .75253 m
.75253 .85354 L
s
.85354 .75253 m
.85354 .85354 L
s
.85354 .75253 m
.95455 .85354 L
s
.85354 .75253 m
.85354 .95455 L
s
.95455 .75253 m
.85354 .85354 L
s
.95455 .75253 m
.95455 .85354 L
s
.95455 .75253 m
.95455 .95455 L
s
.04545 .85354 m
.14646 .85354 L
s
.04545 .85354 m
.24747 .85354 L
s
.04545 .85354 m
.04545 .95455 L
s
.04545 .85354 m
.14646 .95455 L
s
.14646 .85354 m
.24747 .85354 L
s
.14646 .85354 m
.34848 .85354 L
s
.14646 .85354 m
.04545 .95455 L
s
.14646 .85354 m
.14646 .95455 L
s
.14646 .85354 m
.24747 .95455 L
s
.24747 .85354 m
.34848 .85354 L
s
.24747 .85354 m
.44949 .85354 L
s
.24747 .85354 m
.14646 .95455 L
s
.24747 .85354 m
.24747 .95455 L
s
.24747 .85354 m
.34848 .95455 L
s
.34848 .85354 m
.44949 .85354 L
s
.34848 .85354 m
.55051 .85354 L
s
.34848 .85354 m
.24747 .95455 L
s
.34848 .85354 m
.34848 .95455 L
s
.34848 .85354 m
.44949 .95455 L
s
.44949 .85354 m
.55051 .85354 L
s
.44949 .85354 m
.65152 .85354 L
s
.44949 .85354 m
.34848 .95455 L
s
.44949 .85354 m
.44949 .95455 L
s
.44949 .85354 m
.55051 .95455 L
s
.55051 .85354 m
.65152 .85354 L
s
.55051 .85354 m
.75253 .85354 L
s
.55051 .85354 m
.44949 .95455 L
s
.55051 .85354 m
.55051 .95455 L
s
.55051 .85354 m
.65152 .95455 L
s
.65152 .85354 m
.75253 .85354 L
s
.65152 .85354 m
.85354 .85354 L
s
.65152 .85354 m
.55051 .95455 L
s
.65152 .85354 m
.65152 .95455 L
s
.65152 .85354 m
.75253 .95455 L
s
.75253 .85354 m
.85354 .85354 L
s
.75253 .85354 m
.95455 .85354 L
s
.75253 .85354 m
.65152 .95455 L
s
.75253 .85354 m
.75253 .95455 L
s
.75253 .85354 m
.85354 .95455 L
s
.85354 .85354 m
.95455 .85354 L
s
.85354 .85354 m
.75253 .95455 L
s
.85354 .85354 m
.85354 .95455 L
s
.85354 .85354 m
.95455 .95455 L
s
.95455 .85354 m
.85354 .95455 L
s
.95455 .85354 m
.95455 .95455 L
s
.04545 .95455 m
.14646 .95455 L
s
.04545 .95455 m
.24747 .95455 L
s
.14646 .95455 m
.24747 .95455 L
s
.14646 .95455 m
.34848 .95455 L
s
.24747 .95455 m
.34848 .95455 L
s
.24747 .95455 m
.44949 .95455 L
s
.34848 .95455 m
.44949 .95455 L
s
.34848 .95455 m
.55051 .95455 L
s
.44949 .95455 m
.55051 .95455 L
s
.44949 .95455 m
.65152 .95455 L
s
.55051 .95455 m
.65152 .95455 L
s
.55051 .95455 m
.75253 .95455 L
s
.65152 .95455 m
.75253 .95455 L
s
.65152 .95455 m
.85354 .95455 L
s
.75253 .95455 m
.85354 .95455 L
s
.75253 .95455 m
.95455 .95455 L
s
.85354 .95455 m
.95455 .95455 L
s
.025 w
.04545 .04545 Mdot
.14646 .04545 Mdot
.24747 .04545 Mdot
.34848 .04545 Mdot
.44949 .04545 Mdot
.55051 .04545 Mdot
.65152 .04545 Mdot
.75253 .04545 Mdot
.85354 .04545 Mdot
.95455 .04545 Mdot
.04545 .14646 Mdot
.14646 .14646 Mdot
.24747 .14646 Mdot
.34848 .14646 Mdot
.44949 .14646 Mdot
.55051 .14646 Mdot
.65152 .14646 Mdot
.75253 .14646 Mdot
.85354 .14646 Mdot
.95455 .14646 Mdot
.04545 .24747 Mdot
.14646 .24747 Mdot
.24747 .24747 Mdot
.34848 .24747 Mdot
.44949 .24747 Mdot
.55051 .24747 Mdot
.65152 .24747 Mdot
.75253 .24747 Mdot
.85354 .24747 Mdot
.95455 .24747 Mdot
.04545 .34848 Mdot
.14646 .34848 Mdot
.24747 .34848 Mdot
.34848 .34848 Mdot
.44949 .34848 Mdot
.55051 .34848 Mdot
.65152 .34848 Mdot
.75253 .34848 Mdot
.85354 .34848 Mdot
.95455 .34848 Mdot
.04545 .44949 Mdot
.14646 .44949 Mdot
.24747 .44949 Mdot
.34848 .44949 Mdot
.44949 .44949 Mdot
.55051 .44949 Mdot
.65152 .44949 Mdot
.75253 .44949 Mdot
.85354 .44949 Mdot
.95455 .44949 Mdot
.04545 .55051 Mdot
.14646 .55051 Mdot
.24747 .55051 Mdot
.34848 .55051 Mdot
.44949 .55051 Mdot
.55051 .55051 Mdot
.65152 .55051 Mdot
.75253 .55051 Mdot
.85354 .55051 Mdot
.95455 .55051 Mdot
.04545 .65152 Mdot
.14646 .65152 Mdot
.24747 .65152 Mdot
.34848 .65152 Mdot
.44949 .65152 Mdot
.55051 .65152 Mdot
.65152 .65152 Mdot
.75253 .65152 Mdot
.85354 .65152 Mdot
.95455 .65152 Mdot
.04545 .75253 Mdot
.14646 .75253 Mdot
.24747 .75253 Mdot
.34848 .75253 Mdot
.44949 .75253 Mdot
.55051 .75253 Mdot
.65152 .75253 Mdot
.75253 .75253 Mdot
.85354 .75253 Mdot
.95455 .75253 Mdot
.04545 .85354 Mdot
.14646 .85354 Mdot
.24747 .85354 Mdot
.34848 .85354 Mdot
.44949 .85354 Mdot
.55051 .85354 Mdot
.65152 .85354 Mdot
.75253 .85354 Mdot
.85354 .85354 Mdot
.95455 .85354 Mdot
.04545 .95455 Mdot
.14646 .95455 Mdot
.24747 .95455 Mdot
.34848 .95455 Mdot
.44949 .95455 Mdot
.55051 .95455 Mdot
.65152 .95455 Mdot
.75253 .95455 Mdot
.85354 .95455 Mdot
.95455 .95455 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[20]:=",
  ImageSize->{288, 288},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000182000`400?l00000o`00003ooooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`002oooool3o`0001[ooooo0ol0000Jooooo`?o00006_ooool3o`0001[ooooo0ol0000Joooo
o`?o00006_ooool3o`0001[ooooo0ol0000Jooooo`?o00006_ooool3o`0000gooooo000:ooooo`Go
00006?ooool5o`0001Sooooo1Ol0000Hooooo`Go00006?ooool5o`0001Sooooo1Ol0000Hooooo`Go
00006?ooool5o`0001Sooooo1Ol0000Hooooo`Go00003?ooool000Wooooo1ol0000Fooooo`Oo0000
5_ooool7o`0001Kooooo1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000Fooooo`Oo0000
5_ooool7o`0001Kooooo1ol0000;ooooo`002Oooooooo`0000go00002oooool000Wooooo1ol0000F
ooooo`Oo00005_ooool7o`0001Kooooo1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000F
ooooo`Oo00005_ooool7o`0001Kooooo1ol0000;ooooo`002_ooool6o`0001Oooooo1_l0000Goooo
o`Ko00005oooool6o`0001Oooooo1Ol0000Hooooo`Go00006?ooool5o`0001Sooooo1Ol0000Hoooo
o`Go00006?ooool5o`0000cooooo000;ooooo`?o00000_ooool00ol0003oooooooooo`0Dooooo`Co
00000_ooool00ol0003oooooooooo`0Dooooo`Co00000_ooool00ol0003oooooooooo`0Dooooo`Co
00000_ooool00ol0003oooooooooo`0Dooooo`Co000000?oooooo`000?ooool05_ooool4o`000003
ooooool0003ooooo01Gooooo00?o0000ooooool000000_l000000ooooooo0000ooooo`0Eooooo`03
o`000?oooooo000000;o000000?oooooo`000?ooool05Oooool00ol0003oooooo`000002o`000003
ooooool0003ooooo01Gooooo00?o0000ooooool000000_l0000=ooooo`003Oooool01Ol0003ooooo
oooooooooooo000001Cooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo
01;ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo01;ooooo00Go0000
ooooooooooooooooo`000003ooooo`03o`000?oooooooooo01;ooooo00Go0000oooooooooooooooo
o`000002ooooo`03o`000?oooooooooo01?ooooo00Co0000oooooooooooo00000oooool00ol0003o
ooooooooo`0Booooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`0Boooo
o`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`0Booooo`05o`000?oooooo
ooooooooool000000oooool00ol0003oooooooooo`0Booooo`05o`000?ooooooooooooooool00000
3_ooool000gooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oo
oooooooo00;ooooo00Go0000ooooooooooooooooo`00000Cooooo`05o`000?ooooooooooooooool0
00001?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool03?ooool000gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0?ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?oo
ool000gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool03?ooool000go
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool03?ooool000gooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool03?ooool000gooooo00?o0000ooooooooool02_ooool01?l0003oooooooooool0
000<ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00003?ooool00ol0003ooooo
ooooo`0:ooooo`04o`000?ooooooooooo`0000cooooo00?o0000ooooooooool02_ooool01?l0003o
ooooooooool0000<ooooo`03o`000?oooooooooo00Wooooo00Go0000ooooooooooooooooo`00000;
ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00003?ooool00ol0003ooooooooo
o`0:ooooo`04o`000?ooooooooooo`0000cooooo00?o0000ooooooooool02_ooool01?l0003ooooo
ooooool0000<ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00003?ooool00ol0
003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0;ooooo`;o00003Oooool00ol0003o
ooooooooo`0;ooooo`;o00003Oooool00ol0003oooooooooo`0;ooooo`;o00003Oooool00ol0003o
ooooooooo`0;ooooo`;o00003Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo000000co
oooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02oooool2o`0000go
oooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02oooool2o`0000go
oooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool02oooool2o`0000gooooo
00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02oooool2o`0000gooooo
00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02oooool00ol0003ooooo
ooooo`0;ooooo`03o`000?oooooooooo00_ooooo0_l0000=ooooo`03o`000?oooooooooo00_ooooo
0_l0000=ooooo`03o`000?oooooooooo00_ooooo0_l0000=ooooo`03o`000?oooooooooo00_ooooo
0_l0000=ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00[ooooo00Co
0000oooooooooooo00003?ooool00ol0003oooooooooo`0:ooooo`04o`000?ooooooooooo`0000co
oooo00?o0000ooooooooool02_ooool01?l0003oooooooooool0000<ooooo`03o`000?oooooooooo
00[ooooo00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
000000cooooo00?o0000ooooooooool02_ooool01?l0003oooooooooool0000<ooooo`03o`000?oo
oooooooo00[ooooo00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`0:ooooo`04o`00
0?ooooooooooo`0000cooooo00?o0000ooooooooool02_ooool01?l0003oooooooooool0000<oooo
o`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00Go0000oooooooo
ooooooooo`00000;ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00co
oooo000=ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00cooooo000=
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool02oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00cooooo000=ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
4?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
4?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
4?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
4?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
3oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
4?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
4?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
4?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
4?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00cooooo000=ooooo`05o`000?oo
ooooooooooooool000005?ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000oooooooo
ool04_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0
003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooooooooooo
oooo000000?ooooo00?o0000ooooooooool04Oooool01Ol0003ooooooooooooooooo000000?ooooo
00?o0000ooooooooool04_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000oooooooo
ool04_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0
003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooooooooooo
oooo000000kooooo000;ooooo`?o00000_ooool00ol0003oooooooooo`0Dooooo`Co00000_ooool0
0ol0003oooooooooo`0Dooooo`Co00000_ooool00ol0003oooooooooo`0Dooooo`Co00000_ooool0
0ol0003oooooooooo`0Dooooo`Co00000_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo
000000;o000000?oooooo`000?ooool05Oooool00ol0003oooooo`000002o`000003ooooool0003o
oooo01Gooooo00?o0000ooooool000000_l000000ooooooo0000ooooo`0Eooooo`03o`000?oooooo
000000;o000000?oooooo`000?ooool05Oooool00ol0003oooooo`000002o`0000gooooo000:oooo
o`Ko00005oooool6o`0001Oooooo1_l0000Gooooo`Ko00005oooool6o`0001Oooooo1Ol0000Hoooo
o`Go00006?ooool5o`0001Sooooo1Ol0000Hooooo`Go00003?ooool000Wooooo1ol0000Fooooo`Oo
00005_ooool7o`0001Kooooo1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000Fooooo`Oo
00005_ooool7o`0001Kooooo1ol0000;ooooo`002Oooooooo`0000go00002oooool000Wooooo1ol0
000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0
000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000;ooooo`002_ooool6o`0001Oooooo1_l0000G
ooooo`Ko00005oooool6o`0001Oooooo1Ol0000Hooooo`Go00006?ooool5o`0001Sooooo1Ol0000H
ooooo`Go00006?ooool5o`0000cooooo000;ooooo`?o00000_ooool00ol0003oooooooooo`0Doooo
o`Co00000_ooool00ol0003oooooooooo`0Dooooo`Co00000_ooool00ol0003oooooooooo`0Doooo
o`Co00000_ooool00ol0003oooooooooo`0Dooooo`Co000000?oooooo`000?ooool05_ooool4o`00
0003ooooool0003ooooo01Gooooo00?o0000ooooool000000_l000000ooooooo0000ooooo`0Eoooo
o`03o`000?oooooo000000;o000000?oooooo`000?ooool05Oooool00ol0003oooooo`000002o`00
0003ooooool0003ooooo01Gooooo00?o0000ooooool000000_l0000=ooooo`003Oooool01Ol0003o
oooooooooooooooo000001Cooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooo
oooo01;ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo01;ooooo00Go
0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo01;ooooo00Go0000oooooooooooo
ooooo`000002ooooo`03o`000?oooooooooo01?ooooo00Co0000oooooooooooo00000oooool00ol0
003oooooooooo`0Booooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`0B
ooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`0Booooo`05o`000?oo
ooooooooooooool000000oooool00ol0003oooooooooo`0Booooo`05o`000?ooooooooooooooool0
00003_ooool000gooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`00
0?oooooooooo00;ooooo00Go0000ooooooooooooooooo`00000Cooooo`05o`000?oooooooooooooo
ool000001?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool03?ooool000gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0?ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
3?ooool000gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool03?ooool0
00gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool03?ooool000gooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool02_ooool01?l0003ooooooooo
ool0000<ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00003?ooool00ol0003o
ooooooooo`0:ooooo`04o`000?ooooooooooo`0000cooooo00?o0000ooooooooool02_ooool01?l0
003oooooooooool0000<ooooo`03o`000?oooooooooo00Wooooo00Go0000ooooooooooooooooo`00
000;ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00003?ooool00ol0003ooooo
ooooo`0:ooooo`04o`000?ooooooooooo`0000cooooo00?o0000ooooooooool02_ooool01?l0003o
ooooooooool0000<ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00003?ooool0
0ol0003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0;ooooo`;o00003Oooool00ol0
003oooooooooo`0;ooooo`;o00003Oooool00ol0003oooooooooo`0;ooooo`;o00003Oooool00ol0
003oooooooooo`0;ooooo`;o00003Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo0000
00cooooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02oooool2o`00
00gooooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02oooool2o`00
00gooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool02oooool2o`0000go
oooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02oooool2o`0000go
oooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02oooool00ol0003o
ooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo0_l0000=ooooo`03o`000?oooooooooo00_o
oooo0_l0000=ooooo`03o`000?oooooooooo00_ooooo0_l0000=ooooo`03o`000?oooooooooo00_o
oooo0_l0000=ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00[ooooo
00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`0:ooooo`04o`000?ooooooooooo`00
00cooooo00?o0000ooooooooool02_ooool01?l0003oooooooooool0000<ooooo`03o`000?oooooo
oooo00[ooooo00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooo000000cooooo00?o0000ooooooooool02_ooool01?l0003oooooooooool0000<ooooo`03o`00
0?oooooooooo00[ooooo00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`0:ooooo`04
o`000?ooooooooooo`0000cooooo00?o0000ooooooooool02_ooool01?l0003oooooooooool0000<
ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00Go0000oooo
ooooooooooooo`00000;ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00cooooo000=ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00cooooo
000=ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00cooooo000=oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool03oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00cooooo000=ooooo`05o`00
0?ooooooooooooooool000005?ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000oooo
ooooool04_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_ooool0
1Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooooooo
oooooooo000000?ooooo00?o0000ooooooooool04Oooool01Ol0003ooooooooooooooooo000000?o
oooo00?o0000ooooooooool04_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000oooo
ooooool04_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_ooool0
1Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooooooo
oooooooo000000kooooo000;ooooo`?o00000_ooool00ol0003oooooooooo`0Dooooo`Co00000_oo
ool00ol0003oooooooooo`0Dooooo`Co00000_ooool00ol0003oooooooooo`0Dooooo`Co00000_oo
ool00ol0003oooooooooo`0Dooooo`Co00000_ooool00ol0003oooooooooo`0Cooooo`03o`000?oo
oooo000000;o000000?oooooo`000?ooool05Oooool00ol0003oooooo`000002o`000003ooooool0
003ooooo01Gooooo00?o0000ooooool000000_l000000ooooooo0000ooooo`0Eooooo`03o`000?oo
oooo000000;o000000?oooooo`000?ooool05Oooool00ol0003oooooo`000002o`0000gooooo000:
ooooo`Ko00005oooool6o`0001Oooooo1_l0000Gooooo`Ko00005oooool6o`0001Oooooo1Ol0000H
ooooo`Go00006?ooool5o`0001Sooooo1Ol0000Hooooo`Go00003?ooool000Wooooo1ol0000Foooo
o`Oo00005_ooool7o`0001Kooooo1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000Foooo
o`Oo00005_ooool7o`0001Kooooo1ol0000;ooooo`002Oooooooo`0000go00002oooool000Wooooo
1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo
1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000;ooooo`002_ooool6o`0001Oooooo1_l0
000Gooooo`Ko00005oooool6o`0001Oooooo1Ol0000Hooooo`Go00006?ooool5o`0001Sooooo1Ol0
000Hooooo`Go00006?ooool5o`0000cooooo000;ooooo`?o00000_ooool00ol0003oooooooooo`0D
ooooo`Co00000_ooool00ol0003oooooooooo`0Dooooo`Co00000_ooool00ol0003oooooooooo`0D
ooooo`Co00000_ooool00ol0003oooooooooo`0Dooooo`Co000000?oooooo`000?ooool05_ooool4
o`000003ooooool0003ooooo01Gooooo00?o0000ooooool000000_l000000ooooooo0000ooooo`0E
ooooo`03o`000?oooooo000000;o000000?oooooo`000?ooool05Oooool00ol0003oooooo`000002
o`000003ooooool0003ooooo01Gooooo00?o0000ooooool000000_l0000=ooooo`003Oooool01Ol0
003ooooooooooooooooo000001Cooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oo
oooooooo01;ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo01;ooooo
00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo01;ooooo00Go0000oooooooo
ooooooooo`000002ooooo`03o`000?oooooooooo01?ooooo00Co0000oooooooooooo00000oooool0
0ol0003oooooooooo`0Booooo`05o`000?ooooooooooooooool000000oooool00ol0003ooooooooo
o`0Booooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`0Booooo`05o`00
0?ooooooooooooooool000000oooool00ol0003oooooooooo`0Booooo`05o`000?oooooooooooooo
ool000003_ooool000gooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`00000Cooooo`05o`000?oooooooooo
ooooool000001?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool03?ooool000gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0?oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool03?ooool000gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool03?oo
ool000gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool03?ooool000go
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool02_ooool01?l0003ooooo
ooooool0000<ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00003?ooool00ol0
003oooooooooo`0:ooooo`04o`000?ooooooooooo`0000cooooo00?o0000ooooooooool02_ooool0
1?l0003oooooooooool0000<ooooo`03o`000?oooooooooo00Wooooo00Go0000oooooooooooooooo
o`00000;ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00003?ooool00ol0003o
ooooooooo`0:ooooo`04o`000?ooooooooooo`0000cooooo00?o0000ooooooooool02_ooool01?l0
003oooooooooool0000<ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00003?oo
ool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0;ooooo`;o00003Oooool0
0ol0003oooooooooo`0;ooooo`;o00003Oooool00ol0003oooooooooo`0;ooooo`;o00003Oooool0
0ol0003oooooooooo`0;ooooo`;o00003Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
000000cooooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02oooool2
o`0000gooooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02oooool2
o`0000gooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool02oooool2o`00
00gooooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02oooool2o`00
00gooooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo0_l0000=ooooo`03o`000?oooooooooo
00_ooooo0_l0000=ooooo`03o`000?oooooooooo00_ooooo0_l0000=ooooo`03o`000?oooooooooo
00_ooooo0_l0000=ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00[o
oooo00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`0:ooooo`04o`000?oooooooooo
o`0000cooooo00?o0000ooooooooool02_ooool01?l0003oooooooooool0000<ooooo`03o`000?oo
oooooooo00[ooooo00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooo000000cooooo00?o0000ooooooooool02_ooool01?l0003oooooooooool0000<ooooo`03
o`000?oooooooooo00[ooooo00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`0:oooo
o`04o`000?ooooooooooo`0000cooooo00?o0000ooooooooool02_ooool01?l0003oooooooooool0
000<ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00Go0000
ooooooooooooooooo`00000;ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00cooooo000=ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00co
oooo000=ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool02oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00cooooo000=
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool03oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00cooooo000=ooooo`05
o`000?ooooooooooooooool000005?ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000
ooooooooool04_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_oo
ool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooo
oooooooooooo000000?ooooo00?o0000ooooooooool04Oooool01Ol0003ooooooooooooooooo0000
00?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000
ooooooooool04_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_oo
ool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooo
oooooooooooo000000kooooo000;ooooo`?o00000_ooool00ol0003oooooooooo`0Dooooo`Co0000
0_ooool00ol0003oooooooooo`0Dooooo`Co00000_ooool00ol0003oooooooooo`0Dooooo`Co0000
0_ooool00ol0003oooooooooo`0Dooooo`Co00000_ooool00ol0003oooooooooo`0Cooooo`03o`00
0?oooooo000000;o000000?oooooo`000?ooool05Oooool00ol0003oooooo`000002o`000003oooo
ool0003ooooo01Gooooo00?o0000ooooool000000_l000000ooooooo0000ooooo`0Eooooo`03o`00
0?oooooo000000;o000000?oooooo`000?ooool05Oooool00ol0003oooooo`000002o`0000gooooo
000:ooooo`Ko00005oooool6o`0001Oooooo1_l0000Gooooo`Ko00005oooool6o`0001Oooooo1Ol0
000Hooooo`Go00006?ooool5o`0001Sooooo1Ol0000Hooooo`Go00003?ooool000Wooooo1ol0000F
ooooo`Oo00005_ooool7o`0001Kooooo1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000F
ooooo`Oo00005_ooool7o`0001Kooooo1ol0000;ooooo`002Oooooooo`0000go00002oooool000Wo
oooo1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000Fooooo`Oo00005_ooool7o`0001Ko
oooo1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000;ooooo`002_ooool6o`0001Oooooo
1_l0000Gooooo`Ko00005oooool6o`0001Oooooo1Ol0000Hooooo`Go00006?ooool5o`0001Sooooo
1Ol0000Hooooo`Go00006?ooool5o`0000cooooo000;ooooo`?o00000_ooool00ol0003ooooooooo
o`0Dooooo`Co00000_ooool00ol0003oooooooooo`0Dooooo`Co00000_ooool00ol0003ooooooooo
o`0Dooooo`Co00000_ooool00ol0003oooooooooo`0Dooooo`Co000000?oooooo`000?ooool05_oo
ool4o`000003ooooool0003ooooo01Gooooo00?o0000ooooool000000_l000000ooooooo0000oooo
o`0Eooooo`03o`000?oooooo000000;o000000?oooooo`000?ooool05Oooool00ol0003oooooo`00
0002o`000003ooooool0003ooooo01Gooooo00?o0000ooooool000000_l0000=ooooo`003Oooool0
1Ol0003ooooooooooooooooo000001Cooooo00Go0000ooooooooooooooooo`000003ooooo`03o`00
0?oooooooooo01;ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo01;o
oooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo01;ooooo00Go0000oooo
ooooooooooooo`000002ooooo`03o`000?oooooooooo01?ooooo00Co0000oooooooooooo00000ooo
ool00ol0003oooooooooo`0Booooo`05o`000?ooooooooooooooool000000oooool00ol0003ooooo
ooooo`0Booooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`0Booooo`05
o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`0Booooo`05o`000?oooooooooo
ooooool000003_ooool000gooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`00000Cooooo`05o`000?oooooo
ooooooooool000001?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool03?ooool000gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0?
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool03?ooool000gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
3?ooool000gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool03?ooool0
00gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool02_ooool01?l0003o
ooooooooool0000<ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00003?ooool0
0ol0003oooooooooo`0:ooooo`04o`000?ooooooooooo`0000cooooo00?o0000ooooooooool02_oo
ool01?l0003oooooooooool0000<ooooo`03o`000?oooooooooo00Wooooo00Go0000oooooooooooo
ooooo`00000;ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00003?ooool00ol0
003oooooooooo`0:ooooo`04o`000?ooooooooooo`0000cooooo00?o0000ooooooooool02_ooool0
1?l0003oooooooooool0000<ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo0000
3?ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0;ooooo`;o00003Ooo
ool00ol0003oooooooooo`0;ooooo`;o00003Oooool00ol0003oooooooooo`0;ooooo`;o00003Ooo
ool00ol0003oooooooooo`0;ooooo`;o00003Oooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooo000000cooooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02ooo
ool2o`0000gooooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02ooo
ool2o`0000gooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool02oooool2
o`0000gooooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02oooool2
o`0000gooooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo0_l0000=ooooo`03o`000?oooooo
oooo00_ooooo0_l0000=ooooo`03o`000?oooooooooo00_ooooo0_l0000=ooooo`03o`000?oooooo
oooo00_ooooo0_l0000=ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo
00[ooooo00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`0:ooooo`04o`000?oooooo
ooooo`0000cooooo00?o0000ooooooooool02_ooool01?l0003oooooooooool0000<ooooo`03o`00
0?oooooooooo00[ooooo00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooo000000cooooo00?o0000ooooooooool02_ooool01?l0003oooooooooool0000<oooo
o`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`0:
ooooo`04o`000?ooooooooooo`0000cooooo00?o0000ooooooooool02_ooool01?l0003ooooooooo
ool0000<ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00Go
0000ooooooooooooooooo`00000;ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00cooooo000=ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00cooooo000=ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00cooooo
000=ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool03oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00cooooo000=oooo
o`05o`000?ooooooooooooooool000005?ooool01Ol0003ooooooooooooooooo000000?ooooo00?o
0000ooooooooool04_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool0
4_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0003o
oooooooooooooooo000000?ooooo00?o0000ooooooooool04Oooool01Ol0003ooooooooooooooooo
000000?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o
0000ooooooooool04_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool0
4_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0003o
oooooooooooooooo000000kooooo000;ooooo`?o00000_ooool00ol0003oooooooooo`0Dooooo`Co
00000_ooool00ol0003oooooooooo`0Dooooo`Co00000_ooool00ol0003oooooooooo`0Dooooo`Co
00000_ooool00ol0003oooooooooo`0Dooooo`Co00000_ooool00ol0003oooooooooo`0Cooooo`03
o`000?oooooo000000;o000000?oooooo`000?ooool05Oooool00ol0003oooooo`000002o`000003
ooooool0003ooooo01Gooooo00?o0000ooooool000000_l000000ooooooo0000ooooo`0Eooooo`03
o`000?oooooo000000;o000000?oooooo`000?ooool05Oooool00ol0003oooooo`000002o`0000go
oooo000:ooooo`Ko00005oooool6o`0001Oooooo1_l0000Gooooo`Ko00005oooool6o`0001Oooooo
1Ol0000Hooooo`Go00006?ooool5o`0001Sooooo1Ol0000Hooooo`Go00003?ooool000Wooooo1ol0
000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0
000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000;ooooo`002Oooooooo`0000go00002oooool0
00Wooooo1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000Fooooo`Oo00005_ooool7o`00
01Kooooo1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000;ooooo`002_ooool5o`000003
ooooool0003ooooo01Gooooo1Ol000000ooooooo0000ooooo`0Eooooo`Go000000?oooooo`000?oo
ool05Oooool5o`000003ooooool0003ooooo01Gooooo1_l0000Gooooo`Ko00005_ooool7o`0001Ko
oooo1ol0000Fooooo`Oo00005_ooool6o`0000cooooo000;ooooo`?o00000oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooo000000;o00000oooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooo000000;o00000oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo000000;o0000
0oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo000000;o00000_ooool00ol0003ooooo
ooooo`0Cooooo`03o`000?oooooo000000;o00000_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo00?o00000_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00?o0000
0_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00?o00000_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo00?o00003Oooool000gooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00Go0000oooooooooooooooo
o`00000Cooooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
3?ooool000gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool03?ooool0
00gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool03?ooool000gooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool03?ooool000gooooo00?o0000
ooooooooool02_ooool01?l0003oooooooooool0000<ooooo`03o`000?oooooooooo00[ooooo00Co
0000oooooooooooo00003?ooool00ol0003oooooooooo`0:ooooo`04o`000?ooooooooooo`0000co
oooo00?o0000ooooooooool02_ooool01?l0003oooooooooool0000<ooooo`03o`000?oooooooooo
00Wooooo00Go0000ooooooooooooooooo`00000;ooooo`03o`000?oooooooooo00[ooooo00Co0000
oooooooooooo00003?ooool00ol0003oooooooooo`0:ooooo`04o`000?ooooooooooo`0000cooooo
00?o0000ooooooooool02_ooool01?l0003oooooooooool0000<ooooo`03o`000?oooooooooo00[o
oooo00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003o
ooooooooo`0;ooooo`;o00003Oooool00ol0003oooooooooo`0;ooooo`;o00003Oooool00ol0003o
ooooooooo`0;ooooo`;o00003Oooool00ol0003oooooooooo`0;ooooo`;o00003Oooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooo000000cooooo00?o0000ooooooooool02oooool2o`0000go
oooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02oooool2o`0000go
oooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool03?ooool000gooooo
00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02oooool2o`0000gooooo
00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02oooool2o`0000gooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo
0_l0000=ooooo`03o`000?oooooooooo00_ooooo0_l0000=ooooo`03o`000?oooooooooo00_ooooo
0_l0000=ooooo`03o`000?oooooooooo00_ooooo0_l0000=ooooo`03o`000?oooooooooo00cooooo
000=ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00003?ooool00ol0003ooooo
ooooo`0:ooooo`04o`000?ooooooooooo`0000cooooo00?o0000ooooooooool02_ooool01?l0003o
ooooooooool0000<ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00003?ooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooo000000cooooo00?o0000ooooooooool02_ooool0
1?l0003oooooooooool0000<ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo0000
3?ooool00ol0003oooooooooo`0:ooooo`04o`000?ooooooooooo`0000cooooo00?o0000oooooooo
ool02_ooool01?l0003oooooooooool0000<ooooo`03o`000?oooooooooo00cooooo000=ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00Wooooo00Go0000ooooooooooooooooo`00000;ooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
00cooooo000=ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00cooooo
000=ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00cooooo000=oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool03_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00cooooo000=ooooo`05o`000?ooooooooooooooool000005?ooool01Ol0003ooooo
oooooooooooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooooooooooooooo0000
00?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000
ooooooooool04_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04Ooo
ool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooo
oooooooooooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooooooooooooooo0000
00?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000
ooooooooool04_ooool01Ol0003ooooooooooooooooo000000kooooo000=ooooo`04o`000?oooooo
ooooo`0001Kooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Dooooo`04o`00
0?ooooooooooo`0000;ooooo00?o0000ooooooooool05?ooool01?l0003oooooooooool00002oooo
o`03o`000?oooooooooo01Cooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0C
ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool05?ooool01?l0003ooooooooo
ool00002ooooo`03o`000?oooooooooo01Cooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`0Dooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool05?ooool01?l0
003oooooooooool0000>ooooo`002oooool3o`000003ooooool0003ooooo01Oooooo0ol000000ooo
oooo0000ooooo`0Gooooo`?o000000?oooooo`000?ooool05oooool3o`000003ooooool0003ooooo
01Oooooo0ol000000ooooooo0000ooooo`0Fooooo`Go00006?ooool5o`0001Sooooo1Ol0000Hoooo
o`Go00006?ooool4o`0000gooooo000:ooooo`Go00006?ooool5o`0001Sooooo1Ol0000Hooooo`Go
00006?ooool5o`0001Sooooo1Ol0000Hooooo`Go00006?ooool5o`0001Sooooo1Ol0000Hooooo`Go
00003?ooool000Woooooool0000=o`0000_ooooo0009ooooo`Oo00005_ooool7o`0001Kooooo1ol0
000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0
000Fooooo`Oo00002oooool000Wooooo1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000F
ooooo`Oo00005_ooool7o`0001Kooooo1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000;
ooooo`002_ooool5o`000003ooooool0003ooooo01Gooooo1Ol000000ooooooo0000ooooo`0Eoooo
o`Go000000?oooooo`000?ooool05Oooool5o`000003ooooool0003ooooo01Gooooo1_l0000Goooo
o`Ko00005_ooool7o`0001Kooooo1ol0000Fooooo`Oo00005_ooool6o`0000cooooo000;ooooo`?o
00000oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo000000;o00000oooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooo000000;o00000oooool00ol0003oooooooooo`0Booooo`03
o`000?oooooo000000;o00000oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo000000;o
00000_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo000000;o00000_ooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo00?o00000_ooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo00?o00000_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00?o
00000_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00?o00003Oooool000gooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo
00Go0000ooooooooooooooooo`00000Cooooo`05o`000?ooooooooooooooool000001?ooool00ol0
003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool03?ooool000go
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool000gooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool03?ooool000gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool03?ooool000gooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool03?ooool000gooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
3?ooool000gooooo00?o0000ooooooooool02_ooool01?l0003oooooooooool0000<ooooo`03o`00
0?oooooooooo00[ooooo00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`0:ooooo`04
o`000?ooooooooooo`0000cooooo00?o0000ooooooooool02_ooool01?l0003oooooooooool0000<
ooooo`03o`000?oooooooooo00Wooooo00Go0000ooooooooooooooooo`00000;ooooo`03o`000?oo
oooooooo00[ooooo00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`0:ooooo`04o`00
0?ooooooooooo`0000cooooo00?o0000ooooooooool02_ooool01?l0003oooooooooool0000<oooo
o`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`0<
ooooo`003Oooool00ol0003oooooooooo`0;ooooo`;o00003Oooool00ol0003oooooooooo`0;oooo
o`;o00003Oooool00ol0003oooooooooo`0;ooooo`;o00003Oooool00ol0003oooooooooo`0;oooo
o`;o00003Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo000000cooooo00?o0000oooo
ooooool02oooool2o`0000gooooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000oooo
ooooool02oooool2o`0000gooooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000oooo
ooooool03?ooool000gooooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000oooooooo
ool02oooool2o`0000gooooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000oooooooo
ool02oooool2o`0000gooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo00_ooooo0_l0000=ooooo`03o`000?oooooooooo00_ooooo0_l0000=ooooo`03
o`000?oooooooooo00_ooooo0_l0000=ooooo`03o`000?oooooooooo00_ooooo0_l0000=ooooo`03
o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo
00003?ooool00ol0003oooooooooo`0:ooooo`04o`000?ooooooooooo`0000cooooo00?o0000oooo
ooooool02_ooool01?l0003oooooooooool0000<ooooo`03o`000?oooooooooo00[ooooo00Co0000
oooooooooooo00003?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo000000cooooo00?o
0000ooooooooool02_ooool01?l0003oooooooooool0000<ooooo`03o`000?oooooooooo00[ooooo
00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`0:ooooo`04o`000?ooooooooooo`00
00cooooo00?o0000ooooooooool02_ooool01?l0003oooooooooool0000<ooooo`03o`000?oooooo
oooo00cooooo000=ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00Go0000ooooooooooooooooo`00000;
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00cooooo000=ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00cooooo000=ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00cooooo000=ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool04?ooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool04?ooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool04?ooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool04?ooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool03oooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool04?ooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool04?ooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool04?ooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool04?ooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00cooooo000=ooooo`05o`000?ooooooooooooooool0
00005?ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0
003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooooooooooo
oooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooooooooooooooo000000?ooooo
00?o0000ooooooooool04Oooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000oooooooo
ool04_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0
003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooooooooooo
oooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooooooooooooooo000000kooooo
000=ooooo`04o`000?ooooooooooo`0001Kooooo00Co0000oooooooooooo00000_ooool00ol0003o
ooooooooo`0Dooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool05?ooool01?l0
003oooooooooool00002ooooo`03o`000?oooooooooo01Cooooo00Co0000oooooooooooo00000_oo
ool00ol0003oooooooooo`0Cooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool0
5?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo01Cooooo00Co0000oooooooo
oooo00000_ooool00ol0003oooooooooo`0Dooooo`04o`000?ooooooooooo`0000;ooooo00?o0000
ooooooooool05?ooool01?l0003oooooooooool0000>ooooo`002oooool3o`000003ooooool0003o
oooo01Oooooo0ol000000ooooooo0000ooooo`0Gooooo`?o000000?oooooo`000?ooool05oooool3
o`000003ooooool0003ooooo01Oooooo0ol000000ooooooo0000ooooo`0Fooooo`Go00006?ooool5
o`0001Sooooo1Ol0000Hooooo`Go00006?ooool4o`0000gooooo000:ooooo`Go00006?ooool5o`00
01Sooooo1Ol0000Hooooo`Go00006?ooool5o`0001Sooooo1Ol0000Hooooo`Go00006?ooool5o`00
01Sooooo1Ol0000Hooooo`Go00003?ooool000Woooooool0000=o`0000_ooooo0009ooooo`Oo0000
5_ooool7o`0001Kooooo1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000Fooooo`Oo0000
5_ooool7o`0001Kooooo1ol0000Fooooo`Oo00002oooool000Wooooo1ol0000Fooooo`Oo00005_oo
ool7o`0001Kooooo1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000Fooooo`Oo00005_oo
ool7o`0001Kooooo1ol0000;ooooo`002_ooool5o`000003ooooool0003ooooo01Gooooo1Ol00000
0ooooooo0000ooooo`0Eooooo`Go000000?oooooo`000?ooool05Oooool5o`000003ooooool0003o
oooo01Gooooo1_l0000Gooooo`Ko00005_ooool7o`0001Kooooo1ol0000Fooooo`Oo00005_ooool6
o`0000cooooo000;ooooo`?o00000oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo0000
00;o00000oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo000000;o00000oooool00ol0
003oooooooooo`0Booooo`03o`000?oooooo000000;o00000oooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooo000000;o00000_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo0000
00;o00000_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00?o00000_ooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo00?o00000_ooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo00?o00000_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
00?o00003Oooool000gooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`00000Cooooo`05o`000?oooooooooo
ooooool000001?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool03?ooool000gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0?oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0>oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool03?ooool000gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool03?oo
ool000gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool03?ooool000go
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool02_ooool01?l0003ooooo
ooooool0000<ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00003?ooool00ol0
003oooooooooo`0:ooooo`04o`000?ooooooooooo`0000cooooo00?o0000ooooooooool02_ooool0
1?l0003oooooooooool0000<ooooo`03o`000?oooooooooo00Wooooo00Go0000oooooooooooooooo
o`00000;ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00003?ooool00ol0003o
ooooooooo`0:ooooo`04o`000?ooooooooooo`0000cooooo00?o0000ooooooooool02_ooool01?l0
003oooooooooool0000<ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00003?oo
ool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003oooooooooo`0;ooooo`;o00003Oooool0
0ol0003oooooooooo`0;ooooo`;o00003Oooool00ol0003oooooooooo`0;ooooo`;o00003Oooool0
0ol0003oooooooooo`0;ooooo`;o00003Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
000000cooooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02oooool2
o`0000gooooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02oooool2
o`0000gooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool02oooool2o`00
00gooooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02oooool2o`00
00gooooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo0_l0000=ooooo`03o`000?oooooooooo
00_ooooo0_l0000=ooooo`03o`000?oooooooooo00_ooooo0_l0000=ooooo`03o`000?oooooooooo
00_ooooo0_l0000=ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00[o
oooo00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`0:ooooo`04o`000?oooooooooo
o`0000cooooo00?o0000ooooooooool02_ooool01?l0003oooooooooool0000<ooooo`03o`000?oo
oooooooo00[ooooo00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooo000000cooooo00?o0000ooooooooool02_ooool01?l0003oooooooooool0000<ooooo`03
o`000?oooooooooo00[ooooo00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`0:oooo
o`04o`000?ooooooooooo`0000cooooo00?o0000ooooooooool02_ooool01?l0003oooooooooool0
000<ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00Go0000
ooooooooooooooooo`00000;ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo00cooooo000=ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00co
oooo000=ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool02oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00cooooo000=
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool03oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00cooooo000=ooooo`05
o`000?ooooooooooooooool000005?ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000
ooooooooool04_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_oo
ool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooo
oooooooooooo000000?ooooo00?o0000ooooooooool04Oooool01Ol0003ooooooooooooooooo0000
00?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000
ooooooooool04_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_oo
ool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooo
oooooooooooo000000kooooo000=ooooo`04o`000?ooooooooooo`0001Kooooo00Co0000oooooooo
oooo00000_ooool00ol0003oooooooooo`0Dooooo`04o`000?ooooooooooo`0000;ooooo00?o0000
ooooooooool05?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo01Cooooo00Co
0000oooooooooooo00000_ooool00ol0003oooooooooo`0Cooooo`04o`000?ooooooooooo`0000;o
oooo00?o0000ooooooooool05?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo
01Cooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Dooooo`04o`000?oooooo
ooooo`0000;ooooo00?o0000ooooooooool05?ooool01?l0003oooooooooool0000>ooooo`002ooo
ool3o`000003ooooool0003ooooo01Oooooo0ol000000ooooooo0000ooooo`0Gooooo`?o000000?o
ooooo`000?ooool05oooool3o`000003ooooool0003ooooo01Oooooo0ol000000ooooooo0000oooo
o`0Fooooo`Go00006?ooool5o`0001Sooooo1Ol0000Hooooo`Go00006?ooool4o`0000gooooo000:
ooooo`Go00006?ooool5o`0001Sooooo1Ol0000Hooooo`Go00006?ooool5o`0001Sooooo1Ol0000H
ooooo`Go00006?ooool5o`0001Sooooo1Ol0000Hooooo`Go00003?ooool000Woooooool0000=o`00
00_ooooo0009ooooo`Oo00005_ooool7o`0001Kooooo1ol0000Fooooo`Oo00005_ooool7o`0001Ko
oooo1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000Fooooo`Oo00002oooool000Wooooo
1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo
1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000;ooooo`002_ooool5o`000003ooooool0
003ooooo01Gooooo1Ol000000ooooooo0000ooooo`0Eooooo`Go000000?oooooo`000?ooool05Ooo
ool5o`000003ooooool0003ooooo01Gooooo1_l0000Gooooo`Ko00005_ooool7o`0001Kooooo1ol0
000Fooooo`Oo00005_ooool6o`0000cooooo000;ooooo`?o00000oooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooo000000;o00000oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
000000;o00000oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo000000;o00000oooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooo000000;o00000_ooool00ol0003oooooooooo`0C
ooooo`03o`000?oooooo000000;o00000_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo00?o00000_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00?o00000_ooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo00?o00000_ooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooooooo00?o00003Oooool000gooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`00000C
ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`0@ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03?ooool0
00gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`0;ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool03?ooool000gooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool03?ooool000gooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool03?ooool000gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo00Wooooo00?o0000ooooooooool03?ooool000gooooo00?o0000oooooooo
ool02_ooool01?l0003oooooooooool0000<ooooo`03o`000?oooooooooo00[ooooo00Co0000oooo
oooooooo00003?ooool00ol0003oooooooooo`0:ooooo`04o`000?ooooooooooo`0000cooooo00?o
0000ooooooooool02_ooool01?l0003oooooooooool0000<ooooo`03o`000?oooooooooo00Wooooo
00Go0000ooooooooooooooooo`00000;ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooo
oooo00003?ooool00ol0003oooooooooo`0:ooooo`04o`000?ooooooooooo`0000cooooo00?o0000
ooooooooool02_ooool01?l0003oooooooooool0000<ooooo`03o`000?oooooooooo00[ooooo00Co
0000oooooooooooo00003?ooool00ol0003oooooooooo`0<ooooo`003Oooool00ol0003ooooooooo
o`0;ooooo`;o00003Oooool00ol0003oooooooooo`0;ooooo`;o00003Oooool00ol0003ooooooooo
o`0;ooooo`;o00003Oooool00ol0003oooooooooo`0;ooooo`;o00003Oooool00ol0003ooooooooo
o`0:ooooo`03o`000?oooooo000000cooooo00?o0000ooooooooool02oooool2o`0000gooooo00?o
0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02oooool2o`0000gooooo00?o
0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool03?ooool000gooooo00?o0000
ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000
ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00_ooooo0_l0000=
ooooo`03o`000?oooooooooo00_ooooo0_l0000=ooooo`03o`000?oooooooooo00_ooooo0_l0000=
ooooo`03o`000?oooooooooo00_ooooo0_l0000=ooooo`03o`000?oooooooooo00cooooo000=oooo
o`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`0:
ooooo`04o`000?ooooooooooo`0000cooooo00?o0000ooooooooool02_ooool01?l0003ooooooooo
ool0000<ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00003?ooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooo000000cooooo00?o0000ooooooooool02_ooool01?l0003o
ooooooooool0000<ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00003?ooool0
0ol0003oooooooooo`0:ooooo`04o`000?ooooooooooo`0000cooooo00?o0000ooooooooool02_oo
ool01?l0003oooooooooool0000<ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo00Wooooo00Go0000ooooooooooooooooo`00000;ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00cooooo
000=ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00cooooo000=oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool02Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_oo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_oo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_oo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_oo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_oo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_oo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_oo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_oo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo00cooooo000=ooooo`05o`000?ooooooooooooooool000005?ooool01Ol0003ooooooooooooo
oooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooooooooooooooo000000?ooooo
00?o0000ooooooooool04_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000oooooooo
ool04_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04Oooool01Ol0
003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooooooooooo
oooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooooooooooooooo000000?ooooo
00?o0000ooooooooool04_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000oooooooo
ool04_ooool01Ol0003ooooooooooooooooo000000kooooo000=ooooo`04o`000?ooooooooooo`00
01Kooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Dooooo`04o`000?oooooo
ooooo`0000;ooooo00?o0000ooooooooool05?ooool01?l0003oooooooooool00002ooooo`03o`00
0?oooooooooo01Cooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Cooooo`04
o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool05?ooool01?l0003oooooooooool00002
ooooo`03o`000?oooooooooo01Cooooo00Co0000oooooooooooo00000_ooool00ol0003ooooooooo
o`0Dooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool05?ooool01?l0003ooooo
ooooool0000>ooooo`002oooool3o`000003ooooool0003ooooo01Oooooo0ol000000ooooooo0000
ooooo`0Gooooo`?o000000?oooooo`000?ooool05oooool3o`000003ooooool0003ooooo01Oooooo
0ol000000ooooooo0000ooooo`0Fooooo`Go00006?ooool5o`0001Sooooo1Ol0000Hooooo`Go0000
6?ooool4o`0000gooooo000:ooooo`Go00006?ooool5o`0001Sooooo1Ol0000Hooooo`Go00006?oo
ool5o`0001Sooooo1Ol0000Hooooo`Go00006?ooool5o`0001Sooooo1Ol0000Hooooo`Go00003?oo
ool000Woooooool0000=o`0000_ooooo0009ooooo`Oo00005_ooool7o`0001Kooooo1ol0000Foooo
o`Oo00005_ooool7o`0001Kooooo1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000Foooo
o`Oo00002oooool000Wooooo1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000Fooooo`Oo
00005_ooool7o`0001Kooooo1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000;ooooo`00
2_ooool5o`000003ooooool0003ooooo01Gooooo1Ol000000ooooooo0000ooooo`0Eooooo`Go0000
00?oooooo`000?ooool05Oooool5o`000003ooooool0003ooooo01Gooooo1_l0000Gooooo`Ko0000
5_ooool7o`0001Kooooo1ol0000Fooooo`Oo00005_ooool6o`0000cooooo000;ooooo`?o00000ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooo000000;o00000oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooo000000;o00000oooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooo000000;o00000oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo000000;o00000_oo
ool00ol0003oooooooooo`0Cooooo`03o`000?oooooo000000;o00000_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo00?o00000_ooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo00?o00000_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00?o00000_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00?o00003Oooool000gooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00Go0000
ooooooooooooooooo`00000Cooooo`05o`000?ooooooooooooooool000001?ooool00ol0003ooooo
ooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`0@ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool03?ooool000gooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool03?ooool000gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0<
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0<
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0<
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0<
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0<
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0<
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0<
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0<
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool000gooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool03?ooool000gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
3?ooool000gooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool03?ooool000gooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool03?ooool0
00gooooo00?o0000ooooooooool02_ooool01?l0003oooooooooool0000<ooooo`03o`000?oooooo
oooo00[ooooo00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`0:ooooo`04o`000?oo
ooooooooo`0000cooooo00?o0000ooooooooool02_ooool01?l0003oooooooooool0000<ooooo`03
o`000?oooooooooo00Wooooo00Go0000ooooooooooooooooo`00000;ooooo`03o`000?oooooooooo
00[ooooo00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`0:ooooo`04o`000?oooooo
ooooo`0000cooooo00?o0000ooooooooool02_ooool01?l0003oooooooooool0000<ooooo`03o`00
0?oooooooooo00[ooooo00Co0000oooooooooooo00003?ooool00ol0003oooooooooo`0<ooooo`00
3Oooool00ol0003oooooooooo`0;ooooo`;o00003Oooool00ol0003oooooooooo`0;ooooo`;o0000
3Oooool00ol0003oooooooooo`0;ooooo`;o00003Oooool00ol0003oooooooooo`0;ooooo`;o0000
3Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo000000cooooo00?o0000ooooooooool0
2oooool2o`0000gooooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool0
2oooool2o`0000gooooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool0
3?ooool000gooooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02ooo
ool2o`0000gooooo00?o0000ooooooooool02oooool2o`0000gooooo00?o0000ooooooooool02ooo
ool2o`0000gooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo00_ooooo0_l0000=ooooo`03o`000?oooooooooo00_ooooo0_l0000=ooooo`03o`000?oo
oooooooo00_ooooo0_l0000=ooooo`03o`000?oooooooooo00_ooooo0_l0000=ooooo`03o`000?oo
oooooooo00cooooo000=ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00003?oo
ool00ol0003oooooooooo`0:ooooo`04o`000?ooooooooooo`0000cooooo00?o0000ooooooooool0
2_ooool01?l0003oooooooooool0000<ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooo
oooo00003?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo000000cooooo00?o0000oooo
ooooool02_ooool01?l0003oooooooooool0000<ooooo`03o`000?oooooooooo00[ooooo00Co0000
oooooooooooo00003?ooool00ol0003oooooooooo`0:ooooo`04o`000?ooooooooooo`0000cooooo
00?o0000ooooooooool02_ooool01?l0003oooooooooool0000<ooooo`03o`000?oooooooooo00co
oooo000=ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo00Wooooo00Go0000ooooooooooooooooo`00000;ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00cooooo000=ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00cooooo000=ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool02oooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00cooooo000=ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00cooooo
000=ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool04?ooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool04?ooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool04?ooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool04?ooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool03oooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool04?ooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool04?ooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool04?ooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool04?ooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00cooooo000=ooooo`05o`000?ooooooooooooooool000005?oo
ool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooo
oooooooooooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooooooooooooooo0000
00?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000
ooooooooool04Oooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_oo
ool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooo
oooooooooooo000000?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooooooooooooooo0000
00?ooooo00?o0000ooooooooool04_ooool01Ol0003ooooooooooooooooo000000kooooo000=oooo
o`04o`000?ooooooooooo`0001Kooooo00Co0000oooooooooooo00000_ooool00ol0003ooooooooo
o`0Dooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool05?ooool01?l0003ooooo
ooooool00002ooooo`03o`000?oooooooooo01Cooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`0Cooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool05?ooool0
1?l0003oooooooooool00002ooooo`03o`000?oooooooooo01Cooooo00Co0000oooooooooooo0000
0_ooool00ol0003oooooooooo`0Dooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooooooo
ool05?ooool01?l0003oooooooooool0000>ooooo`002oooool3o`000003ooooool0003ooooo01Oo
oooo0ol000000ooooooo0000ooooo`0Gooooo`?o000000?oooooo`000?ooool05oooool3o`000003
ooooool0003ooooo01Oooooo0ol000000ooooooo0000ooooo`0Fooooo`Go00006?ooool5o`0001So
oooo1Ol0000Hooooo`Go00006?ooool4o`0000gooooo000:ooooo`Go00006?ooool5o`0001Sooooo
1Ol0000Hooooo`Go00006?ooool5o`0001Sooooo1Ol0000Hooooo`Go00006?ooool5o`0001Sooooo
1Ol0000Hooooo`Go00003?ooool000Woooooool0000=o`0000_ooooo0009ooooo`Oo00005_ooool7
o`0001Kooooo1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000Fooooo`Oo00005_ooool7
o`0001Kooooo1ol0000Fooooo`Oo00002oooool000Wooooo1ol0000Fooooo`Oo00005_ooool7o`00
01Kooooo1ol0000Fooooo`Oo00005_ooool7o`0001Kooooo1ol0000Fooooo`Oo00005_ooool7o`00
01Kooooo1ol0000;ooooo`002_ooool5o`0001Sooooo1Ol0000Hooooo`Go00006?ooool5o`0001So
oooo1Ol0000Hooooo`Go00006?ooool5o`0001Sooooo1Ol0000Hooooo`Go00006?ooool5o`0000co
oooo000;ooooo`?o00006_ooool3o`0001[ooooo0ol0000Jooooo`?o00006_ooool3o`0001[ooooo
0ol0000Jooooo`?o00006_ooool3o`0001[ooooo0ol0000Jooooo`?o00003Oooool00?oooooo8Ooo
ool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Ooo
ool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-0.0500054, -0.0500054, \
0.00383279, 0.00383279}},
  CellTags->"LocalInteractions:42"]
}, Open  ]],

Cell["\<\
Some of the edges are obscurred. We can shake the graph to reveal \
all of the edges.\
\>", "Text",
  CellTags->"LocalInteractions:42"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(ShowGraph[\[IndentingNewLine]ShakeGraph[
          g,  .25]\[IndentingNewLine]];\)\)], "Input",
  CellLabel->"In[23]:=",
  CellTags->"LocalInteractions:42"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0390823 0.91516 0.0456949 0.913898 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 0 0 r
.005 w
[ ] 0 setdash
.07453 .0611 m
.16255 .08022 L
s
.07453 .0611 m
.26812 .04569 L
s
.07453 .0611 m
.05878 .14788 L
s
.07453 .0611 m
.15836 .16488 L
s
.07453 .0611 m
.0543 .24895 L
s
.16255 .08022 m
.26812 .04569 L
s
.16255 .08022 m
.34665 .07858 L
s
.16255 .08022 m
.05878 .14788 L
s
.16255 .08022 m
.15836 .16488 L
s
.16255 .08022 m
.25703 .1422 L
s
.16255 .08022 m
.13205 .25456 L
s
.26812 .04569 m
.34665 .07858 L
s
.26812 .04569 m
.4481 .06472 L
s
.26812 .04569 m
.15836 .16488 L
s
.26812 .04569 m
.25703 .1422 L
s
.26812 .04569 m
.35997 .15698 L
s
.26812 .04569 m
.27061 .24947 L
s
.34665 .07858 m
.4481 .06472 L
s
.34665 .07858 m
.54797 .06067 L
s
.34665 .07858 m
.25703 .1422 L
s
.34665 .07858 m
.35997 .15698 L
s
.34665 .07858 m
.46407 .15171 L
s
.34665 .07858 m
.3362 .2676 L
s
.4481 .06472 m
.54797 .06067 L
s
.4481 .06472 m
.64486 .064 L
s
.4481 .06472 m
.35997 .15698 L
s
.4481 .06472 m
.46407 .15171 L
s
.4481 .06472 m
.535 .14269 L
s
.4481 .06472 m
.44777 .25919 L
s
.54797 .06067 m
.64486 .064 L
s
.54797 .06067 m
.73871 .06617 L
s
.54797 .06067 m
.46407 .15171 L
s
.54797 .06067 m
.535 .14269 L
s
.54797 .06067 m
.64613 .14375 L
s
.54797 .06067 m
.5397 .25945 L
s
.64486 .064 m
.73871 .06617 L
s
.64486 .064 m
.84158 .0642 L
s
.64486 .064 m
.535 .14269 L
s
.64486 .064 m
.64613 .14375 L
s
.64486 .064 m
.74091 .145 L
s
.64486 .064 m
.6433 .26429 L
s
.73871 .06617 m
.84158 .0642 L
s
.73871 .06617 m
.94858 .05966 L
s
.73871 .06617 m
.64613 .14375 L
s
.73871 .06617 m
.74091 .145 L
s
.73871 .06617 m
.83653 .14641 L
s
.73871 .06617 m
.74066 .24899 L
s
.84158 .0642 m
.94858 .05966 L
s
.84158 .0642 m
.74091 .145 L
s
.84158 .0642 m
.83653 .14641 L
s
.84158 .0642 m
.9219 .16162 L
s
.84158 .0642 m
.82486 .26432 L
s
.94858 .05966 m
.83653 .14641 L
s
.94858 .05966 m
.9219 .16162 L
s
.94858 .05966 m
.95216 .25878 L
s
.05878 .14788 m
.15836 .16488 L
s
.05878 .14788 m
.25703 .1422 L
s
.05878 .14788 m
.0543 .24895 L
s
.05878 .14788 m
.13205 .25456 L
s
.05878 .14788 m
.04576 .33411 L
s
.15836 .16488 m
.25703 .1422 L
s
.15836 .16488 m
.35997 .15698 L
s
.15836 .16488 m
.0543 .24895 L
s
.15836 .16488 m
.13205 .25456 L
s
.15836 .16488 m
.27061 .24947 L
s
.15836 .16488 m
.14883 .35462 L
s
.25703 .1422 m
.35997 .15698 L
s
.25703 .1422 m
.46407 .15171 L
s
.25703 .1422 m
.13205 .25456 L
s
.25703 .1422 m
.27061 .24947 L
s
.25703 .1422 m
.3362 .2676 L
s
.25703 .1422 m
.2658 .35208 L
s
.35997 .15698 m
.46407 .15171 L
s
.35997 .15698 m
.535 .14269 L
s
.35997 .15698 m
.27061 .24947 L
s
.35997 .15698 m
.3362 .2676 L
s
.35997 .15698 m
.44777 .25919 L
s
.35997 .15698 m
.35654 .35521 L
s
.46407 .15171 m
.535 .14269 L
s
.46407 .15171 m
.64613 .14375 L
s
.46407 .15171 m
.3362 .2676 L
s
.46407 .15171 m
.44777 .25919 L
s
.46407 .15171 m
.5397 .25945 L
s
.46407 .15171 m
.46449 .35882 L
s
.535 .14269 m
.64613 .14375 L
s
.535 .14269 m
.74091 .145 L
s
.535 .14269 m
.44777 .25919 L
s
.535 .14269 m
.5397 .25945 L
s
.535 .14269 m
.6433 .26429 L
s
.535 .14269 m
.53157 .3462 L
s
.64613 .14375 m
.74091 .145 L
s
.64613 .14375 m
.83653 .14641 L
s
.64613 .14375 m
.5397 .25945 L
s
.64613 .14375 m
.6433 .26429 L
s
.64613 .14375 m
.74066 .24899 L
s
.64613 .14375 m
.65467 .34511 L
s
.74091 .145 m
.83653 .14641 L
s
.74091 .145 m
.9219 .16162 L
s
.74091 .145 m
.6433 .26429 L
s
.74091 .145 m
.74066 .24899 L
s
.74091 .145 m
.82486 .26432 L
s
.74091 .145 m
.74559 .36415 L
s
.83653 .14641 m
.9219 .16162 L
s
.83653 .14641 m
.74066 .24899 L
s
.83653 .14641 m
.82486 .26432 L
s
.83653 .14641 m
.95216 .25878 L
s
.83653 .14641 m
.83267 .34634 L
s
.9219 .16162 m
.82486 .26432 L
s
.9219 .16162 m
.95216 .25878 L
s
.9219 .16162 m
.93309 .35658 L
s
.0543 .24895 m
.13205 .25456 L
s
.0543 .24895 m
.27061 .24947 L
s
.0543 .24895 m
.04576 .33411 L
s
.0543 .24895 m
.14883 .35462 L
s
.0543 .24895 m
.05535 .4734 L
s
.13205 .25456 m
.27061 .24947 L
s
.13205 .25456 m
.3362 .2676 L
s
.13205 .25456 m
.04576 .33411 L
s
.13205 .25456 m
.14883 .35462 L
s
.13205 .25456 m
.2658 .35208 L
s
.13205 .25456 m
.14836 .45883 L
s
.27061 .24947 m
.3362 .2676 L
s
.27061 .24947 m
.44777 .25919 L
s
.27061 .24947 m
.14883 .35462 L
s
.27061 .24947 m
.2658 .35208 L
s
.27061 .24947 m
.35654 .35521 L
s
.27061 .24947 m
.23321 .44205 L
s
.3362 .2676 m
.44777 .25919 L
s
.3362 .2676 m
.5397 .25945 L
s
.3362 .2676 m
.2658 .35208 L
s
.3362 .2676 m
.35654 .35521 L
s
.3362 .2676 m
.46449 .35882 L
s
.3362 .2676 m
.35092 .45024 L
s
.44777 .25919 m
.5397 .25945 L
s
.44777 .25919 m
.6433 .26429 L
s
.44777 .25919 m
.35654 .35521 L
s
.44777 .25919 m
.46449 .35882 L
s
.44777 .25919 m
.53157 .3462 L
s
.44777 .25919 m
.44177 .44814 L
s
.5397 .25945 m
.6433 .26429 L
s
.5397 .25945 m
.74066 .24899 L
s
.5397 .25945 m
.46449 .35882 L
s
.5397 .25945 m
.53157 .3462 L
s
.5397 .25945 m
.65467 .34511 L
s
.5397 .25945 m
.55608 .43658 L
s
.6433 .26429 m
.74066 .24899 L
s
.6433 .26429 m
.82486 .26432 L
s
.6433 .26429 m
.53157 .3462 L
s
.6433 .26429 m
.65467 .34511 L
s
.6433 .26429 m
.74559 .36415 L
s
.6433 .26429 m
.63075 .44587 L
s
.74066 .24899 m
.82486 .26432 L
s
.74066 .24899 m
.95216 .25878 L
s
.74066 .24899 m
.65467 .34511 L
s
.74066 .24899 m
.74559 .36415 L
s
.74066 .24899 m
.83267 .34634 L
s
.74066 .24899 m
.73927 .45717 L
s
.82486 .26432 m
.95216 .25878 L
s
.82486 .26432 m
.74559 .36415 L
s
.82486 .26432 m
.83267 .34634 L
s
.82486 .26432 m
.93309 .35658 L
s
.82486 .26432 m
.82982 .43309 L
s
.95216 .25878 m
.83267 .34634 L
s
.95216 .25878 m
.93309 .35658 L
s
.95216 .25878 m
.94894 .46326 L
s
.04576 .33411 m
.14883 .35462 L
s
.04576 .33411 m
.2658 .35208 L
s
.04576 .33411 m
.05535 .4734 L
s
.04576 .33411 m
.14836 .45883 L
s
.04576 .33411 m
.06745 .55114 L
s
.14883 .35462 m
.2658 .35208 L
s
.14883 .35462 m
.35654 .35521 L
s
.14883 .35462 m
.05535 .4734 L
s
.14883 .35462 m
.14836 .45883 L
s
.14883 .35462 m
.23321 .44205 L
s
.14883 .35462 m
.15127 .53421 L
s
.2658 .35208 m
.35654 .35521 L
s
.2658 .35208 m
.46449 .35882 L
s
.2658 .35208 m
.14836 .45883 L
s
.2658 .35208 m
.23321 .44205 L
s
.2658 .35208 m
.35092 .45024 L
s
.2658 .35208 m
.25211 .53555 L
s
.35654 .35521 m
.46449 .35882 L
s
.35654 .35521 m
.53157 .3462 L
s
.35654 .35521 m
.23321 .44205 L
s
.35654 .35521 m
.35092 .45024 L
s
.35654 .35521 m
.44177 .44814 L
s
.35654 .35521 m
.34444 .55639 L
s
.46449 .35882 m
.53157 .3462 L
s
.46449 .35882 m
.65467 .34511 L
s
.46449 .35882 m
.35092 .45024 L
s
.46449 .35882 m
.44177 .44814 L
s
.46449 .35882 m
.55608 .43658 L
s
.46449 .35882 m
.45507 .56573 L
s
.53157 .3462 m
.65467 .34511 L
s
.53157 .3462 m
.74559 .36415 L
s
.53157 .3462 m
.44177 .44814 L
s
.53157 .3462 m
.55608 .43658 L
s
.53157 .3462 m
.63075 .44587 L
s
.53157 .3462 m
.53946 .55 L
s
.65467 .34511 m
.74559 .36415 L
s
.65467 .34511 m
.83267 .34634 L
s
.65467 .34511 m
.55608 .43658 L
s
.65467 .34511 m
.63075 .44587 L
s
.65467 .34511 m
.73927 .45717 L
s
.65467 .34511 m
.63136 .54663 L
s
.74559 .36415 m
.83267 .34634 L
s
.74559 .36415 m
.93309 .35658 L
s
.74559 .36415 m
.63075 .44587 L
s
.74559 .36415 m
.73927 .45717 L
s
.74559 .36415 m
.82982 .43309 L
s
.74559 .36415 m
.73413 .54266 L
s
.83267 .34634 m
.93309 .35658 L
s
.83267 .34634 m
.73927 .45717 L
s
.83267 .34634 m
.82982 .43309 L
s
.83267 .34634 m
.94894 .46326 L
s
.83267 .34634 m
.85862 .54499 L
s
.93309 .35658 m
.82982 .43309 L
s
.93309 .35658 m
.94894 .46326 L
s
.93309 .35658 m
.93056 .5528 L
s
.05535 .4734 m
.14836 .45883 L
s
.05535 .4734 m
.23321 .44205 L
s
.05535 .4734 m
.06745 .55114 L
s
.05535 .4734 m
.15127 .53421 L
s
.05535 .4734 m
.05637 .64903 L
s
.14836 .45883 m
.23321 .44205 L
s
.14836 .45883 m
.35092 .45024 L
s
.14836 .45883 m
.06745 .55114 L
s
.14836 .45883 m
.15127 .53421 L
s
.14836 .45883 m
.25211 .53555 L
s
.14836 .45883 m
.15044 .65797 L
s
.23321 .44205 m
.35092 .45024 L
s
.23321 .44205 m
.44177 .44814 L
s
.23321 .44205 m
.15127 .53421 L
s
.23321 .44205 m
.25211 .53555 L
s
.23321 .44205 m
.34444 .55639 L
s
.23321 .44205 m
.25133 .66244 L
s
.35092 .45024 m
.44177 .44814 L
s
.35092 .45024 m
.55608 .43658 L
s
.35092 .45024 m
.25211 .53555 L
s
.35092 .45024 m
.34444 .55639 L
s
.35092 .45024 m
.45507 .56573 L
s
.35092 .45024 m
.33233 .63819 L
s
.44177 .44814 m
.55608 .43658 L
s
.44177 .44814 m
.63075 .44587 L
s
.44177 .44814 m
.34444 .55639 L
s
.44177 .44814 m
.45507 .56573 L
s
.44177 .44814 m
.53946 .55 L
s
.44177 .44814 m
.44638 .64755 L
s
.55608 .43658 m
.63075 .44587 L
s
.55608 .43658 m
.73927 .45717 L
s
.55608 .43658 m
.45507 .56573 L
s
.55608 .43658 m
.53946 .55 L
s
.55608 .43658 m
.63136 .54663 L
s
.55608 .43658 m
.54578 .65884 L
s
.63075 .44587 m
.73927 .45717 L
s
.63075 .44587 m
.82982 .43309 L
s
.63075 .44587 m
.53946 .55 L
s
.63075 .44587 m
.63136 .54663 L
s
.63075 .44587 m
.73413 .54266 L
s
.63075 .44587 m
.63855 .65372 L
s
.73927 .45717 m
.82982 .43309 L
s
.73927 .45717 m
.94894 .46326 L
s
.73927 .45717 m
.63136 .54663 L
s
.73927 .45717 m
.73413 .54266 L
s
.73927 .45717 m
.85862 .54499 L
s
.73927 .45717 m
.7382 .64099 L
s
.82982 .43309 m
.94894 .46326 L
s
.82982 .43309 m
.73413 .54266 L
s
.82982 .43309 m
.85862 .54499 L
s
.82982 .43309 m
.93056 .5528 L
s
.82982 .43309 m
.83992 .62743 L
s
.94894 .46326 m
.85862 .54499 L
s
.94894 .46326 m
.93056 .5528 L
s
.94894 .46326 m
.95424 .65683 L
s
.06745 .55114 m
.15127 .53421 L
s
.06745 .55114 m
.25211 .53555 L
s
.06745 .55114 m
.05637 .64903 L
s
.06745 .55114 m
.15044 .65797 L
s
.06745 .55114 m
.06492 .72424 L
s
.15127 .53421 m
.25211 .53555 L
s
.15127 .53421 m
.34444 .55639 L
s
.15127 .53421 m
.05637 .64903 L
s
.15127 .53421 m
.15044 .65797 L
s
.15127 .53421 m
.25133 .66244 L
s
.15127 .53421 m
.14545 .72999 L
s
.25211 .53555 m
.34444 .55639 L
s
.25211 .53555 m
.45507 .56573 L
s
.25211 .53555 m
.15044 .65797 L
s
.25211 .53555 m
.25133 .66244 L
s
.25211 .53555 m
.33233 .63819 L
s
.25211 .53555 m
.23152 .73931 L
s
.34444 .55639 m
.45507 .56573 L
s
.34444 .55639 m
.53946 .55 L
s
.34444 .55639 m
.25133 .66244 L
s
.34444 .55639 m
.33233 .63819 L
s
.34444 .55639 m
.44638 .64755 L
s
.34444 .55639 m
.34507 .74964 L
s
.45507 .56573 m
.53946 .55 L
s
.45507 .56573 m
.63136 .54663 L
s
.45507 .56573 m
.33233 .63819 L
s
.45507 .56573 m
.44638 .64755 L
s
.45507 .56573 m
.54578 .65884 L
s
.45507 .56573 m
.44519 .75069 L
s
.53946 .55 m
.63136 .54663 L
s
.53946 .55 m
.73413 .54266 L
s
.53946 .55 m
.44638 .64755 L
s
.53946 .55 m
.54578 .65884 L
s
.53946 .55 m
.63855 .65372 L
s
.53946 .55 m
.54654 .73384 L
s
.63136 .54663 m
.73413 .54266 L
s
.63136 .54663 m
.85862 .54499 L
s
.63136 .54663 m
.54578 .65884 L
s
.63136 .54663 m
.63855 .65372 L
s
.63136 .54663 m
.7382 .64099 L
s
.63136 .54663 m
.64326 .73952 L
s
.73413 .54266 m
.85862 .54499 L
s
.73413 .54266 m
.93056 .5528 L
s
.73413 .54266 m
.63855 .65372 L
s
.73413 .54266 m
.7382 .64099 L
s
.73413 .54266 m
.83992 .62743 L
s
.73413 .54266 m
.71638 .73679 L
s
.85862 .54499 m
.93056 .5528 L
s
.85862 .54499 m
.7382 .64099 L
s
.85862 .54499 m
.83992 .62743 L
s
.85862 .54499 m
.95424 .65683 L
s
.85862 .54499 m
.81428 .7497 L
s
.93056 .5528 m
.83992 .62743 L
s
.93056 .5528 m
.95424 .65683 L
s
.93056 .5528 m
.94297 .72952 L
s
.05637 .64903 m
.15044 .65797 L
s
.05637 .64903 m
.25133 .66244 L
s
.05637 .64903 m
.06492 .72424 L
s
.05637 .64903 m
.14545 .72999 L
s
.05637 .64903 m
.05559 .83984 L
s
.15044 .65797 m
.25133 .66244 L
s
.15044 .65797 m
.33233 .63819 L
s
.15044 .65797 m
.06492 .72424 L
s
.15044 .65797 m
.14545 .72999 L
s
.15044 .65797 m
.23152 .73931 L
s
.15044 .65797 m
.15549 .8223 L
s
.25133 .66244 m
.33233 .63819 L
s
.25133 .66244 m
.44638 .64755 L
s
.25133 .66244 m
.14545 .72999 L
s
.25133 .66244 m
.23152 .73931 L
s
.25133 .66244 m
.34507 .74964 L
s
.25133 .66244 m
.25507 .83917 L
s
.33233 .63819 m
.44638 .64755 L
s
.33233 .63819 m
.54578 .65884 L
s
.33233 .63819 m
.23152 .73931 L
s
.33233 .63819 m
.34507 .74964 L
s
.33233 .63819 m
.44519 .75069 L
s
.33233 .63819 m
.3515 .84393 L
s
.44638 .64755 m
.54578 .65884 L
s
.44638 .64755 m
.63855 .65372 L
s
.44638 .64755 m
.34507 .74964 L
s
.44638 .64755 m
.44519 .75069 L
s
.44638 .64755 m
.54654 .73384 L
s
.44638 .64755 m
.44237 .84933 L
s
.54578 .65884 m
.63855 .65372 L
s
.54578 .65884 m
.7382 .64099 L
s
.54578 .65884 m
.44519 .75069 L
s
.54578 .65884 m
.54654 .73384 L
s
.54578 .65884 m
.64326 .73952 L
s
.54578 .65884 m
.54169 .82153 L
s
.63855 .65372 m
.7382 .64099 L
s
.63855 .65372 m
.83992 .62743 L
s
.63855 .65372 m
.54654 .73384 L
s
.63855 .65372 m
.64326 .73952 L
s
.63855 .65372 m
.71638 .73679 L
s
.63855 .65372 m
.64394 .84301 L
s
.7382 .64099 m
.83992 .62743 L
s
.7382 .64099 m
.95424 .65683 L
s
.7382 .64099 m
.64326 .73952 L
s
.7382 .64099 m
.71638 .73679 L
s
.7382 .64099 m
.81428 .7497 L
s
.7382 .64099 m
.74844 .83926 L
s
.83992 .62743 m
.95424 .65683 L
s
.83992 .62743 m
.71638 .73679 L
s
.83992 .62743 m
.81428 .7497 L
s
.83992 .62743 m
.94297 .72952 L
s
.83992 .62743 m
.83626 .86333 L
s
.95424 .65683 m
.81428 .7497 L
s
.95424 .65683 m
.94297 .72952 L
s
.95424 .65683 m
.92676 .84835 L
s
.06492 .72424 m
.14545 .72999 L
s
.06492 .72424 m
.23152 .73931 L
s
.06492 .72424 m
.05559 .83984 L
s
.06492 .72424 m
.15549 .8223 L
s
.06492 .72424 m
.06175 .91805 L
s
.14545 .72999 m
.23152 .73931 L
s
.14545 .72999 m
.34507 .74964 L
s
.14545 .72999 m
.05559 .83984 L
s
.14545 .72999 m
.15549 .8223 L
s
.14545 .72999 m
.25507 .83917 L
s
.14545 .72999 m
.13892 .93346 L
s
.23152 .73931 m
.34507 .74964 L
s
.23152 .73931 m
.44519 .75069 L
s
.23152 .73931 m
.15549 .8223 L
s
.23152 .73931 m
.25507 .83917 L
s
.23152 .73931 m
.3515 .84393 L
s
.23152 .73931 m
.2679 .95077 L
s
.34507 .74964 m
.44519 .75069 L
s
.34507 .74964 m
.54654 .73384 L
s
.34507 .74964 m
.25507 .83917 L
s
.34507 .74964 m
.3515 .84393 L
s
.34507 .74964 m
.44237 .84933 L
s
.34507 .74964 m
.35573 .92018 L
s
.44519 .75069 m
.54654 .73384 L
s
.44519 .75069 m
.64326 .73952 L
s
.44519 .75069 m
.3515 .84393 L
s
.44519 .75069 m
.44237 .84933 L
s
.44519 .75069 m
.54169 .82153 L
s
.44519 .75069 m
.45012 .95431 L
s
.54654 .73384 m
.64326 .73952 L
s
.54654 .73384 m
.71638 .73679 L
s
.54654 .73384 m
.44237 .84933 L
s
.54654 .73384 m
.54169 .82153 L
s
.54654 .73384 m
.64394 .84301 L
s
.54654 .73384 m
.53949 .92259 L
s
.64326 .73952 m
.71638 .73679 L
s
.64326 .73952 m
.81428 .7497 L
s
.64326 .73952 m
.54169 .82153 L
s
.64326 .73952 m
.64394 .84301 L
s
.64326 .73952 m
.74844 .83926 L
s
.64326 .73952 m
.64655 .93499 L
s
.71638 .73679 m
.81428 .7497 L
s
.71638 .73679 m
.94297 .72952 L
s
.71638 .73679 m
.64394 .84301 L
s
.71638 .73679 m
.74844 .83926 L
s
.71638 .73679 m
.83626 .86333 L
s
.71638 .73679 m
.76028 .93662 L
s
.81428 .7497 m
.94297 .72952 L
s
.81428 .7497 m
.74844 .83926 L
s
.81428 .7497 m
.83626 .86333 L
s
.81428 .7497 m
.92676 .84835 L
s
.81428 .7497 m
.83894 .93581 L
s
.94297 .72952 m
.83626 .86333 L
s
.94297 .72952 m
.92676 .84835 L
s
.94297 .72952 m
.94576 .9418 L
s
.05559 .83984 m
.15549 .8223 L
s
.05559 .83984 m
.25507 .83917 L
s
.05559 .83984 m
.06175 .91805 L
s
.05559 .83984 m
.13892 .93346 L
s
.15549 .8223 m
.25507 .83917 L
s
.15549 .8223 m
.3515 .84393 L
s
.15549 .8223 m
.06175 .91805 L
s
.15549 .8223 m
.13892 .93346 L
s
.15549 .8223 m
.2679 .95077 L
s
.25507 .83917 m
.3515 .84393 L
s
.25507 .83917 m
.44237 .84933 L
s
.25507 .83917 m
.13892 .93346 L
s
.25507 .83917 m
.2679 .95077 L
s
.25507 .83917 m
.35573 .92018 L
s
.3515 .84393 m
.44237 .84933 L
s
.3515 .84393 m
.54169 .82153 L
s
.3515 .84393 m
.2679 .95077 L
s
.3515 .84393 m
.35573 .92018 L
s
.3515 .84393 m
.45012 .95431 L
s
.44237 .84933 m
.54169 .82153 L
s
.44237 .84933 m
.64394 .84301 L
s
.44237 .84933 m
.35573 .92018 L
s
.44237 .84933 m
.45012 .95431 L
s
.44237 .84933 m
.53949 .92259 L
s
.54169 .82153 m
.64394 .84301 L
s
.54169 .82153 m
.74844 .83926 L
s
.54169 .82153 m
.45012 .95431 L
s
.54169 .82153 m
.53949 .92259 L
s
.54169 .82153 m
.64655 .93499 L
s
.64394 .84301 m
.74844 .83926 L
s
.64394 .84301 m
.83626 .86333 L
s
.64394 .84301 m
.53949 .92259 L
s
.64394 .84301 m
.64655 .93499 L
s
.64394 .84301 m
.76028 .93662 L
s
.74844 .83926 m
.83626 .86333 L
s
.74844 .83926 m
.92676 .84835 L
s
.74844 .83926 m
.64655 .93499 L
s
.74844 .83926 m
.76028 .93662 L
s
.74844 .83926 m
.83894 .93581 L
s
.83626 .86333 m
.92676 .84835 L
s
.83626 .86333 m
.76028 .93662 L
s
.83626 .86333 m
.83894 .93581 L
s
.83626 .86333 m
.94576 .9418 L
s
.92676 .84835 m
.83894 .93581 L
s
.92676 .84835 m
.94576 .9418 L
s
.06175 .91805 m
.13892 .93346 L
s
.06175 .91805 m
.2679 .95077 L
s
.13892 .93346 m
.2679 .95077 L
s
.13892 .93346 m
.35573 .92018 L
s
.2679 .95077 m
.35573 .92018 L
s
.2679 .95077 m
.45012 .95431 L
s
.35573 .92018 m
.45012 .95431 L
s
.35573 .92018 m
.53949 .92259 L
s
.45012 .95431 m
.53949 .92259 L
s
.45012 .95431 m
.64655 .93499 L
s
.53949 .92259 m
.64655 .93499 L
s
.53949 .92259 m
.76028 .93662 L
s
.64655 .93499 m
.76028 .93662 L
s
.64655 .93499 m
.83894 .93581 L
s
.76028 .93662 m
.83894 .93581 L
s
.76028 .93662 m
.94576 .9418 L
s
.83894 .93581 m
.94576 .9418 L
s
.025 w
.07453 .0611 Mdot
.16255 .08022 Mdot
.26812 .04569 Mdot
.34665 .07858 Mdot
.4481 .06472 Mdot
.54797 .06067 Mdot
.64486 .064 Mdot
.73871 .06617 Mdot
.84158 .0642 Mdot
.94858 .05966 Mdot
.05878 .14788 Mdot
.15836 .16488 Mdot
.25703 .1422 Mdot
.35997 .15698 Mdot
.46407 .15171 Mdot
.535 .14269 Mdot
.64613 .14375 Mdot
.74091 .145 Mdot
.83653 .14641 Mdot
.9219 .16162 Mdot
.0543 .24895 Mdot
.13205 .25456 Mdot
.27061 .24947 Mdot
.3362 .2676 Mdot
.44777 .25919 Mdot
.5397 .25945 Mdot
.6433 .26429 Mdot
.74066 .24899 Mdot
.82486 .26432 Mdot
.95216 .25878 Mdot
.04576 .33411 Mdot
.14883 .35462 Mdot
.2658 .35208 Mdot
.35654 .35521 Mdot
.46449 .35882 Mdot
.53157 .3462 Mdot
.65467 .34511 Mdot
.74559 .36415 Mdot
.83267 .34634 Mdot
.93309 .35658 Mdot
.05535 .4734 Mdot
.14836 .45883 Mdot
.23321 .44205 Mdot
.35092 .45024 Mdot
.44177 .44814 Mdot
.55608 .43658 Mdot
.63075 .44587 Mdot
.73927 .45717 Mdot
.82982 .43309 Mdot
.94894 .46326 Mdot
.06745 .55114 Mdot
.15127 .53421 Mdot
.25211 .53555 Mdot
.34444 .55639 Mdot
.45507 .56573 Mdot
.53946 .55 Mdot
.63136 .54663 Mdot
.73413 .54266 Mdot
.85862 .54499 Mdot
.93056 .5528 Mdot
.05637 .64903 Mdot
.15044 .65797 Mdot
.25133 .66244 Mdot
.33233 .63819 Mdot
.44638 .64755 Mdot
.54578 .65884 Mdot
.63855 .65372 Mdot
.7382 .64099 Mdot
.83992 .62743 Mdot
.95424 .65683 Mdot
.06492 .72424 Mdot
.14545 .72999 Mdot
.23152 .73931 Mdot
.34507 .74964 Mdot
.44519 .75069 Mdot
.54654 .73384 Mdot
.64326 .73952 Mdot
.71638 .73679 Mdot
.81428 .7497 Mdot
.94297 .72952 Mdot
.05559 .83984 Mdot
.15549 .8223 Mdot
.25507 .83917 Mdot
.3515 .84393 Mdot
.44237 .84933 Mdot
.54169 .82153 Mdot
.64394 .84301 Mdot
.74844 .83926 Mdot
.83626 .86333 Mdot
.92676 .84835 Mdot
.06175 .91805 Mdot
.13892 .93346 Mdot
.2679 .95077 Mdot
.35573 .92018 Mdot
.45012 .95431 Mdot
.53949 .92259 Mdot
.64655 .93499 Mdot
.76028 .93662 Mdot
.83894 .93581 Mdot
.94576 .9418 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[23]:=",
  ImageSize->{288, 288},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000182000`400?l00000o`00003ooooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00Boooool3o`000=;ooooo001:ooooo`Go0000dOooool004Wooooo1ol0003@ooooo`00AOoo
ool=o`000<kooooo000Dooooo`?o00008?ooool>o`0000?ooooo2Ol000000ooooooo0000o`000009
o`0003oooooo0ol0001`ooooo`?o00003_ooool001?ooooo1Ol0000Booooo`go00003_ooool3o`00
00;ooooo1Ol00002ooooo`;o00002_ooool:o`0001Sooooo0ol0000Iooooo`Go00006?ooool3o`00
03Gooooo0ol0000Kooooo`Go00003Oooool001;ooooo1ol00003ooooo`ko00006?ooool3o`0000Go
oooo1Ol00004ooooo`?o00004Oooool:o`0000gooooo1Ol0000Gooooo`Oo00005_ooool5o`0001Ko
oooo0ol0000Jooooo`Go00006Oooool7o`0000cooooo000Booooo`[o00008oooool3o`0000Oooooo
00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`04ooooo`?o00006?ooool;o`000003
ooooool0003o000000Go00002oooool^o`0001Cooooo1Ol0000HooooobKo00003?ooool001;ooooo
2_l0000Pooooo`?o00002Oooool00ol0003oooooooooo`02o`0000?ooooo00?o0000ooooooooool0
1_ooool2o`00027oooooQOl0000<ooooo`Oo00003?ooool001?ooooo1Ol00004ooooo`Co00006Ooo
ool3o`0000_ooooo00Co0000oooooooooooooooo0_l00004ooooo`03o`000?oooooooooo00Oooooo
0ol00004ooooo`?o00004?ooool7o`000003ooooool0003o000000go00003oooool6o`0001Gooooo
1ol0000Cooooo`Oo00005oooool7o`0001Sooooo1_l0000=ooooo`005?ooool4o`0000Sooooo1Ol0
0008ooooo`?o00001_ooool3o`0000gooooo00?o0000ooooooooool00_ooool2o`0000Cooooo00?o
0000ooooooooool02_ooool2o`000003ooooool0003o000000?o00002?oooolFo`0001Oooooo1?l0
0002ooooo`03o`000?oooooooooo017ooooo2?l0000Cooooo`So00005_ooool6o`0001Sooooo00?o
0000ooooooooool00ol0000>ooooo`005?ooool2o`0000;ooooo00?o0000ooooooooool02_ooool4
o`0000?ooooo1Ol00002ooooo`?o00003oooool00ol0003oooooooooo`03ooooo`;o00001Oooool0
0ol0003oooooooooo`0;oooooaCo00002_ooool4o`0000;ooooo00?o0000ooooooooool04oooool0
1?l0003oooooo`000?l00004ooooo`03o`000?oooooooooo00oooooo00Co0000oooooooooooooooo
0ol00002ooooo`03o`000?oooooooooo013ooooo1_l00002ooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool01?l0000Fooooo`;o00000oooool2o`0000oooooo000Dooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool03Oooool:o`00017ooooo00?o0000ooooooooool00_oo
oolPo`0001Cooooo00?o0000ooooooooool00_l00003ooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool00_l00005ooooo`03o`000?oooooooooo00cooooo0_l00005ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03o`0000Cooooo00?o
0000ooooooooool03oooool2o`0000Cooooo00Co0000oooooooooooo00005?ooool00ol0003ooooo
ooooo`03ooooo`;o00003oooool001Cooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`0?oooooako00000_ooool2o`0000Oooooo00?o0000ooooooooool02Oooool7o`0001Gooooo00Co
0000oooooooooooooooo0_l00004ooooo`03o`000?oooooooooo00oooooo00Co0000oooooooooooo
oooo0_l00006ooooo`;o00002oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`04ooooo`05o`000?oooooooooooooo
ool000004_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooo000000oooooo000Dooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool7o`00013ooooo00?o0000oooooooo
ool01_ooool2o`0000Sooooo00?o0000ooooooooool01oooool9o`0001?ooooo00?o0000oooooooo
ool00_ooool2o`0000Gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`02ooooo`;o
00002?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool01?ooool2o`0000[ooooo0_l00006ooooo`03o`000?oooooooooo00Cooooo0_l0000<ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0=ooooo`;o
00001_ooool00ol0003oooooo`00000?ooooo`004oooool2o`0000Kooooo00?o0000ooooooooool0
3?ooool9o`0000oooooo00?o0000ooooooooool01_ooool2o`0000Wooooo00?o0000ooooooooool0
1Oooool01?l0003oooooooooooooool3o`0000?ooooo0_l0000@ooooo`03o`000?oooooooooo00?o
oooo0_l00006ooooo`;o00003?ooool00ol0003oooooooooo`03ooooo`;o00002Oooool00ol0003o
ooooooooo`04ooooo`;o00002Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool01Oooool2o`0000Cooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooo000000oooooo000Cooooo`;o00001oooool00ol0003ooooo
ooooo`09ooooo`;o00000oooool3o`0000?ooooo0_l0000<ooooo`03o`000?oooooooooo00Oooooo
0_l0000:ooooo`03o`000?oooooooooo00;ooooo0_l00005ooooo`;o00001Oooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooool000001oooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Cooooo0_l0000:ooooo`03o`000?oooooooooo00;ooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Gooooo
0_l00008ooooo`;o00001Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooool000003oooool001?ooooo0_l00008ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool00oooool2o`0000Kooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooo000000[ooooo00Go0000ooooooooooooooooo`000007ooooo`;o0000
1_ooool2o`0000_ooooo00?o0000ooooooooool01Oooool00ol0003oooooo`000008ooooo`03o`00
0?oooooooooo00Kooooo00?o0000ooooooooool01?ooool2o`0000cooooo00Co0000ooooool0003o
00003?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool02?ooool2o`0000Kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`04
o`000?ooooooooooo`0000oooooo000Cooooo`;o00002?ooool00ol0003oooooooooo`05ooooo`;o
00001_ooool2o`0000Oooooo0_l00007ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooool0
00002oooool00ol0003oooooo`000008ooooo`;o00002?ooool2o`0000Sooooo00?o0000oooooooo
ool01_ooool00ol0003oooooo`000009ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool01Oooool2o`0000gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`09ooooo`04
o`000?ooooooooooo`0000_ooooo00?o0000ooooooooool02Oooool01Ol0003ooooooooooooooooo
000000_ooooo0_l00007ooooo`03o`000?oooooooooo00Gooooo0_l0000:ooooo`04o`000?oooooo
ooooo`0000oooooo000Cooooo`;o00002Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo00Kooooo0_l00009ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02Oooool0
0ol0003oooooo`00000;ooooo`;o00002Oooool2o`0000[ooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooo000000[ooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`06ooooo`;o00002oooool2o`000003ooooool0003o000000cooooo00?o0000
ooooooooool02_ooool2o`0000cooooo00?o0000ooooooooool02_ooool3o`0000cooooo0_l00008
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02_ooool01?l0003oooooooooool0
000?ooooo`004_ooool00ol0003oooooo`00000:ooooo`03o`000?oooooooooo00;o00002Oooool2
o`0000[ooooo0_l00002ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooool000002_ooool0
1?l0003oooooooooool00008ooooo`;o00002oooool2o`0000?ooooo00?o0000ooooooooool02?oo
ool00ol0003oooooo`00000;ooooo`04o`000?ooooooooooo`0000Wooooo0_l0000:ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`04o`00
0?ooooooooooo`0000_ooooo00?o0000ooooooooool02_ooool3o`0000cooooo0_l00008ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool02oooool01?l0003oooooooooool0000?oooo
o`004_ooool2o`0000cooooo0_l0000;ooooo`;o00003?ooool2o`0000gooooo00?o0000ooooool0
00002?ooool2o`0000Cooooo00?o0000ooooooooool01Oooool2o`0000gooooo00?o0000ooooool0
00002oooool01?l0003oooooooooool0000;ooooo`03o`000?oooooo000000Wooooo0_l00008oooo
o`;o00001oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00Go0000oooo
ooooooooooooo`00000;ooooo`03o`000?oooooooooo00Sooooo00Co0000ooooool0003o00003Ooo
ool01Ol0003ooooooooooooooooo000000oooooo000Booooo`;o00002oooool3o`0000[ooooo00?o
0000ooooool000003?ooool00ol0003oooooo`00000<ooooo`03o`000?oooooo000000Oooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`03ooooo`04o`000?ooooooooooo`0000gooooo
0_l0000;ooooo`04o`000?ooooooooooo`0000cooooo00?o0000ooooooooool01oooool00ol0003o
ooooo`000007ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00gooooo00Go0000ooooooooooooooooo`00000?oooo
o`004_ooool2o`0000Wooooo0_l00002ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooool0
00002oooool01?l0003oooooooooooooool2o`0000[ooooo00?o0000ooooool000001Oooool2o`00
00Sooooo00?o0000ooooooooool00oooool01?l0003oooooooooool0000=ooooo`04o`000?oooooo
0000o`0000Wooooo00Co0000oooooooooooo00002oooool01?l0003oooooo`000?l00007ooooo`03
o`000?oooooo000000Gooooo0_l0000<ooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool01_ooool2o`0000Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`08ooooo`03
o`000?oooooo000000kooooo00Go0000ooooooooooooooooo`00000?ooooo`004_ooool2o`0000So
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`07ooooo`03o`000?oooooo000000[o
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo000000Co
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00
00cooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`06ooooo`04o`000?oooooooooo
o`0000[ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
000000Cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Oooooo00Go0000ooooooooooooooooo`00000<ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool03Oooool0017ooooo00?o0000ooooool000001_ooool2o`0000Oooooo00?o0000
ooooooooool01_ooool00ol0003oooooo`000009ooooo`03o`000?oooooooooo00Kooooo0_l00007
ooooo`03o`000?oooooo000000;ooooo0_l0000=ooooo`05o`000?ooooooooooooooool000000_oo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Cooooo0_l00006ooooo`04o`000?oo
ooooooooo`0000Wooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooo000000?ooooo00?o0000ooooooooool03oooool2o`0000Gooooo00?o0000ooooooooool0
0oooool2o`0000cooooo0_l00005ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo0_l00005ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0=ooooo`004Ooo
ool00ol0003oooooo`000005ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01Ooo
ool2o`0000Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`03ooooo`06o`000?oo
ooooooooo`000?oooooo00004?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`03ooooo`05o`000?oooooooooo
ooooool000001oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00;ooooo00Co0000
ooooool0003ooooo0_l0000Dooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`0<ooooo`;o00001?ooool2o`0000Kooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool03Ooo
ool0017ooooo00?o0000ooooool000000oooool2o`0000cooooo00?o0000ooooooooool01?ooool2
o`0000Wooooo00?o0000ooooooooool02_ooool2o`0000;ooooo0ol000000ooooooo0000o`00000B
ooooo`03o`000?oooooo000000?ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`09
ooooo`;o00000oooool01Ol0003ooooooooooooooooo000000Kooooo00?o0000ooooooooool02?oo
ool01_l0003ooooooooooooooooo0000ooooo`;o00005oooool01Ol0003ooooooooooooooooo0000
00?ooooo00?o0000ooooooooool04?ooool01Ol0003ooooooooooooooooo000000?ooooo0_l0000A
ooooo`04o`000?ooooooooooooooo`;o00001Oooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0=ooooo`004Oooool0
0ol0003oooooo`000002ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool00oooool0
0ol0003oooooo`000008ooooo`03o`000?oooooooooo00gooooo1ol0000Dooooo`;o00000oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00cooooo0_l000000ooooooo0000ooooo`02
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02_ooool6o`0001Wooooo00?o0000
ooooool000000_l000000ooooooo0000ooooo`0Cooooo`03o`000?oooooo000000;o000000?ooooo
o`000?ooool04oooool00ol0003oooooooooo`02o`0000?ooooo0_l0000;ooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0=ooooo`003oooool3o`00
0004ooooool0003o0000o`00013ooooo00?o0000ooooooooool00_ooool00ol0003oooooo`000007
ooooo`03o`000?oooooooooo00kooooo1ol0000Eooooo`05o`000?ooooooooooooooool000001_oo
ool00ol0003oooooooooo`0?ooooo`;o00000oooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo00_ooooo1_l0000Jooooo`Go00005_ooool5o`0001Kooooo00?o0000ooooool000000_l0
00000ooooooo0000ooooo`0=ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`0=ooooo`003_ooool6o`0001?ooooo00Oo0000ooooooooooooooooo`00
0?oooooo000000Kooooo00?o0000ooooooooool01?oooolIo`0000kooooo00Go0000oooooooooooo
ooooo`000005ooooo`03o`000?oooooooooo017ooooo0_l00002ooooo`?o000000?oooooo`000?oo
ool02_oooolYo`0001Cooooo1ol0000Fooooo`Go00004?ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool03Oooool000gooooo1ol0000:oooooago0000
2?ooool@o`000003ooooool0003o000001;o00000oooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooo000000Go00000_oooolCo`0000gooooo>Ol0000:ooooo`Oo00003oooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03Oooool000gooooo4Ol0
000;ooooo`05o`000?oooooo0000ooooool000001?ooool00ol0003oooooooooo`0:ooooo`Co0000
0oooool7o`0000Kooooo1_l00009ooooo`04o`000?oooooo0000oooooaKo00001?ooool?o`0000?o
oooo6_l0000:ooooo`Oo00005?oooolSo`00013ooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00gooooo000=ooooo`go00003oooool2o`0000;ooooo
00Go0000ooooooooooooooooo`000009ooooo`Co00001_ooool00ol0003oooooooooo`04o`000003
ooooool0003ooooo00[ooooo1_l00003ooooo`03o`000?oooooooooo00Go00003?oooolLo`0000Go
oooo1_l0000Jooooo`Go00005_ooool5o`0000kooooo5Ol0000;ooooo`03o`000?oooooo000000;o
00001_ooool00ol0003oooooooooo`0=ooooo`003_ooool5o`0000Oooooo1_l0000:ooooo`03o`00
0?oooooo000000;o000000?oooooo`000?ooool01Oooool4o`0000Wooooo00?o0000ooooooooool0
0_ooool01Ol0003oooooo`000?oooooo0000017ooooo3?l000000ooooooo0000o`00000@o`0000;o
oooo00?o0000ooooool000001_l0000=ooooo`03o`000?oooooo000000;o000000?oooooo`000?oo
ool06Oooool5o`0001Kooooo1Ol0000Gooooo`_o000000?oooooo`000?l000001?l00006ooooo`Go
00001Oooool00ol0003oooooooooo`0=ooooo`003oooool4o`0000gooooo1Ol00005ooooo`Ko0000
0oooool4o`0000cooooo00?o0000ooooooooool00oooool2o`000003ooooool0003o000000_ooooo
5_l0000Aooooo`03o`000?oooooo000000Go00003_ooool01?l0003oooooooooool00002ooooo`;o
00006?ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo01;ooooo00Ko0000oooo
oooooooo0000ooooool0000Gooooo`Co00000_ooool00ol0003oooooooooo`02oooooa?o00001?oo
ool00ol0003oooooooooo`0=ooooo`004?ooool00ol0003oooooo`00000Booooo`ko00002OoooolM
o`0000Wooooo00?o0000ooooool000001_l0000Eooooo`;o00000_ooool4o`0000gooooo00Oo0000
ooooooooooooooooo`000?oooooo000000;ooooo00?o0000ooooooooool05?ooool01Ol0003ooooo
oooooooooooo000000?ooooo00?o0000ooooooooool04?ooool01Ol0003ooooooooooooooooo0000
00;ooooo00?o0000ooooooooool04oooool01?l0003oooooo`000?l00004ooooo`03o`000?oooooo
oooo00cooooo2?l00005ooooo`03o`000?oooooooooo00cooooo000@ooooo`04o`000?oooooo0000
o`0001Kooooo4_l00005ooooo`03o`000?oooooooooo00Gooooo0_l00002ooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool01Ol0000Fooooo`04o`000?ooooooooooooooo`;o000000?o
ooooo`000?ooool02oooool00ol0003oooooooooo`02ooooo`03o`000?oooooo000000?ooooo00?o
0000ooooooooool04_ooool01?l0003oooooooooooooool2o`0000Cooooo00?o0000ooooooooool0
3_ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000004oooool00ol0003o
ooooo`000002o`0000Gooooo00?o0000ooooooooool03?ooool7o`0000Gooooo00?o0000oooooooo
ool03?ooool0013ooooo00Go0000ooooool0003oooooo`00000Eooooo`Oo00003oooool00ol0003o
ooooooooo`06ooooo`;o00000_ooool2o`0001?ooooo00Co0000ooooool0003ooooo1?l0000Eoooo
o`;o00000oooool2o`0000;ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooo000000Cooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`02oooo
o`;o00001Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00?o00001_ooool00ol0
003oooooooooo`0<ooooo`Go00001_ooool00ol0003oooooooooo`0<ooooo`004?ooool2o`0000;o
oooo00?o0000ooooooooool04_ooool8o`0000kooooo00?o0000ooooooooool01oooool2o`0000;o
oooo0_l0000Cooooo`;o00000_ooool2o`0000;ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooo`000003ooooo`;o00000oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooool000001Oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?o
oooo0_l00006ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00kooooo00Co0000oooooooooooooooo0ol00007oooo
o`03o`000?oooooooooo00_ooooo1?l00007ooooo`03o`000?oooooooooo00cooooo000@ooooo`;o
00000oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00?o00000_ooool2o`0000_o
oooo00?o0000ooooooooool02?ooool2o`0000;ooooo00?o0000ooooool000004Oooool2o`0000?o
oooo0_l00003ooooo`03o`000?oooooooooo00oooooo00Co0000oooooooooooo00000oooool2o`00
00?ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo0000
00Gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`04ooooo`;o00001oooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`0<ooooo`03o`000?oooooooooo00;ooooo0ol00008ooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool00_l00007ooooo`03o`000?oooooooooo00cooooo000@ooooo`;o
00001?ooool00ol0003oooooooooo`0>ooooo`?o00000_ooool2o`0000Gooooo00?o0000oooooooo
ool01_ooool2o`0000cooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0>oooo
o`03o`000?oooooooooo00;ooooo0_l00004ooooo`03o`000?oooooooooo00cooooo0_l00003oooo
o`04o`000?ooooooooooooooo`;o00001?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooool000001_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo00Gooooo0_l00008ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool00oooool3
o`0000Wooooo00?o0000ooooooooool01oooool01?l0003oooooooooooooool2o`0000Oooooo00?o
0000ooooooooool03?ooool000oooooo0ol00004ooooo`03o`000?oooooooooo00gooooo00Co0000
oooooooooooo00000_ooool2o`0000Kooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`0<ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool03Oooool2o`0000Cooooo
0_l00005ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool00oooool01?l0003ooooo
ooooooooool2o`0000Gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`05ooooo`03
o`000?oooooo000000Oooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`06ooooo`;o
00002?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Cooooo0ol0000:ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool00_ooool00ol0003oooooo`000006ooooo`03
o`000?oooooooooo00cooooo000?ooooo`?o00001Oooool00ol0003oooooooooo`0;ooooo`09o`00
0?ooooooooooooooool0003oooooo`000?oooooo000000Oooooo0_l00003ooooo`03o`000?oooooo
oooo00gooooo0_l000000ooooooo0000ooooo`02ooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooool000000oooool00ol0003oooooo`000005ooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool01?ooool01_l0003oooooooooool0003oooooo`0000Gooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooo000000Sooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`07ooooo`;o00002Oooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo00Gooooo0ol0000;ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
0oooool00ol0003oooooo`000006ooooo`03o`000?oooooooooo00cooooo000?ooooo`?o00001_oo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooool0003ooooo
o`000009ooooo`03o`000?oooooo0000013ooooo0_l000000ooooooo0000ooooo`03ooooo`03o`00
0?oooooooooo00Wooooo00Co0000oooooooooooo00000oooool00ol0003oooooo`000006ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool01Oooool01_l0003oooooooooool0003ooooo
o`0000Kooooo00Co0000oooooooooooo00002Oooool00ol0003oooooo`000009ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool02?ooool2o`0000[ooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`06ooooo`?o00003?ooool01Ol0003ooooooooooooooooo000000Kooooo
00?o0000ooooool000001_ooool00ol0003oooooooooo`0<ooooo`003oooool3o`0000Kooooo00?o
0000ooooooooool01oooool2o`0000Cooooo00Ko0000oooooooooooo0000ooooool0000:ooooo`03
o`000?oooooooooo00oooooo0_l000000ooooooo0000ooooo`03ooooo`03o`000?oooooooooo00So
oooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooo000000Oooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`06ooooo`06o`000?ooooooooooo`000?oooooo00001ooo
ool2o`0000[ooooo00?o0000ooooool000002_ooool00ol0003oooooooooo`03ooooo`03o`000?oo
oooooooo00Wooooo0_l0000;ooooo`05o`000?ooooooooooooooool000002_ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01oooool00ol0003ooooo
o`00000=ooooo`03o`000?oooooo000000Oooooo00Co0000oooooooooooo00001Oooool00ol0003o
ooooooooo`0<ooooo`003oooool3o`0000Oooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooo000000;ooooo00?o0000ooooooooool01oooool01?l0003ooooo
o`000?l0000?ooooo`;o000000?oooooo`000?ooool01?ooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo00;ooooo00Oo0000ooooooooooooooooo`000?oooooo000000Sooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`07ooooo`06o`000?ooooooooooo`000?oooooo0000
1oooool2o`0000[ooooo00?o0000ooooool000002oooool01Ol0003ooooooooooooooooo000000co
oooo0ol0000;ooooo`03o`000?oooooo000000_ooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooool000003_ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooo000000Gooooo00?o0000ooooooooool03?ooool000oooooo
00?o0000ooooool000002?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Gooooo
00Go0000ooooool0003oooooo`000009ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool03?ooool2o`000003ooooool0003ooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`03ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01oooool01Ol0
003ooooooooooooooooo000000[ooooo00Ko0000oooooooooooo0000ooooool00007ooooo`;o0000
2_ooool00ol0003oooooo`00000<ooooo`03o`000?oooooo000000gooooo0ol0000<ooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool02?ooool01?l0003oooooooooool0000;ooooo`;o
00003_ooool00ol0003oooooo`000008ooooo`03o`000?oooooo000000Gooooo00?o0000oooooooo
ool03?ooool000oooooo0_l0000:ooooo`05o`000?ooooooooooooooool000002?ooool01Ol0003o
ooooo`000?oooooo000000Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0;oooo
o`;o000000?oooooo`000?ooool01Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00Cooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
000000_ooooo00Ko0000oooooooooooo0000ooooool00006ooooo`04o`000?ooooooooooo`0000Wo
oooo0ol0000=ooooo`03o`000?oooooooooo00cooooo0ol0000;ooooo`03o`000?oooooo000000_o
oooo00?o0000ooooooooool02Oooool2o`0000cooooo0_l0000=ooooo`05o`000?oooooooooooooo
ool000001oooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo00cooooo000?oooo
o`;o00002_ooool01?l0003oooooo`000?l00009ooooo`;o00000_ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00Kooooo0_l0000;ooooo`;o000000?oooooo`000?ooool01_ooool0
1Ol0003ooooooooooooooooo000000Oooooo00Co0000oooooooooooo00000_ooool00ol0003ooooo
ooooo`08ooooo`;o00003?ooool00ol0003oooooo`000002ooooo`03o`000?oooooooooo00?ooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`06ooooo`?o00003Oooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooo000000_ooooo00Co0000oooooooooooo00002_ooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00[ooooo0ol0000<ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo
00cooooo000?ooooo`;o00002oooool00ol0003oooooooooo`08ooooo`03o`000?oooooo000000;o
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00So
oooo00Co0000ooooool0003o00001oooool01?l0003oooooooooool00008ooooo`04o`000?oooooo
ooooo`0000;ooooo00?o0000ooooooooool01oooool01?l0003oooooooooool0000;ooooo`03o`00
0?oooooo000000;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00Kooooo0ol0000<ooooo`03o`000?oooooo000000gooooo00?o0000ooooool00000
2_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
2?ooool00ol0003oooooo`00000;ooooo`?o00002oooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo00?ooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`0<ooooo`00
3oooool2o`0000[ooooo00?o0000ooooool000002Oooool00ol0003oooooo`000002ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`07ooooo`04o`00
0?oooooo0000o`0000Sooooo0_l00009ooooo`03o`000?oooooo000000?ooooo00?o0000oooooooo
ool01_ooool01Ol0003ooooooooooooooooo000000_ooooo00?o0000ooooool000000_ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01Oooool3o`00
00_ooooo00Go0000ooooooooooooooooo`00000<ooooo`03o`000?oooooo000000Wooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00Go0000
ooooooooooooooooo`00000:ooooo`?o00002_ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo00cooooo
000?ooooo`;o00002Oooool01?l0003oooooooooool00009ooooo`03o`000?oooooo000000;ooooo
00Co0000oooooooooooooooo0_l0000?ooooo`;o00001oooool01?l0003oooooo`000?l00008oooo
o`;o00002Oooool00ol0003oooooo`000003ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`08ooooo`03o`000?oooooo000000;ooooo00Go0000oooo
ooooooooooooo`000008ooooo`03o`000?oooooooooo00Cooooo0ol0000:ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool02Oooool00ol0003oooooo`000008ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool02?ooool3o`0000Wooooo00?o0000ooooooooool02Oooool0
1Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000>ooooo`003ooo
ool2o`0000Oooooo0_l00004ooooo`03o`000?oooooooooo00Kooooo0_l00003ooooo`04o`000?oo
ooooooooo`0001?ooooo00?o0000ooooooooool01?ooool01?l0003oooooo`000?l00007ooooo`03
o`000?oooooo000000Wooooo00?o0000ooooool000000oooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01oooool00ol0003oooooo`000002ooooo`04
o`000?ooooooooooo`0000Wooooo00?o0000ooooooooool01?ooool3o`0000Wooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooo000000Oooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`07ooooo`?o00002?ooool00ol0003oooooooooo`0;oooo
o`04o`000?ooooooooooo`0000?ooooo00Go0000ooooooooooooooooo`00000>ooooo`003oooool2
o`0000Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`;o00000oooool0
0ol0003oooooo`00000Eooooo`03o`000?oooooooooo00?ooooo00Co0000ooooool0003o00001_oo
ool01Ol0003ooooooooooooooooo000000Sooooo00?o0000ooooool000000oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003ooooo
o`000002ooooo`04o`000?ooooooooooo`0000[ooooo00?o0000ooooooooool00oooool3o`0000So
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooo000000Ko
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooo000000Oo
oooo00?o0000ooooooooool03Oooool00ol0003oooooo`000004ooooo`04o`000?ooooooooooo`00
00kooooo000?ooooo`;o00001Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Go
oooo0_l00003ooooo`;o00005oooool2o`0000?ooooo00Co0000ooooool0003o00001Oooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooool000000oooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool01Oooool00ol0
003oooooo`000002ooooo`03o`000?oooooo000000cooooo00?o0000ooooooooool00_ooool2o`00
00Sooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooo0000
00Kooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo0000
00Kooooo00?o0000ooooooooool03oooool2o`0000Cooooo00Co0000oooooooooooo00003_ooool0
00oooooo0_l00004ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool00oooool2o`00
00Cooooo00?o0000ooooooooool06?ooool01Ol0003oooooooooool0003ooooo00;o00001?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Gooooo0_l00004ooooo`05o`000?oooooo
ooooooooool000003Oooool00ol0003oooooooooo`04ooooo`;o00000oooool2o`0000gooooo00?o
0000ooooooooool00_ooool2o`0000Oooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooo000000Gooooo00?o0000ooooooooool03?ooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooo000000Gooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`02ooooo`04o`000?ooooooooooo`0000kooooo000?ooooo`04o`000?ooooooooooooooo`;o0000
3?ooool00ol0003oooooooooo`02ooooo`;o00000oooool2o`0001_ooooo00Co0000ooooool0003o
oooo0_l00003ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01?ooool2o`0000Co
oooo00Co0000oooooooooooo00003oooool00ol0003oooooooooo`03ooooo`;o00000oooool2o`00
00kooooo00Co0000oooooooooooooooo0_l00006ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool01Oooool00ol0003oooooo`000004ooooo`03o`000?oooooooooo00kooooo00Go0000
ooooooooooooooooo`000003ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool01?oo
ool00ol0003oooooo`000004ooooo`03o`000?oooooooooo01;ooooo0_l00004ooooo`03o`000?oo
oooo000000kooooo000>ooooo`?o000000?oooooo`000?ooool03Oooool00ol0003oooooooooo`02
ooooo`;o00000_ooool00ol0003oooooo`00000Looooo`;o000000Koooooo`000?l0003o0000oooo
ool0000:ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool000001?ooool3o`00013ooooo
00?o0000ooooooooool00oooool2o`0000?ooooo00?o0000ooooooooool03_ooool00ol0003ooooo
ooooo`02o`0000Gooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooo000000?ooooo00?o0000ooooooooool04?ooool00ol0003oooooo`000002o`000003oooo
ool0003ooooo00kooooo00?o0000ooooooooool00oooool00ol0003oooooo`000003ooooo`03o`00
0?oooooooooo01?ooooo00?o0000ooooool000000oooool00ol0003oooooo`00000>ooooo`003Ooo
ool5o`00013ooooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0001go
oooo1_l0000;ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool000001?ooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo00;ooooo0_l00002ooooo`;o00004?ooool00ol0003o
ooooooooo`02o`0000Cooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`03ooooo`03
o`000?oooooo000000;ooooo00?o0000ooooooooool04_ooool5o`00013ooooo00?o0000oooooooo
ool00oooool00ol0003oooooo`000002ooooo`03o`000?oooooooooo01Cooooo00Co0000oooooooo
oooo00000_ooool00ol0003oooooo`00000>ooooo`003?ooool7o`00013ooooo1?l000000ooooooo
0000ooooo`02ooooo`03o`000?oooooooooo01_ooooo1ol0000;ooooo`04o`000?oooooooooooooo
o`;o00001?ooool2o`0001Cooooo00Co0000oooooooooooooooo0_l000001?oooooo0000ooooool0
000Aooooo`;o000000?oooooo`000?ooool00_ooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooool000000_ooool00ol0003oooooooooo`0Aooooo`Oo00004?oo
ool01?l0003oooooooooooooool2o`000004ooooool0003oooooo`0001Oooooo00Go0000oooooooo
ooooooooo`000002ooooo`;o00003_ooool000coooooBol00005ooooo`04o`000?oooooooooooooo
o`;o00000oooool00ol0003oooooo`00000Eooooo`03o`000?oooooo000000;o000000Coooooo`00
0?oooooo00004_ooool4o`000003ooooool0003ooooo01Gooooo00Wo0000ooooooooooooooooo`00
0?oooooo0000ooooool000003OoooolEo`0000[ooooo00?o0000ooooooooool00_l000000ooooooo
0000o`00000Hooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool000000_l0000=ooooo`00
3?ooool7o`0000?ooooo2ol000000ooooooo0000o`000005o`0000?ooooo00?o0000ooooooooool0
5?l00007ooooo`[o00000ooooolAo`0001Kooooo1Ol00002ooooo`03o`000?oooooooooo013ooooo
1Ol0000Hooooo`03o`000?oooooo000002Ko000000?oooooo`000?l000004ol0000Eooooo`03o`00
0?oooooooooo00?ooooo1Ol0000<ooooo`003Oooool5o`0000oooooo3ol0000Jooooo`Ko00001?oo
ool4o`0000Kooooo1?l000000ooooooo0000ooooo`02oooooa;o00001?ooool7o`000003ooooool0
003ooooo013ooooo1ol00006oooooaOo00002?ooool7o`0000Sooooo1Ol00007ooooo`Ko00001_oo
ool6o`0000Cooooo5?l000000ooooooo0000ooooo`03ooooo`Oo00002oooool000kooooo1?l0000@
ooooo`Oo00000oooool01?l0003ooooooooooooooolDo`0000Gooooo00?o0000ooooool000001?l0
0008ooooo`?o00000oooool5o`0000?ooooo00?o0000ooooooooool03ooooolbo`0000_ooooo3_l0
000?ooooo`Go00003Oooool<o`0000oooooo5_l0000;ooooo`003_ooool2o`0000;ooooo00?o0000
ooooooooool03Oooool7o`0000;ooooo00?o0000ooooooooool05_oooolCo`0000Cooooo2Ol00002
ooooo`03o`000?oooooo000002?o00002ooooomXo`0000_ooooo00Co0000oooooooooooooooo1ol0
000;ooooo`003_ooool2o`0000?ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`03
o`0000;ooooo0ol0000Kooooo`04o`000?ooooooooooooooo`?o00000oooool00ol0003ooooooooo
o`03oooooaSo00003oooool5o`0000;ooooo00?o0000ooooooooool04?ooool6o`0001Oooooo1ol0
000Dooooo`04o`000?ooooooooooooooo`;o00000_ooool00ol0003oooooooooo`0>ooooo`Oo0000
6_ooool00ol0003oooooooooo`07o`0000cooooo000>ooooo`;o00001?ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00;ooooo0_l00004ooooo`03o`000?oooooooooo01Oooooo0_l0
0004ooooo`?o00001?ooool00ol0003oooooooooo`08ooooo`Oo00000_ooool00ol0003ooooooooo
o`0Eooooo`Go00000_ooool00ol0003oooooooooo`0@ooooo`Co00000_ooool2o`0001Gooooo1_l0
000Dooooo`03o`000?oooooooooo00;ooooo0_l00003ooooo`03o`000?oooooooooo00kooooo1_l0
000Jooooo`03o`000?oooooo000000?ooooo0ol0000=ooooo`003_ooool2o`0000Gooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`03ooooo`;o00001?ooool3o`0001Kooooo00?o0000
ooooooooool01?ooool3o`0000Cooooo00?o0000ooooooooool02Oooool7o`000003ooooool0003o
oooo01Gooooo00?o0000ooooooooool00_l000001?oooooo0000ooooool0000Aooooo`;o000000?o
ooooo`000?ooool01?ooool00ol0003oooooooooo`0@ooooo`;o00000_ooool5o`0001;ooooo00?o
0000ooooooooool00oooool2o`0000Cooooo00?o0000ooooooooool03Oooool4o`000003ooooool0
003o000001Wooooo0_l00004ooooo`;o00003_ooool000kooooo0_l00006ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool01?ooool2o`0000Cooooo00Co0000oooooooooooo00005?oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooo000000Gooooo00?o0000ooooooooool02?oo
ool4o`0000?ooooo0_l0000Eooooo`04o`000?ooooooooooooooo`;o00000_ooool2o`00017ooooo
0_l000000ooooooo0000ooooo`05ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0
0oooool01Ol0003oooooo`000?oooooo0000013ooooo00?o0000ooooooooool01?ooool2o`0000Go
oooo00?o0000ooooooooool02oooool01?l0003oooooooooool00002ooooo`03o`000?oooooo0000
01Oooooo0_l00005ooooo`;o00003_ooool000kooooo0_l00007ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`02ooooo`05o`000?oooooooooooooo
ool000004_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooo000000Kooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`02o`0000Cooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`02ooooo`;o00000oooool00ol0003oooooooooo`0>ooooo`04o`000?oooooo0000
ooooo`;o00001_ooool2o`0000gooooo00?o0000ooooooooool01?ooool3o`0000;ooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`05ooooo`;o00001_ooool00ol0003oooooooooo`09
ooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000Eooooo`03o`00
0?oooooo000000Gooooo0_l0000>ooooo`003_ooool2o`0000Sooooo00Go0000oooooooooooooooo
o`000009ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool2o`0000oooooo
00?o0000ooooooooool01oooool00ol0003oooooo`000007ooooo`03o`000?oooooooooo00Cooooo
00Co0000oooooooooooooooo0_l00004ooooo`?o00004Oooool00ol0003oooooooooo`03ooooo`;o
00000oooool2o`0000kooooo00?o0000ooooooooool00_l000000ooooooo0000ooooo`07ooooo`03
o`000?oooooooooo00Sooooo0_l00007ooooo`?o00000oooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo00Gooooo0_l00007ooooo`03o`000?oooooooooo00Sooooo00Go0000oooooooo
ooooooooo`000002ooooo`05o`000?ooooooooooooooool000004_ooool2o`0000;ooooo00?o0000
ooooooooool00oooool2o`0000kooooo000>ooooo`;o00002?ooool01?l0003oooooooooool0000:
ooooo`;o00000oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool02?ooool00ol0003oooooo`000008ooooo`03o`000?oooooooooo00?ooooo00Co0000
oooooooooooooooo0_l00004ooooo`04o`000?ooooooooooo`0000oooooo00?o0000ooooooooool0
1?ooool2o`0000?ooooo00?o0000ooooool000003?ooool01?l0003oooooooooooooool2o`000003
ooooool0003ooooo00Sooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`?o
00001?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Kooooo0_l00008ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool00_ooool2o`000003ooooool0003ooooo00?o
oooo0_l0000?ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003o
ooooo`00000>ooooo`003_ooool2o`0000Wooooo0_l0000;ooooo`;o00000oooool00ol0003ooooo
ooooo`05ooooo`;o00002Oooool2o`0000_ooooo00?o0000ooooool000002Oooool01Ol0003ooooo
oooooooooooo000000Cooooo00?o0000ooooool000000oooool01?l0003oooooooooooooool2o`00
00cooooo00?o0000ooooooooool01Oooool00ol0003oooooo`000002ooooo`04o`000?oooooooooo
o`0000_ooooo00Co0000oooooooooooooooo0_l000000ooooooo0000ooooo`09ooooo`;o00001Ooo
ool00ol0003oooooooooo`08ooooo`?o00001Oooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Oooooo0_l00009ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00ooo
ool2o`000003ooooool0003ooooo00Gooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool000003_ooool000kooooo0_l00008
ooooo`?o00002oooool2o`0000?ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo00[ooooo0_l000000ooooooo0000ooooo`08ooooo`04o`000?oooooo
ooooo`0000Kooooo0_l00003ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooo000000;ooooo00Go0000oooooooooooooooo
o`000009ooooo`03o`000?oooooooooo00;ooooo0_l000000ooooooo0000ooooo`0;ooooo`03o`00
0?oooooooooo00;o00002oooool3o`0000Kooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`08ooooo`;o00002_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Cooooo
0_l000000ooooooo0000ooooo`06ooooo`03o`000?oooooooooo00Sooooo0_l00006ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooool000003_ooool000kooooo0_l00007ooooo`05o`000?oo
ooooooooooooool000002_ooool2o`0000?ooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00_ooooo0_l000000ooooooo0000ooooo`09ooooo`;o0000
1oooool2o`0000?ooooo00?o0000ooooooooool01?ooool2o`0000Oooooo00?o0000ooooooooool0
1oooool00ol0003oooooo`000002ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`03ooooo`;o000000?oooooo`000?ooool03?ooool2o`0000cooooo
00Go0000ooooool0003oooooo`000006ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool02Oooool2o`0000_ooooo00Co0000oooooooooooo00001oooool2o`000003ooooool0003ooooo
00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooool000003_ooool000kooooo0_l00006ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool01oooool2o`0000?ooooo00?o0000ooooooooool02Oooool2o`0000;o
oooo00?o0000ooooooooool03?ooool2o`000003ooooool0003ooooo00Wooooo0_l00007ooooo`;o
00000oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool02?ooool00ol0003oooooo`000002ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`04ooooo`;o000000?oooooo`000?ooool03?ooool3o`0000_o
oooo00Go0000ooooool0003oooooo`000007ooooo`05o`000?ooooooooooooooool000003?ooool2
o`0000_ooooo00Co0000oooooooooooo00001oooool3o`0000[ooooo00?o0000ooooooooool00ooo
ool2o`0000Wooooo00?o0000ooooooooool00_ooool00ol0003oooooo`00000>ooooo`003Oooool3
o`0000Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`;o00000oooool0
0ol0003oooooooooo`0;ooooo`;o00003oooool3o`0000_ooooo00?o0000ooooool000001_ooool0
0ol0003oooooo`000002ooooo`03o`000?oooooooooo00Oooooo00Go0000ooooooooooooooooo`00
000;ooooo`03o`000?oooooo000000;ooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00Cooooo0_l000000ooooooo0000ooooo`0:ooooo`;o00000ooo
ool00ol0003oooooooooo`08ooooo`05o`000?oooooo0000ooooool000002?ooool00ol0003ooooo
o`00000=ooooo`;o00003?ooool2o`0000Sooooo0ol0000;ooooo`05o`000?ooooooooooooooool0
00002oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool03?ooool000go
oooo0ol00004ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01Oooool00ol0003o
ooooo`000002ooooo`03o`000?oooooooooo00_ooooo0ol0000>ooooo`?o00002_ooool01Ol0003o
oooooooooooooooo000000Gooooo00?o0000ooooool000000_ooool00ol0003oooooooooo`08oooo
o`?o00002oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00Co0000
oooooooooooo00001oooool2o`000003ooooool0003ooooo00Wooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00;o00002Oooool00ol0003ooooooooo
o`0<ooooo`;o00003?ooool2o`0000Wooooo0_l0000<ooooo`?o00003?ooool01Ol0003ooooooooo
oooooooo000000;ooooo00?o0000ooooooooool03?ooool000gooooo0ol00003ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool01?ooool00ol0003oooooo`000002ooooo`03o`000?oo
oooooooo00Wooooo0_l00003ooooo`03o`000?oooooooooo00[ooooo00Co0000ooooool0003o0000
2Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool00000
0_ooool00ol0003oooooooooo`09ooooo`;o00002oooool01ol0003ooooooooooooooooo0000oooo
ool000002?ooool2o`0000Sooooo0_l000000ooooooo0000ooooo`08ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`02o`0000Sooooo00?o0000oooo
ool000003Oooool2o`0000_ooooo00Co0000oooooooooooo00002?ooool2o`0000cooooo0ol0000<
ooooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`0<ooooo`003Oooool0
0ol0003oooooo`000002ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool00oooool0
0ol0003oooooo`000002ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`09ooooo`04o`000?oooooo0000o`0000Sooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooo000000;ooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`02o`0000Wooooo00Oo0000ooooooooooooooooo`000?oooooo000000So
oooo0_l00008ooooo`;o00000_ooool00ol0003oooooooooo`04ooooo`;o00002_ooool2o`0000Ko
oooo00?o0000ooooooooool00_l00007ooooo`05o`000?ooooooooooooooool000003?ooool2o`00
00[ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`05ooooo`;o00002oooool01Ol0
003ooooooooooooooooo000000_ooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oo
oooooooo00cooooo000=ooooo`05o`000?oooooo0000ooooool000003oooool00ol0003ooooooooo
o`03ooooo`;o00000_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo0_l0
0009ooooo`04o`000?oooooo0000o`0000Oooooo00?o0000ooooooooool01_ooool01ol0003ooooo
oooooooooooo0000ooooool000000_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool01_ooool01ol0003ooooooooooooooooo0000ooooool000002?oo
ool00ol0003oooooo`000007ooooo`;o00000_ooool00ol0003oooooooooo`03ooooo`03o`000?oo
oooooooo00cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02o`0000Oooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`;o00002_ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00Cooooo0_l00009ooooo`;o00001Oooool00ol0003ooooooooo
o`08ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool03?ooool000cooooo1Ol0
000@ooooo`03o`000?oooooooooo00?ooooo0_l00002ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`06ooooo`04o`000?ooooooooooo`0000Oooooo
00?o0000ooooooooool01oooool01?l0003oooooooooool00002ooooo`03o`000?oooooo000000So
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`07o`000?oooooooooooooo
ool0003oooooo`000007ooooo`05o`000?ooooooooooooooool000001_ooool2o`0000;ooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool00_l00006ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool02?oo
ool2o`0000Wooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`03ooooo`;o00002?oo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00Co0000oooooooooooo0000
0oooool00ol0003oooooooooo`0<ooooo`002oooool5o`0001;ooooo00?o0000ooooooooool00_oo
ool2o`000003ooooool0003ooooo00Oooooo00?o0000ooooooooool02oooool2o`0000Kooooo00Co
0000oooooooooooo00001_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooo000000;ooooo
00?o0000ooooool000001oooool00ol0003oooooooooo`07ooooo`;o00001Oooool01ol0003ooooo
oooooooooooo0000ooooool000001_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00?ooooo0_l00002ooooo`03o`000?oooooooooo00;o00004_ooool2o`0000;ooooo00?o0000oooo
ooooool00_l00005ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01oooool2o`00
00Sooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`02ooooo`;o00001oooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00Co0000oooooooooooo00000oooool0
0ol0003oooooooooo`0<ooooo`002_ooool7o`0001;ooooo00Ko0000ooooooooooooooooo`000?oo
ool2o`0000Oooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`02ooooo`05o`000?oo
ooooooooooooool000001Oooool00ol0003oooooooooo`0;ooooo`;o00000_ooool00ol0003ooooo
o`000006ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool00_ooool01ol0003ooooo
oooooooooooo0000ooooool000001Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00;ooooo00Oo0000ooooooooooooooooo`000?oooooo000001Kooooo00?o0000ooooool000000_oo
ool2o`0000Cooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`;o00001ooo
ool00ol0003oooooooooo`09ooooo`04o`000?ooooooooooooooo`;o00001Oooool2o`0000cooooo
00?o0000ooooooooool01_ooool00ol0003oooooo`000003ooooo`03o`000?oooooooooo00cooooo
000:ooooo`Wo00004Oooool01Ol0003oooooooooool0003ooooo00;o00001Oooool2o`0001;ooooo
00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool03Oooool01_l0003oooooooooool0003oooooo`0000Gooooo00?o0000ooooooooool03?ooool2
o`0000;ooooo00?o0000ooooooooool00_ooool2o`0000Gooooo00?o0000ooooooooool01_ooool0
1Ol0003ooooooooooooooooo000000?ooooo0_l0000Hooooo`;o00000_ooool2o`0000?ooooo00?o
0000ooooooooool02_ooool00ol0003oooooooooo`05ooooo`;o00001oooool00ol0003ooooooooo
o`0:ooooo`03o`000?oooooooooo00;o00001?ooool00ol0003oooooooooo`0=ooooo`;o00001_oo
ool00ol0003oooooo`000003ooooo`03o`000?oooooooooo00cooooo000:oooooaCo00001oooool0
1?l0003oooooo`000?ooool2o`0000Cooooo00?o0000ooooooooool04oooool2o`000003ooooool0
003ooooo00;ooooo00Go0000ooooooooooooooooo`00000@ooooo`04o`000?ooooooooooooooo`;o
00001?ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooo000000Cooooo0_l00004ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooool000000_l000000ooooooo0000o`00000Jooooo`;o
000000Koooooo`000?l0003o0000ooooool0000>ooooo`03o`000?oooooooooo00Cooooo0_l00006
ooooo`03o`000?oooooooooo00cooooo00?o0000ooooool000000_l000000ooooooo0000o`00000B
ooooo`03o`000?oooooooooo00?ooooo0_l00004ooooo`03o`000?oooooooooo00cooooo000;oooo
o`Go00001Oooool5o`0000Cooooo2_l000000ooooooo0000o`000003ooooo`03o`000?oooooooooo
01Kooooo0_l00003ooooo`05o`000?ooooooooooooooool000004Oooool00ol0003oooooooooo`02
o`0000?ooooo00?o0000ooooooooool04Oooool2o`0000Cooooo0_l00003ooooo`03o`000?oooooo
oooo00[ooooo1Ol000000ooooooo0000ooooo`0Iooooo`03o`000?oooooo000000Co00004?ooool0
0ol0003oooooooooo`03ooooo`;o00001Oooool00ol0003oooooooooo`0>ooooo`Go00005Oooool0
0ol0003oooooooooo`02ooooo`;o00001?ooool00ol0003oooooooooo`0<ooooo`003?ooool4o`00
00[ooooo1Ol00008ooooo`co00005Oooool2o`000006ooooool0003o0000o`000?oooooo00004_oo
ool2o`000003ooooool0003o000000;ooooo00?o0000ooooooooool04oooool2o`0000?ooooo0_l0
0002ooooo`03o`000?oooooooooo00[ooooo2?l0000Jooooo`So00004?ooool00ol0003ooooooooo
o`02ooooo`;o00001?ooool00ol0003oooooooooo`0>ooooo`Oo00005Oooool01?l0003ooooooooo
ooooool2o`0000Cooooo00?o0000ooooooooool03?ooool000gooooo00Co0000ooooool0003o0000
3_ooool5o`0000?ooooo1_l00006ooooo`[o00002_ooool00ol0003oooooooooo`05o`0001?ooooo
00?o0000ooooool000001?l0000Fooooo`03o`000?oooooo000000;ooooo0_l00002ooooo`04o`00
0?ooooooooooooooofSo00005?ooool00ol0003oooooo`000002o`0000Cooooo00?o0000oooooooo
ool03?ooool000gooooo00Go0000ooooool0003oooooo`00000Booooo`[o00003oooool;o`000003
ooooool0003o000000Go00004_ooool00ol0003oooooo`000004o`0000[ooooo6Ol00002ooooo`ko
000000?oooooo`000?ooool04ol00005ooooo`go00003Oooool00ol0003oooooooooo`02o`0000?o
oooo00?o0000ooooooooool02oooool;o`0000;ooooo2_l0000;ooooo`Go00000oooool00ol0003o
ooooooooo`0<ooooo`003Oooool3o`000003ooooool0003ooooo01CoooooD?l00008ooooo`04o`00
0?oooooooooooooooago00002ooooolCo`0000Kooooo1Ol00009ooooo`03o`000?oooooo000000;o
000000?oooooo`000?ooool02?ooool5o`0000Gooooo1_l0000<ooooo`Wo000000?oooooo`000?l0
00001Ol00002ooooo`03o`000?oooooooooo00cooooo000=ooooo`?o00000_ooool00ol0003ooooo
ooooo`0Booooo`Oo00006Oooool00ol0003oooooo`000006o`0001;ooooo;?l00008ooooo`Co0000
0_ooool2o`0001Sooooo3_l00005ooooo`Go00001Oooool5o`0000Gooooo1Ol0000:ooooo`Co0000
0_ooool00ol0003oooooooooo`09oooooa7o00000_ooool00ol0003oooooooooo`0<ooooo`003Ooo
ool3o`0000?ooooo00?o0000ooooooooool04_ooool5o`0001[ooooo00?o0000ooooool000001Ol0
000Cooooo`So00005Oooool00ol0003oooooooooo`07o`0000cooooo00?o0000ooooooooool00_l0
0003ooooo`03o`000?oooooooooo01Kooooo00Co0000oooooooooooooooo0_l00002ooooo`03o`00
0?oooooooooo00?ooooo6Ol00006oooooa_o00002_ooool7o`0000;ooooo00?o0000ooooooooool0
3?ooool000gooooo0ol00004ooooo`03o`000?oooooooooo017ooooo1Ol0000Iooooo`03o`000?oo
oooo000000;ooooo1?l0000Booooo`;o000000?oooooo`000?l000000ol0000Fooooo`03o`000?oo
oooooooo00Oo00002oooool01?l0003oooooooooooooool2o`0000?ooooo0_l0000Fooooo`;o0000
0oooool2o`0000?ooooo00?o0000ooooooooool03_oooolCo`0000Oooooo00?o0000ooooooooool0
0ol00004ooooo`03o`000?oooooooooo017ooooo1_l00002ooooo`03o`000?oooooooooo00gooooo
000=ooooo`?o00001Oooool00ol0003oooooooooo`0?ooooo`;o000000Goooooo`000?oooooooooo
o`00000Hooooo`;o00000oooool2o`0000;ooooo00?o0000ooooooooool03_ooool00ol0003ooooo
o`000002ooooo`?o000000?oooooo`000?ooool05?ooool01?l0003oooooo`000?ooool5o`000003
ooooool0003ooooo00Sooooo00?o0000ooooooooool00_ooool2o`0000?ooooo00?o0000ooooool0
00005?ooool00ol0003oooooo`000003ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool04?ooool7o`00017ooooo00?o0000ooooooooool00ol00005ooooo`03o`000?oooooooooo00ko
oooo0_l00002ooooo`?o00000oooool00ol0003oooooooooo`0=ooooo`003_ooool2o`0000Gooooo
00?o0000ooooooooool03_ooool01Ol0003oooooo`000?oooooo000000?ooooo00?o0000oooooooo
ool05Oooool01ol0003ooooooooooooooooo0000ooooool000000oooool00ol0003oooooooooo`0;
ooooo`;o00000_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool04_oo
ool2o`0000?ooooo0ol00003ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool00ooo
ool00ol0003oooooo`000002ooooo`04o`000?ooooooooooo`0001;ooooo00Co0000oooooooooooo
00000oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00oooooo1ol0000@ooooo`04
o`000?ooooooooooooooo`?o00001_ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
00?ooooo0_l00003ooooo`03o`000?oooooooooo00gooooo000>ooooo`;o00001_ooool00ol0003o
ooooooooo`0=ooooo`05o`000?oooooo0000ooooool000001?ooool00ol0003oooooooooo`0Coooo
o`;o00000oooool00ol0003oooooo`000004ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool00_ooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool04?ooool2
o`0000Cooooo0_l00005ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool0
0ol0003oooooo`000002ooooo`05o`000?ooooooooooooooool000004?ooool01Ol0003ooooooooo
oooooooo000000;ooooo0_l00006ooooo`03o`000?oooooooooo00cooooo0_l00002ooooo`?o0000
0_ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00;ooooo0ol00007ooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool01?ooool2o`0000?ooooo00?o0000ooooooooool0
3Oooool000kooooo0_l00007ooooo`03o`000?oooooooooo00_ooooo00Ko0000oooooooooooo0000
ooooool00005ooooo`03o`000?oooooooooo013ooooo0_l000001ooooooo0000oooooooooooo0000
ooooool000001_ooool00ol0003oooooooooo`06ooooo`;o00001Oooool01Ol0003ooooooooooooo
oooo000000Gooooo00?o0000ooooooooool03_ooool00ol0003oooooo`000004ooooo`;o00001_oo
ool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooool000000_ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`02o`0000Oooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`02ooooo`;o0000
1?ooool2o`0000_ooooo00?o0000ooooooooool00oooool3o`0000Sooooo00?o0000ooooooooool0
1oooool2o`0000Oooooo0_l00003ooooo`03o`000?oooooooooo00gooooo000>ooooo`;o00002?oo
ool00ol0003oooooooooo`09ooooo`07o`000?ooooooooooooooool0003oooooo`000006ooooo`03
o`000?oooooooooo00kooooo00Co0000oooooooooooo00000oooool00ol0003oooooo`000006oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool01?l0003oooooooooool00007
ooooo`03o`000?oooooooooo00cooooo00Co0000oooooooooooo00000oooool00ol0003oooooo`00
0007ooooo`03o`000?oooooo000000Sooooo00Ko0000oooooooooooo0000ooooool00005ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02o`0000Oo
oooo00?o0000ooooooooool02?ooool2o`0000Gooooo0_l00006ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool01?ooool3o`0000Wooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`07ooooo`;o00000oooool00ol0003oooooooooo`0=ooooo`003_ooool2o`0000Wooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`02ooooo`03o`000?oooooo000000Oooooo
00?o0000ooooooooool03?ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooool0
00001oooool00ol0003oooooooooo`02ooooo`;o00002Oooool00ol0003oooooo`000008ooooo`03
o`000?oooooooooo00[ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooo0000
00Sooooo0_l00008ooooo`06o`000?ooooooooooo`000?oooooo00001_ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00_l00008ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01Oooool2o`0000Oooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`05ooooo`?o00002_ooool00ol0003oooooooooo`03ooooo`03o`000?oo
oooooooo00Sooooo0_l00003ooooo`03o`000?oooooooooo00gooooo000>ooooo`;o00002Oooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooool000002?ooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_oo
ool00ol0003oooooooooo`06ooooo`04o`000?ooooooooooo`0000_ooooo00?o0000ooooool00000
2?ooool00ol0003oooooooooo`08ooooo`;o00001?ooool01ol0003ooooooooooooooooo0000oooo
ool000002?ooool00ol0003oooooo`000007ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool00_l00009ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01_ooool2
o`0000Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`;o000000?ooooo
o`000?ooool02Oooool00ol0003oooooooooo`02o`0000_ooooo0_l00003ooooo`03o`000?oooooo
oooo00gooooo000>ooooo`;o00002_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooool000002Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00?ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`07ooooo`;o00003?ooool0
0ol0003oooooo`000009ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01?ooool0
1?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Gooooo00Go0000oooooooooooooooo
o`000006ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`03ooooo`;o00002?ooool01Ol0003oooooo`000?oooooo000000[ooooo00Co0000oooo
oooooooooooo0_l00009ooooo`;o00002Oooool2o`0000?ooooo00?o0000ooooooooool01_ooool2
o`000003ooooool0003ooooo00[ooooo0_l0000=ooooo`03o`000?oooooo000000;ooooo00?o0000
ooooooooool03Oooool000kooooo0_l0000;ooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool01?ooool00ol0003oooooo`00000:ooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool01?ooool00ol0003oooooo`000003ooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ool000003?ooool00ol0003oooooo`00000:ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool01Oooool01_l0003oooooooooool0003oooooo`0000Oooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`03ooooo`07o`000?ooooooooooooooool0003oooooo`000008ooooo`05
o`000?ooooooooooooooool000002_ooool01Ol0003oooooo`000?oooooo000000_ooooo00?o0000
ooooool000002oooool2o`0000_ooooo00?o0000ooooool000002_ooool00ol0003oooooo`00000;
ooooo`;o00003Oooool00ol0003oooooo`000002ooooo`03o`000?oooooooooo00gooooo000>oooo
o`;o00003?ooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooool000002oooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00000ooo
ool00ol0003oooooooooo`05ooooo`05o`000?ooooooooooooooool000002oooool00ol0003ooooo
o`00000;ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01_ooool01_l0003ooooo
ooooool0003oooooo`0000Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`03oooo
o`06o`000?ooooooooooo`000?oooooo00002Oooool00ol0003oooooo`00000;ooooo`04o`000?oo
oooo0000o`0000cooooo0_l0000<ooooo`;o00003?ooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooo000000[ooooo00Co0000oooooooooooo00003?ooool00ol0003oooooo`000002ooooo`03
o`000?oooooooooo00gooooo000>ooooo`;o00003Oooool00ol0003oooooo`000009ooooo`;o0000
3?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Gooooo00Co0000oooooooooooo
00000oooool00ol0003oooooooooo`03ooooo`;o00001Oooool00ol0003oooooooooo`08ooooo`03
o`000?oooooo000000cooooo00Co0000ooooool0003o00002?ooool01ol0003ooooooooooooooooo
0000ooooool000001Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00;ooooo00Ko
0000oooooooooooo0000ooooool0000:ooooo`03o`000?oooooooooo00[ooooo00Co0000ooooool0
003o00002oooool00ol0003oooooo`00000<ooooo`;o00002oooool00ol0003oooooo`00000:oooo
o`03o`000?oooooo000000Sooooo0_l00004ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ool000000_ooool00ol0003oooooooooo`0=ooooo`003_ooool2o`0000kooooo00?o0000oooooooo
ool02?ooool2o`0000gooooo00Co0000ooooool0003o00002?ooool00ol0003oooooo`000004oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`08oooo
o`03o`000?oooooo000000gooooo00?o0000ooooooooool02?ooool01?l0003oooooooooool00002
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool02Oooool01Ol0003ooooooooooooo
oooo000000;ooooo00?o0000ooooool000002Oooool00ol0003oooooo`00000;ooooo`;o000000?o
ooooo`000?ooool02Oooool01Ol0003ooooooooooooooooo000000_ooooo0_l0000;ooooo`03o`00
0?oooooooooo00;o00002?ooool00ol0003oooooo`000007ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool02?ooool00ol0003oooooo`000002ooooo`03o`000?oooooooooo00gooooo
000>ooooo`;o00003_ooool00ol0003oooooooooo`08ooooo`;o00003_ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooo000000Cooooo00?o0000ooooooooool00_l00009ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooool000003?ooool00ol0003oooooo`000009ooooo`04o`000?oo
ooooooooo`0000;ooooo00Go0000ooooooooooooooooo`00000=ooooo`;o000000?oooooo`000?oo
ool00_ooool2o`0000Sooooo00Go0000ooooooooooooooooo`00000:ooooo`;o000000?oooooo`00
0?ooool01oooool2o`0000Gooooo00?o0000ooooooooool02?ooool2o`0000[ooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`05ooooo`03o`000?oooooo000000Kooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooo000000;ooooo00?o0000oooo
ooooool03Oooool000kooooo0_l0000=ooooo`03o`000?oooooo000000Wooooo0_l0000=ooooo`03
o`000?oooooo000000Wooooo0_l00005ooooo`03o`000?oooooo000000cooooo00?o0000oooooooo
ool01_ooool00ol0003oooooo`00000;ooooo`05o`000?ooooooooooooooool000002?ooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`00013ooooo0_l00003ooooo`;o00001ooo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Oooooo0_l000000ooooooo0000oooo
o`06ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool01?l0003ooooooooo
ool00003ooooo`;o00002oooool00ol0003oooooooooo`06ooooo`06o`000?ooooooooooo`000?oo
oooo00003oooool000kooooo0_l0000<ooooo`05o`000?ooooooooooooooool000002?ooool2o`00
00cooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooo000000Gooooo0_l0000>
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooool000002_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00Gooooo00Co0000oooooooooooo00000_ooool01?l0003ooooooooo
ool0000Aooooo`04o`000?ooooooooooooooo`;o00001_ooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Gooooo00Go0000ooooool0003oooooo`000005ooooo`;o00002Oooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`03ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool03?ooool0
0ol0003oooooooooo`05ooooo`06o`000?ooooooooooo`000?oooooo00003oooool000kooooo0_l0
000;ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01Oooool2o`0000_ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`04ooooo`03o`000?oooooo000000Cooooo0_l0
000@ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooool000002?ooool2o`0000Kooooo00?o
0000ooooooooool01Oooool00ol0003oooooo`000003ooooo`03o`000?oooooo000001;ooooo0_l0
0003ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`04ooooo`05o`000?oooooo0000ooooool000001?ooool00ol0003oooooooooo`0:ooooo`03o`00
0?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`09ooooo`;o0000
0oooool01_l0003oooooooooool0003oooooo`00013ooooo00?o0000ooooooooool01?ooool01_l0
003oooooooooool0003oooooo`0000oooooo000>ooooo`;o00002oooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo00Cooooo0_l0000:ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool00oooool2o`0000?ooooo0ol0000Booooo`03o`000?oooooooooo00?ooooo00?o0000
ooooool000001oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooool000000oooool2o`0001?ooooo00?o0000ooooool000000_ooool2o`0000?ooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`03ooooo`;o00000_ooool01Ol0003ooooooooooooo
oooo000000kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00_ooooo00?o0000ooooool000000_l000000ooooooo0000o`00000Booooo`03o`000?oo
oooooooo00?ooooo00Ko0000oooooooooooo0000ooooool0000?ooooo`003_ooool3o`0000Wooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`;o00002Oooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00;ooooo0_l00002ooooo`04o`000?ooooooooooo`0001?o
oooo00?o0000ooooooooool00_ooool00ol0003oooooo`000006ooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool00oooool00ol0003oooooo`000003ooooo`03o`000?oooooooooo01;o
oooo00Go0000oooooooooooo0000ooooo`03o`000003ooooool0003ooooo00cooooo00?o0000oooo
ooooool00_ooool2o`0000;ooooo00Co0000ooooool0003o00004?ooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool03Oooool6o`0001Cooooo00?o0000
ooooooooool00_ooool01_l0003oooooooooool0003oooooo`0000oooooo000>ooooo`?o00002?oo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00?ooooo0_l00007ooooo`;o00002ooo
ool00ol0003oooooo`000002o`0000;ooooo00Go0000ooooooooooooooooo`00000Cooooo`03o`00
0?oooooooooo00?ooooo0_l00005ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0
0_ooool2o`0000?ooooo0_l0000Dooooo`04o`000?ooooooooooooooo`Go00003oooool01?l0003o
ooooooooooooool2o`0000;ooooo0_l0000Booooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool01?ooool00ol0003oooooooooo`0=ooooo`Oo00005Oooool01Ol0003ooooooooooooooooo
000000;ooooo00?o0000ooooool000003oooool000kooooo0ol00007ooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool00_ooool2o`0000Kooooo00?o0000ooooooooool03?ooool6o`00
00Cooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00;ooooo0_l0000?ooooo`04o`000?ooooooooooooooo`;o00000_ooool00ol0003oooooo`00000D
ooooo`03o`000?oooooooooo00Oo00003oooool00ol0003oooooooooo`02o`000003ooooool0003o
000001Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo00Sooooo3Ol0000Fooooo`04o`000?ooooooooooo`0000?ooooo0_l0000?ooooo`003_ooool3
o`0000Kooooo00?o0000ooooooooool02oooool01?l0003oooooooooooooool2o`0000Gooooo00?o
0000ooooooooool03?ooool7o`0000Cooooo00?o0000ooooooooool04oooool01Ol0003ooooooooo
oooooooo000000?ooooo00?o0000ooooooooool04?ooool00ol0003oooooo`000002o`000005oooo
ool0003oooooooooool000004oooool>o`0000gooooo1_l0000Fooooo`03o`000?oooooooooo01?o
00000oooool=o`0001Cooooo00?o0000ooooool000000oooool2o`0000oooooo000?ooooo`;o0000
1_ooool00ol0003oooooooooo`0<ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003o
ooooooooo`0=oooooa?o00003oooool00ol0003oooooo`000002o`000003ooooool0003ooooo01?o
oooo1Ol00003ooooo`03o`000?oooooooooo00;ooooo4Ol00002ooooo`Oo000000?oooooo`000?l0
00002ol000000ooooooo0000o`000003o`000003ooooool0003ooooo00Gooooo4ol00002ooooo`05
o`000?ooooooooooooooool000003?ooool3o`0000Cooooo1Ol000001?oooooo0000ooooooooool5
o`00013ooooo0_l00003ooooo`;o00003oooool000oooooo0_l00005ooooo`03o`000?oooooooooo
00gooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo00Sooooo3Ol00003
ooooobOo00002_oooolEo`0000[ooooo9_l0000Aooooo`05o`000?ooooooooooooooool000000ooo
ool00ol0003oooooooooo`06ooooo`Co00001oooool5o`000003ooooool0003ooooo00Kooooo1?l0
000=ooooo`04o`000?ooooooooooooooo`;o00003oooool000oooooo0_l00004ooooo`03o`000?oo
oooooooo00oooooo00?o0000ooooool000000_l000000ooooooo0000ooooo`05ooooo`Oo00001Ooo
ool5o`0000Gooooo00?o0000ooooooooool01oooool;o`0000;ooooo1ol00003oooooboo00000ooo
ool5o`0000oooooo4Ol0000?ooooo`03o`000?oooooo000000;o000000?oooooo`000?ooool01?oo
ool4o`0000[ooooo00?o0000ooooooooool00_l000000ooooooo0000o`00000;ooooo`Co00002Ooo
ool2o`0000;ooooo0_l0000?ooooo`003oooool2o`0000?ooooo00?o0000ooooooooool04Oooool5
o`000003ooooool0003o000000Ko00002_ooool5o`0000Gooooo00?o0000ooooooooool02OoooolK
o`0000[ooooo1ol00002ooooo`03o`000?oooooooooo01;ooooo00Go0000oooooooooooo0000oooo
o`02o`000003ooooool0003ooooo00kooooo2?l00006ooooo`[o00002Oooool5o`0000?ooooo0ol0
000=ooooo`04o`000?ooooooooooooooo`;o00000_ooool00ol0003oooooooooo`0=ooooo`Co0000
1Oooool01?l0003oooooo`000?ooool2o`0000oooooo000?ooooo`;o00000_ooool00ol0003ooooo
ooooo`0Aooooo`[o00002?oooolMo`0000_ooooo1ol0000Dooooo`Go00000oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooo000000;ooooo0_l00002ooooo`03o`000?oooooooooo00gooooo
1Ol000000ooooooo0000o`00000>oooooa;o00003oooool00ol0003oooooooooo`02ooooo`;o0000
0_ooool2o`0001;ooooo1_l00002ooooo`Co00003_ooool000oooooo0_l00002ooooo`03o`000?oo
oooooooo00gooooo5_l00005ooooo`04o`000?ooooooooooooooo`;o00000_ooool01Ol0003ooooo
oooooooooooo000001Kooooo1_l0000Eooooo`Go00000oooool00ol0003oooooooooo`0Booooo`03
o`000?oooooo000000;ooooo0_l00003ooooo`03o`000?oooooooooo00cooooo1?l00002ooooo`03
o`000?oooooo000001Kooooo8_l000000ooooooo0000ooooo`0Eooooo`So00003Oooool000kooooo
0ol000000ooooooo0000ooooo`09oooooa7o00003oooool00ol0003oooooooooo`03ooooo`05o`00
0?ooooooooooooooool000000_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00Co
00005?ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001Cooooo0_l00003
ooooo`;o00001?ooool00ol0003oooooooooo`0:ooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool0000Eooooo`Oo00003oooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooo000000;ooooo8Ol0000<ooooo`003Oooool5o`0000Gooooo2Ol00008ooooo`Ko00003_oo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool000005?oo
ool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0001;ooooo00Co0000oooooooooooo
oooo0_l00002ooooo`;o00005Oooool00ol0003oooooooooo`02ooooo`;o00001?ooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool000001?ooool00ol0003o
ooooooooo`0Booooo`Oo00003_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo000000;o
oooo00?o0000ooooool000005Oooool00ol0003oooooo`000006o`0000cooooo000<ooooo`go0000
3oooool4o`0000;ooooo0_l0000<ooooo`03o`000?oooooooooo00Cooooo0_l00004ooooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool00oooool01Ol0003ooooooooooooooooo0000013o
oooo00?o0000ooooooooool00_ooool2o`0000?ooooo00?o0000ooooooooool04_ooool2o`0000Co
oooo0_l00005ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool00oooool00ol0003o
ooooo`000005ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool00ol00002ooooo`;o
00002oooool00ol0003oooooooooo`07ooooo`;o00000_ooool01?l0003oooooooooool0000Doooo
o`03o`000?oooooo000000Ko00003?ooool000cooooo1ol0000Dooooo`03o`000?oooooooooo00;o
00001?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Gooooo0_l00004ooooo`;o
00004Oooool2o`0000Gooooo0_l00004ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool00oooool2o`0000?ooooo0_l0000Cooooo`;o00001?ooool2o`0000Kooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooo000000Kooooo00?o0000oooooooo
ool03Oooool2o`0000?ooooo0_l00005ooooo`03o`000?oooooooooo00Sooooo00?o0000oooooooo
ool01oooool01Ol0003oooooo`000?oooooo000000?ooooo00?o0000ooooooooool04Oooool2o`00
0003ooooool0003o000000?o00003Oooool000cooooo1ol0000Cooooo`04o`000?oooooooooooooo
o`;o00001Oooool2o`0000Oooooo00?o0000ooooooooool01_ooool2o`0000Cooooo00?o0000oooo
ool000003oooool00ol0003oooooooooo`05ooooo`;o00001Oooool00ol0003oooooooooo`0:oooo
o`03o`000?oooooooooo00Cooooo0_l00003ooooo`03o`000?oooooo0000017ooooo00?o0000oooo
ool000000oooool00ol0003oooooo`000006ooooo`03o`000?oooooooooo00Cooooo00?o0000oooo
ooooool01Oooool00ol0003oooooo`000007ooooo`03o`000?oooooooooo00_ooooo00?o0000oooo
ooooool00oooool2o`0000Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08oooo
o`05o`000?oooooo0000ooooool000001?ooool00ol0003oooooooooo`0@ooooo`04o`000?oooooo
ooooooooo`?o00003_ooool000gooooo1ol0000Aooooo`03o`000?oooooooooo00;ooooo0_l00007
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01oooool2o`0000Cooooo00Co0000
oooooooooooo00003Oooool00ol0003oooooooooo`06ooooo`;o00001_ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Gooooo0_l00003ooooo`04o`000?ooooooooooo`0000oooooo
00Co0000oooooooooooo00000oooool2o`0000Sooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooo000000Sooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`04ooooo`;o00001oooool2o`0000Gooooo00?o0000ooooooooool02Oooool01Ol0003o
ooooo`000?oooooo000000Gooooo00?o0000ooooooooool03_ooool2o`0000?ooooo0_l0000?oooo
o`003_ooool4o`0000;ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`03ooooo`;o
00002?ooool01Ol0003ooooooooooooooooo000000[ooooo00?o0000ooooool000000oooool01Ol0
003ooooooooooooooooo000000_ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool2o`0000?ooooo00Go0000
ooooooooooooooooo`00000=ooooo`05o`000?ooooooooooooooool000000oooool2o`0000Wooooo
00Go0000ooooooooooooooooo`000008ooooo`03o`000?oooooo000000Wooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`05ooooo`;o00002Oooool01Ol0003ooooooooooooooooo0000
00cooooo00Go0000ooooool0003oooooo`000006ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooool000000oooool2o`0000oooooo000?ooooo`?o00000oooool2o`0000gooooo00?o0000oooo
ooooool00oooool2o`0000Wooooo0ol0000;ooooo`03o`000?oooooo000000?ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo0_l00003oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02oooo
o`04o`000?ooooooooooooooo`;o00002_ooool00ol0003oooooo`000009ooooo`03o`000?oooooo
000000[ooooo00?o0000ooooooooool01?ooool2o`0000Sooooo0_l0000:ooooo`?o00003Oooool0
1_l0003oooooooooool0003oooooo`0000Gooooo00?o0000ooooooooool02oooool01?l0003ooooo
ooooool00003ooooo`;o00003oooool000oooooo0ol00005ooooo`;o00002_ooool00ol0003ooooo
ooooo`04ooooo`;o00002_ooool2o`0000_ooooo00?o0000ooooool000000oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01oooool2o`0000?ooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00;ooooo
00Co0000oooooooooooooooo0_l0000:ooooo`;o00002_ooool00ol0003oooooo`00000;ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool02?ooool2o`0000_ooooo0_l0000=ooooo`06
o`000?ooooooooooo`000?oooooo00001_ooool00ol0003oooooooooo`09ooooo`05o`000?oooooo
ooooooooool000000oooool2o`0000oooooo000?ooooo`?o00001oooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo00Gooooo0_l0000:ooooo`03o`000?oooooo000000[ooooo00?o0000
ooooool000000oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00;ooooo0_l0000<
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`08
ooooo`;o00000oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool00oooool01?l0003oooooooooooooool2o`0000[ooooo0_l0000:ooooo`03o`000?oo
oooo000000cooooo00Co0000oooooooooooo00002oooool2o`0000[ooooo00Co0000oooooooooooo
00003?ooool01_l0003oooooooooool0003oooooo`0000Oooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`02ooooo`06o`000?ooooooooooo`000?oooooo00003oooool000oooooo0ol0
0008ooooo`;o00001Oooool00ol0003oooooooooo`06ooooo`;o00002Oooool01?l0003ooooooooo
ooooool2o`0000Sooooo00?o0000ooooool000000oooool00ol0003oooooooooo`05ooooo`04o`00
0?ooooooooooo`0000kooooo00?o0000ooooooooool02Oooool01?l0003oooooooooool0000;oooo
o`03o`000?oooooo000000;ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Cooooo00Ko0000oooooooooooo0000ooooool00009ooooo`04o`000?oo
ooooooooo`0000Wooooo00?o0000ooooool000003Oooool2o`0000cooooo0_l00009ooooo`03o`00
0?oooooooooo00;ooooo0_l0000:ooooo`06o`000?ooooooooooo`000?oooooo00002?ooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo00?ooooo00Ko0000oooooooooooo0000ooooool0
000?ooooo`003oooool2o`000003ooooool0003ooooo00Sooooo00Go0000ooooooooooooooooo`00
0009ooooo`;o00002?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooool000000_ooool00ol0003oooooooooo`06ooooo`;o00003oooool00ol0003ooooooooo
o`0:ooooo`;o00003Oooool2o`0000;ooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00Kooooo00Go0000ooooool0003oooooo`000008ooooo`05o`00
0?ooooooooooooooool000002Oooool2o`0000gooooo0ol0000<ooooo`;o00002?ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Oooooo00Co0000oooooooooooooooo0_l00009oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool01_l0003oooooooooool0003o
ooooo`0000oooooo000?ooooo`;o000000?oooooo`000?ooool02Oooool3o`0000[ooooo0_l00007
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooo`000002
ooooo`03o`000?oooooooooo00Kooooo0_l0000?ooooo`03o`000?oooooooooo00[ooooo0_l0000=
ooooo`;o00000_ooool00ol0003oooooooooo`07ooooo`04o`000?ooooooooooo`0000Wooooo00Go
0000ooooool0003oooooo`000007ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
1_ooool2o`0000cooooo00Go0000ooooooooooooooooo`00000;ooooo`;o00001oooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00Co0000oooooooooooooooo0_l0000:oooo
o`03o`000?oooooooooo00;o00001oooool01_l0003oooooooooool0003oooooo`0000oooooo000?
ooooo`04o`000?oooooo0000o`0000_ooooo0_l0000:ooooo`;o00001_ooool00ol0003ooooooooo
o`08ooooo`;o00001Oooool00ol0003oooooo`000002ooooo`03o`000?oooooooooo00Gooooo00Co
0000oooooooooooo00003_ooool00ol0003oooooooooo`09ooooo`04o`000?ooooooooooo`0000co
oooo0_l00002ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooool000002Oooool01Ol0003o
ooooo`000?oooooo000000Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05oooo
o`;o00002oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Sooooo0_l00006oooo
o`03o`000?oooooooooo00Wooooo0_l00006ooooo`04o`000?ooooooooooooooo`;o00002_ooool0
0ol0003oooooo`000009ooooo`06o`000?ooooooooooo`000?oooooo00003oooool000oooooo00Co
0000ooooool0003o00002oooool01?l0003oooooo`000?l00008ooooo`;o00001Oooool00ol0003o
ooooooooo`0;ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool000000_ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool02_ooool2o`0000[o
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`;o00000_ooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00Go0000ooooool0003oooooo`000005oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01?ooool2o`0000[ooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`07ooooo`;o00001_ooool00ol0003oooooooooo`0;oooo
o`03o`000?oooooooooo00?ooooo00Oo0000ooooooooooooooooo`000?oooooo000000[ooooo00?o
0000ooooooooool02?ooool00ol0003oooooo`000002ooooo`03o`000?oooooooooo00gooooo000?
ooooo`04o`000?oooooo0000o`0000[ooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`05ooooo`;o00001Oooool00ol0003oooooooooo`0<ooooo`;o00000_ooool00ol0003ooooooooo
o`02o`0000Gooooo0_l00006ooooo`03o`000?oooooooooo00Wooooo0_l00009ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool02?ooool2o`0000;ooooo00?o0000ooooooooool02?oo
ool00ol0003oooooo`000009ooooo`05o`000?oooooo0000ooooool000001?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00Cooooo0_l00009ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool01Oooool3o`0000Gooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo00;ooooo0_l00009ooooo`03o`000?oooooo000000Wooooo
00?o0000ooooool000000_ooool00ol0003oooooooooo`0=ooooo`003oooool01?l0003oooooo`00
0?l00009ooooo`03o`000?oooooooooo00Cooooo0_l00005ooooo`;o00001?ooool00ol0003ooooo
ooooo`0?ooooo`03o`000?oooooo000000;ooooo0_l00004ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool02?ooool2o`0000Sooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`07ooooo`;o00000_ooool00ol0003oooooooooo`07ooooo`05o`000?ooooooooooooooool0
00002?ooool2o`0000;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00?ooooo0_l00007ooooo`;o00002oooool00ol0003oooooooooo`04ooooo`?o
00001?ooool00ol0003oooooooooo`0?ooooo`;o00000_ooool00ol0003oooooooooo`02ooooo`;o
00002?ooool01Ol0003ooooooooooooooooo000000Sooooo00?o0000ooooool000000_ooool00ol0
003oooooooooo`0=ooooo`003oooool01?l0003oooooo`000?l00008ooooo`03o`000?oooooooooo
00Oooooo0_l00003ooooo`;o00000oooool00ol0003oooooooooo`0Aooooo`;o00000_ooool2o`00
00?ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`07ooooo`;o00001oooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo0_l00002ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`05ooooo`;o00000_ooool01Ol0
003ooooooooooooooooo000000gooooo00?o0000ooooooooool00_ooool2o`0000Kooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`03ooooo`?o00000oooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooo000000Cooooo0_l00007ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool01Oooool00ol0003oooooo`000002ooooo`03o`000?oooooooooo00gooooo000?oooo
o`04o`000?ooooooooooo`0000Oooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`03
o`000003ooooool0003ooooo01Cooooo0_l000001_oooooo0000o`000?l0003oooooo`0000gooooo
00?o0000ooooooooool01_ooool2o`0000Oooooo00?o0000ooooooooool02Oooool00ol0003ooooo
ooooo`05ooooo`05o`000?oooooo0000ooooool000002?ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Cooooo0_l00002ooooo`04o`000?ooooooooooo`0000kooooo00?o0000oooo
ooooool00_ooool2o`0000Gooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`02oooo
o`03o`000?oooooo000000;ooooo00?o0000ooooooooool05?ooool2o`0000Cooooo0_l00006oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooo`000002oooo
o`03o`000?oooooooooo00gooooo000?ooooo`04o`000?ooooooooooo`0000Kooooo00?o0000oooo
ooooool03?ooool6o`0001Kooooo00?o0000ooooool000001?l0000?ooooo`03o`000?oooooooooo
00Gooooo0_l00006ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool01?ooool01Ol0
003oooooo`000?oooooo000000Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`03
ooooo`;o00000_ooool00ol0003oooooo`00000@ooooo`04o`000?ooooooooooooooo`;o00001?oo
ool00ol0003oooooooooo`0@ooooo`09o`000?ooooooooooooooool0003oooooo`000?oooooo0000
01Sooooo0_l00004ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`03ooooo`;o00000oooool00ol0003oooooooooo`0=ooooo`003oooool01?l0003o
ooooooooool00006ooooo`03o`000?oooooooooo00cooooo1ol0000Eooooo`So00003oooool00ol0
003oooooooooo`04ooooo`;o00001Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
00Cooooo00Go0000ooooool0003oooooo`000006ooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool00_ooool2o`0000;ooooo0_l0000Booooo`03o`000?oooooooooo00;o00000_ooool2
o`0001Cooooo00?o0000ooooool000001?l0000Iooooo`03o`000?oooooo000000?ooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00?ooooo0_l00003
ooooo`03o`000?oooooooooo00gooooo000?ooooo`04o`000?ooooooooooo`0000Gooooo00?o0000
ooooooooool03OoooolTo`00013ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool00oooool01?l0003oooooo`000?l0
0006ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooooooo0_l00002ooooo`03o`00
0?oooooooooo01;ooooo1?l000000ooooooo0000ooooo`0Fooooo`Go00006oooool01Ol0003ooooo
o`000?l0003ooooo00?o000000?oooooo`000?ooool02oooool00ol0003oooooooooo`02ooooo`;o
00000oooool00ol0003oooooooooo`0=ooooo`003oooool00ol0003oooooooooo`02o`0000?ooooo
00?o0000ooooooooool02_ooool;o`0000;ooooo4_l00002ooooo`ko00002_ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool04?ooool00ol0003ooooo
ooooo`02ooooo`04o`000?oooooo0000o`0000Kooooo00?o0000ooooooooool02oooool00ol0003o
ooooo`000002o`000003ooooool0003o000001Cooooo1Ol0000Gooooo`Oo00006_ooool01?l0003o
ooooooooooooool5o`0000kooooo00Co0000oooooooooooooooo0_l00003ooooo`03o`000?oooooo
oooo00gooooo000?ooooo`03o`000?oooooooooo00?o000000?oooooo`000?ooool01oooool5o`00
00Gooooo3ol00002ooooo`Wo00000_ooool6o`0000Gooooo2Ol00005ooooo`05o`000?oooooooooo
ooooool000000oooool00ol0003oooooooooo`0Booooo`06o`000?ooooooooooooooool0003ooooo
0_l00005ooooo`03o`000?oooooooooo00gooooo1Ol000000ooooooo0000ooooo`0Booooo`Oo0000
2ooooolQo`0000_ooooo00?o0000ooooooooool01ol0000>ooooo`03o`000?oooooo000000;o0000
0oooool00ol0003oooooooooo`0=ooooo`003oooool00ol0003oooooo`000004o`0000Cooooo1Ol0
0004ooooo`_o00005Oooool9o`0000Sooooo1?l000000ooooooo0000o`000005o`000006ooooool0
003o0000o`000?oooooo00005_ooool01Ol0003oooooooooool0003ooooo00;o00001?ooool00ol0
003oooooooooo`0=ooooo`So00002OoooomDo`0000gooooo1Ol00002ooooo`03o`000?oooooooooo
00gooooo000?oooooaCo00001Oooool01?l0003oooooo`000?l00002ooooo`03o`000?oooooooooo
01Cooooo00Co0000oooooooooooo00000_ooool:o`0000?ooooo1Ol00003ooooo`Ko00005oooool0
1?l0003oooooo`000?ooool2o`0000?ooooo00?o0000ooooooooool00ooooolUo`000003ooooool0
003o000000Go00005oooool6o`0001[ooooo5ol000000ooooooo0000o`000005o`000003ooooool0
003ooooo00kooooo000?ooooo`Wo00003oooool00ol0003oooooooooo`02o`0000?ooooo00?o0000
ooooooooool04_ooool2o`0000;ooooo00Co0000oooooooooooo00002OoooolGo`0000Cooooo7?l0
0007ooooo`_o00000_ooool8o`0000_ooooo1_l0000Gooooo`Co00000_ooool00ol0003ooooooooo
o`0Gooooo`03o`000?oooooooooo00Ko00002_ooool<o`000003ooooool0003ooooo00kooooo000?
ooooo`So00003oooool01?l0003oooooooooooooool2o`0000?ooooo00?o0000ooooooooool04Ooo
ool01?l0003oooooo`000?ooool2o`0000?ooooo00?o0000ooooooooool03ooooolEo`0000cooooo
00?o0000ooooool000000_l000000ooooooo0000ooooo`07ooooo`Go00001?ooool9o`0001?ooooo
1?l00002ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool00_l00003ooooo`;o0000
5oooool3o`0000;ooooo1?l0000?ooooo`Oo000000?oooooo`000?ooool03_ooool000oooooo00?o
0000ooooool000001?l0000@ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`0@ooooo`04o`000?oooooo0000ooooo`;o00001?ooool00ol0003ooooo
ooooo`0?ooooo`Oo00000_oooolAo`0000Kooooo1_l00004ooooo`Go000000?oooooo`000?l00000
1_l000000ooooooo0000o`000004o`0001Cooooo00?o0000ooooooooool00_l00003ooooo`03o`00
0?oooooooooo017ooooo00Co0000oooooooooooooooo0_l00005ooooo`03o`000?oooooooooo01Co
oooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000kooooo1_l00002oooo
o`03o`000?oooooooooo00gooooo000@ooooo`03o`000?oooooo000000?o00003oooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03_ooool01Ol0003o
ooooooooool0003ooooo00;o00001Oooool00ol0003oooooooooo`0?ooooo`Ko00003OoooolLo`00
00Sooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo00;o00001?ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00;ooooo0_l00006
ooooo`03o`000?oooooooooo01;ooooo0_l00004ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`03o`0000Cooooo00?o0000ooooooooool03?ooool0
013ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0<ooooo`06o`000?oooooo
ooooooooool0003ooooo0_l00006ooooo`03o`000?oooooooooo00kooooo1?l00002ooooo`03o`00
0?oooooooooo01Gooooo2?l0000@ooooo`05o`000?ooooooooooooooool000000_ooool2o`0001;o
oooo00Co0000oooooooooooooooo0_l00005ooooo`03o`000?oooooooooo00kooooo00Co0000oooo
oooooooooooo0ol00007ooooo`03o`000?oooooooooo013ooooo00?o0000ooooool000001?ooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool00_ooool2
o`0000Cooooo00?o0000ooooooooool03?ooool0013ooooo00Co0000oooooooooooo00000oooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00;ooooo00Co0000ooooool0003o00001_oo
ool00ol0003oooooooooo`0=ooooo`04o`000?oooooo0000o`0000Cooooo00?o0000ooooooooool0
5Oooool7o`0000oooooo00?o0000ooooooooool00_ooool01_l0003oooooooooool0003oooooo`00
013ooooo00?o0000ooooooooool00_ooool2o`0000Kooooo00?o0000ooooooooool03?ooool00ol0
003oooooooooo`02ooooo`?o00002?ooool2o`0000kooooo0_l00002ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`06ooooo`;o00001Oooool2o`00
00Cooooo00?o0000ooooooooool03?ooool0013ooooo00Co0000ooooool0003o00000oooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Cooooo0ol00007ooooo`03o`000?oooooooooo
00_ooooo00?o0000ooooooooool00_l00005ooooo`03o`000?oooooooooo01?ooooo1ol0000?oooo
o`03o`000?oooooooooo00?ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0<
ooooo`03o`000?oooooooooo00?ooooo0_l00007ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool00oooool3o`0000[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`02
ooooo`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo00Gooooo0_l00004ooooo`03o`000?oooooooooo00cooooo000@ooooo`04o`000?oooooo
0000o`0000Cooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`05ooooo`?o00002?oo
ool00ol0003oooooooooo`09ooooo`04o`000?ooooooooooooooo`;o00001_ooool2o`00017ooooo
0_l000000ooooooo0000ooooo`04o`0000kooooo00?o0000ooooooooool01?ooool01?l0003ooooo
ooooool00003ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool00oooool2o`0000So
oooo0_l00009ooooo`03o`000?oooooooooo00Cooooo0ol0000;ooooo`03o`000?oooooooooo00So
oooo00?o0000ooooooooool00oooool01Ol0003ooooooooooooooooo000000Sooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`06ooooo`;o00001?ooool00ol0003oooooooooo`0<oooo
o`004?ooool01?l0003oooooo`000?l00005ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool01Oooool3o`0000Wooooo00?o0000ooooooooool02?ooool01?l0003oooooooooooooool2
o`0000Sooooo00?o0000ooooooooool03?ooool2o`0000?ooooo00Co0000oooooooooooo00000_oo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Gooooo0_l000000ooooooo0000oooo
o`03ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool3o`0000cooooo00?o
0000ooooooooool01Oooool2o`0000Kooooo00Go0000ooooooooooooooooo`000009ooooo`04o`00
0?ooooooooooo`0000Wooooo00?o0000ooooool000000oooool00ol0003oooooooooo`0<ooooo`00
4?ooool01?l0003oooooo`000?l00006ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool01_ooool3o`0000Wooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`02ooooo`;o
00002Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00?ooooo00Co0000oooooooo
oooo00000oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo0_l000000ooo
oooo0000ooooo`04ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01_ooool3o`00
00gooooo0_l00004ooooo`03o`000?oooooooooo00Kooooo00Go0000ooooooooooooooooo`00000:
ooooo`;o00002oooool2o`0000?ooooo00?o0000ooooooooool03?ooool0013ooooo00Co0000oooo
ool0003o00001oooool01Ol0003ooooooooooooooooo000000[ooooo0_l0000:ooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool01oooool3o`0000[ooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`02ooooo`?o00002_ooool00ol0003oooooooooo`07ooooo`;o00001_oo
ool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
1oooool2o`000003ooooool0003ooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00[ooooo00Go0000ooooooooooooooooo`000009ooooo`?o
00003oooool01?l0003oooooooooool00009ooooo`03o`000?oooooooooo00;o00002_ooool2o`00
00_ooooo0_l00003ooooo`03o`000?oooooooooo00cooooo000@ooooo`04o`000?oooooo0000o`00
00Oooooo00Co0000oooooooooooo00002oooool2o`0000_ooooo00Go0000ooooooooooooooooo`00
000:ooooo`03o`000?oooooo000000_ooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`03ooooo`?o00002oooool00ol0003oooooooooo`04ooooo`;o00002?ooool01?l0003oooooo`00
0?l00005ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool02?ooool2o`000003oooo
ool0003ooooo00Kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo00_ooooo00Co0000oooooooooooo00002Oooool3o`00013ooooo0_l0000:ooooo`04
o`000?ooooooooooo`0000Wooooo0_l00002ooooo`03o`000?oooooooooo00Sooooo0_l00003oooo
o`03o`000?oooooooooo00cooooo000@ooooo`04o`000?oooooo0000o`0000Sooooo0_l0000<oooo
o`;o00003?ooool00ol0003oooooo`00000;ooooo`03o`000?oooooo000000cooooo00Go0000oooo
ooooooooooooo`000006ooooo`?o00003?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo00Sooooo00Co0000ooooool0003o00001_ooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo00Wooooo0_l000000ooooooo0000ooooo`07ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`0<ooooo`;o00002_ooool00ol0003oooooo`00
000?ooooo`03o`000?oooooo000000[ooooo00Co0000oooooooooooo00002?ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo00Sooooo0_l00003ooooo`03o`000?oooooooooo00cooooo
000@ooooo`04o`000?oooooo0000o`0000Wooooo00?o0000ooooooooool02_ooool2o`0000gooooo
00?o0000ooooooooool02_ooool00ol0003oooooo`00000<ooooo`04o`000?ooooooooooo`0000Oo
oooo0ol0000=ooooo`04o`000?oooooo0000o`0000_ooooo00Co0000ooooool0003o00001oooool0
1?l0003oooooooooool0000=ooooo`03o`000?oooooo000000Wooooo00Co0000oooooooooooo0000
2oooool00ol0003oooooooooo`0<ooooo`;o00002_ooool00ol0003oooooo`00000>ooooo`05o`00
0?ooooooooooooooool000002Oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool01oooool00ol0003oooooo`000002ooooo`03o`000?oooooooooo
00cooooo000@ooooo`04o`000?oooooo0000o`0000Sooooo00?o0000ooooool000002oooool2o`00
00gooooo0_l0000;ooooo`03o`000?oooooo000000gooooo00?o0000ooooool000001oooool00ol0
003oooooo`00000=ooooo`?o00003Oooool2o`0000Wooooo00?o0000ooooool000003Oooool00ol0
003oooooo`00000:ooooo`;o00003?ooool00ol0003oooooooooo`0;ooooo`04o`000?oooooooooo
o`0000Wooooo00?o0000ooooool000003Oooool00ol0003oooooooooo`03ooooo`;o00002?ooool0
0ol0003oooooo`000006ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool0
0ol0003oooooo`000002ooooo`03o`000?oooooooooo00cooooo000@ooooo`;o000000?oooooo`00
0?ooool01_ooool01Ol0003ooooooooooooooooo000000[ooooo0_l0000<ooooo`03o`000?oooooo
000000_ooooo00?o0000ooooool000003_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
000000cooooo00Go0000ooooooooooooooooo`00000<ooooo`;o00002_ooool00ol0003ooooooooo
o`0<ooooo`03o`000?oooooo000000[ooooo0_l0000<ooooo`;o00002oooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00Gooooo00Co0000oooooooooooo00002oooool2o`0000Sooooo
00?o0000ooooooooool01Oooool3o`0000Gooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooo000000;ooooo00?o0000ooooooooool03?ooool0013ooooo0_l0
00000ooooooo0000ooooo`05ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool02?oo
ool2o`0000_ooooo00Go0000ooooooooooooooooo`00000:ooooo`03o`000?oooooo000000gooooo
00?o0000ooooool000001oooool00ol0003oooooo`00000:ooooo`;o00001Oooool00ol0003ooooo
ooooo`09ooooo`;o00002Oooool00ol0003oooooo`00000=ooooo`03o`000?oooooo000000[ooooo
00?o0000ooooool000002oooool2o`0000[ooooo00?o0000ooooooooool01?ooool2o`0000Gooooo
00Co0000oooooooooooo00002_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Co
oooo0_l00004ooooo`;o00003?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo000000;o
oooo00?o0000ooooooooool03?ooool0013ooooo0_l000000ooooooo0000ooooo`04ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool01oooool2o`0000[ooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`07ooooo`?o00003?ooool01?l0003oooooooooool00007ooooo`03
o`000?oooooo000000Sooooo0_l00008ooooo`03o`000?oooooooooo00Sooooo0_l00008ooooo`05
o`000?ooooooooooooooool000003?ooool00ol0003oooooo`000009ooooo`05o`000?oooooooooo
ooooool000002_ooool2o`0000[ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`02
ooooo`04o`000?ooooooooooo`0000Wooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`03ooooo`;o00000oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooool000000_ooool00ol0003oooooooooo`0<ooooo`004?ooool2o`000003ooooool0003o
oooo00Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`;o00002Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Kooooo0ol0000;ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool01?ooool00ol0003oooooo`000007ooooo`03o`000?oooooo
oooo00Wooooo00?o0000ooooooooool01oooool2o`0000Oooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooo000000Sooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`07ooooo`;o00002Oooool00ol0003oooooooooo`08ooooo`05o`000?oooooo
ooooooooool000000_ooool00ol0003oooooooooo`05ooooo`;o00003oooool2o`0000?ooooo0_l0
0002ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool00oooool01_l0003ooooooooo
ool0003oooooo`0000kooooo000@ooooo`;o000000?oooooo`000?ooool00oooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Gooooo0_l00009ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool01_ooool3o`0000[ooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooo000000Gooooo0_l0000=ooooo`03o`000?oooooooooo00Kooooo
0_l00006ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02?ooool00ol0003ooooo
o`000007ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01_ooool2o`0000Sooooo
00?o0000ooooooooool02_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool04Oooool5o`000003ooooool0003ooooo017ooooo00?o0000oooooooo
ool00_ooool01_l0003oooooooooool0003oooooo`0000kooooo000@ooooo`;o000000?oooooo`00
0?ooool00_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Cooooo0_l00008oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01Oooool3o`0000Wooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo000000?ooooo0_l0000@oooo
o`;o00001_ooool2o`0000Gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooo000000Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05oooo
o`;o00001oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooo000000;ooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`0Booooo`Ko00005?ooool01Ol0003ooooooooooooooooo
000000;ooooo00?o0000ooooool000003_ooool0013ooooo0_l000001Ooooooo0000oooooooooooo
000000cooooo00?o0000ooooooooool01?ooool2o`0000Oooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`03ooooo`04o`000?oooooo0000o`0000Wooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`02o`000005ooooool0003oooooooooool000005?ooool00ol0003ooooo
ooooo`03ooooo`;o00001?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Kooooo
0_l00007ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01?ooool2o`0000Kooooo
00?o0000ooooooooool03_ooool2o`0000;ooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`0Booooo`Oo00005Oooool01?l0003oooooooooool00002ooooo`03o`000?oooooo000000ko
oooo000@ooooo`;o000000Coooooo`000?oooooo00003_ooool00ol0003oooooooooo`03ooooo`;o
00001_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00;ooooo00Co0000ooooool0
003o00002?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo000000;o000000Coooooo`00
0?l0003o00005_ooool00ol0003oooooooooo`02ooooo`;o00000oooool00ol0003oooooooooo`0;
ooooo`03o`000?oooooooooo00Gooooo0_l00006ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool00oooool2o`0000Gooooo00?o0000ooooooooool04?ooool01?l0003oooooooooool0
0002ooooo`;o00005?ooool8o`0001Kooooo00?o0000ooooool000000_ooool00ol0003oooooo`00
000>ooooo`004?ooool2o`000003ooooool0003o0000013ooooo00?o0000ooooooooool00_ooool2
o`0000Gooooo00?o0000ooooooooool03Oooool01_l0003ooooooooooooooooo0000ooooo`;o0000
1oooool00ol0003oooooooooo`0:ooooo`Ko00006Oooool01?l0003oooooooooooooool2o`0000;o
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`04ooooo`;o00001Oooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo00;ooooo0_l00004ooooo`03o`000?oooooooooo017o
oooo1_l0000<oooooaKo00004oooool2o`0000?ooooo0_l0000>ooooo`004?ooool00ol0003ooooo
ooooo`02o`00017ooooo00Co0000oooooooooooooooo0_l00004ooooo`03o`000?oooooooooo00ko
oooo00Ko0000ooooooooooooooooo`000?ooool2o`0000Kooooo00?o0000ooooooooool02_ooool7
o`0001[ooooo00?o0000ooooool000000_l000000ooooooo0000ooooo`0@ooooo`03o`000?oooooo
oooo00?ooooo0_l00005ooooo`03o`000?oooooooooo00gooooo00Co0000oooooooooooooooo0_l0
0004ooooo`03o`000?oooooooooo017ooooo1_l00002ooooo`go00002Oooool6o`0000Cooooo1?l0
000@ooooo`04o`000?ooooooooooooooo`;o00003_ooool000oooooo1Ol0000Cooooo`03o`000?oo
oooooooo00;o00001?ooool00ol0003oooooooooo`0?ooooo`05o`000?ooooooooooo`000?ooool0
0_l00005ooooo`03o`000?oooooooooo00Wooooo3_l0000Fooooo`Go00004oooool00ol0003ooooo
ooooo`02ooooo`;o00001?ooool00ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00;o0000
0oooool00ol0003oooooooooo`0@ooooo`ko00004Oooool00ol0003oooooo`000002o`0000;ooooo
00?o0000ooooooooool01Oooool4o`0000cooooo00Co0000oooooooooooooooo0_l0000>ooooo`00
3_ooool5o`0001Cooooo00?o0000ooooooooool00_l00003ooooo`03o`000?oooooooooo017ooooo
00Co0000ooooool0003ooooo0_l00004ooooo`03o`000?oooooo000001?o00000_oooolDo`0000Co
oooo1ol0000Cooooo`04o`000?ooooooooooooooo`;o00000oooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooo000000;o000000?oooooo`000?ooool02OoooolBo`0000?ooooo3Ol00005oooo
o`04o`000?ooooooooooooooo`;o00000oooool00ol0003oooooooooo`08ooooo`Co00002Oooool0
0ol0003oooooooooo`02o`0000kooooo000=ooooo`Oo00005?ooool00ol0003oooooo`000002o`00
0003ooooool0003ooooo01Cooooo2ol00008ooooo`?o00000oooool6o`0000cooooo8?l00009oooo
o`03o`000?oooooooooo00;o00000_ooool00ol0003oooooooooo`0Cooooo`Go00000_ooool@o`00
00?ooooo2?l0000@ooooo`co00000oooool00ol0003oooooooooo`0;ooooo`Co00001Oooool2o`00
0004ooooool0003o0000o`0000gooooo000=ooooo`_o00004Oooool5o`0000gooooo2ol00002oooo
o`05o`000?ooooooooooooooool000001_ooool4o`0000Gooooo00?o0000ooooool000000_l00000
0ooooooo0000ooooo`0;oooooaGo000000?oooooo`000?l000001Ol00003oooooa_o00002Oooool@
o`0000cooooo00?o0000ooooool000001?l0000Cooooo`;o00001?ooool3o`000003ooooool0003o
000000[o00002Oooool4o`000003ooooool0003ooooo00Go00003?ooool000gooooo1ol00004oooo
o`ko00000_ooool7o`000003ooooool0003o000000Wo00002_ooool00ol0003oooooo`000002o`00
0003ooooool0003ooooo00?ooooo0ol00008ooooo`05o`000?ooooooooooooooool000000_ooool=
o`0000oooooo5Ol00007ooooo`Go00002ooooolAo`0001Cooooo0_l000000ooooooo0000o`000002
o`0001;ooooo00?o0000ooooooooool01?ooool3o`0000Kooooo00?o0000ooooooooool01?oooolF
o`0000_ooooo000>ooooo`Ko00004Oooool?o`00013ooooo00?o0000ooooool000001?l00002oooo
o`?o00002Oooool<o`0001Wooooo1?l00002ooooo`03o`000?oooooooooo00Oooooo4_l000000ooo
oooo0000o`00000=o`0000Cooooo1ol0000Dooooo`03o`000?oooooooooo00;o00000_ooool00ol0
003oooooooooo`0>ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooool000001oooool00ol0
003oooooooooo`0@ooooo`Wo00002oooool000oooooo1?l000000ooooooo0000ooooo`0Booooo`Oo
00001?ooool?o`0000;ooooo2Ol000000ooooooo0000o`00000:o`0000Gooooo0_l00002ooooo`03
o`000?oooooo000001Oooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`0@oooo
o`_o00004Oooool6o`0001Cooooo0_l00002ooooo`;o00000oooool00ol0003oooooooooo`0<oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooool000002?ooool00ol0003oooooooooo`0@oooo
o`So00002oooool0013ooooo00?o0000ooooool000000_ooool00ol0003oooooooooo`0@ooooo`Ko
00005?ooool<o`0000[ooooo00?o0000ooooooooool01Oooool01?l0003oooooooooool00002oooo
o`03o`000?oooooooooo01?ooooo00Go0000ooooooooooooooooo`000005ooooo`03o`000?oooooo
oooo013ooooo1ol0000Cooooo`03o`000?oooooooooo00Co00004oooool00ol0003oooooo`000002
ooooo`;o00000oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooool000002Oooool00ol0003oooooooooo`0?ooooo`Oo00003?ooool0013ooooo00?o0000oooo
ool000000oooool00ol0003oooooooooo`0=ooooo`;o00000_ooool4o`0001Kooooo2?l0000;oooo
o`03o`000?oooooooooo00Kooooo00Co0000oooooooooooo00000oooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0?
ooooo`Oo00004_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`00017ooooo00So
0000oooooooooooo0000ooooool0003oooooo`0000Cooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`07ooooo`;o000000?oooooo`000?ooool02Oooool00ol0003oooooooooo`0=oooo
o`;o00000_ooool3o`0000gooooo000@ooooo`?o00001?ooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo00;ooooo0_l00002ooooo`03o`000?oooooooooo01?ooooo2?l0000:ooooo`03
o`000?oooooooooo00Oooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`0?oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00?o00000_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo
00?ooooo00Go0000ooooooooooooooooo`00000?ooooo`09o`000?ooooooooooooooool0003ooooo
o`000?oooooo000000Gooooo00?o0000ooooooooool01_ooool2o`0000[ooooo00Co0000oooooooo
oooo00002oooool00ol0003oooooooooo`0:ooooo`;o000000Goooooo`000?ooooooooooo`00000?
ooooo`004?ooool3o`0000Gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`03oooo
o`;o00000oooool00ol0003oooooooooo`0@ooooo`?o00000_ooool3o`0000;ooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`08ooooo`04o`000?ooooooooooo`0000Gooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Kooooo0_l0000<
ooooo`04o`000?ooooooooooooooo`;o00001?ooool00ol0003oooooooooo`0;ooooo`;o00001_oo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool00_oo
ool00ol0003oooooo`000002ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`0:ooooo`04o`000?ooooooooooo`0000cooooo00?o0000ooooooooool0
2?ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000ooooooooool03Oooool0013ooooo
0ol00006ooooo`03o`000?oooooooooo00Kooooo0_l00006ooooo`;o00001?ooool00ol0003ooooo
ooooo`0>ooooo`04o`000?ooooooooooo`0000;ooooo0_l00004ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool02Oooool01?l0003oooooooooool00006ooooo`03o`000?oooooooooo
00_ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool00_ooool2o`0000Gooooo0_l0000:ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooool000000_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool02oooool01?l0003oooooooooool0000=ooooo`03o`000?oooooo
oooo00Gooooo0_l00004ooooo`04o`000?ooooooooooo`0000oooooo000@ooooo`?o00001oooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Kooooo0_l00005ooooo`03o`000?oooooo
oooo00_ooooo0_l00003ooooo`03o`000?oooooooooo00;o00001Oooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo00[ooooo00Co0000oooooooooooo00001oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00?ooooo0_l00007ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool00oooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo00Cooooo
00Go0000ooooooooooooooooo`00000>ooooo`04o`000?ooooooooooo`0000kooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`0000oooooo000@oooo
o`?o00002?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Kooooo0ol00006oooo
o`03o`000?oooooooooo00Sooooo0_l00005ooooo`05o`000?oooooo0000ooooool000001_ooool0
1?l0003oooooooooool0000=ooooo`;o000000?oooooo`000?ooool01oooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00Cooooo0_l00008ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool01?ooool00ol0003oooooo`000003ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooool000003_ooool01Ol0003ooooooooooooooooo000000oooooo00?o0000ooooooooool0
0_l00007ooooo`04o`000?ooooooooooo`0000oooooo000@ooooo`?o00002Oooool4o`0000Wooooo
0ol00007ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01Oooool01Ol0003ooooo
o`000?oooooo000000Oooooo0_l0000>ooooo`;o000000?oooooo`000?ooool02?ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02oooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00Gooooo0_l00009ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool01Oooool00ol0003oooooo`000003ooooo`03o`000?oooooooooo00Go
oooo0_l0000?ooooo`05o`000?ooooooooooooooool000004?ooool2o`0000Wooooo00Co0000oooo
oooooooo00003oooool0013ooooo0ol0000:ooooo`;o00002_ooool3o`0000Sooooo00?o0000oooo
ooooool00oooool2o`0000Oooooo00Ko0000oooooooooooo0000ooooool00007ooooo`;o00003_oo
ool2o`000003ooooool0003ooooo00Wooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00cooooo00Co0000ooooool0003o00002Oooool00ol0003ooooo
ooooo`08ooooo`Co00003?ooool00ol0003oooooooooo`07ooooo`05o`000?ooooooooooooooool0
00002?ooool00ol0003oooooo`000003ooooo`03o`000?oooooooooo00Gooooo0_l0000?ooooo`05
o`000?ooooooooooooooool000003oooool3o`0000Wooooo00Co0000oooooooooooo00003oooool0
013ooooo0ol00009ooooo`04o`000?ooooooooooo`0000Wooooo0ol00009ooooo`03o`000?oooooo
oooo00;o00002Oooool01_l0003oooooooooool0003oooooo`0000Kooooo00Co0000oooooooooooo
00003Oooool2o`000003ooooool0003ooooo00[ooooo00Go0000ooooooooooooooooo`00000<oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`09oooo
o`;o00003Oooool00ol0003oooooooooo`08ooooo`04o`000?ooooooooooo`0000Sooooo00?o0000
ooooool000000oooool00ol0003oooooooooo`03ooooo`;o00000_ooool00ol0003oooooooooo`0<
ooooo`05o`000?ooooooooooooooool000003_ooool01Ol0003ooooooooooooooooo000000Sooooo
00?o0000ooooool000004?ooool0013ooooo0ol00008ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool01_ooool3o`0000[ooooo0_l0000;ooooo`03o`000?oooooo000000;ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00[ooooo0_l0
00000ooooooo0000ooooo`0;ooooo`03o`000?oooooo000000cooooo0_l0000>ooooo`03o`000?oo
oooo000000[ooooo00?o0000ooooooooool02?ooool01?l0003oooooooooool0000<ooooo`;o0000
2Oooool00ol0003oooooo`000009ooooo`;o00001?ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool02oooool2o`0000?ooooo00?o0000ooooooooool0
2_ooool2o`0000Gooooo00?o0000ooooooooool01Oooool00ol0003oooooo`00000@ooooo`004?oo
ool3o`0000Kooooo0_l00006ooooo`03o`000?oooooooooo00Gooooo0ol00009ooooo`?o00002ooo
ool00ol0003oooooo`000002ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`09ooooo`;o000000?oooooo`000?ooool03?ooool00ol0003ooooooooo
o`0;ooooo`;o00003Oooool01Ol0003ooooooooooooooooo000000Wooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo0_l0000:ooooo`03o`00
0?oooooooooo00Sooooo0_l00004ooooo`05o`000?ooooooooooooooool000001_ooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo00Gooooo0_l0000@ooooo`004?ooool3o`0000Gooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`04ooooo`?o00002?ooool01Ol0003ooooo
oooooooooooo000000[ooooo00?o0000ooooool000000_ooool01Ol0003ooooooooooooooooo0000
00Sooooo0_l0000:ooooo`03o`000?oooooo000000cooooo00?o0000ooooool000003?ooool2o`00
00cooooo00?o0000ooooooooool00oooool2o`0000Oooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo0_l00009ooooo`03o`000?oooooo0000
00Wooooo0_l00004ooooo`04o`000?ooooooooooo`0000Sooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`04ooooo`;o00004?ooool0013ooooo00?o0000ooooool000001?ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00?ooooo0ol00006ooooo`;o00001Oooool00ol0
003oooooooooo`07ooooo`03o`000?oooooo000000;ooooo00Co0000oooooooooooo00002oooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooo000000_ooooo00Go0000ooooooooooooooooo`00
000;ooooo`;o00002oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`;o00002?ooool2o`0000Sooooo00Go
0000ooooooooooooooooo`000008ooooo`;o00001?ooool00ol0003oooooo`000009ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`06ooooo`;o0000
3?ooool00ol0003oooooooooo`03ooooo`;o00004?ooool0013ooooo1?l000000ooooooo0000o`00
000=ooooo`03o`000?oooooooooo00;ooooo0ol00004ooooo`;o00002?ooool00ol0003ooooooooo
o`06ooooo`;o00000oooool00ol0003oooooo`00000=ooooo`03o`000?oooooooooo00Kooooo0ol0
000:ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02?ooool2o`0000[ooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo0_l0
000;ooooo`03o`000?oooooooooo00Gooooo0_l00007ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool01Oooool2o`0000Cooooo0_l0000;ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool00_ooool2o`00013ooooo000@ooooo`Go00004?ooool01ol0003ooooooooooooo
oooo0000ooooool000000oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Gooooo
0_l00003ooooo`;o00003oooool00ol0003oooooooooo`05ooooo`?o00002Oooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00Oooooo0_l00009ooooo`03o`000?oooooooooo00[ooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00cooooo
00?o0000ooooooooool01?ooool2o`0000Kooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00;ooooo0_l0000=ooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`;o00004Oooool01?l0003ooooo
ooooooooool2o`00013ooooo000?ooooo`Oo00004?ooool00ol0003oooooo`000003o`000003oooo
ool0003o000000gooooo00?o0000ooooooooool01?ooool2o`0000?ooooo00?o0000ooooooooool0
3oooool00ol0003oooooooooo`04ooooo`?o00002?ooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo00Kooooo0_l00007ooooo`;o00003_ooool01Ol0003ooooooooooooooooo000000?o
oooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`03ooooo`;o00001Oooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00;ooooo0_l00003ooooo`03o`000?oooooo000000go
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool04_ooool00ol0003oooooo`000002o`00013ooooo000?ooooo`[o0000
3_ooool6o`00013ooooo00?o0000ooooooooool00oooool01?l0003oooooooooooooool2o`0001;o
oooo00?o0000ooooooooool00oooool3o`0000Oooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool03oooool00ol0003o
ooooo`000002o`000003ooooool0003ooooo017ooooo0_l00003ooooo`;o00001?ooool00ol0003o
ooooooooo`09ooooo`04o`000?ooooooooooooooo`;o00000_ooool01?l0003oooooooooool0000>
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02
o`0001Kooooo1Ol0000?ooooo`003oooool7o`0000;ooooo3?l00002ooooo`Oo00004Oooool01?l0
003oooooooooooooool2o`0000;ooooo00?o0000ooooool000004oooool00ol0003oooooooooo`02
ooooo`?o00001_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`0Aooooo`Go00005Oooool00ol0003oooooooooo`02
o`0000?ooooo00?o0000ooooooooool02oooool00ol0003oooooo`000002o`000003ooooool0003o
oooo00;ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooool000005oooool7o`0000kooooo000@ooooo`Go00003?ooool>o`00
013ooooo00?o0000ooooool000000_l000001Ooooooo0000oooooooooooo000001Cooooo00Co0000
oooooooooooooooo0ol00005ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo017ooooo1ol0000Eooooo`03o`000?oo
oooo000000;o000000?oooooo`000?ooool03_ooool5o`0000Cooooo00?o0000ooooooooool03_oo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Cooooo0_l0000;oooooaCo00003_oo
ool0013ooooo1Ol0000Aoooooa?o00001oooool5o`0000?ooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`03o`0000Cooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool03ooooolUo`0000oooooo1ol00003
ooooo`03o`000?oooooooooo00Kooooo8Ol00007ooooo`go00003_ooool0013ooooo00?o0000oooo
ool000000_ooool00ol0003oooooooooo`0?ooooo`Ko00002?oooolAo`0000;ooooo00?o0000oooo
ooooool05?ooool00ol0003oooooo`000002o`0000?ooooo00?o0000ooooooooool04Oooool01Ol0
003ooooooooooooooooo000000?ooooo00?o0000ooooooooool01OoooolEo`0000Cooooo3_l00003
ooooobSo00002Oooool01Ol0003ooooooooooooooooo000000?ooooo0_l000000ooooooo0000oooo
o`0<ooooo`Ko00001oooool5o`0000oooooo000@ooooo`03o`000?oooooo000000?ooooo00?o0000
ooooooooool03_ooool4o`000003ooooool0003o0000013ooooo3ol0000Cooooo`Co00000_ooool0
0ol0003oooooooooo`0Cooooo`03o`000?oooooo000000co00000_ooool6o`0000Oooooo1Ol0000@
oooooaCo00001oooool7o`000003ooooool0003o000000Go00003_ooool4o`0000;ooooo00Go0000
ooooooooooooooooo`000006ooooo`Oo00003Oooool4o`00013ooooo000@ooooo`03o`000?oooooo
000000Cooooo00?o0000ooooooooool03?ooool01?l0003oooooooooool00002ooooo`03o`000?oo
oooo0000013ooooo1ol00002oooooako00003_ooool>o`0000Kooooo1Ol0000=oooooaGo00001_oo
ool7o`0000Gooooo4Ol00003ooooo`04o`000?ooooooooooooooo`Oo00001oooool6o`0000Cooooo
1ol0000Cooooo`04o`000?oooooo0000o`00017ooooo000?ooooo`04o`000?oooooo0000o`0000Go
oooo00?o0000ooooooooool02_ooool01?l0003oooooooooooooool2o`000005ooooool0003ooooo
ooooool000004?ooool6o`0000;ooooo00?o0000ooooooooool02OoooolRo`0000Kooooo3?l00000
0ooooooo0000o`00000Bo`0000;ooooo00?o0000ooooooooool04oooool7o`0000oooooo1Ol00002
ooooob3o00006?ooool00ol0003oooooooooo`02o`00017ooooo000?ooooo`04o`000?oooooo0000
o`0000Kooooo00?o0000ooooooooool02Oooool01?l0003oooooooooooooool2o`000003ooooool0
003ooooo00;ooooo00?o0000ooooooooool03Oooool4o`0000;ooooo00?o0000ooooool000005_oo
oolZo`0000oooooo00?o0000ooooooooool00_l00003ooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool00ol00002ooooo`03o`000?oooooooooo00cooooo00Ko0000oooooooooooo0000
ooooool00004ooooo`03o`000?oooooooooo00[ooooo2ol00003ooooo`03o`000?oooooooooo01Oo
oooo00?o0000ooooooooool00_l0000Aooooo`003oooool01?l0003oooooo`000?l00007ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool00_ooool2o`000003ooooool0003ooooo00?o
oooo00?o0000ooooooooool02oooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000oooo
ool000005Oooool7o`0001Kooooo1ol0000Dooooo`04o`000?ooooooooooooooo`;o00001?ooool0
0ol0003oooooooooo`0>ooooo`;o00001?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo00[ooooo00Go0000ooooooooooooooooo`000002ooooo`05o`000?ooooooooooooooool00000
4?ooool7o`0000?ooooo00?o0000ooooooooool05_ooool01?l0003oooooooooooooool2o`00017o
oooo000?ooooo`04o`000?oooooo0000o`0000Sooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`03ooooo`;o000000?oooooo`000?ooool01?ooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool2o`0001Kooooo1Ol0000Hooooo`Oo
00004_ooool00ol0003oooooooooo`02ooooo`;o00001Oooool00ol0003oooooooooo`0<ooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00;ooooo0_l00002ooooo`04o`000?ooooooooooo`00017ooooo1_l00003oooo
o`03o`000?oooooooooo01Gooooo00?o0000ooooooooool00_ooool2o`00017ooooo000?ooooo`04
o`000?oooooo0000o`0000Wooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04oooo
o`;o000000?oooooo`000?ooool01Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo0000
00;o000000?oooooo`000?ooool05Oooool00ol0003oooooo`000002o`0000?ooooo00?o0000oooo
ooooool03_ooool00ol0003oooooooooo`03ooooo`;o00001_ooool00ol0003oooooooooo`0:oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo00?ooooo0_l00003ooooo`03o`000?oooooo0000017ooooo1?l00002oooo
o`04o`000?ooooooooooo`0001Kooooo00?o0000ooooooooool00oooool2o`00017ooooo000?oooo
o`04o`000?oooooo0000o`0000[ooooo00Go0000ooooooooooooooooo`000007ooooo`;o000000?o
ooooo`000?ooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo0_l0
0004ooooo`?o00004_ooool01?l0003oooooooooooooool2o`0000;ooooo00?o0000ooooooooool0
4_ooool01Ol0003ooooooooooooooooo000000Gooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`04ooooo`;o00001oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool00_ooool2o`00013ooooo00?o0000ooooooooool00_l00003ooooo`03
o`000?oooooo000001Gooooo00?o0000ooooooooool01?ooool2o`00017ooooo000?ooooo`04o`00
0?oooooo0000o`0000_ooooo00?o0000ooooool000002?ooool2o`000003ooooool0003ooooo00Oo
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`05ooooo`;o00001?ooool01?l0003o
ooooooooool0000@ooooo`03o`000?oooooooooo00;ooooo0_l00003ooooo`03o`000?oooooooooo
013ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`04ooooo`;o00002oooool00ol0
003oooooooooo`05ooooo`;o00002?ooool00ol0003oooooooooo`05ooooo`;o00002Oooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01Oooool2o`00
00Cooooo00?o0000ooooooooool03_ooool01Ol0003ooooooooooooooooo000000Cooooo0_l0000E
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooool000004Oooool000oooooo00Co0000oooo
ool0003o00003?ooool2o`0000Sooooo0_l000000ooooooo0000ooooo`08ooooo`05o`000?oooooo
ooooooooool000002?ooool2o`0000Cooooo00Go0000ooooooooooooooooo`00000>ooooo`03o`00
0?oooooooooo00?ooooo0_l00004ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
1_ooool2o`0000Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo00Oooooo00Go0000ooooooooooooooooo`000008ooooo`;o00001?ooool2o`0000ko
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool01?ooool00ol0003oooooo`00000Aooooo`003oooool01?l0003ooooo
o`000?l0000<ooooo`03o`000?oooooooooo00Oooooo0_l000000ooooooo0000ooooo`09ooooo`03
o`000?oooooo000000[ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool01?ooool2o`0000Gooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Oooooo0_l00007ooooo`03
o`000?oooooooooo00Kooooo0_l00009ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool02_ooool00ol0003oooooooooo`08ooooo`04o`000?ooooooooooo`0000Sooooo0_l00004oooo
o`03o`000?oooooo000000cooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03oooo
o`?o00004Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooo0000017ooooo000?ooooo`04
o`000?oooooo0000o`0000_ooooo00?o0000ooooool000002?ooool01?l0003oooooo`000?l0000;
ooooo`03o`000?oooooooooo00Wooooo0_l00003ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`05ooooo`;o00001_ooool00ol0003oooooooooo`0:
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00Oooooo0_l0000:ooooo`04o`000?oooooo0000o`0000gooooo00?o
0000ooooooooool02Oooool2o`0000[ooooo0_l00003ooooo`04o`000?ooooooooooo`0000[ooooo
00?o0000ooooooooool01?ooool2o`0000Cooooo00Co0000oooooooooooo00003oooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooo0000017ooooo000?ooooo`04o`000?oooooo0000o`0000[o
oooo00Go0000ooooooooooooooooo`000006ooooo`03o`000?oooooooooo00;o00002_ooool00ol0
003oooooo`00000:ooooo`;o00000oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool3o`0000Kooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo00[ooooo00Go0000ooooooooooooooooo`00000:
ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`09
ooooo`;o00002_ooool2o`0000?ooooo00Go0000ooooooooooooooooo`000009ooooo`03o`000?oo
oooooooo00Cooooo0_l00004ooooo`05o`000?ooooooooooooooool000003_ooool00ol0003ooooo
ooooo`06ooooo`03o`000?oooooo0000017ooooo000?ooooo`;o000000?oooooo`000?ooool02?oo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_l0
0009ooooo`05o`000?ooooooooooooooool000002Oooool2o`0000?ooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Sooooo0_l00007ooooo`03o`00
0?oooooooooo00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0;ooooo`?o0000
2oooool00ol0003oooooooooo`09ooooo`03o`000?oooooo000000kooooo00?o0000ooooooooool0
2Oooool00ol0003oooooo`000009ooooo`;o00000oooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool2o`0000Cooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooool00000
4Oooool000oooooo0_l000000ooooooo0000ooooo`08ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`02o`0000Sooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`06ooooo`;o00000oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool02Oooool2o`0000Sooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00cooooo0_l0000;ooooo`03o`000?oo
oooooooo00Sooooo00Go0000ooooooooooooooooo`00000=ooooo`03o`000?oooooooooo00Sooooo
00Co0000oooooooooooooooo0_l00007ooooo`03o`000?oooooo000000;ooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Kooooo0_l00004ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooo0000017ooooo000?ooooo`;o000000?oooooo`000?ooool01oooool00ol0003ooooo
ooooo`06ooooo`05o`000?ooooooooooooooool000000_ooool2o`0000Oooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooo000000;ooooo00?o0000oooooooo
ool01oooool2o`000003ooooool0003ooooo00_ooooo0_l00009ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00;o
00002Oooool00ol0003oooooooooo`06ooooo`;o00001Oooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`;o
00000_ooool00ol0003oooooooooo`04ooooo`05o`000?ooooooooooooooool000002_ooool2o`00
00?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Sooooo00Co0000oooooooooooo00004Oooool000oooooo0_l000000ooooooo0000ooooo`06oooo
o`03o`000?oooooooooo00Sooooo00Co0000oooooooooooo00000_ooool2o`0000Kooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`05ooooo`;o00000_ooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo00_ooooo0_l0000:ooooo`04o`000?ooooooooooo`0000cooooo00?o
0000ooooooooool02_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Cooooo0_l0
0002ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooool000002oooool2o`0000?ooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Wooooo00Co
0000oooooooooooo00004Oooool000oooooo0_l000000ooooooo0000ooooo`05ooooo`03o`000?oo
oooooooo00[ooooo00?o0000ooooool000000_ooool2o`0000Gooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`04ooooo`;o00000_ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooo000000cooooo0_l0000;ooooo`;o00003?ooool2o`0000_ooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`03ooooo`;o00000_ooool00ol0003oooooooooo`06ooooo`;o00002ooo
ool2o`0000?ooooo00?o0000ooooooooool01_ooool2o`0000Cooooo00?o0000ooooooooool02Ooo
ool01?l0003oooooooooool0000Aooooo`003oooool2o`000003ooooool0003ooooo00Cooooo00?o
0000ooooooooool03?ooool2o`0000;ooooo0_l00004ooooo`03o`000?oooooooooo00_ooooo00?o
0000ooooooooool00oooool2o`0000;ooooo00?o0000ooooooooool01oooool01Ol0003ooooooooo
oooooooo000000_ooooo0_l0000;ooooo`;o00003?ooool00ol0003oooooo`000009ooooo`03o`00
0?oooooooooo00Oooooo0_l00005ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`02ooooo`05o`000?oooooo0000ooooool000002?ooool2o`0000_o
oooo0_l00003ooooo`03o`000?oooooooooo00Sooooo00Co0000oooooooooooo00003?ooool01?l0
003oooooooooool0000Aooooo`003oooool2o`000003ooooool0003ooooo00Cooooo00?o0000oooo
ooooool03Oooool00ol0003oooooooooo`02o`0000?ooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`02ooooo`05o`000?oooooo0000ooooool000002?ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00Sooooo0_l0000:ooooo`04o`000?ooooooooooo`0000_ooooo00?o
0000ooooool000002?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00;ooooo00Co
0000oooooooooooooooo0_l0000>ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`0;ooooo`07o`000?ooooooooooooooool0003oooooo`000002oooo
o`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00002_ooool2o`0000?ooooo00?o0000
ooooooooool02Oooool2o`0000gooooo00Co0000oooooooooooo00004Oooool000oooooo0_l00000
0ooooooo0000ooooo`03ooooo`03o`000?oooooooooo00kooooo0_l00002ooooo`04o`000?oooooo
ooooo`00017ooooo00Wo0000ooooooooooooooooo`000?oooooo0000ooooool000001oooool00ol0
003oooooooooo`05ooooo`03o`000?oooooooooo00Oooooo0_l00009ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool02?ooool00ol0003oooooo`000007ooooo`03o`000?oooooooooo
00cooooo0_l000001_oooooo0000o`000?l0003oooooo`00013ooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00cooooo00Co0000oooooooooooooooo
0_l00002ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooo000000;ooooo00?o0000ooooooooool02Oooool2o`0000gooooo
00Co0000oooooooooooo00004Oooool000oooooo0_l000000ooooooo0000ooooo`02ooooo`03o`00
0?oooooooooo00oooooo00?o0000ooooool000001?l0000Cooooo`08o`000?ooooooooooo`000?oo
oooo0000ooooool00006ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool2
o`0000Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
000000Oooooo00?o0000ooooooooool03_ooool5o`0001;ooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo00kooooo00So0000oooooooooooo0000oooo
ool0003oooooo`0000Gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`06ooooo`03
o`000?oooooo000000;ooooo00?o0000ooooooooool02?ooool01?l0003oooooooooool0000<oooo
o`04o`000?ooooooooooo`00017ooooo000?ooooo`;o000000Goooooo`000?ooooooooooo`00000B
ooooo`03o`000?oooooo000000Co00005?ooool00ol0003oooooooooo`02o`000003ooooool0003o
oooo00Cooooo00?o0000ooooooooool02Oooool2o`0000Kooooo0_l00007ooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooo`000006ooooo`03o`000?oooooo
oooo00kooooo1ol0000Booooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`0@ooooo`07o`000?oooooo0000ooooool0003oooooo`000004ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooo`000002ooooo`03o`00
0?oooooooooo00Sooooo00Go0000ooooooooooooooooo`00000:ooooo`05o`000?oooooooooooooo
ool000004Oooool000oooooo0_l000001?oooooo0000ooooool0000Cooooo`Wo00004oooool01?l0
003oooooo`000?ooool2o`0000Cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`03
ooooo`;o00001_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooool000001Oooool00ol0003oooooooooo`0>ooooo`_o00004?ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool04Oooool2o`000004ooooool0003o
ooooo`0000?ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`05ooooo`;o00000_oo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01ooo
ool01Ol0003ooooooooooooooooo0000017ooooo000?ooooo`05o`000?oooooo0000ooooool00000
4OoooolDo`0000cooooo0_l000000ooooooo0000o`000003ooooo`03o`000?oooooooooo00kooooo
00?o0000ooooooooool00_ooool2o`0000Gooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooo000000Cooooo00?o0000ooooooooool01ooooolOo`0000Gooooo
00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000001Gooooo0_l000000ooooooo
0000o`000002ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool01?ooool2o`0000;o
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`;o00001oooool01Ol0003o
oooooooooooooooo0000017ooooo000?ooooo`05o`000?oooooo0000ooooool000003?ooool5o`00
00?ooooo2?l00006ooooo`_o00001Oooool00ol0003oooooo`000002o`000003ooooool0003ooooo
017ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00cooooo00?o0000ooooooooool00oooool00ol0003oooooo`000003ooooo`03o`000?oooooooooo
00So00000oooool4o`0000?ooooo1Ol00005ooooo`Go00001_ooool<o`000003ooooool0003ooooo
01Kooooo00?o0000ooooool000000_l000000ooooooo0000ooooo`0;ooooo`03o`000?oooooooooo
00?ooooo00Go0000ooooool0003oooooo`000007ooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool01?ooool01Ol0003ooooooooooooooooo0000017ooooo000>ooooo`Go00002?ooool5
o`0000Sooooo00?o0000ooooool000001?l0000=oooooa3o00005?ooool01Ol0003ooooooooooooo
oooo000000?ooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`02ooooo`Wo00001ooo
ool4o`0000Oooooo1Ol0000:ooooo`Go00002?ooool01Ol0003oooooooooool0003ooooo00_o0000
3_ooool6o`0000kooooo00?o0000ooooooooool00_ooool01Ol0003oooooo`000?oooooo000000Ko
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`03ooooo`05o`000?oooooooooooooo
ool000004Oooool000gooooo1Ol00004ooooo`Go00003Oooool2o`000006ooooool0003o0000o`00
0?oooooo00004Oooool@o`00013ooooo00?o0000ooooool000000_l000000ooooooo0000ooooo`0?
ooooo`Oo000000Coooooo`000?oooooo00002?ooool3o`0000_ooooo00?o0000ooooool000000_oo
ool00ol0003oooooooooo`0<ooooo`Go00001?ooool5o`0000[ooooo3?l00002ooooo`Oo00003_oo
ool02Ol0003ooooooooooooooooo0000ooooool0003oooooo`000006ooooo`03o`000?oooooooooo
00_ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo0000017ooooo000<oooo
o`[o00004_ooool00ol0003oooooooooo`0^o`0000Wooooo1Ol00009ooooo`So00000oooool00ol0
003oooooo`000004o`0000Gooooo1?l0000=ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000
ooooooooool04?ooool9o`0000cooooo6Ol00009ooooo`08o`000?ooooooooooo`000?oooooo0000
ooooool00005ooooo`03o`000?oooooooooo00gooooo00?o0000ooooool000000_l00004ooooo`03
o`000?oooooooooo00kooooo000<ooooob3o00001Oooool00ol0003oooooooooo`0Booooo`Oo0000
1?oooolOo`0000cooooo1Ol00002ooooo`Co00004?ooool01Ol0003ooooooooooooooooo000000Co
oooo00?o0000ooooooooool01ooooolMo`0000cooooo2_l00003oooooa7o00001?ooool00ol0003o
ooooooooo`0?ooooo`Go00000oooool00ol0003oooooooooo`0>ooooo`003?ooool7o`0001?ooooo
00?o0000ooooool000000_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo017ooooo
1ol0000AoooooaSo00001Oooool8o`0000[ooooo7Ol0000;ooooo`Oo00000_ooool9o`0000cooooo
1_l00004ooooo`?o00002oooool01?l0003oooooo`000?oooolCo`0000Cooooo1ol00002ooooo`03
o`000?oooooooooo00kooooo000=ooooo`Go00004oooool01?l0003oooooooooool00002ooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool04?ooool00ol0003oooooo`000003o`0000;o
oooo00?o0000ooooooooool04Oooool7o`0000[ooooo6ol00009ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0@ooooo`Oo00002oooool9o`0000;o
oooo00?o0000ooooool000001?l00007ooooo`Co00002?ooool2o`000003ooooool0003o000000?o
oooo00?o0000ooooooooool02oooool;o`0000;ooooo00?o0000ooooooooool03_ooool000kooooo
1?l0000Booooo`05o`000?ooooooooooooooool000000_ooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00gooooo0_l00002ooooo`03o`000?oooooo000000Cooooo00?o0000oooooooo
ool04Oooool5o`0001Cooooo1ol0000Cooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`0=ooooo`;o000000?oooooo`000?l000000ol000000ooooooo
0000ooooo`0Booooo`[o00002_ooool4o`0000Gooooo1?l00002ooooo`03o`000?oooooooooo00[o
oooo3Ol00002ooooo`03o`000?oooooooooo00kooooo000?ooooo`04o`000?oooooo0000o`00013o
oooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00008ooooo`03o`000?oooooooooo
00_ooooo00?o0000ooooooooool00_ooool00ol0003oooooo`000005ooooo`;o00004Oooool5o`00
01Cooooo1ol0000Booooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00;ooooo0ol00003ooooo`;o00004Oooool00ol0
003oooooooooo`02ooooo`03o`000?oooooo000000;ooooo2Ol00005ooooo`?o00000_ooool6o`00
00Kooooo1ol00007ooooo`Go00000oooool00ol0003oooooooooo`0>ooooo`003oooool01Ol0003o
ooooo`000?oooooo000000kooooo00?o0000ooooooooool00oooool00ol0003oooooo`00000:oooo
o`03o`000?oooooooooo00Wooooo00?o0000ooooooooool01?ooool00ol0003oooooo`000006oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool00_l000000ooooooo0000ooooo`0Aoooo
o`03o`000?oooooooooo00Co000000?oooooo`000?l000004?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`04oooo
o`;o00001Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ool000000oooool00ol0003oooooooooo`05oooooaKo00003Oooool00ol0003oooooo`000002o`00
00Cooooo00?o0000ooooooooool03_ooool0013ooooo0_l00002ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool01?ooool00ol0003oooooo`00000;ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool01Oooool00ol0003oooooo`000007ooooo`03o`000?oooooooooo00_o
oooo00Co0000oooooooooooooooo0_l00002ooooo`03o`000?oooooooooo00kooooo00?o0000oooo
ooooool00_ooool00ol0003oooooo`000003ooooo`03o`000?oooooooooo00cooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool01Oooool2o`0000Kooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`04oooo
o`03o`000?oooooo000000Cooooo00?o0000ooooooooool03Oooool7o`0001;ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00kooooo000@ooooo`;o
00000oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooool0
00003?ooool00ol0003oooooooooo`04ooooo`;o00002?ooool00ol0003oooooo`000008ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo0000
00kooooo00?o0000ooooooooool00oooool00ol0003oooooo`000004ooooo`03o`000?oooooooooo
00[ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Gooooo0_l00008ooooo`;o00001oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooool000001Oooool00ol0003oooooooooo`0<ooooo`Oo00004Oooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool03_ooool0013o
oooo0_l00004ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003o
ooooo`00000=ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool02?ooool00ol0003o
ooooo`000009ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool01Oooool2o`0000Go
oooo0_l0000:ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo00Sooooo0_l00008ooooo`;o00002?ooool00ol0003o
ooooooooo`07ooooo`;o00001_ooool00ol0003oooooooooo`0<ooooo`Go000000?oooooo`000?oo
ool03_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool03_ooool0013ooooo0_l00005ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
1oooool00ol0003oooooo`00000>ooooo`04o`000?ooooooooooo`0000_ooooo00?o0000ooooool0
00002_ooool2o`0000Oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo00Oooooo0_l00008ooooo`;o00001oooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo00Kooooo0_l0000<ooooo`05o`000?ooooooooooooooool000002oooool2o`00
00[ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`08ooooo`;o00001oooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooo000000;o00000oooool2o`0000cooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00kooooo000@ooooo`;o
00001_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooool0
00003_ooool00ol0003oooooo`00000<ooooo`03o`000?oooooo000000cooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Cooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`08ooooo`;o00002?ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool03?ooool3o`0000cooooo0_l0000;ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool02Oooool00ol0003oooooo`000007ooooo`03
o`000?oooooooooo00Sooooo00Ko0000oooooooooooo0000ooooool00005ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool01oooool01Ol0003ooooooooooooooooo0000013ooooo000@
ooooo`;o00001oooool01?l0003oooooooooool0000;ooooo`;o00003oooool2o`0000kooooo0_l0
000=ooooo`05o`000?ooooooooooooooool000002?ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool02Oooool2o`0000Wooooo0_l00004ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool03?ooool2o`0000gooooo0_l0000<ooooo`04o`00
0?ooooooooooo`0000cooooo00?o0000ooooool000002?ooool00ol0003oooooooooo`06ooooo`07
o`000?ooooooooooooooool0003oooooo`000006ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool02?ooool01Ol0003ooooooooooooooooo0000013ooooo000@ooooo`;o00002?ooool2
o`0000_ooooo00?o0000ooooool000003_ooool01?l0003oooooooooool0000=ooooo`;o00003_oo
ool01?l0003oooooooooool00008ooooo`03o`000?oooooooooo00Kooooo00Go0000oooooooooooo
ooooo`00000<ooooo`;o00002oooool01?l0003oooooooooool0000:ooooo`03o`000?oooooooooo
00_ooooo00Co0000oooooooooooo00003?ooool2o`0000gooooo0_l0000=ooooo`03o`000?oooooo
000000Wooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
000000Oooooo0_l00005ooooo`03o`000?oooooooooo00Wooooo00Go0000ooooooooooooooooo`00
000@ooooo`004?ooool2o`0000Sooooo0_l0000;ooooo`03o`000?oooooo000000gooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`0:ooooo`;o00003oooool2o`0000Wooooo00?o0000
ooooooooool01oooool00ol0003oooooo`00000=ooooo`;o00003?ooool2o`0000_ooooo00?o0000
ooooooooool02Oooool2o`0000Cooooo00?o0000ooooooooool02Oooool2o`0000gooooo00?o0000
ooooool000003Oooool2o`0000[ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooo000000Wooooo00Go0000ooooooooooooooooo`00000<ooooo`05o`000?oo
ooooooooooooool000004?ooool0013ooooo0_l00007ooooo`03o`000?oooooo000000_ooooo00?o
0000ooooool000002oooool2o`0000Kooooo00?o0000ooooooooool02Oooool2o`0000oooooo00?o
0000ooooool000002?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00cooooo0_l0
000=ooooo`;o00002_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`05o`000?ooooooooooooooool00000
3?ooool2o`0000[ooooo00Go0000ooooooooooooooooo`000006ooooo`03o`000?oooooo000000[o
oooo00?o0000ooooool000003_ooool01?l0003oooooooooool0000@ooooo`004?ooool2o`0000Ko
oooo00Go0000ooooooooooooooooo`00000:ooooo`03o`000?oooooo000000[ooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`08ooooo`;o00003_ooool01Ol0003ooooooooooooooooo
000000Oooooo00?o0000ooooooooool01oooool00ol0003oooooo`00000=ooooo`;o00003?ooool0
1?l0003oooooooooool00009ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00ooo
ool2o`0000[ooooo0_l0000;ooooo`03o`000?oooooo000000Oooooo00?o0000ooooool000002ooo
ool2o`0000kooooo00Co0000oooooooooooo00004?ooool0013ooooo0_l00005ooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool01oooool00ol0003oooooo`000009ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool01oooool00ol0003oooooo`00000<ooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool01?ooool2o`0000Kooooo0_l00003ooooo`03o`000?oo
oooooooo00[ooooo0_l0000;ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`05ooooo`;o00002oooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`;o00003?oo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooo000000[ooooo00Co0000oooooooooooo0000
3Oooool01?l0003oooooooooool0000@ooooo`004Oooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01_ooool2o`0000Wooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`08ooooo`;o00003?ooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00?ooooo0_l00005ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
2Oooool2o`0000_ooooo00?o0000ooooooooool00oooool2o`0000Kooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo0_l0000:ooooo`03o`00
0?oooooo000000Sooooo0_l00009ooooo`03o`000?oooooooooo00;ooooo0_l0000;ooooo`04o`00
0?ooooooooooo`00013ooooo000Aooooo`05o`000?ooooooooooooooool000002Oooool00ol0003o
ooooooooo`05ooooo`;o00001oooool2o`0000kooooo00?o0000ooooooooool01oooool2o`0000_o
oooo00?o0000ooooooooool01_ooool2o`0000Cooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00[ooooo0_l00009ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool01_ooool2o`0000Wooooo00Go0000ooooooooooooooooo`000007oooo
o`;o00002?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Sooooo00Co0000oooo
oooooooo00004?ooool0013ooooo0ol000000ooooooo0000ooooo`0:ooooo`03o`000?oooooooooo
00Cooooo0_l00006ooooo`03o`000?oooooooooo00oooooo00?o0000ooooooooool01_ooool2o`00
00[ooooo00?o0000ooooooooool02Oooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`09ooooo`;o00002?ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0?
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0<
ooooo`;o00001_ooool2o`0000Sooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`04
ooooo`;o00001oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooool000004?ooool000oooooo1Ol0000=ooooo`03o`000?oooooooooo00?ooooo0_l00005oooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool01Oooool2o`0000Wooooo00?o0000oooo
ooooool02oooool00ol0003oooooo`000002o`000003ooooool0003ooooo00[ooooo00?o0000oooo
ooooool02?ooool2o`0000Sooooo00?o0000ooooooooool02Oooool2o`000005ooooool0003o0000
o`000?ooool00_l0000Cooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`0?ooooo`03o`000?oooooooooo00?ooooo0_l00007ooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool00oooool2o`0000Kooooo00?o0000ooooooooool02Oooool2
o`0000Sooooo00?o0000ooooool000004?ooool000kooooo1ol0000=ooooo`03o`000?oooooooooo
00;ooooo0_l00004ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool01?ooool2o`00
00Sooooo00?o0000ooooooooool03Oooool5o`0000gooooo00?o0000ooooooooool01oooool2o`00
00Oooooo00?o0000ooooooooool03?ooool5o`0001Kooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool00_ooool2o`00
00Gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo0000
013ooooo000>ooooo`Oo00003_ooool01?l0003oooooooooooooool2o`0000;ooooo0_l0000Goooo
o`03o`000?oooooooooo00?ooooo0_l00008ooooo`03o`000?oooooooooo00cooooo1ol0000=oooo
o`03o`000?oooooooooo00Kooooo0_l00006ooooo`03o`000?oooooooooo00cooooo1ol0000Foooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0Coooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`09oooo
o`04o`000?ooooooooooooooo`;o00001?ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooool000004?ooool000kooooo3_l00008ooooo`03o`000?oooooo0000
00;o000000?oooooo`000?ooool06Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool01_oooom7o`0001;ooooo00Go0000ooooooooooooooooo`000003
ooooo`03o`000?oooooooooo01Gooooo0_l00002ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`02o`0000?ooooo00?o0000ooooooooool04?ooool2
o`0000Gooooo0_l0000@ooooo`003oooool5o`0000Kooooo2?l00003ooooo`Go00007?oooolFo`00
00Gooooo2ol0000=ooooo`03o`000?oooooooooo00Cooooo0_l00005ooooo`03o`000?oooooooooo
00cooooo2?l000000ooooooo0000o`00000Bo`0000?ooooo00?o0000ooooool000000_l000000ooo
oooo0000ooooo`0Iooooo`03o`000?oooooo000000;o000000?oooooo`000?ooool03_ooool00ol0
003oooooo`000002o`000003ooooool0003ooooo01Cooooo00?o0000ooooooooool00_ooool2o`00
013ooooo000@ooooo`?o00003Oooool;o`0000Oooooo5Ol00004ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool02_ooool3o`0000?ooooo1Ol00003ooooo`?o00002oooool00ol0003o
ooooooooo`03ooooo`;o00001?ooool00ol0003oooooooooo`0:ooooo`?o00000_ooool5o`0000[o
oooo1ol00005oooooa3o00005Oooool5o`00017ooooo1Ol0000Gooooo`04o`000?oooooooooooooo
o`;o00004?ooool002Cooooo3_l0000Eooooo`05o`000?ooooooooooooooool000001?ooool00ol0
003oooooooooo`08ooooo`?o00001oooool3o`0000Oooooo0ol00009ooooo`03o`000?oooooooooo
00;ooooo0_l00003ooooo`03o`000?oooooooooo00Sooooo0ol00006ooooo`?o00004_ooool?o`00
00Kooooo4?l00004ooooo`Oo00003oooool7o`0001Oooooo0_l000001?oooooo0000o`000?l0000?
ooooo`009?ooool7o`000003ooooool0003o000000So00004_ooool00ol0003oooooooooo`02o`00
00?ooooo00?o0000ooooooooool01?ooool4o`0001Oooooo0ol00007ooooo`04o`000?oooooooooo
ooooo`;o00000oooool00ol0003oooooooooo`05ooooo`?o00008ooooom6o`0001Cooooo1Ol0000>
ooooo`009Oooool5o`0000Wooooo2_l0000<ooooo`03o`000?oooooo000000;o000000?oooooo`00
0?ooool00oooool3o`0001kooooo0ol00005ooooo`05o`000?ooooooooooooooool000000_ooool0
0ol0003oooooooooo`04ooooo`;o00006oooool;o`0000?ooooo1ol0000Jooooo`Oo00002_oooolP
o`0000Cooooo1ol0000=ooooo`009_ooool3o`0001;ooooo2?l00007ooooo`Go00000_ooool3o`00
02Cooooo0ol00003ooooo`03o`000?oooooo000000?o00001?ooool3o`0001;ooooo2ol0000?oooo
o`Go00007?ooool5o`00017ooooo1Ol0000@oooooa3o00003Oooool004;ooooo3ol0000Zooooo`?o
000000?oooooo`000?l000000ol000001?oooooo0000o`000?l0000:ooooo`_o00006oooool3o`00
01kooooo0ol0000Cooooo`?o00006_ooool7o`0000gooooo0019oooooaoo00005_ooool7o`0000;o
oooo2ol0001kooooo`Go00003_ooool004Wooooo1ol0000Hoooooaoo0000Qoooool3o`0000oooooo
001:ooooo`Go0000;oooool7o`0009_ooooo001;ooooo`?o0000<Oooool5o`0009cooooo0020oooo
o`?o0000WOooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool0
0?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool0
0?oooooo8Oooool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-0.0427109, -0.0500055, \
0.00380737, 0.00381263}},
  CellTags->"LocalInteractions:42"]
}, Open  ]],

Cell[BoxData[
    \(DeleteModel[m]\)], "Input",
  CellLabel->"In[24]:=",
  CellTags->"LocalInteractions:42"]
}, Closed]]
}, Open  ]]
},
FrontEndVersion->"5.0 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 701}},
WindowSize->{520, 578},
WindowMargins->{{Automatic, 46}, {Automatic, 22}},
StyleDefinitions -> Notebook[{
  
  Cell[CellGroupData[{
  Cell["Style Definitions for On-line Help", "Title"],
  
  Cell["\<\
These styles are carefully tuned for all aspects of the online \
help. It's recommended that they remain unchanged.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell["Style Environment Names", "Section"],
  
  Cell[StyleData[All, "Working"],
    PageWidth->WindowWidth,
    ShowCellBracket->False,
    CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
    ShowAutoStyles->False,
    ScriptMinSize->9],
  
  Cell[StyleData[All, "Brackets"],
    PageWidth->WindowWidth,
    ShowCellBracket->True,
    CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
    ShowAutoStyles->False,
    ScriptMinSize->9],
  
  Cell[StyleData[All, "Presentation"],
    PageWidth->WindowWidth,
    ShowCellBracket->False,
    CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
    ShowAutoStyles->False,
    ScriptMinSize->9],
  
  Cell[StyleData[All, "SlideShow"],
    PageWidth->WindowWidth,
    ScrollingOptions->{"PagewiseDisplay"->True,
    "VerticalScrollRange"->Fit},
    ShowCellBracket->False,
    ScriptMinSize->9],
  
  Cell[StyleData[All, "Printout"],
    PageWidth->PaperWidth,
    ShowCellBracket->False,
    ShowAutoStyles->False,
    ScriptMinSize->5,
    PrivateFontOptions->{"FontType"->"Outline"}],
  
  Cell[StyleData[All, "EnhancedPrintout"],
    PageWidth->PaperWidth,
    ShowCellBracket->True,
    ScriptMinSize->5,
    FontFamily->"Palatino",
    PrivateFontOptions->{"FontType"->"Outline"}],
  
  Cell[StyleData[All, "EnhancedPrintoutNonGray"],
    PageWidth->PaperWidth,
    ShowCellBracket->False,
    ScriptMinSize->5,
    FontFamily->"Palatino",
    PrivateFontOptions->{"FontType"->"Outline"}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Notebook Options", "Section"],
  
  Cell["\<\
  The options defined for the style below will be used at the \
Notebook level.  \
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Notebook"],
    PageHeaders->{{Cell[ 
            TextData[ {
              CounterBox[ "Page"]}], "PageNumber"], None, Cell[ 
            TextData[ {"Printed from the ", 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              " Help Browser"}], "PageHeader"]}, {Cell[ 
            TextData[ {"Printed from the ", 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              " Help Browser"}], "PageHeader"], None, Cell[ 
            TextData[ {
              CounterBox[ "Page"]}], "PageNumber"]}},
    PageFooters->{{None, Cell[ 
            
            TextData[ {
              "\[Copyright]1988-2003 Wolfram Research, Inc. All rights \
reserved."}], "PageFooter"], None}, {None, Cell[ 
            
            TextData[ {
              "\[Copyright]1988-2003 Wolfram Research, Inc. All rights \
reserved."}], "PageFooter"], None}},
    PageHeaderLines->{True, True},
    PageFooterLines->{True, True},
    PrintingOptions->{"FacingPages"->True},
    CellLabelAutoDelete->False,
    CellFrameLabelMargins->6,
    StyleMenuListing->None],
  
  Cell[StyleData["Notebook", "Printout"],
    PageHeaders->{{Cell[ 
            TextData[ {
              CounterBox[ "Page"]}], "PageNumber"], None, Cell[ 
            TextData[ {"Printed from the ", 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              " Help Browser"}], "PageHeader"]}, {Cell[ 
            TextData[ {"Printed from the ", 
              StyleBox[ "Mathematica", FontSlant -> "Italic"], 
              " Help Browser"}], "PageHeader"], None, Cell[ 
            TextData[ {
              CounterBox[ "Page"]}], "PageNumber"]}},
    PageFooters->{{None, Cell[ 
            TextData[ {
              "\[Copyright]1988-2003 Wolfram Research, Inc. All rights \
reserved."}], "PageFooter"], None}, {None, Cell[ 
            
            TextData[ {
              "\[Copyright]1988-2003 Wolfram Research, Inc. All rights \
reserved."}], "PageFooter"], None}},
    PageHeaderLines->{True, True},
    PageFooterLines->{True, True},
    PrintingOptions->{"FacingPages"->True}],
  
  Cell[StyleData["Notebook", "EnhancedPrintout"],
    PageFooters->{{None, None, None}, {None, None, None}},
    PageHeaderLines->{True, True},
    PageFooterLines->{False, False},
    PrintingOptions->{"PrintingMargins"->{{54, 54}, {36, 72}},
    "PageSize"->{594, 657},
    "PrintRegistrationMarks"->True,
    "FirstPageHeader"->False,
    "FacingPages"->True,
    "FirstPageFace"->Right}]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Headings", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Chapter"],
    CellFrame->{{0, 0}, {0.5, 0}},
    CellMargins->{{27, 27}, {10, 40}},
    CellGroupingRules->{"TitleGrouping", 0},
    PageBreakBelow->False,
    DefaultNewInlineCellStyle->"None",
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], BoxMargins -> 
                {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    LanguageCategory->"NaturalLanguage",
    CounterIncrements->"Chapter",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
        "Subtitle", 0}, {"Subsubtitle", 0}},
    FontFamily->"Helvetica",
    FontSize->24,
    FontWeight->"Plain",
    FontColor->RGBColor[0.592157, 0.313726, 0.313726]],
  
  Cell[StyleData["Chapter", "Presentation"],
    FontSize->36],
  
  Cell[StyleData["Chapter", "Printout"],
    CellMargins->{{2, 10}, {6, 30}},
    FontSize->24],
  
  Cell[StyleData["Chapter", "EnhancedPrintout"],
    CellMargins->{{2, 10}, {6, 30}},
    FontFamily->"Frutiger 55 Roman",
    FontSize->24,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Chapter", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 10}, {6, 30}},
    FontFamily->"Frutiger 55 Roman",
    FontSize->24]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Section"],
    CellMargins->{{27, 27}, {9, 30}},
    CellGroupingRules->{"SectionGrouping", 30},
    PageBreakBelow->False,
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    CounterIncrements->"Section",
    CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}},
    FontFamily->"Helvetica",
    FontSize->20,
    FontWeight->"Bold",
    FontColor->RGBColor[0.592157, 0.313726, 0.313726]],
  
  Cell[StyleData["Section", "Presentation"],
    FontSize->30],
  
  Cell[StyleData["Section", "SlideShow"],
    CellFrame->{{0, 0}, {0, 0.5}},
    ShowCellBracket->False,
    CellMargins->{{0, 0}, {5, 0}},
    PageBreakBelow->False,
    CellFrameMargins->{{36, 36}, {Inherited, 15}},
    FontFamily->"Helvetica",
    FontSize->18,
    FontWeight->"Bold",
    FontColor->GrayLevel[1],
    Background->RGBColor[0.408011, 0.440726, 0.8]],
  
  Cell[StyleData["Section", "Printout"],
    CellMargins->{{2, 0}, {0, 18}},
    PageBreakBelow->False,
    FontSize->18],
  
  Cell[StyleData["Section", "EnhancedPrintout"],
    CellFrame->{{0, 0}, {0.5, 0}},
    CellMargins->{{2, 2}, {5, 30}},
    CellGroupingRules->{"SectionGrouping", 30},
    PageBreakBelow->False,
    CellFrameMargins->8,
    CounterIncrements->"Section",
    CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->16,
    FontWeight->"Plain",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Section", "EnhancedPrintoutNonGray"],
    CellFrame->{{0, 0}, {0.5, 0}},
    CellMargins->{{2, Inherited}, {5, 30}},
    CellGroupingRules->{"SectionGrouping", 30},
    PageBreakBelow->False,
    CellFrameMargins->8,
    CounterIncrements->"Section",
    CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->16,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsection"],
    CellDingbat->None,
    CellMargins->{{27, 27}, {0, 18}},
    CellElementSpacings->{"ClosedGroupTopMargin"->18},
    CellGroupingRules->{"SectionGrouping", 40},
    PageBreakBelow->False,
    CellFrameLabelMargins->6,
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    CounterIncrements->"Subsection",
    CounterAssignments->{{"Subsubsection", 0}},
    FontFamily->"Helvetica",
    FontSize->16,
    FontWeight->"Bold",
    FontColor->RGBColor[0.592157, 0.313726, 0.313726]],
  
  Cell[StyleData["Subsection", "Presentation"],
    FontSize->24],
  
  Cell[StyleData["Subsection", "SlideShow"],
    CellDingbat->None,
    CellMargins->{{70, 0}, {4, 12}},
    FontSize->12],
  
  Cell[StyleData["Subsection", "Printout"],
    CellMargins->{{2, 0}, {5, 24}},
    FontSize->12],
  
  Cell[StyleData["Subsection", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {5, 20}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->12,
    FontWeight->"Plain",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Subsection", "EnhancedPrintoutNonGray"],
    CellMargins->{{9, 0}, {5, 20}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->12,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsubsection"],
    CellMargins->{{27, 27}, {0, 18}},
    CellElementSpacings->{"ClosedGroupTopMargin"->18},
    CellGroupingRules->{"SectionGrouping", 50},
    PageBreakBelow->False,
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold",
    FontColor->RGBColor[0.592157, 0.313726, 0.313726]],
  
  Cell[StyleData["Subsubsection", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Subsubsection", "Printout"],
    CellMargins->{{2, 0}, {3, 8}},
    FontSize->10],
  
  Cell[StyleData["Subsubsection", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {3, 8}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->10,
    FontWeight->"Plain",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Subsubsection", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {3, 8}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->10,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SubsubsectionColor"],
    CellMargins->{{27, 27}, {0, 18}},
    CellElementSpacings->{"ClosedGroupTopMargin"->18},
    CellGroupingRules->{"SectionGrouping", 50},
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold",
    FontColor->RGBColor[0.297993, 0, 0.454994]],
  
  Cell[StyleData["SubsubsectionColor", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["SubsubsectionColor", "Printout"],
    CellMargins->{{2, 0}, {0, 18}},
    PageBreakBelow->False,
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SubsectionIcon"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{46, 27}, {0, 18}},
    CellElementSpacings->{"ClosedGroupTopMargin"->8},
    CellGroupingRules->{"SectionGrouping", 40},
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    CounterIncrements->"Subsection",
    FontFamily->"Helvetica",
    FontSize->16,
    FontWeight->"Bold",
    FontColor->RGBColor[0.592157, 0.313726, 0.313726]],
  
  Cell[StyleData["SubsectionIcon", "Presentation"],
    FontSize->24],
  
  Cell[StyleData["SubsectionIcon", "Printout"],
    CellDingbat->"\[FilledSquare]",
    ShowGroupOpenCloseIcon->False,
    CellMargins->{{16, 0}, {0, 18}},
    PageBreakBelow->False,
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SubsubsectionIcon"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{46, 27}, {0, 8}},
    CellElementSpacings->{"ClosedGroupTopMargin"->4},
    CellGroupingRules->{"SectionGrouping", 50},
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    CounterIncrements->"Subsubsection",
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold",
    FontColor->RGBColor[0.592157, 0.313726, 0.313726]],
  
  Cell[StyleData["SubsubsectionIcon", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["SubsubsectionIcon", "Printout"],
    ShowGroupOpenCloseIcon->False,
    CellMargins->{{2, 0}, {0, 18}},
    PageBreakBelow->False,
    FontSize->10]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Text", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Text"],
    CellMargins->{{27, 27}, {0, 8}},
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    ParagraphSpacing->{0, 8},
    CounterIncrements->"Text",
    FontSize->12],
  
  Cell[StyleData["Text", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Text", "SlideShow"],
    CellMargins->{{36, 24}, {4, 4}},
    Hyphenation->False,
    FontSize->14],
  
  Cell[StyleData["Text", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    Hyphenation->True,
    FontSize->10],
  
  Cell[StyleData["Text", "EnhancedPrintout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["Text", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["CompactText"],
    CellMargins->{{27, 27}, {0, 8}},
    ParagraphSpacing->{0, 0},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["CompactText", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["CompactText", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    Hyphenation->True,
    FontSize->8],
  
  Cell[StyleData["CompactText", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->8],
  
  Cell[StyleData["CompactText", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Compact12Text"],
    CellMargins->{{27, 27}, {0, 8}},
    ParagraphSpacing->{0, 0},
    StyleMenuListing->None],
  
  Cell[StyleData["Compact12Text", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Compact12Text", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    Hyphenation->True,
    FontSize->10],
  
  Cell[StyleData["Compact12Text", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["Compact12Text", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TextSans"],
    CellMargins->{{27, 27}, {0, 8}},
    CellHorizontalScrolling->True,
    ParagraphSpacing->{0, 8},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10],
  
  Cell[StyleData["TextSans", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["TextSans", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    Hyphenation->True,
    FontSize->8],
  
  Cell[StyleData["TextSans", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    Hyphenation->True,
    FontFamily->"Frutiger 55 Roman",
    FontSize->8],
  
  Cell[StyleData["TextSans", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    Hyphenation->True,
    FontFamily->"Frutiger 55 Roman",
    FontSize->8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedText"],
    CellMargins->{{66, 4}, {4, 4}},
    LineSpacing->{1, 3},
    ParagraphIndent->-22,
    CounterIncrements->"ItemizedText",
    StyleMenuListing->None],
  
  Cell[StyleData["ItemizedText", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedText", "Printout"],
    CellMargins->{{16, 4}, {2, 4}},
    Hyphenation->True,
    FontSize->10],
  
  Cell[StyleData["ItemizedText", "EnhancedPrintout"],
    CellMargins->{{16, 4}, {2, 4}},
    Hyphenation->True,
    LineSpacing->{1, 1},
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["ItemizedText", "EnhancedPrintoutNonGray"],
    Hyphenation->True,
    LineSpacing->{1, 1},
    ParagraphIndent->-18,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedTextNote"],
    CellMargins->{{88, 4}, {4, 0}},
    LineSpacing->{1, 2},
    CounterIncrements->"ItemizedTextNote",
    StyleMenuListing->None],
  
  Cell[StyleData["ItemizedTextNote", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedTextNote", "Printout"],
    CellMargins->{{34, 4}, {4, 1}},
    Hyphenation->True,
    FontSize->10],
  
  Cell[StyleData["ItemizedTextNote", "EnhancedPrintout"],
    CellMargins->{{39, 4}, {4, 1}},
    Hyphenation->True,
    LineSpacing->{1, 1},
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["ItemizedTextNote", "EnhancedPrintoutNonGray"],
    CellMargins->{{39, 4}, {4, 1}},
    Hyphenation->True,
    LineSpacing->{1, 1},
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["IndentedText"],
    CellMargins->{{66, 4}, {0, 6}},
    LineSpacing->{1, 3},
    CounterIncrements->"IndentedText",
    StyleMenuListing->None],
  
  Cell[StyleData["IndentedText", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["IndentedText", "SlideShow"],
    CellMargins->{{80, 24}, {5, 5}},
    Hyphenation->False,
    FontSize->13],
  
  Cell[StyleData["IndentedText", "Printout"],
    CellMargins->{{16, 4}, {2, 4}},
    Hyphenation->True,
    FontSize->10],
  
  Cell[StyleData["IndentedText", "EnhancedPrintout"],
    CellMargins->{{39, Inherited}, {Inherited, Inherited}},
    Hyphenation->True,
    LineSpacing->{1, 1},
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["IndentedText", "EnhancedPrintoutNonGray"],
    Hyphenation->True,
    LineSpacing->{1, 1},
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedList"],
    CellMargins->{{58, 4}, {4, 4}},
    CellFrameLabels->{{Cell[ 
            TextData[ {
              StyleBox[ 
                CounterBox[ "ItemizedList"], "TB"], 
              StyleBox[ ".", "TB"]}], CellBaseline -> Baseline, CellSize -> {
            24, Inherited}, TextAlignment -> Right], Inherited}, {
        Inherited, Inherited}},
    LineSpacing->{1, 3},
    CounterIncrements->"ItemizedList",
    StyleMenuListing->None],
  
  Cell[StyleData["ItemizedList", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedList", "Printout"],
    CellMargins->{{9, 4}, {2, 4}},
    Hyphenation->True,
    FontSize->10],
  
  Cell[StyleData["ItemizedList", "EnhancedPrintout"],
    CellMargins->{{9, 4}, {2, 4}},
    Hyphenation->True,
    LineSpacing->{1, 1},
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["ItemizedList", "EnhancedPrintoutNonGray"],
    Hyphenation->True,
    LineSpacing->{1, 1},
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedSubList"],
    CellMargins->{{92, 4}, {4, 4}},
    CellFrameLabels->{{Cell[ 
            TextData[ {
              StyleBox[ 
                CounterBox[ "ItemizedSubList"], "TB"], 
              StyleBox[ ".", "TB"]}], CellBaseline -> Baseline, CellSize -> {
            24, Inherited}, TextAlignment -> Right], Inherited}, {
        Inherited, Inherited}},
    CounterIncrements->"ItemizedSubList",
    StyleMenuListing->None,
    CounterBoxOptions->{CounterFunction:>(Part[ 
        CharacterRange[ "a", "z"], #]&)}],
  
  Cell[StyleData["ItemizedSubList", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedSubList", "Printout"],
    CellMargins->{{34, 4}, {4, 1}},
    Hyphenation->True,
    FontSize->10],
  
  Cell[StyleData["ItemizedSubList", "EnhancedPrintout"],
    CellMargins->{{26, 4}, {2, 4}},
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["ItemizedSubList", "EnhancedPrintoutNonGray"],
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedSubListNote"],
    CellMargins->{{110, 4}, {4, 4}},
    CounterIncrements->"ItemizedSubList",
    StyleMenuListing->None,
    CounterBoxOptions->{CounterFunction:>(Part[ 
        CharacterRange[ "a", "z"], #]&)}],
  
  Cell[StyleData["ItemizedSubListNote", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedSubListNote", "Printout"],
    CellMargins->{{34, 4}, {4, 1}},
    Hyphenation->True,
    FontSize->10],
  
  Cell[StyleData["ItemizedSubListNote", "EnhancedPrintout"],
    CellMargins->{{56, 4}, {2, 4}},
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["ItemizedSubListNote", "EnhancedPrintoutNonGray"],
    CellMargins->{{48, 4}, {2, 4}},
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["BulletedList"],
    CellMargins->{{76, 4}, {4, 4}},
    CellFrameLabels->{{
      Cell[ "\[Bullet]", "BulletedList", CellBaseline -> Baseline], 
          Inherited}, {Inherited, Inherited}},
    LineSpacing->{1, 3},
    CounterIncrements->"BulletText",
    StyleMenuListing->None],
  
  Cell[StyleData["BulletedList", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["BulletedList", "Printout"],
    CellMargins->{{16, 4}, {4, 1}},
    Hyphenation->True,
    FontSize->10],
  
  Cell[StyleData["BulletedList", "EnhancedPrintout"],
    CellMargins->{{26, 4}, {2, 4}},
    Hyphenation->True,
    LineSpacing->{1, 1},
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["BulletedList", "EnhancedPrintoutNonGray"],
    Hyphenation->True,
    LineSpacing->{1, 1},
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ListNote"],
    CellMargins->{{88, 4}, {4, 0}},
    LineSpacing->{1, 2},
    CounterIncrements->"ListNote",
    StyleMenuListing->None],
  
  Cell[StyleData["ListNote", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ListNote", "Printout"],
    CellMargins->{{34, 4}, {4, 1}},
    Hyphenation->True,
    FontSize->10],
  
  Cell[StyleData["ListNote", "EnhancedPrintout"],
    CellMargins->{{39, 4}, {4, 1}},
    Hyphenation->True,
    LineSpacing->{1, 1},
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["ListNote", "EnhancedPrintoutNonGray"],
    CellMargins->{{39, 4}, {4, 1}},
    Hyphenation->True,
    LineSpacing->{1, 1},
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MathCaption"],
    CellFrame->{{0, 0}, {0, 0.5}},
    CellMargins->{{66, 12}, {2, 20}},
    PageBreakBelow->False,
    CellFrameMargins->{{8, 8}, {8, 2}},
    CellFrameColor->GrayLevel[0.700008],
    CellFrameLabelMargins->4,
    LineSpacing->{1, 1},
    ParagraphSpacing->{0, 8},
    FontColor->GrayLevel[0.2]],
  
  Cell[StyleData["MathCaption", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["MathCaption", "SlideShow"],
    ShowCellBracket->False,
    CellMargins->{{36, 36}, {6, 6}}],
  
  Cell[StyleData["MathCaption", "Printout"],
    CellMargins->{{9, 0}, {0, 14}},
    Hyphenation->True,
    FontSize->9,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["MathCaption", "EnhancedPrintout"],
    CellMargins->{{9, 0}, {0, 14}},
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->9,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["MathCaption", "EnhancedPrintoutNonGray"],
    CellMargins->{{9, 0}, {0, 14}},
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->9,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SmallText"],
    CellMargins->{{27, 27}, {0, 8}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0.7, 0},
    CounterIncrements->"SmallText",
    FontSize->9],
  
  Cell[StyleData["SmallText", "Presentation"],
    FontSize->14],
  
  Cell[StyleData["SmallText", "Printout"],
    CellMargins->{{2, 2}, {5, 5}},
    TextJustification->1,
    Hyphenation->True,
    FontSize->7],
  
  Cell[StyleData["SmallText", "EnhancedPrintout"],
    CellMargins->{{2, 2}, {5, 5}},
    TextJustification->1,
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->7],
  
  Cell[StyleData["SmallText", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 2}, {5, 5}},
    TextJustification->1,
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->7]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Input/Output", "Section"],
  
  Cell["\<\
The cells in this section define styles used for input and output \
to the kernel.  Be careful when modifying, renaming, or removing these \
styles, because the front end associates special meanings with these style \
names.    \
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Input"],
    ShowCellBracket->True,
    CellMargins->{{66, 4}, {3, 8}},
    Evaluatable->True,
    CellGroupingRules->"InputGrouping",
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    CellLabelAutoDelete->False,
    CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultInputFormatType,
    ShowSpecialCharacters->Automatic,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    LanguageCategory->"Mathematica",
    FormatType->StandardForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    FontWeight->"Bold"],
  
  Cell[StyleData["Input", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Input", "SlideShow"],
    ShowCellBracket->True,
    CellMargins->{{100, 50}, {0, 6}},
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    CellFrameMargins->{{8, 8}, {4, 8}},
    Background->RGBColor[1, 1, 0.8]],
  
  Cell[StyleData["Input", "Printout"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {4, 6}},
    FontSize->9],
  
  Cell[StyleData["Input", "EnhancedPrintout"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {4, 6}},
    FontSize->9],
  
  Cell[StyleData["Input", "EnhancedPrintoutNonGray"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {4, 6}},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Output"],
    ShowCellBracket->True,
    CellMargins->{{66, 4}, {8, 2}},
    CellEditDuplicate->True,
    CellGroupingRules->"OutputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    CellLabelAutoDelete->False,
    CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultOutputFormatType,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    LanguageCategory->None,
    FormatType->StandardForm],
  
  Cell[StyleData["Output", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Output", "SlideShow"],
    ShowCellBracket->True,
    CellMargins->{{100, 50}, {6, 0}},
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    CellFrameMargins->{{8, 8}, {8, 4}},
    Background->RGBColor[1, 1, 0.8]],
  
  Cell[StyleData["Output", "Printout"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {6, 4}},
    FontSize->9],
  
  Cell[StyleData["Output", "EnhancedPrintout"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {6, 4}},
    FontSize->9],
  
  Cell[StyleData["Output", "EnhancedPrintoutNonGray"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {6, 4}},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["InputOnly"],
    ShowCellBracket->True,
    CellMargins->{{66, 4}, {8, 8}},
    Evaluatable->True,
    CellGroupingRules->"InputGrouping",
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    CellLabelAutoDelete->False,
    CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultInputFormatType,
    ShowSpecialCharacters->Automatic,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    LanguageCategory->"Mathematica",
    FormatType->StandardForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["InputOnly", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["InputOnly", "SlideShow"],
    ShowCellBracket->True,
    CellMargins->{{100, 50}, {6, 6}},
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    Background->RGBColor[1, 1, 0.8]],
  
  Cell[StyleData["InputOnly", "Printout"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {6, 6}},
    FontSize->9],
  
  Cell[StyleData["InputOnly", "EnhancedPrintout"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {6, 6}},
    FontSize->9],
  
  Cell[StyleData["InputOnly", "EnhancedPrintoutNonGray"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {6, 6}},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Message"],
    ShowCellBracket->True,
    CellMargins->{{66, 4}, {4, 2}},
    CellGroupingRules->"OutputGrouping",
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultOutputFormatType,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    AutoStyleOptions->{"UnmatchedBracketStyle"->None},
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    LanguageCategory->None,
    FormatType->InputForm,
    CounterIncrements->"Message",
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10,
    FontColor->RGBColor[0.6, 0.100008, 0.100008]],
  
  Cell[StyleData["Message", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Message", "SlideShow"],
    CellMargins->{{100, 50}, {6, 6}},
    FontSize->10,
    FontColor->RGBColor[0.699992, 0.4, 0]],
  
  Cell[StyleData["Message", "Printout"],
    ShowCellBracket->False,
    CellMargins->{{39, Inherited}, {Inherited, Inherited}},
    FontSize->9,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Message", "EnhancedPrintout"],
    ShowCellBracket->False,
    CellMargins->{{39, Inherited}, {Inherited, Inherited}},
    FontFamily->"Courier",
    FontSize->9,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Message", "EnhancedPrintoutNonGray"],
    ShowCellBracket->False,
    CellMargins->{{39, Inherited}, {Inherited, Inherited}},
    FontFamily->"Courier",
    FontSize->9,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Print"],
    ShowCellBracket->True,
    CellMargins->{{66, 4}, {4, 2}},
    CellGroupingRules->"OutputGrouping",
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultOutputFormatType,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    LanguageCategory->None,
    FormatType->InputForm,
    StyleMenuListing->None],
  
  Cell[StyleData["Print", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Print", "SlideShow"],
    CellMargins->{{100, 50}, {6, 6}}],
  
  Cell[StyleData["Print", "Printout"],
    ShowCellBracket->False,
    CellMargins->{{57, Inherited}, {Inherited, Inherited}},
    FontSize->9],
  
  Cell[StyleData["Print", "EnhancedPrintout"],
    ShowCellBracket->False,
    CellMargins->{{57, Inherited}, {Inherited, Inherited}},
    FontFamily->"Courier Std",
    FontSize->9],
  
  Cell[StyleData["Print", "EnhancedPrintoutNonGray"],
    ShowCellBracket->False,
    CellMargins->{{57, Inherited}, {Inherited, Inherited}},
    FontFamily->"Courier Std",
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Graphics"],
    ShowCellBracket->True,
    CellMargins->{{66, 4}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    PageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    DefaultFormatType->DefaultFormatTypeForOutput,
    LanguageCategory->None,
    FormatType->InputForm,
    StyleMenuListing->None,
    FontWeight->"Plain"],
  
  Cell[StyleData["Graphics", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Graphics", "SlideShow"],
    ShowCellBracket->True,
    CellMargins->{{100, 50}, {6, 0}},
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    CellFrameMargins->{{8, 8}, {4, 4}},
    Background->RGBColor[1, 1, 0.8]],
  
  Cell[StyleData["Graphics", "Printout"],
    ShowCellBracket->False,
    CellMargins->{{39, Inherited}, {Inherited, Inherited}},
    ImageSize->{250, 250},
    FontSize->9],
  
  Cell[StyleData["Graphics", "EnhancedPrintout"],
    ShowCellBracket->False,
    CellMargins->{{32, Inherited}, {Inherited, Inherited}},
    ImageSize->{250, 250},
    FontFamily->"Courier Std",
    FontSize->9],
  
  Cell[StyleData["Graphics", "EnhancedPrintoutNonGray"],
    ShowCellBracket->False,
    CellMargins->{{32, Inherited}, {Inherited, Inherited}},
    ImageSize->{250, 250},
    FontFamily->"Courier Std",
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["CellLabel"],
    LanguageCategory->None,
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9,
    FontWeight->"Plain",
    FontColor->RGBColor[0.269993, 0.308507, 0.6]],
  
  Cell[StyleData["CellLabel", "Presentation"],
    FontSize->14],
  
  Cell[StyleData["CellLabel", "SlideShow"],
    FontColor->RGBColor[0.699992, 0.4, 0]],
  
  Cell[StyleData["CellLabel", "Printout"],
    FontFamily->"Courier",
    FontSize->8,
    FontSlant->"Oblique",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["CellLabel", "EnhancedPrintout"],
    FontFamily->"Courier Std",
    FontSize->8,
    FontSlant->"Oblique",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["CellLabel", "EnhancedPrintoutNonGray"],
    FontFamily->"Courier Std",
    FontSize->8,
    FontSlant->"Oblique",
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Name"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9,
    FontWeight->"Plain",
    FontSlant->"Italic",
    FontColor->RGBColor[0.269993, 0.308507, 0.6]],
  
  Cell[StyleData["Name", "Presentation"],
    FontSize->14],
  
  Cell[StyleData["Name", "Printout"],
    FontSize->7,
    FontSlant->"Oblique",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Name", "EnhancedPrintout"],
    FontFamily->"Frutiger 56 Italic",
    FontSize->7,
    FontSlant->"Plain",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Name", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 56 Italic",
    FontSize->7,
    FontSlant->"Plain",
    FontColor->GrayLevel[0]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Hyperlinks", "Section"],
  
  Cell["\<\
The cells below define styles useful for making hypertext \
ButtonBoxes.  The \"Hyperlink\" style is for links within the same Notebook, \
or between Notebooks. The others point to the various sections of the help \
browser. These styles will modify individual words or letters in a cell \
exclusive of the cell tag.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Hyperlink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #2]}]&),
    Active->True,
    ButtonNote->ButtonData}],
  
  Cell[StyleData["Hyperlink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["Hyperlink", "EnhancedPrintout"],
    FontFamily->"Palatino",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["Hyperlink", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MainBookLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "MainBook", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["MainBookLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["MainBookLink", "EnhancedPrintout"],
    FontFamily->"Palatino",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["MainBookLink", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MainBookLinkMR"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontFamily->"Courier",
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "MainBook", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["MainBookLinkMR", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["MainBookLinkMR", "EnhancedPrintout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["MainBookLinkMR", "EnhancedPrintoutNonGray"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["AddOnsLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontFamily->"Courier",
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "AddOns", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["AddOnsLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["AddOnsLink", "EnhancedPrintout"],
    FontFamily->"WRICourier",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["AddOnsLink", "EnhancedPrintoutNonGray"],
    FontFamily->"WRICourier",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["AddOnsLinkText"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontFamily->"Times",
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "AddOns", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["AddOnsLinkText", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["AddOnsLinkText", "EnhancedPrintout"],
    FontFamily->"Palatino",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["AddOnsLinkText", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["RefGuideLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontFamily->"Courier",
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "RefGuide", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["RefGuideLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["RefGuideLink", "EnhancedPrintout"],
    FontFamily->"WRICourier",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["RefGuideLink", "EnhancedPrintoutNonGray"],
    FontFamily->"WRICourier",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["GettingStartedLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "GettingStarted", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["GettingStartedLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["GettingStartedLink", "EnhancedPrintout"],
    FontFamily->"Palatino",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["GettingStartedLink", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DemosLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "Demos", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["DemosLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["DemosLink", "EnhancedPrintout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["DemosLink", "EnhancedPrintoutNonGray"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TourLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "Tour", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["TourLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["TourLink", "EnhancedPrintout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["TourLink", "EnhancedPrintoutNonGray"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["OtherInformationLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "OtherInformation", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["OtherInformationLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["OtherInformationLink", "EnhancedPrintout"],
    FontFamily->"Palatino",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["OtherInformationLink", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino",
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["OtherInformationLinkMR"],
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "OtherInformation", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["OtherInformationLinkMR", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["OtherInformationLinkMR", "EnhancedPrintout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["OtherInformationLinkMR", "EnhancedPrintoutNonGray"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MasterIndexLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "MasterIndex", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["MasterIndexLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["MasterIndexLink", "EnhancedPrintout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["MasterIndexLink", "EnhancedPrintoutNonGray"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["NotebookLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontFamily->"Times",
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["NotebookLink", "Printout"],
    FontSize->11,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["NotebookLink", "EnhancedPrintout"],
    FontFamily->"Palatino",
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["NotebookLink", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino",
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["NotebookLinkMR"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontFamily->"Courier",
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["NotebookLinkMR", "Printout"],
    FontSize->11,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["NotebookLinkMR", "EnhancedPrintout"],
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["NotebookLinkMR", "EnhancedPrintoutNonGray"],
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Palette Styles", "Section"],
  
  Cell["\<\
The cells below define styles that define standard \
ButtonFunctions, for use in palette buttons.\
\>", "Text"],
  
  Cell[StyleData["Paste"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookApply[ 
          FrontEnd`InputNotebook[ ], #, After]}]&)}],
  
  Cell[StyleData["Evaluate"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookApply[ 
          FrontEnd`InputNotebook[ ], #, All], 
        FrontEnd`SelectionEvaluate[ 
          FrontEnd`InputNotebook[ ], All]}]&)}],
  
  Cell[StyleData["EvaluateCell"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookApply[ 
          FrontEnd`InputNotebook[ ], #, All], 
        FrontEnd`SelectionMove[ 
          FrontEnd`InputNotebook[ ], All, Cell, 1], 
        FrontEnd`SelectionEvaluateCreateCell[ 
          FrontEnd`InputNotebook[ ], All]}]&)}],
  
  Cell[StyleData["CopyEvaluate"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`SelectionCreateCell[ 
          FrontEnd`InputNotebook[ ], All], 
        FrontEnd`NotebookApply[ 
          FrontEnd`InputNotebook[ ], #, All], 
        FrontEnd`SelectionEvaluate[ 
          FrontEnd`InputNotebook[ ], All]}]&)}],
  
  Cell[StyleData["CopyEvaluateCell"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`SelectionCreateCell[ 
          FrontEnd`InputNotebook[ ], All], 
        FrontEnd`NotebookApply[ 
          FrontEnd`InputNotebook[ ], #, All], 
        FrontEnd`SelectionEvaluateCreateCell[ 
          FrontEnd`InputNotebook[ ], All]}]&)}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Inline Formatting", "Section"],
  
  Cell["\<\
These styles are for modifying individual words or letters in a \
cell exclusive of the cell tag.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["JT"],
    StyleMenuListing->None,
    FontFamily->"JFontText"],
  
  Cell[StyleData["JT", "Printout"]],
  
  Cell[StyleData["JT", "EnhancedPrintout"]],
  
  Cell[StyleData["JT", "EnhancedPrintoutNonGray"]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["JS"],
    StyleMenuListing->None,
    FontFamily->"JFontSans"],
  
  Cell[StyleData["JS", "Printout"]],
  
  Cell[StyleData["JS", "EnhancedPrintout"]],
  
  Cell[StyleData["JS", "EnhancedPrintoutNonGray"]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["JSB"],
    StyleMenuListing->None,
    FontFamily->"JFontSansBold"],
  
  Cell[StyleData["JSB", "Printout"]],
  
  Cell[StyleData["JSB", "EnhancedPrintout"]],
  
  Cell[StyleData["JSB", "EnhancedPrintoutNonGray"]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["RM"],
    StyleMenuListing->None,
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["RM", "Printout"]],
  
  Cell[StyleData["RM", "EnhancedPrintout"]],
  
  Cell[StyleData["RM", "EnhancedPrintoutNonGray"]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["BF"],
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["BF", "Printout"]],
  
  Cell[StyleData["BF", "EnhancedPrintout"]],
  
  Cell[StyleData["BF", "EnhancedPrintoutNonGray"]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["IT"],
    StyleMenuListing->None,
    FontSlant->"Italic"],
  
  Cell[StyleData["IT", "Printout"]],
  
  Cell[StyleData["IT", "EnhancedPrintout"]],
  
  Cell[StyleData["IT", "EnhancedPrintoutNonGray"]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TR"],
    StyleMenuListing->None,
    FontFamily->"Times",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["TR", "Printout"]],
  
  Cell[StyleData["TR", "EnhancedPrintout"],
    FontFamily->"Palatino"],
  
  Cell[StyleData["TR", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TI"],
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSlant->"Italic"],
  
  Cell[StyleData["TI", "Printout"]],
  
  Cell[StyleData["TI", "EnhancedPrintout"],
    FontFamily->"Palatino"],
  
  Cell[StyleData["TI", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TB"],
    StyleMenuListing->None,
    FontFamily->"Times",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  
  Cell[StyleData["TB", "Printout"]],
  
  Cell[StyleData["TB", "EnhancedPrintout"],
    FontFamily->"Palatino"],
  
  Cell[StyleData["TB", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TBI"],
    StyleMenuListing->None,
    FontFamily->"Times",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  
  Cell[StyleData["TBI", "Printout"]],
  
  Cell[StyleData["TBI", "EnhancedPrintout"],
    FontFamily->"Palatino"],
  
  Cell[StyleData["TBI", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MR"],
    Hyphenation->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["MR", "Printout"]],
  
  Cell[StyleData["MR", "EnhancedPrintout"],
    FontFamily->"Courier Std"],
  
  Cell[StyleData["MR", "EnhancedPrintoutNonGray"],
    FontFamily->"Courier Std"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MO"],
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontWeight->"Plain",
    FontSlant->"Italic"],
  
  Cell[StyleData["MO", "Printout"],
    FontSlant->"Oblique"],
  
  Cell[StyleData["MO", "EnhancedPrintout"],
    FontFamily->"Courier Std",
    FontSlant->"Oblique"],
  
  Cell[StyleData["MO", "EnhancedPrintoutNonGray"],
    FontFamily->"Courier Std",
    FontSlant->"Oblique"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MB"],
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  
  Cell[StyleData["MB", "Printout"]],
  
  Cell[StyleData["MB", "EnhancedPrintout"],
    FontFamily->"Courier Std"],
  
  Cell[StyleData["MB", "EnhancedPrintoutNonGray"],
    FontFamily->"Courier Std"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MBO"],
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  
  Cell[StyleData["MBO", "Printout"],
    FontSlant->"Oblique"],
  
  Cell[StyleData["MBO", "EnhancedPrintout"],
    FontFamily->"Courier Std",
    FontSlant->"Oblique"],
  
  Cell[StyleData["MBO", "EnhancedPrintoutNonGray"],
    FontFamily->"Courier Std",
    FontSlant->"Oblique"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SR"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["SR", "Printout"]],
  
  Cell[StyleData["SR", "EnhancedPrintout"],
    FontFamily->"Frutiger 55 Roman"],
  
  Cell[StyleData["SR", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 55 Roman"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SO"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Plain",
    FontSlant->"Italic"],
  
  Cell[StyleData["SO", "Printout"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Plain",
    FontSlant->"Italic"],
  
  Cell[StyleData["SO", "EnhancedPrintout"],
    FontFamily->"Frutiger 56 Italic",
    FontSlant->"Plain"],
  
  Cell[StyleData["SO", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 56 Italic",
    FontSlant->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SB"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  
  Cell[StyleData["SB", "Printout"],
    StyleMenuListing->None],
  
  Cell[StyleData["SB", "EnhancedPrintout"],
    FontFamily->"Frutiger 65 Bold",
    FontWeight->"Plain"],
  
  Cell[StyleData["SB", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 65 Bold",
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SBColor"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  
  Cell[StyleData["SBColor", "Printout"],
    StyleMenuListing->None],
  
  Cell[StyleData["SBColor", "EnhancedPrintout"],
    FontFamily->"Frutiger 65 Bold",
    FontWeight->"Plain"],
  
  Cell[StyleData["SBColor", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 65 Bold",
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SBO"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  
  Cell[StyleData["SBO", "Printout"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  
  Cell[StyleData["SBO", "EnhancedPrintout"],
    FontFamily->"Frutiger 66 BoldItalic",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["SBO", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 66 BoldItalic",
    FontWeight->"Plain",
    FontSlant->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["M4"],
    ShowCellBracket->True,
    StyleMenuListing->None,
    FontFamily->"Mathematica4",
    CharacterEncoding->"Mathematica4"],
  
  Cell[StyleData["M4", "Printout"],
    ShowCellBracket->True,
    StyleMenuListing->None,
    FontFamily->"Mathematica4",
    CharacterEncoding->"Mathematica4"],
  
  Cell[StyleData["M4", "EnhancedPrintout"],
    ShowCellBracket->True,
    StyleMenuListing->None,
    FontFamily->"Mathematica4",
    CharacterEncoding->"Mathematica4"],
  
  Cell[StyleData["M4", "EnhancedPrintoutNonGray"],
    ShowCellBracket->True,
    StyleMenuListing->None,
    FontFamily->"Mathematica4",
    CharacterEncoding->"Mathematica4"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SO10"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10,
    FontWeight->"Plain",
    FontSlant->"Italic"],
  
  Cell[StyleData["SO10", "Printout"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->8,
    FontWeight->"Plain",
    FontSlant->"Italic"],
  
  Cell[StyleData["SO10", "EnhancedPrintout"],
    StyleMenuListing->None,
    FontFamily->"Frutiger 56 Italic",
    FontSize->8,
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["SO10", "EnhancedPrintoutNonGray"],
    StyleMenuListing->None,
    FontFamily->"Frutiger 56 Italic",
    FontSize->8,
    FontWeight->"Plain",
    FontSlant->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["S9"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9,
    FontWeight->"Plain"],
  
  Cell[StyleData["S9", "Printout"],
    FontSize->9,
    FontWeight->"Plain"],
  
  Cell[StyleData["S9", "EnhancedPrintout"],
    FontFamily->"Frutiger 55 Roman",
    FontSize->9,
    FontWeight->"Plain"],
  
  Cell[StyleData["S9", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 55 Roman",
    FontSize->9,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["S10"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10,
    FontWeight->"Plain"],
  
  Cell[StyleData["S10", "Printout"],
    FontSize->10,
    FontWeight->"Plain"],
  
  Cell[StyleData["S10", "EnhancedPrintout"],
    FontFamily->"Frutiger 55 Roman",
    FontSize->10,
    FontWeight->"Plain"],
  
  Cell[StyleData["S10", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 55 Roman",
    FontSize->10,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SB9"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9,
    FontWeight->"Bold",
    PrivateFontOptions->{"OperatorSubstitution"->False}],
  
  Cell[StyleData["SB9", "Printout"],
    FontSize->7],
  
  Cell[StyleData["SB9", "EnhancedPrintout"],
    FontFamily->"Frutiger 65 Bold",
    FontSize->7,
    FontWeight->"Plain"],
  
  Cell[StyleData["SB9", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 65 Bold",
    FontSize->7,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SB10"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10,
    FontWeight->"Bold"],
  
  Cell[StyleData["SB10", "Printout"],
    FontSize->8],
  
  Cell[StyleData["SB10", "EnhancedPrintout"],
    FontFamily->"Frutiger 65 Bold",
    FontSize->8,
    FontWeight->"Plain"],
  
  Cell[StyleData["SB10", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 65 Bold",
    FontSize->8,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MR10"],
    Hyphenation->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    SingleLetterItalics->False,
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->10,
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["MR10", "Printout"],
    FontSize->7],
  
  Cell[StyleData["MR10", "EnhancedPrintout"],
    FontFamily->"Courier Std",
    FontSize->7],
  
  Cell[StyleData["MR10", "EnhancedPrintoutNonGray"],
    FontFamily->"Courier Std",
    FontSize->7]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["C1"],
    StyleMenuListing->None,
    FontColor->RGBColor[0.4, 0, 1]],
  
  Cell[StyleData["C1", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["C1", "EnhancedPrintout"],
    FontFamily->"Palatino",
    FontSize->10,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["C1", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino",
    FontSize->10,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["C1MR"],
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontColor->RGBColor[0.4, 0, 1]],
  
  Cell[StyleData["C1MR", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["C1MR", "EnhancedPrintout"],
    FontFamily->"Courier Std",
    FontSize->10,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["C1MR", "EnhancedPrintoutNonGray"],
    FontFamily->"Courier Std",
    FontSize->10,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SmallCaps"],
    StyleMenuListing->None,
    Magnification->0.8],
  
  Cell[StyleData["SmallCaps", "Printout"]],
  
  Cell[StyleData["SmallCaps", "EnhancedPrintout"],
    FontFamily->"Palatino"],
  
  Cell[StyleData["SmallCaps", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["KeyboardChars"],
    StyleMenuListing->None,
    FontSize->12],
  
  Cell[StyleData["KeyboardChars", "Printout"],
    FontSize->10],
  
  Cell[StyleData["KeyboardChars", "EnhancedPrintout"],
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["KeyboardChars", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Emphasis Boxes and Pictures", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Box"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnSpacings->1}],
  
  Cell[StyleData["Box", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Box", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["Box", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["Box", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DoubleBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnSpacings->2,
    RowAlignments->Top}],
  
  Cell[StyleData["DoubleBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["DoubleBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["DoubleBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["DoubleBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["1ColumnBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnSpacings->1}],
  
  Cell[StyleData["1ColumnBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["1ColumnBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["1ColumnBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["1ColumnBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["2ColumnBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    SingleLetterItalics->False,
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnWidths->{0.31, 0.67}}],
  
  Cell[StyleData["2ColumnBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["2ColumnBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->9,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["2ColumnBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->9,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["2ColumnBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->9,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["2ColumnEvenBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnWidths->0.46}],
  
  Cell[StyleData["2ColumnEvenBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["2ColumnEvenBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["2ColumnEvenBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["2ColumnEvenBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["2ColumnSmallBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnSpacings->1.5,
    ColumnWidths->0.35,
    ColumnAlignments->{Right, Left}}],
  
  Cell[StyleData["2ColumnSmallBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["2ColumnSmallBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["2ColumnSmallBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["2ColumnSmallBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["3ColumnBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnWidths->0.32}],
  
  Cell[StyleData["3ColumnBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["3ColumnBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["3ColumnBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["3ColumnBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["3ColumnSmallBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnSpacings->1.5,
    ColumnWidths->0.24,
    ColumnAlignments->{Right, Center, Left}}],
  
  Cell[StyleData["3ColumnSmallBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["3ColumnSmallBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["3ColumnSmallBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["3ColumnSmallBox", "EnhancedPrintoutNonGray"],
    CellFrame->0.5,
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["4ColumnBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    SingleLetterItalics->False,
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnWidths->{0.13, 0.35, 0.13, 0.35}}],
  
  Cell[StyleData["4ColumnBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["4ColumnBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["4ColumnBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["4ColumnBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["5ColumnBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnWidths->0.202}],
  
  Cell[StyleData["5ColumnBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["5ColumnBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->9,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["5ColumnBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->9,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["5ColumnBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->9,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["6ColumnBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnWidths->{0.12, 0.22, 0.12, 0.12, 0.22, 0.12}}],
  
  Cell[StyleData["6ColumnBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["6ColumnBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["6ColumnBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["6ColumnBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FramedBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["FramedBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["FramedBox", "Printout"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["FramedBox", "EnhancedPrintout"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["FramedBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DefinitionBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.4, 0.6},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["DefinitionBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["DefinitionBox", "Printout"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["DefinitionBox", "EnhancedPrintout"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["DefinitionBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DefinitionBox3Col"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.35, 0.2, 0.45},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["DefinitionBox3Col", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["DefinitionBox3Col", "Printout"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["DefinitionBox3Col", "EnhancedPrintout"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["DefinitionBox3Col", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DefinitionBox4Col"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.15, 0.35, 0.15, 0.35},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["DefinitionBox4Col", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["DefinitionBox4Col", "Printout"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["DefinitionBox4Col", "EnhancedPrintout"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["DefinitionBox4Col", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DefinitionBox5Col"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->0.2,
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["DefinitionBox5Col", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["DefinitionBox5Col", "Printout"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["DefinitionBox5Col", "EnhancedPrintout"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["DefinitionBox5Col", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DefinitionBox6Col"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.13, 0.24, 0.13, 0.13, 0.24, 0.13},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["DefinitionBox6Col", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["DefinitionBox6Col", "Printout"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["DefinitionBox6Col", "EnhancedPrintout"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["DefinitionBox6Col", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 4}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TopBox"],
    CellFrame->{{0.5, 0.5}, {0, 0.5}},
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakBelow->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.31, 0.62},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["TopBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TopBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    Background->GrayLevel[1]],
  
  Cell[StyleData["TopBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    Background->GrayLevel[1]],
  
  Cell[StyleData["TopBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MiddleBox"],
    CellFrame->{{0.5, 0.5}, {0, 0}},
    CellMargins->{{27, 12}, {0, -7}},
    CellHorizontalScrolling->True,
    PageBreakAbove->False,
    PageBreakBelow->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.31, 0.62},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["MiddleBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["MiddleBox", "Printout"],
    CellMargins->{{2, 0}, {0, 2}},
    CellFrameColor->GrayLevel[0],
    Background->GrayLevel[1]],
  
  Cell[StyleData["MiddleBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 4}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    Background->GrayLevel[1]],
  
  Cell[StyleData["MiddleBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 4}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["BottomBox"],
    CellFrame->{{0.5, 0.5}, {0.5, 0}},
    CellMargins->{{27, 12}, {0, -7}},
    CellHorizontalScrolling->True,
    PageBreakAbove->False,
    PageBreakBelow->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.31, 0.62},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["BottomBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["BottomBox", "Printout"],
    CellMargins->{{2, 0}, {0, -5}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1],
    GridBoxOptions->{RowMinHeight->2.2}],
  
  Cell[StyleData["BottomBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, -5}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1],
    GridBoxOptions->{RowMinHeight->2.2}],
  
  Cell[StyleData["BottomBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, -5}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1],
    GridBoxOptions->{RowMinHeight->2.2}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TopSpanBox"],
    CellFrame->{{0.5, 0.5}, {0, 0.5}},
    CellMargins->{{27, 12}, {-2, 8}},
    CellHorizontalScrolling->True,
    PageBreakBelow->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.9, 0.03},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["TopSpanBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TopSpanBox", "Printout"],
    CellMargins->{{2, 0}, {-2, 8}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["TopSpanBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {-4, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]],
  
  Cell[StyleData["TopSpanBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {-4, 8}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MiddleSpanBox"],
    CellFrame->{{0.5, 0.5}, {0, 0}},
    CellMargins->{{27, 12}, {0, 0}},
    CellHorizontalScrolling->True,
    PageBreakAbove->False,
    PageBreakBelow->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.9, 0.03},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["MiddleSpanBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["MiddleSpanBox", "Printout"],
    CellMargins->{{2, 0}, {-5, 0}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1],
    GridBoxOptions->{RowMinHeight->1.8}],
  
  Cell[StyleData["MiddleSpanBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {-7, 0}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1],
    GridBoxOptions->{RowMinHeight->1.8}],
  
  Cell[StyleData["MiddleSpanBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {-7, 0}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    FontSize->10,
    Background->GrayLevel[1],
    GridBoxOptions->{RowMinHeight->1.8}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Picture"],
    CellMargins->{{27, Inherited}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["Picture", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Picture", "Printout"],
    CellMargins->{{2, Inherited}, {4, 4}},
    Magnification->0.65],
  
  Cell[StyleData["Picture", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.65],
  
  Cell[StyleData["Picture", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.65]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["OpenCloseItemizedPicture"],
    CellMargins->{{88, 4}, {4, 4}},
    PrivateCellOptions->{"DefaultCellGroupOpen"->False},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["OpenCloseItemizedPicture", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["OpenCloseItemizedPicture", "Printout"],
    CellMargins->{{76, 2}, {0, 0}},
    CellElementSpacings->{"CellMinHeight"->1,
    "ClosedCellHeight"->0},
    CellOpen->False],
  
  Cell[StyleData["OpenCloseItemizedPicture", "EnhancedPrintout"],
    CellMargins->{{76, 2}, {0, 0}},
    CellElementSpacings->{"CellMinHeight"->1,
    "ClosedCellHeight"->0},
    CellOpen->False],
  
  Cell[StyleData["OpenCloseItemizedPicture", "EnhancedPrintoutNonGray"],
    CellMargins->{{76, 2}, {0, 0}},
    CellElementSpacings->{"CellMinHeight"->1,
    "ClosedCellHeight"->0},
    CellOpen->False]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedPicture"],
    CellMargins->{{88, 4}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemizedPicture", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedPicture", "Printout"],
    CellMargins->{{77, 2}, {4, -4}},
    Magnification->0.5],
  
  Cell[StyleData["ItemizedPicture", "EnhancedPrintout"],
    CellMargins->{{78, 2}, {12, -6}},
    Magnification->0.5],
  
  Cell[StyleData["ItemizedPicture", "EnhancedPrintoutNonGray"],
    CellMargins->{{75, 2}, {4, -6}},
    Magnification->0.5]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ListGraphic"],
    CellMargins->{{88, 4}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ListGraphic", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ListGraphic", "Printout"],
    CellMargins->{{77, 2}, {4, -4}},
    Magnification->0.5],
  
  Cell[StyleData["ListGraphic", "EnhancedPrintout"],
    CellMargins->{{78, 2}, {12, -6}},
    Magnification->0.5],
  
  Cell[StyleData["ListGraphic", "EnhancedPrintoutNonGray"],
    CellMargins->{{75, 2}, {4, -6}},
    Magnification->0.5]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ListNoteBox"],
    CellFrame->0.5,
    CellMargins->{{88, 12}, {8, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxMargins->{{1, 1}, {1.5, 1.5}}},
    GridBoxOptions->{ColumnSpacings->1}],
  
  Cell[StyleData["ListNoteBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ListNoteBox", "Printout"],
    CellMargins->{{77, 4}, {6, 2}},
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["ListNoteBox", "EnhancedPrintout"],
    CellMargins->{{39, 4}, {6, 2}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["ListNoteBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{77, 4}, {6, 2}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureGroup"],
    CellMargins->{{41, 4}, {0, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PictureGroup", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PictureGroup", "Printout"],
    CellMargins->{{76, 2}, {0, 0}},
    CellElementSpacings->{"CellMinHeight"->1,
    "ClosedCellHeight"->0},
    CellOpen->False],
  
  Cell[StyleData["PictureGroup", "EnhancedPrintout"],
    CellMargins->{{76, 2}, {0, 0}},
    CellElementSpacings->{"CellMinHeight"->1,
    "ClosedCellHeight"->0},
    CellOpen->False],
  
  Cell[StyleData["PictureGroup", "EnhancedPrintoutNonGray"],
    CellMargins->{{76, 2}, {0, 0}},
    CellElementSpacings->{"CellMinHeight"->1,
    "ClosedCellHeight"->0},
    CellOpen->False]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Sound"],
    ShowCellBracket->True,
    CellMargins->{{27, Inherited}, {0, 8}},
    StyleMenuListing->None],
  
  Cell[StyleData["Sound", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Sound", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10],
  
  Cell[StyleData["Sound", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10],
  
  Cell[StyleData["Sound", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Caption"],
    CellMargins->{{27, 4}, {0, 3}},
    PageBreakAbove->False,
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9],
  
  Cell[StyleData["Caption", "Presentation"],
    FontSize->14],
  
  Cell[StyleData["Caption", "Printout"],
    CellMargins->{{2, 4}, {2, 0}},
    FontSize->7],
  
  Cell[StyleData["Caption", "EnhancedPrintout"],
    CellMargins->{{2, 4}, {2, 2}},
    FontFamily->"Frutiger 55 Roman",
    FontSize->7],
  
  Cell[StyleData["Caption", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 4}, {2, -2}},
    FontFamily->"Frutiger 55 Roman",
    FontSize->7]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Tables", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["2ColumnTable"],
    CellMargins->{{35, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{ColumnWidths->{0.34, 0.64},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["2ColumnTable", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["2ColumnTable", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9],
  
  Cell[StyleData["2ColumnTable", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9],
  
  Cell[StyleData["2ColumnTable", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["2ColumnEvenTable"],
    CellMargins->{{35, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{ColumnWidths->0.49,
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["2ColumnEvenTable", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["2ColumnEvenTable", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9],
  
  Cell[StyleData["2ColumnEvenTable", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9],
  
  Cell[StyleData["2ColumnEvenTable", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["3ColumnTable"],
    CellMargins->{{35, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{ColumnWidths->{0.28, 0.28, 0.43},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["3ColumnTable", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["3ColumnTable", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9],
  
  Cell[StyleData["3ColumnTable", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9],
  
  Cell[StyleData["3ColumnTable", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Formulas and Programming", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["InlineFormula"],
    CellMargins->{{27, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    LanguageCategory->"Formula",
    AutoSpacing->True,
    ScriptLevel->1,
    SingleLetterItalics->True,
    SpanMaxSize->Infinity,
    StyleMenuListing->None,
    GridBoxOptions->{ColumnWidths->Automatic}],
  
  Cell[StyleData["InlineFormula", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10],
  
  Cell[StyleData["InlineFormula", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10],
  
  Cell[StyleData["InlineFormula", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["InlineOutput"],
    CellMargins->{{27, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    LanguageCategory->None,
    StyleMenuListing->None,
    FontFamily->"Courier"],
  
  Cell[StyleData["InlineOutput", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9.5],
  
  Cell[StyleData["InlineOutput", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9.5],
  
  Cell[StyleData["InlineOutput", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9.5]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DisplayFormula"],
    CellMargins->{{66, Inherited}, {Inherited, 10}},
    CellHorizontalScrolling->True,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    LanguageCategory->"Formula",
    ScriptLevel->0,
    SingleLetterItalics->True,
    SpanMaxSize->Infinity,
    StyleMenuListing->None,
    UnderoverscriptBoxOptions->{LimitsPositioning->True},
    GridBoxOptions->{ColumnWidths->Automatic}],
  
  Cell[StyleData["DisplayFormula", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["DisplayFormula", "Printout"]],
  
  Cell[StyleData["DisplayFormula", "EnhancedPrintout"],
    FontFamily->"Palatino"],
  
  Cell[StyleData["DisplayFormula", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DisplayMath"],
    CellMargins->{{66, 10}, {7, 7}},
    Evaluatable->False,
    CellGroupingRules->"InputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    DefaultFormatType->DefaultInputFormatType,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    LanguageCategory->"Formula",
    FormatType->InputForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    CounterIncrements->"Input"],
  
  Cell[StyleData["DisplayMath", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["DisplayMath", "Printout"],
    CellMargins->{{39, 0}, {6, 6}},
    FontSize->9],
  
  Cell[StyleData["DisplayMath", "EnhancedPrintout"],
    CellMargins->{{39, 0}, {4, 6}},
    FontFamily->"WRICourier",
    FontSize->9],
  
  Cell[StyleData["DisplayMath", "EnhancedPrintoutNonGray"],
    CellMargins->{{39, 0}, {4, 6}},
    FontFamily->"WRICourier",
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["NumberedEquation"],
    CellMargins->{{66, 27}, {7, 7}},
    CellFrameLabels->{{None, Cell[ 
            TextData[ {"(", 
              CounterBox[ "NumberedEquation"], ")"}]]}, {None, None}},
    DefaultFormatType->DefaultInputFormatType,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    LanguageCategory->"Formula",
    CounterIncrements->"NumberedEquation",
    FormatTypeAutoConvert->False],
  
  Cell[StyleData["NumberedEquation", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["NumberedEquation", "Printout"],
    CellMargins->{{39, 55}, {0, 10}},
    FontSize->10],
  
  Cell[StyleData["NumberedEquation", "EnhancedPrintout"],
    CellMargins->{{39, 55}, {0, 10}},
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["NumberedEquation", "EnhancedPrintoutNonGray"],
    CellMargins->{{39, 55}, {0, 10}},
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["EquationNumber"],
    CellMargins->{{66, Inherited}, {Inherited, Inherited}},
    LineSpacing->{1.83, 0},
    LanguageCategory->"Formula"],
  
  Cell[StyleData["EquationNumber", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["EquationNumber", "Printout"],
    LineSpacing->{1.7, 0}],
  
  Cell[StyleData["EquationNumber", "EnhancedPrintout"],
    LineSpacing->{1.7, 0},
    FontFamily->"Palatino"],
  
  Cell[StyleData["EquationNumber", "EnhancedPrintoutNonGray"],
    LineSpacing->{1.7, 0},
    FontFamily->"Palatino"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Program"],
    CellMargins->{{66, Inherited}, {Inherited, 10}},
    CellHorizontalScrolling->True,
    ShowSpecialCharacters->Automatic,
    AutoItalicWords->{},
    LanguageCategory->"Formula",
    FontFamily->"Courier"],
  
  Cell[StyleData["Program", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Program", "Printout"],
    CellMargins->{{42, 30}, {Inherited, 4}},
    FontSize->9.5],
  
  Cell[StyleData["Program", "EnhancedPrintout"],
    CellMargins->{{42, 30}, {Inherited, 4}},
    FontFamily->"WRICourier",
    FontSize->9.5],
  
  Cell[StyleData["Program", "EnhancedPrintoutNonGray"],
    CellMargins->{{42, 30}, {Inherited, 4}},
    FontFamily->"WRICourier",
    FontSize->9.5]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Unique Help Browser Styles", "Section"],
  
  Cell[CellGroupData[{
  
  Cell["\<\
Standard Styles
\
\>", "Subsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["InspectorLevel1"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{27, 10}, {2, 7}},
    CellGroupingRules->{"SectionGrouping", 60},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    ParagraphIndent->-38,
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->16,
    FontWeight->"Bold"],
  
  Cell[StyleData["InspectorLevel1", "Presentation"],
    FontSize->24],
  
  Cell[StyleData["InspectorLevel1", "SlideShow"],
    HyphenationOptions->{"HyphenationCharacter"->"-"}],
  
  Cell[StyleData["InspectorLevel1", "Printout"],
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["InspectorLevel2"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{27, 4}, {0, 14}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->14,
    FontWeight->"Bold"],
  
  Cell[StyleData["InspectorLevel2", "Presentation"],
    FontSize->21],
  
  Cell[StyleData["InspectorLevel2", "SlideShow"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{48, 10}, {2, 12}},
    CellGroupingRules->{"SectionGrouping", 70},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    ParagraphIndent->-27,
    FontFamily->"Helvetica",
    FontSize->14,
    FontWeight->"Bold"],
  
  Cell[StyleData["InspectorLevel2", "Printout"],
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->12]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ObjectName"],
    CellFrame->{{0, 0}, {0.5, 0}},
    CellMargins->{{0, 0}, {0, 0}},
    CellGroupingRules->{"SectionGrouping", 50},
    CellFrameMargins->{{27, 12}, {3, 15}},
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->18,
    FontWeight->"Bold",
    Background->RGBColor[0.960784, 0.878431, 0.666667]],
  
  Cell[StyleData["ObjectName", "Presentation"],
    FontSize->24],
  
  Cell[StyleData["ObjectName", "SlideShow"],
    CellMargins->{{72, 4}, {1, 14}},
    CellGroupingRules->{"SectionGrouping", 90},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["ObjectName", "Printout"],
    CellMargins->{{0, 0}, {0, 10}},
    CellFrameMargins->{{24, 8}, {Inherited, Inherited}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->12]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SubObjectNameClosed"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{27, 4}, {1, 10}},
    PrivateCellOptions->{"DefaultCellGroupOpen"->False},
    CellGroupingRules->{"SectionGrouping", 90},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->14,
    FontWeight->"Bold"],
  
  Cell[StyleData["SubObjectNameClosed", "Presentation"],
    FontSize->21],
  
  Cell[StyleData["SubObjectNameClosed", "SlideShow"],
    CellMargins->{{72, 4}, {1, 14}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["SubObjectNameClosed", "Printout"],
    CellMargins->{{2, 0}, {1, 10}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->12]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SubObjectName"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{27, 4}, {1, 10}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->18,
    FontWeight->"Bold"],
  
  Cell[StyleData["SubObjectName", "Presentation"],
    FontSize->24],
  
  Cell[StyleData["SubObjectName", "SlideShow"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{90, 4}, {1, 14}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontFamily->"Courier",
    FontSize->12],
  
  Cell[StyleData["SubObjectName", "Printout"],
    CellMargins->{{2, 0}, {1, 10}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontFamily->"Courier",
    FontSize->12]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["GroupObjectName"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{27, 4}, {0, 14}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->18,
    FontWeight->"Bold"],
  
  Cell[StyleData["GroupObjectName", "Presentation"],
    FontSize->24],
  
  Cell[StyleData["GroupObjectName", "SlideShow"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{72, 10}, {2, 12}},
    CellGroupingRules->{"SectionGrouping", 70},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    ParagraphIndent->-27,
    CounterIncrements->"Outline2",
    FontFamily->"Courier",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["GroupObjectName", "Printout"],
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["GroupObjectNameClosed"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{27, 4}, {0, 14}},
    PrivateCellOptions->{"DefaultCellGroupOpen"->False},
    CellGroupingRules->{"SectionGrouping", 80},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->18,
    FontWeight->"Bold"],
  
  Cell[StyleData["GroupObjectNameClosed", "Presentation"],
    FontSize->24],
  
  Cell[StyleData["GroupObjectNameClosed", "SlideShow"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{72, 10}, {2, 12}},
    CellGroupingRules->{"SectionGrouping", 70},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    ParagraphIndent->-27,
    CounterIncrements->"Outline2",
    FontFamily->"Courier",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["GroupObjectNameClosed", "Printout"],
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ObjectNameWarningMessages"],
    CellMargins->{{27, 4}, {1, 10}},
    CellGroupingRules->{"SectionGrouping", 65},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->18,
    FontWeight->"Bold"],
  
  Cell[StyleData["ObjectNameWarningMessages", "Presentation"],
    FontSize->24],
  
  Cell[StyleData["ObjectNameWarningMessages", "SlideShow"],
    CellMargins->{{10, 4}, {1, 10}},
    CellGroupingRules->{"SectionGrouping", 65},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontFamily->"Courier",
    FontSize->16,
    FontWeight->"Bold"],
  
  Cell[StyleData["ObjectNameWarningMessages", "Printout"],
    CellMargins->{{2, 0}, {1, 10}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->12]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Command"],
    CellFrame->{{0, 0}, {0.5, 0}},
    CellMargins->{{0, 0}, {0, 0}},
    CellFrameMargins->{{27, 12}, {3, 15}},
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    CounterIncrements->"Section",
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->18,
    FontWeight->"Bold",
    Background->RGBColor[0.960784, 0.878431, 0.666667]],
  
  Cell[StyleData["Command", "Presentation"],
    FontSize->24],
  
  Cell[StyleData["Command", "Printout"],
    CellMargins->{{0, 0}, {0, 14}},
    PageBreakBelow->False,
    CellFrameMargins->{{24, 8}, {Inherited, Inherited}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["CharacterName"],
    CellFrame->{{0, 0}, {0.5, 0}},
    CellMargins->{{0, 0}, {0, 0}},
    CellFrameMargins->{{27, 27}, {8, 8}},
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216]],
  
  Cell[StyleData["CharacterName", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["CharacterName", "SlideShow"],
    CellMargins->{{72, 4}, {1, 14}},
    CellGroupingRules->{"SectionGrouping", 90},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["CharacterName", "Printout"],
    CellMargins->{{2, 0}, {0, 4}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Usage"],
    CellFrame->{{0, 0}, {0.5, 0}},
    CellMargins->{{0, 0}, {0, 0}},
    CellFrameMargins->{{27, 27}, {8, 8}},
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    Hyphenation->False,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    ParagraphSpacing->{0, 6},
    ParagraphIndent->-10,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216]],
  
  Cell[StyleData["Usage", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Usage", "SlideShow"],
    CellFrame->{{0, 0}, {0.5, 0.5}},
    CellMargins->{{72, 4}, {0, 4}},
    CellFrameMargins->5,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    ParagraphSpacing->{0, 6},
    ParagraphIndent->-10,
    StyleMenuListing->None],
  
  Cell[StyleData["Usage", "Printout"],
    CellMargins->{{0, 0}, {0, 0}},
    CellFrameMargins->{{24, 8}, {Inherited, Inherited}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontSize->10,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ErrorMessage"],
    CellFrame->{{0, 0}, {0.5, 0.5}},
    ShowCellBracket->True,
    CellMargins->{{27, 4}, {0, 4}},
    CellGroupingRules->"OutputGrouping",
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
    CellFrameMargins->5,
    DefaultFormatType->DefaultOutputFormatType,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FormatType->InputForm,
    StyleMenuListing->None,
    FontColor->RGBColor[0, 0, 1]],
  
  Cell[StyleData["ErrorMessage", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ErrorMessage", "SlideShow"],
    CellMargins->{{72, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None],
  
  Cell[StyleData["ErrorMessage", "Printout"],
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->9,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Notes"],
    CellMargins->{{27, 27}, {0, 8}},
    CellHorizontalScrolling->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    ParagraphSpacing->{0, 6},
    ParagraphIndent->-10,
    StyleMenuListing->None,
    FontFamily->"Times"],
  
  Cell[StyleData["Notes", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Notes", "SlideShow"],
    CellMargins->{{72, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    ParagraphSpacing->{0, 6},
    ParagraphIndent->-10,
    StyleMenuListing->None,
    FontFamily->"Times"],
  
  Cell[StyleData["Notes", "Printout"],
    CellMargins->{{24, 0}, {0, 8}},
    Hyphenation->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["NotesList"],
    CellMargins->{{20, 4}, {2, 8}},
    CellHorizontalScrolling->True,
    ScriptLevel->1,
    SingleLetterItalics->True,
    StyleMenuListing->None,
    FontFamily->"Times"],
  
  Cell[StyleData["NotesList", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["NotesList", "SlideShow"],
    CellMargins->{{82, 4}, {2, 8}},
    CellHorizontalScrolling->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    ScriptLevel->1,
    SingleLetterItalics->True,
    StyleMenuListing->None,
    FontFamily->"Times"],
  
  Cell[StyleData["NotesList", "Printout"],
    CellMargins->{{12, 0}, {2, 8}},
    Hyphenation->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ReferenceSection"],
    CellFrame->{{0, 0}, {0, 0.5}},
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{27, 4}, {0, 10}},
    CellGroupingRules->{"SectionGrouping", 30},
    CellFrameMargins->12,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Bold"],
  
  Cell[StyleData["ReferenceSection", "Presentation"],
    FontSize->20],
  
  Cell[StyleData["ReferenceSection", "Printout"],
    CellMargins->{{3, 0}, {0, 10}},
    PageBreakBelow->False,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->9,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Reference"],
    CellMargins->{{27, 27}, {0, 8}},
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    ParagraphSpacing->{0, 8},
    CounterIncrements->"Reference",
    FontSize->12],
  
  Cell[StyleData["Reference", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Reference", "SlideShow"],
    CellMargins->{{27, 27}, {4, 4}},
    Hyphenation->False,
    FontSize->14],
  
  Cell[StyleData["Reference", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    Hyphenation->True,
    FontSize->10],
  
  Cell[StyleData["Reference", "EnhancedPrintout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["Reference", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ExampleSection"],
    CellFrame->{{0, 0}, {0, 0.5}},
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{27, 4}, {0, 10}},
    CellGroupingRules->{"SectionGrouping", 70},
    CellFrameMargins->12,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Bold"],
  
  Cell[StyleData["ExampleSection", "Presentation"],
    FontSize->20],
  
  Cell[StyleData["ExampleSection", "Printout"],
    CellMargins->{{3, 0}, {0, 10}},
    PageBreakBelow->False,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->9,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ExampleText"],
    CellMargins->{{27, 40}, {0, 18}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    ParagraphSpacing->{0, 6},
    StyleMenuListing->None,
    FontColor->RGBColor[0, 0, 0.4]],
  
  Cell[StyleData["ExampleText", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ExampleText", "Printout"],
    CellMargins->{{2, 80}, {0, 8}},
    PageBreakBelow->False,
    Hyphenation->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->8,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ExampleSubsection"],
    ShowCellBracket->True,
    CellMargins->{{27, 4}, {0, 16}},
    CellGroupingRules->{"SectionGrouping", 80},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10,
    FontWeight->"Bold"],
  
  Cell[StyleData["ExampleSubsection", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["ExampleSubsection", "Printout"],
    CellMargins->{{12, 0}, {0, 16}},
    PageBreakBelow->False,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->7]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MessagesSection"],
    CellFrame->{{0, 0}, {0, 0.5}},
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{27, 4}, {0, 10}},
    CellGroupingRules->{"SectionGrouping", 70},
    CellFrameMargins->12,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Bold"],
  
  Cell[StyleData["MessagesSection", "Presentation"],
    FontSize->20],
  
  Cell[StyleData["MessagesSection", "Printout"],
    CellMargins->{{3, 0}, {0, 10}},
    PageBreakBelow->False,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->9,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TemplateSection"],
    CellFrame->{{0, 0}, {0, 0.5}},
    CellMargins->{{27, 4}, {0, 10}},
    PrivateCellOptions->{"DefaultCellGroupOpen"->True},
    CellGroupingRules->{"SectionGrouping", 70},
    CellFrameMargins->12,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Bold"],
  
  Cell[StyleData["TemplateSection", "Presentation"],
    FontSize->20],
  
  Cell[StyleData["TemplateSection", "Printout"],
    CellMargins->{{3, 0}, {0, 10}},
    PageBreakBelow->False,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->9,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["LineHead"],
    CellFrame->{{0, 0}, {0.5, 0}},
    CellMargins->{{27, 4}, {8, 18}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    CounterIncrements->"Subsection",
    CounterAssignments->{{"Subsubsection", 0}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["LineHead", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["LineHead", "Printout"],
    CellMargins->{{2, 0}, {8, 18}},
    PageBreakBelow->False,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FlushInput"],
    CellMargins->{{27, 4}, {1, 4}},
    Evaluatable->True,
    CellGroupingRules->"InputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    CellLabelAutoDelete->False,
    CellLabelMargins->{{23, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultInputFormatType,
    ShowSpecialCharacters->Automatic,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FormatType->StandardForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["FlushInput", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["FlushInput", "Printout"],
    CellMargins->{{2, 0}, {1, 4}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FlushOutput"],
    CellMargins->{{27, Inherited}, {Inherited, Inherited}},
    CellEditDuplicate->True,
    CellGroupingRules->"OutputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    CellLabelAutoDelete->False,
    CellLabelMargins->{{23, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultOutputFormatType,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FormatType->StandardForm,
    StyleMenuListing->None],
  
  Cell[StyleData["FlushOutput", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["FlushOutput", "Printout"],
    CellMargins->{{2, Inherited}, {Inherited, Inherited}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DialogItem"],
    CellDingbat->"\[EmptyDiamond]",
    CellMargins->{{27, 4}, {0, 12}},
    CellGroupingRules->{"SectionGrouping", 70},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10,
    FontWeight->"Bold"],
  
  Cell[StyleData["DialogItem", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["DialogItem", "Printout"],
    CellMargins->{{12, 0}, {0, 12}},
    PageBreakBelow->False,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["GroupDivider"],
    CellMargins->{{27, Inherited}, {Inherited, Inherited}},
    CellEditDuplicate->True,
    CellGroupingRules->{"TitleGrouping", 0},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None],
  
  Cell[StyleData["GroupDivider", "Presentation"],
    FontSize->18]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Highlight"],
    CellFrame->0.5,
    CellMargins->{{27, 4}, {0, 18}},
    CellFrameColor->GrayLevel[0.800015],
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->12,
    Background->GrayLevel[0.950011]],
  
  Cell[StyleData["Highlight", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Highlight", "Printout"],
    CellMargins->{{2, 0}, {0, 18}},
    Hyphenation->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    LineSpacing->{1, 3},
    FontSize->8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["UserNotes"],
    CellFrame->{{3, 0}, {0, 0}},
    CellMargins->{{27, 4}, {0, 8}},
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    ParagraphIndent->-7,
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10],
  
  Cell[StyleData["UserNotes", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["UserNotes", "Printout"],
    CellMargins->{{2, 0}, {0, 4}},
    Hyphenation->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    LineSpacing->{1, 3},
    FontSize->8],
  
  Cell[StyleData["UserNotes", "EnhancedPrintout"],
    CellMargins->{{0, 0}, {0, 4}},
    Hyphenation->True,
    LineSpacing->{1, 3},
    FontFamily->"Frutiger 55 Roman",
    FontSize->8],
  
  Cell[StyleData["UserNotes", "EnhancedPrintoutNonGray"],
    CellMargins->{{0, 0}, {0, 4}},
    Hyphenation->True,
    LineSpacing->{1, 3},
    FontFamily->"Frutiger 55 Roman",
    FontSize->8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MoreInfo"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    ParagraphIndent->-7,
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10,
    Background->RGBColor[0.964706, 0.929412, 0.839216]],
  
  Cell[StyleData["MoreInfo", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["MoreInfo", "Printout"],
    CellMargins->{{2, 0}, {0, 4}},
    Hyphenation->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    LineSpacing->{1, 3},
    FontSize->8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["UserTips"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    ParagraphIndent->-7,
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10,
    Background->RGBColor[0.964706, 0.929412, 0.839216]],
  
  Cell[StyleData["UserTips", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["UserTips", "Printout"],
    CellMargins->{{2, 0}, {0, 4}},
    CellFrameColor->GrayLevel[0.800015],
    Hyphenation->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    LineSpacing->{1, 3},
    FontSize->8,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["UserTips", "EnhancedPrintout"],
    CellMargins->{{0, 0}, {0, 4}},
    CellFrameColor->GrayLevel[0],
    Hyphenation->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    LineSpacing->{1, 3},
    FontFamily->"Frutiger 55 Roman",
    FontSize->8,
    Background->GrayLevel[0.700008]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Theorem"],
    CellFrame->{{4, 0}, {0, 0}},
    CellMargins->{{27, 62}, {0, 14}},
    CellFrameMargins->4,
    CellFrameColor->RGBColor[0, 0, 0.8],
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    LineSpacing->{1, 1},
    ParagraphSpacing->{0, 8}],
  
  Cell[StyleData["Theorem", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Theorem", "Printout"],
    CellMargins->{{2, 0}, {0, 14}},
    CellFrameMargins->3,
    CellFrameColor->GrayLevel[0.8],
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->9,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Commentary"],
    CellFrame->{{2, 0}, {0, 0}},
    CellMargins->{{36, 10}, {7, 7}},
    PageBreakBelow->False,
    CellFrameMargins->8,
    CellFrameColor->RGBColor[0, 0.2, 1],
    LineSpacing->{1, 3},
    FontSlant->"Italic"],
  
  Cell[StyleData["Commentary", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Commentary", "Printout"],
    CellMargins->{{36, 0}, {6, 6}},
    CellFrameColor->GrayLevel[0.8],
    FontSize->10],
  
  Cell[StyleData["Commentary", "EnhancedPrintout"],
    CellMargins->{{36, 0}, {6, 6}},
    CellFrameColor->GrayLevel[0.8],
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["Commentary", "EnhancedPrintoutNonGray"],
    CellMargins->{{36, 0}, {6, 6}},
    CellFrameColor->GrayLevel[0.8],
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Level1Icon"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{48, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    ParagraphSpacing->{0, 8},
    StyleMenuListing->None],
  
  Cell[StyleData["Level1Icon", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Level1Icon", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Level2Icon"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{48, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    ParagraphSpacing->{0, 8},
    StyleMenuListing->None],
  
  Cell[StyleData["Level2Icon", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Level2Icon", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    HyphenationOptions->{"HyphenationCharacter"->"-"},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["CopyrightHead"],
    CellMargins->{{27, 4}, {0, 8}},
    PageBreakAbove->False,
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["CopyrightHead", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["CopyrightHead", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Copyright"],
    CellMargins->{{27, 4}, {0, 8}},
    PageBreakAbove->False,
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10],
  
  Cell[StyleData["Copyright", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["Copyright", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    FontSize->8],
  
  Cell[StyleData["Copyright", "EnhancedPrintout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    FontFamily->"Frutiger 55 Roman",
    FontSize->7]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["RegisterSubsection"],
    CellDingbat->None,
    CellMargins->{{27, 27}, {0, 18}},
    CellElementSpacings->{"ClosedGroupTopMargin"->18},
    CellGroupingRules->{"SectionGrouping", 45},
    CellFrameLabelMargins->6,
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    FontFamily->"Helvetica",
    FontSize->16],
  
  Cell[StyleData["RegisterSubsection", "Presentation"],
    FontSize->24],
  
  Cell[StyleData["RegisterSubsection", "SlideShow"],
    CellDingbat->None,
    CellMargins->{{70, 0}, {4, 12}},
    FontSize->12],
  
  Cell[StyleData["RegisterSubsection", "Printout"],
    CellMargins->{{9, 0}, {5, 24}},
    FontSize->12],
  
  Cell[StyleData["RegisterSubsection", "EnhancedPrintout"],
    CellMargins->{{9, 0}, {5, 20}},
    FontFamily->"Frutiger 55 Roman",
    FontSize->12],
  
  Cell[StyleData["RegisterSubsection", "EnhancedPrintoutNonGray"],
    CellMargins->{{9, 0}, {5, 20}},
    FontFamily->"Frutiger 55 Roman",
    FontSize->12]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["RegisterSubsubsection"],
    CellMargins->{{27, 27}, {0, 18}},
    CellElementSpacings->{"ClosedGroupTopMargin"->18},
    CellGroupingRules->{"SectionGrouping", 50},
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    FontColor->RGBColor[0.592157, 0.313726, 0.313726]],
  
  Cell[StyleData["RegisterSubsubsection", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["RegisterSubsubsection", "Printout"],
    CellMargins->{{2, 0}, {3, 8}},
    FontSize->10],
  
  Cell[StyleData["RegisterSubsubsection", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {3, 8}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->10,
    FontWeight->"Plain",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["RegisterSubsubsection", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {3, 8}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->10,
    FontWeight->"Plain",
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["RegisterText"],
    CellMargins->{{27, 4}, {0, 8}},
    PageBreakAbove->False,
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["RegisterText", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["RegisterText", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    FontSize->8],
  
  Cell[StyleData["RegisterText", "EnhancedPrintout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    FontFamily->"Palatino",
    FontSize->7]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["CaptionHead"],
    CellMargins->{{27, 4}, {0, 8}},
    PageBreakAbove->False,
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["CaptionHead", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["CaptionHead", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    FontSize->8],
  
  Cell[StyleData["CaptionHead", "EnhancedPrintout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    FontFamily->"Palatino",
    FontSize->7]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["CaptionText"],
    CellMargins->{{66, 4}, {0, 8}},
    PageBreakAbove->False,
    StyleMenuListing->None],
  
  Cell[StyleData["CaptionText", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["CaptionText", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    FontSize->8],
  
  Cell[StyleData["CaptionText", "EnhancedPrintout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    FontFamily->"Palatino",
    FontSize->7]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["BulletText"],
    CellMargins->{{76, 4}, {4, 4}},
    CellFrameLabels->{{
      Cell[ "\[Bullet]", "BulletText", CellBaseline -> Baseline], 
          Inherited}, {Inherited, Inherited}},
    Hyphenation->False,
    LineSpacing->{1, 3},
    CounterIncrements->"BulletText",
    StyleMenuListing->None],
  
  Cell[StyleData["BulletText", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["BulletText", "Printout"],
    FontSize->10],
  
  Cell[StyleData["BulletText", "EnhancedPrintout"],
    CellMargins->{{16, 4}, {2, 4}},
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["BulletText", "EnhancedPrintoutNonGray"],
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["HelpLabels"],
    CellMargins->{{88, 4}, {0, 8}},
    StyleMenuListing->None],
  
  Cell[StyleData["HelpLabels", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["HelpLabels", "Printout"],
    CellMargins->{{34, 2}, {6, 6}},
    FontSize->10],
  
  Cell[StyleData["HelpLabels", "EnhancedPrintout"],
    CellMargins->{{34, 2}, {6, 6}},
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell["Manual.nb Merge", "Subsection"],
  
  Cell[CellGroupData[{
  
  Cell["Function List", "Subsubsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FunctionName"],
    CellDingbat->"\[FilledSquare]",
    CellMargins->{{24, 10}, {10, 12}},
    CellGroupingRules->{"SectionGrouping", 40},
    PageBreakBelow->False,
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->14,
    FontWeight->"Bold",
    CellTags->"FunctionName"],
  
  Cell[StyleData["FunctionName", "Presentation"],
    FontSize->21],
  
  Cell[StyleData["FunctionName", "Printout"],
    CellMargins->{{9, 0}, {10, 10}},
    FontSize->12],
  
  Cell[StyleData["FunctionName", "EnhancedPrintout"],
    CellMargins->{{9, 0}, {10, 10}},
    FontFamily->"Courier",
    FontSize->12],
  
  Cell[StyleData["FunctionName", "EnhancedPrintoutNonGray"],
    CellMargins->{{9, 0}, {10, 10}},
    FontFamily->"Courier",
    FontSize->12]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FunctionSubsection"],
    CellDingbat->"\[FilledSquare]",
    CellMargins->{{36, 10}, {0, 6}},
    CellGroupingRules->{"SectionGrouping", 60},
    PageBreakBelow->False,
    StyleMenuListing->None,
    FontWeight->"Bold",
    CellTags->"FunctionSubsection"],
  
  Cell[StyleData["FunctionSubsection", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["FunctionSubsection", "Printout"],
    CellMargins->{{30, 0}, {0, 6}}],
  
  Cell[StyleData["FunctionSubsection", "EnhancedPrintout"],
    CellMargins->{{30, 0}, {0, 6}},
    FontFamily->"Palatino",
    FontSize->11],
  
  Cell[StyleData["FunctionSubsection", "EnhancedPrintoutNonGray"],
    CellMargins->{{30, 0}, {0, 6}},
    FontFamily->"Palatino",
    FontSize->11]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FunctionDescription"],
    CellMargins->{{36, 10}, {4, 0}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0.7, 0},
    CounterIncrements->"FunctionDescription",
    StyleMenuListing->None,
    FontWeight->"Plain"],
  
  Cell[StyleData["FunctionDescription", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["FunctionDescription", "Printout"],
    CellMargins->{{30, 0}, {4, 0}},
    FontSize->11],
  
  Cell[StyleData["FunctionDescription", "EnhancedPrintout"],
    CellMargins->{{30, 0}, {4, 0}},
    TextJustification->0,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["FunctionDescription", "EnhancedPrintoutNonGray"],
    CellMargins->{{30, 0}, {4, 0}},
    TextJustification->0,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FunctionDescriptionRuled"],
    CellFrame->{{0, 0}, {0.25, 0.25}},
    CellMargins->{{36, 10}, {4, 0}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0.7, 0},
    CounterIncrements->"FunctionDescriptionRuled",
    StyleMenuListing->None],
  
  Cell[StyleData["FunctionDescriptionRuled", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["FunctionDescriptionRuled", "Printout"],
    CellMargins->{{30, 0}, {4, 0}},
    FontSize->11],
  
  Cell[StyleData["FunctionDescriptionRuled", "EnhancedPrintout"],
    CellMargins->{{30, 0}, {4, 0}},
    TextJustification->0,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["FunctionDescriptionRuled", "EnhancedPrintoutNonGray"],
    CellMargins->{{30, 0}, {4, 0}},
    TextJustification->0,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FunctionDescriptionRuleTop"],
    CellFrame->{{0, 0}, {0, 0.25}},
    CellMargins->{{36, 10}, {4, 0}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0.7, 0},
    CounterIncrements->"FunctionDescriptionRuleTop",
    StyleMenuListing->None],
  
  Cell[StyleData["FunctionDescriptionRuleTop", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["FunctionDescriptionRuleTop", "Printout"],
    CellMargins->{{30, 0}, {4, 0}},
    FontSize->11],
  
  Cell[StyleData["FunctionDescriptionRuleTop", "EnhancedPrintout"],
    CellMargins->{{30, 0}, {4, 0}},
    TextJustification->0,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["FunctionDescriptionRuleTop", "EnhancedPrintoutNonGray"],
    CellMargins->{{30, 0}, {4, 0}},
    TextJustification->0,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FunctionDescriptionRuleBottom"],
    CellFrame->{{0, 0}, {0.25, 0}},
    CellMargins->{{36, 10}, {4, 0}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0.7, 0},
    CounterIncrements->"FunctionDescriptionRuleBottom",
    StyleMenuListing->None],
  
  Cell[StyleData["FunctionDescriptionRuleBottom", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["FunctionDescriptionRuleBottom", "Printout"],
    CellMargins->{{30, 0}, {4, 0}},
    FontSize->11],
  
  Cell[StyleData["FunctionDescriptionRuleBottom", "EnhancedPrintout"],
    CellMargins->{{30, 0}, {4, 0}},
    TextJustification->0,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["FunctionDescriptionRuleBottom", "EnhancedPrintoutNonGray"],
    CellMargins->{{30, 0}, {4, 0}},
    TextJustification->0,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FunctionExample"],
    CellMargins->{{36, 10}, {4, 0}},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["FunctionExample", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["FunctionExample", "Printout"],
    CellMargins->{{30, 0}, {4, 0}},
    FontSize->9],
  
  Cell[StyleData["FunctionExample", "EnhancedPrintout"],
    CellMargins->{{30, 0}, {4, 0}},
    FontFamily->"Palatino",
    FontSize->9],
  
  Cell[StyleData["FunctionExample", "EnhancedPrintoutNonGray"],
    CellMargins->{{30, 0}, {4, 0}},
    FontFamily->"Palatino",
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FunctionTextNote"],
    CellMargins->{{36, 4}, {0, 4}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0, 4},
    LineIndent->0,
    StyleMenuListing->None],
  
  Cell[StyleData["FunctionTextNote", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["FunctionTextNote", "Printout"],
    CellMargins->{{36, 4}, {0, 4}},
    FontSize->9],
  
  Cell[StyleData["FunctionTextNote", "EnhancedPrintout"],
    CellMargins->{{36, 4}, {0, 4}},
    FontFamily->"Palatino",
    FontSize->8],
  
  Cell[StyleData["FunctionTextNote", "EnhancedPrintoutNonGray"],
    CellMargins->{{36, 4}, {0, 4}},
    FontFamily->"Palatino",
    FontSize->8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["3ColumnFunctionTable"],
    CellMargins->{{36, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->2,
    ColumnWidths->{0.28, 0.28, 0.43},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["3ColumnFunctionTable", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["3ColumnFunctionTable", "Printout"],
    CellMargins->{{30, 0}, {0, 8}},
    FontSize->10],
  
  Cell[StyleData["3ColumnFunctionTable", "EnhancedPrintout"],
    CellMargins->{{30, 0}, {0, 8}},
    FontSize->10],
  
  Cell[StyleData["3ColumnFunctionTable", "EnhancedPrintoutNonGray"],
    CellMargins->{{30, 0}, {0, 8}},
    FontSize->10]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Browser Emulation", "Subsubsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TextNormal"],
    CellMargins->{{12, 10}, {7, 7}},
    LineSpacing->{1, 3},
    CounterIncrements->"TextNormal",
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->12],
  
  Cell[StyleData["TextNormal", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TextNormal", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["BrowserEmulation"],
    CellMargins->{{12, 1}, {7, 24}},
    CellGroupingRules->{"SectionGrouping", 70},
    LineSpacing->{1, 3},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    GridBoxOptions->{ColumnWidths->0.25,
    ColumnAlignments->{Left},
    GridFrame->True,
    GridFrameMargins->0.5,
    ColumnLines->True}],
  
  Cell[StyleData["BrowserEmulation", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["BrowserEmulation", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["CategoryDefs"],
    CellMargins->{{300, 10}, {7, 7}},
    LineSpacing->{1, 3},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    Background->RGBColor[1, 0.8, 0.6],
    GridBoxOptions->{ColumnAlignments->{Left},
    GridFrame->False,
    RowLines->True,
    ColumnLines->True}],
  
  Cell[StyleData["CategoryDefs", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["CategoryDefs", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Category1"],
    ShowCellBracket->False,
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{12, 10}, {7, 7}},
    CellGroupingRules->{"SectionGrouping", 50},
    StyleMenuListing->None,
    FontSize->16,
    FontWeight->"Bold"],
  
  Cell[StyleData["Category1", "Presentation"],
    FontSize->24],
  
  Cell[StyleData["Category1", "Printout"],
    CellMargins->{{2, 2}, {6, 6}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Category2"],
    ShowCellBracket->False,
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{85, 10}, {7, 7}},
    CellGroupingRules->{"SectionGrouping", 60},
    StyleMenuListing->None,
    FontSize->14,
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0, 0.500008]],
  
  Cell[StyleData["Category2", "Presentation"],
    FontSize->21],
  
  Cell[StyleData["Category2", "Printout"],
    CellMargins->{{2, 2}, {6, 6}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Category3"],
    ShowCellBracket->False,
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{157, 10}, {7, 7}},
    CellGroupingRules->{"SectionGrouping", 70},
    StyleMenuListing->None,
    FontSize->12,
    FontWeight->"Bold",
    FontColor->RGBColor[0.2, 0, 0.4]],
  
  Cell[StyleData["Category3", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Category3", "Printout"],
    CellMargins->{{2, 2}, {6, 6}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Category4"],
    ShowCellBracket->False,
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{230, 10}, {7, 7}},
    CellGroupingRules->{"SectionGrouping", 80},
    StyleMenuListing->None,
    FontWeight->"Bold",
    FontColor->RGBColor[0, 0.300008, 0.4]],
  
  Cell[StyleData["Category4", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Category4", "Printout"],
    CellMargins->{{2, 2}, {6, 6}}]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Misc", "Subsubsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["4ColumnTable"],
    CellMargins->{{10, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->2,
    ColumnWidths->0.25,
    ColumnAlignments->{Left, Center}}],
  
  Cell[StyleData["4ColumnTable", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["4ColumnTable", "Printout"],
    CellMargins->{{2, 0}, {0, 8}}],
  
  Cell[StyleData["4ColumnTable", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}}],
  
  Cell[StyleData["4ColumnTable", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["5ColumnTable"],
    CellMargins->{{10, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->2,
    ColumnWidths->0.2,
    ColumnAlignments->{Left, Center}}],
  
  Cell[StyleData["5ColumnTable", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["5ColumnTable", "Printout"],
    CellMargins->{{2, 0}, {0, 8}}],
  
  Cell[StyleData["5ColumnTable", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}}],
  
  Cell[StyleData["5ColumnTable", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["6ColumnTable"],
    CellMargins->{{10, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->2,
    ColumnWidths->0.16,
    ColumnAlignments->{Left, Center}}],
  
  Cell[StyleData["6ColumnTable", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["6ColumnTable", "Printout"],
    CellMargins->{{2, 0}, {0, 8}}],
  
  Cell[StyleData["6ColumnTable", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}}],
  
  Cell[StyleData["6ColumnTable", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["7ColumnTable"],
    CellMargins->{{10, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->2,
    ColumnWidths->0.14,
    ColumnAlignments->{Left, Center}}],
  
  Cell[StyleData["7ColumnTable", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["7ColumnTable", "Printout"],
    CellMargins->{{2, 0}, {0, 8}}],
  
  Cell[StyleData["7ColumnTable", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}}],
  
  Cell[StyleData["7ColumnTable", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["8ColumnTable"],
    CellMargins->{{10, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->2,
    ColumnWidths->0.12,
    ColumnAlignments->{Left, Center}}],
  
  Cell[StyleData["8ColumnTable", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["8ColumnTable", "Printout"],
    CellMargins->{{2, 0}, {0, 8}}],
  
  Cell[StyleData["8ColumnTable", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}}],
  
  Cell[StyleData["8ColumnTable", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ABItemizedText"],
    CellMargins->{{20, 4}, {0, 5}},
    LineSpacing->{1, 3},
    ParagraphIndent->-21,
    CounterIncrements->"ItemizedText",
    StyleMenuListing->None],
  
  Cell[StyleData["ABItemizedText", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ABItemizedText", "Printout"],
    Hyphenation->True,
    ParagraphIndent->-21,
    FontSize->11],
  
  Cell[StyleData["ABItemizedText", "EnhancedPrintout"],
    Hyphenation->True,
    ParagraphIndent->-21,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["ABItemizedText", "EnhancedPrintoutNonGray"],
    Hyphenation->True,
    ParagraphIndent->-21,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ChapNumber"],
    CellMargins->{{27, Inherited}, {20, 40}},
    CellGroupingRules->{"TitleGrouping", 0},
    PageBreakBelow->False,
    DefaultNewInlineCellStyle->"None",
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    LanguageCategory->"NaturalLanguage",
    CounterIncrements->"Title",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
        "Subtitle", 0}, {"Subsubtitle", 0}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->42,
    FontWeight->"Plain",
    FontColor->RGBColor[0.592157, 0.313726, 0.313726]],
  
  Cell[StyleData["ChapNumber", "Presentation"],
    FontSize->63],
  
  Cell[StyleData["ChapNumber", "Printout"],
    CellMargins->{{2, 10}, {15, 30}},
    FontSize->36],
  
  Cell[StyleData["ChapNumber", "EnhancedPrintout"],
    CellMargins->{{2, 10}, {15, 30}},
    FontFamily->"Frutiger 55 Roman",
    FontSize->36,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["ChapNumber", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 10}, {15, 30}},
    FontFamily->"Frutiger 55 Roman",
    FontSize->36,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ChapTitle"],
    CellMargins->{{27, Inherited}, {80, 10}},
    CellGroupingRules->{"TitleGrouping", 0},
    PageBreakBelow->False,
    DefaultNewInlineCellStyle->"None",
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    LanguageCategory->"NaturalLanguage",
    CounterIncrements->"Title",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
        "Subtitle", 0}, {"Subsubtitle", 0}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->36,
    FontWeight->"Bold",
    FontColor->RGBColor[0.592157, 0.313726, 0.313726]],
  
  Cell[StyleData["ChapTitle", "Presentation"],
    FontSize->54],
  
  Cell[StyleData["ChapTitle", "Printout"],
    CellMargins->{{2, 10}, {80, 6}},
    FontSize->30],
  
  Cell[StyleData["ChapTitle", "EnhancedPrintout"],
    CellMargins->{{2, 10}, {80, 6}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->30,
    FontWeight->"Plain",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["ChapTitle", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 10}, {80, 6}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->30,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemDingbat"],
    CellSize->{22, 14},
    TextAlignment->Right,
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["ItemDingbat", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemDingbat", "Printout"],
    CellSize->{22, 13.125}],
  
  Cell[StyleData["ItemDingbat", "EnhancedPrintout"],
    CellSize->{22, 11}],
  
  Cell[StyleData["ItemDingbat", "EnhancedPrintoutNonGray"],
    CellSize->{22, 11}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item1"],
    CellMargins->{{19, 4}, {4, 4}},
    ParagraphIndent->-22,
    CounterIncrements->"Item1",
    StyleMenuListing->None],
  
  Cell[StyleData["Item1", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Item1", "Printout"],
    CellMargins->{{12, 0}, {2, 4}},
    FontSize->10],
  
  Cell[StyleData["Item1", "EnhancedPrintout"],
    CellMargins->{{16, 0}, {2, 4}},
    FontSize->10],
  
  Cell[StyleData["Item1", "EnhancedPrintoutNonGray"],
    CellMargins->{{16, 0}, {2, 4}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item1Continued"],
    CellMargins->{{41, 4}, {4, 1}},
    CounterIncrements->"Item1Continued",
    StyleMenuListing->None],
  
  Cell[StyleData["Item1Continued", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Item1Continued", "Printout"],
    CellMargins->{{34, 0}, {4, 1}},
    FontSize->10],
  
  Cell[StyleData["Item1Continued", "EnhancedPrintout"],
    CellMargins->{{39, 0}, {4, 1}},
    FontSize->10],
  
  Cell[StyleData["Item1Continued", "EnhancedPrintoutNonGray"],
    CellMargins->{{39, 0}, {4, 1}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item2"],
    CellMargins->{{32, 4}, {4, 4}},
    ParagraphIndent->-22,
    CounterIncrements->"Item2",
    StyleMenuListing->None],
  
  Cell[StyleData["Item2", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Item2", "Printout"],
    CellMargins->{{26, 0}, {4, 4}},
    ParagraphIndent->-22,
    FontSize->10],
  
  Cell[StyleData["Item2", "EnhancedPrintout"],
    CellMargins->{{29, 0}, {2, 4}},
    ParagraphIndent->-22,
    FontSize->10],
  
  Cell[StyleData["Item2", "EnhancedPrintoutNonGray"],
    CellMargins->{{29, 0}, {2, 4}},
    ParagraphIndent->-22,
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item2Continued"],
    CellMargins->{{54, 4}, {4, 1}},
    CounterIncrements->"Item2Continued",
    StyleMenuListing->None],
  
  Cell[StyleData["Item2Continued", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Item2Continued", "Printout"],
    CellMargins->{{27, 0}, {4, 1}}],
  
  Cell[StyleData["Item2Continued", "EnhancedPrintout"],
    CellMargins->{{52, 0}, {4, 1}},
    FontSize->10],
  
  Cell[StyleData["Item2Continued", "EnhancedPrintoutNonGray"],
    CellMargins->{{52, 0}, {4, 1}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item3"],
    CellMargins->{{45, 4}, {4, 4}},
    ParagraphIndent->-23,
    CounterIncrements->"Item3",
    StyleMenuListing->None],
  
  Cell[StyleData["Item3", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Item3", "Printout"],
    CellMargins->{{27, 0}, {2, 4}}],
  
  Cell[StyleData["Item3", "EnhancedPrintout"],
    CellMargins->{{42, 0}, {2, 4}},
    FontSize->10],
  
  Cell[StyleData["Item3", "EnhancedPrintoutNonGray"],
    CellMargins->{{42, 0}, {2, 4}},
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item3Continued"],
    CellMargins->{{67, 4}, {4, 1}},
    CounterIncrements->"Item3Continued",
    StyleMenuListing->None],
  
  Cell[StyleData["Item3Continued", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Item3Continued", "Printout"],
    CellMargins->{{27, 0}, {4, 1}}],
  
  Cell[StyleData["Item3Continued", "EnhancedPrintout"],
    CellMargins->{{65, 0}, {4, 1}},
    FontSize->10],
  
  Cell[StyleData["Item3Continued", "EnhancedPrintoutNonGray"],
    CellMargins->{{65, 0}, {4, 1}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedBulletText"],
    CellMargins->{{19, 4}, {0, 5}},
    LineSpacing->{1, 3},
    ParagraphIndent->-22,
    CounterIncrements->"ItemizedBulletText",
    StyleMenuListing->None],
  
  Cell[StyleData["ItemizedBulletText", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedBulletText", "Printout"],
    Hyphenation->True,
    ParagraphIndent->-20,
    FontSize->11],
  
  Cell[StyleData["ItemizedBulletText", "EnhancedPrintout"],
    Hyphenation->True,
    ParagraphIndent->-19,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["ItemizedBulletText", "EnhancedPrintoutNonGray"],
    Hyphenation->True,
    ParagraphIndent->-19,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["NoteBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {8, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxMargins->{{1, 1}, {1.5, 1.5}}},
    GridBoxOptions->{ColumnSpacings->1}],
  
  Cell[StyleData["NoteBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["NoteBox", "Printout"],
    CellMargins->{{2, 4}, {6, 2}},
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["NoteBox", "EnhancedPrintout"],
    CellMargins->{{2, 2}, {6, 2}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["NoteBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 4}, {6, 2}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedNoteBox"],
    CellFrame->0.5,
    CellMargins->{{41, 4}, {8, 2}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxMargins->{{1, 1}, {1.5, 1.5}}},
    GridBoxOptions->{ColumnSpacings->1}],
  
  Cell[StyleData["ItemizedNoteBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedNoteBox", "Printout"],
    CellMargins->{{39, 4}, {6, 2}},
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["ItemizedNoteBox", "EnhancedPrintout"],
    CellMargins->{{39, 4}, {6, 2}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["ItemizedNoteBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{39, 4}, {6, 2}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedTopBox"],
    CellFrame->{{0.5, 0.5}, {0, 0.5}},
    CellMargins->{{37, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameMargins->{{8, 8}, {0, 8}},
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.31, 0.62},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["ItemizedTopBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedTopBox", "Printout"],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["ItemizedTopBox", "EnhancedPrintout"],
    CellMargins->{{39, 4}, {0, 6}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["ItemizedTopBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{39, 4}, {0, 6}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedBottomBox"],
    CellFrame->{{0.5, 0.5}, {0.5, 0}},
    CellMargins->{{37, 4}, {4, 0}},
    CellHorizontalScrolling->True,
    CellFrameMargins->{{8, 8}, {8, 0}},
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.31, 0.62},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["ItemizedBottomBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedBottomBox", "Printout"],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["ItemizedBottomBox", "EnhancedPrintout"],
    CellMargins->{{39, 4}, {6, 0}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["ItemizedBottomBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{39, 4}, {6, 0}},
    CellFrameColor->GrayLevel[0],
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MiddleSpacedBox"],
    CellFrame->{{0.5, 0.5}, {0, 0}},
    CellMargins->{{27, 12}, {0, -7}},
    CellHorizontalScrolling->True,
    PageBreakAbove->False,
    PageBreakBelow->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.31, 0.62},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["MiddleSpacedBox", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["MiddleSpacedBox", "Printout"],
    CellMargins->{{2, 0}, {0, 0}},
    Background->GrayLevel[1],
    GridBoxOptions->{RowMinHeight->1.8}],
  
  Cell[StyleData["MiddleSpacedBox", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 0}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    Background->GrayLevel[1],
    GridBoxOptions->{RowMinHeight->1.8}],
  
  Cell[StyleData["MiddleSpacedBox", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 0}},
    CellFrameColor->GrayLevel[0],
    FontFamily->"Palatino",
    Background->GrayLevel[1],
    GridBoxOptions->{RowMinHeight->1.8}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedNote"],
    CellMargins->{{41, 4}, {0, 12}},
    LineSpacing->{1, 2},
    CounterIncrements->"ItemizedNote",
    StyleMenuListing->None],
  
  Cell[StyleData["ItemizedNote", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedNote", "Printout"],
    CellMargins->{{38, 4}, {0, 9}},
    Hyphenation->True,
    FontSize->11],
  
  Cell[StyleData["ItemizedNote", "EnhancedPrintout"],
    CellMargins->{{38, 4}, {0, 0}},
    TextJustification->1,
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["ItemizedNote", "EnhancedPrintoutNonGray"],
    CellMargins->{{38, 4}, {0, 0}},
    TextJustification->1,
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedNoteBelow"],
    CellMargins->{{41, 4}, {0, 8}},
    LineSpacing->{1, 2},
    CounterIncrements->"ItemizedNote",
    StyleMenuListing->None],
  
  Cell[StyleData["ItemizedNoteBelow", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedNoteBelow", "Printout"],
    CellMargins->{{38, 4}, {0, 12}},
    Hyphenation->True,
    FontSize->11],
  
  Cell[StyleData["ItemizedNoteBelow", "EnhancedPrintout"],
    CellMargins->{{38, 4}, {0, 8}},
    TextJustification->1,
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["ItemizedNoteBelow", "EnhancedPrintoutNonGray"],
    CellMargins->{{38, 4}, {0, 8}},
    TextJustification->1,
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedTextBelowPic"],
    CellMargins->{{19, 4}, {0, 8}},
    LineSpacing->{1, 3},
    ParagraphIndent->-22,
    CounterIncrements->"ItemizedText",
    StyleMenuListing->None],
  
  Cell[StyleData["ItemizedTextBelowPic", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedTextBelowPic", "Printout"],
    CellMargins->{{20, 4}, {2, 12}},
    Hyphenation->True,
    ParagraphIndent->-18,
    FontSize->11],
  
  Cell[StyleData["ItemizedTextBelowPic", "EnhancedPrintout"],
    CellMargins->{{20, 4}, {2, 12}},
    Hyphenation->True,
    ParagraphIndent->-17,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["ItemizedTextBelowPic", "EnhancedPrintoutNonGray"],
    CellMargins->{{20, 4}, {2, 12}},
    Hyphenation->True,
    ParagraphIndent->-17,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedTextNote2"],
    CellMargins->{{41, 4}, {0, 4}},
    LineSpacing->{1, 2},
    CounterIncrements->"ItemizedNote",
    StyleMenuListing->None],
  
  Cell[StyleData["ItemizedTextNote2", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemizedTextNote2", "Printout"],
    CellMargins->{{38, 4}, {0, 2}},
    Hyphenation->True,
    FontSize->11],
  
  Cell[StyleData["ItemizedTextNote2", "EnhancedPrintout"],
    CellMargins->{{38, 4}, {0, 2}},
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["ItemizedTextNote2", "EnhancedPrintoutNonGray"],
    CellMargins->{{38, 4}, {0, 2}},
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["NumberedItem1"],
    CellMargins->{{48, 4}, {4, 4}},
    CellGroupingRules->{"SectionGrouping", 15},
    ParagraphIndent->-23,
    CounterIncrements->"NumberedItem1",
    StyleMenuListing->None],
  
  Cell[StyleData["NumberedItem1", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["NumberedItem1", "Printout"],
    CellMargins->{{12, 0}, {0, 8}}],
  
  Cell[StyleData["NumberedItem1", "EnhancedPrintout"],
    CellMargins->{{12, 0}, {0, 8}}],
  
  Cell[StyleData["NumberedItem1", "EnhancedPrintoutNonGray"],
    CellMargins->{{12, 0}, {0, 8}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["NumberedItem2"],
    CellMargins->{{71, 4}, {3, 3}},
    CellGroupingRules->{"SectionGrouping", 15},
    ParagraphIndent->-21,
    CounterIncrements->"NumberedItem2",
    StyleMenuListing->None],
  
  Cell[StyleData["NumberedItem2", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["NumberedItem2", "Printout"],
    CellMargins->{{27, 0}, {0, 4}}],
  
  Cell[StyleData["NumberedItem2", "EnhancedPrintout"],
    CellMargins->{{27, 0}, {0, 4}}],
  
  Cell[StyleData["NumberedItem2", "EnhancedPrintoutNonGray"],
    CellMargins->{{27, 0}, {0, 4}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["NumberedItem3"],
    CellMargins->{{94, 4}, {2, 2}},
    CellGroupingRules->{"SectionGrouping", 15},
    ParagraphIndent->-23,
    CounterIncrements->"NumberedItem3",
    StyleMenuListing->None],
  
  Cell[StyleData["NumberedItem3", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["NumberedItem3", "Printout"],
    CellMargins->{{27, 0}, {0, 4}}],
  
  Cell[StyleData["NumberedItem3", "EnhancedPrintout"],
    CellMargins->{{27, 0}, {0, 4}}],
  
  Cell[StyleData["NumberedItem3", "EnhancedPrintoutNonGray"],
    CellMargins->{{27, 0}, {0, 4}},
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PageHeaderBold"],
    CellMargins->{{0, 0}, {2, 0}},
    StyleMenuListing->None,
    FontSize->8,
    FontWeight->"Bold",
    FontSlant->"Italic"],
  
  Cell[StyleData["PageHeaderBold", "Printout"]],
  
  Cell[StyleData["PageHeaderBold", "EnhancedPrintout"],
    FontFamily->"Frutiger"],
  
  Cell[StyleData["PageHeaderBold", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SingleRowTable"],
    CellMargins->{{10, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->2,
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["SingleRowTable", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["SingleRowTable", "Printout"],
    CellMargins->{{2, 0}, {0, 8}}],
  
  Cell[StyleData["SingleRowTable", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}}],
  
  Cell[StyleData["SingleRowTable", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {0, 8}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsubsubsection"],
    CellMargins->{{27, 4}, {0, 18}},
    CellElementSpacings->{"ClosedGroupTopMargin"->18},
    StyleMenuListing->None,
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["Subsubsubsection", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Subsubsubsection", "Printout"],
    CellMargins->{{2, 0}, {3, 8}},
    FontSize->10],
  
  Cell[StyleData["Subsubsubsection", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {3, 8}},
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["Subsubsubsection", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {3, 8}},
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsubtitle"],
    CellMargins->{{27, Inherited}, {20, 15}},
    CellGroupingRules->{"TitleGrouping", 20},
    PageBreakBelow->False,
    DefaultNewInlineCellStyle->"None",
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    LanguageCategory->"NaturalLanguage",
    CounterIncrements->"Subsubtitle",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->14,
    FontSlant->"Italic"],
  
  Cell[StyleData["Subsubtitle", "Presentation"],
    FontSize->21],
  
  Cell[StyleData["Subsubtitle", "Printout"],
    CellMargins->{{2, 10}, {8, 10}},
    FontSize->12],
  
  Cell[StyleData["Subsubtitle", "EnhancedPrintout"],
    CellMargins->{{2, 10}, {8, 10}},
    FontFamily->"Frutiger 55 Roman",
    FontSize->12],
  
  Cell[StyleData["Subsubtitle", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 10}, {8, 10}},
    FontFamily->"Frutiger 55 Roman",
    FontSize->12]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subtitle"],
    CellMargins->{{27, Inherited}, {20, 15}},
    CellGroupingRules->{"TitleGrouping", 10},
    PageBreakBelow->False,
    DefaultNewInlineCellStyle->"None",
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    LanguageCategory->"NaturalLanguage",
    CounterIncrements->"Subtitle",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
        "Subsubtitle", 0}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->24],
  
  Cell[StyleData["Subtitle", "Presentation"],
    FontSize->36],
  
  Cell[StyleData["Subtitle", "Printout"],
    CellMargins->{{2, 10}, {10, 15}},
    FontSize->24],
  
  Cell[StyleData["Subtitle", "EnhancedPrintout"],
    CellMargins->{{2, 10}, {10, 15}},
    FontFamily->"Frutiger 55 Roman",
    FontSize->24],
  
  Cell[StyleData["Subtitle", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 10}, {10, 15}},
    FontFamily->"Frutiger 55 Roman",
    FontSize->24]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TextBelow"],
    CellMargins->{{27, 4}, {0, 14}},
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    ParagraphSpacing->{0, 8},
    StyleMenuListing->None,
    FontSize->12],
  
  Cell[StyleData["TextBelow", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TextBelow", "Printout"],
    CellMargins->{{2, 2}, {6, 12}},
    TextJustification->1,
    Hyphenation->True,
    FontSize->10],
  
  Cell[StyleData["TextBelow", "EnhancedPrintout"],
    CellMargins->{{2, 2}, {6, 12}},
    TextJustification->1,
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["TextBelow", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 2}, {6, 12}},
    TextJustification->1,
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Title"],
    CellMargins->{{27, Inherited}, {20, 40}},
    CellGroupingRules->{"TitleGrouping", 0},
    PageBreakBelow->False,
    DefaultNewInlineCellStyle->"None",
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    LanguageCategory->"NaturalLanguage",
    CounterIncrements->"Title",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
        "Subtitle", 0}, {"Subsubtitle", 0}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->36,
    FontWeight->"Bold",
    FontColor->RGBColor[0.592157, 0.313726, 0.313726]],
  
  Cell[StyleData["Title", "Presentation"],
    FontSize->54],
  
  Cell[StyleData["Title", "Printout"],
    CellMargins->{{2, 10}, {15, 30}},
    FontSize->30],
  
  Cell[StyleData["Title", "EnhancedPrintout"],
    CellMargins->{{2, 10}, {15, 30}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->30.5,
    FontWeight->"Plain"],
  
  Cell[StyleData["Title", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 10}, {15, 30}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->30.5,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Undersubsection"],
    CellMargins->{{10, 4}, {0, 18}},
    CellElementSpacings->{"ClosedGroupTopMargin"->18},
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
            TextForm]},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["Undersubsection", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Undersubsection", "Printout"],
    CellMargins->{{2, 0}, {7, 10}},
    FontSize->10],
  
  Cell[StyleData["Undersubsection", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {7, 8}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->10,
    FontWeight->"Plain"],
  
  Cell[StyleData["Undersubsection", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {7, 8}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->10,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SectionFirst"],
    CellMargins->{{27, 27}, {12, 18}},
    CellGroupingRules->{"SectionGrouping", 30},
    PageBreakBelow->False,
    CounterIncrements->"Section",
    FontFamily->"Helvetica",
    FontSize->20,
    FontWeight->"Bold",
    FontColor->RGBColor[0.592157, 0.313726, 0.313726]],
  
  Cell[StyleData["SectionFirst", "Presentation"],
    FontSize->30],
  
  Cell[StyleData["SectionFirst", "Printout"],
    CellMargins->{{2, 0}, {0, 6}},
    PageBreakBelow->False,
    FontSize->18],
  
  Cell[StyleData["SectionFirst", "EnhancedPrintout"],
    CellFrame->{{0, 0}, {0.5, 0}},
    CellMargins->{{2, Inherited}, {5, 6}},
    CellGroupingRules->{"SectionGrouping", 30},
    PageBreakBelow->False,
    CellFrameMargins->8,
    CounterIncrements->"Section",
    CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->16,
    FontWeight->"Plain",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["SectionFirst", "EnhancedPrintoutNonGray"],
    CellFrame->{{0, 0}, {0.5, 0}},
    CellMargins->{{2, Inherited}, {5, 6}},
    CellGroupingRules->{"SectionGrouping", 30},
    PageBreakBelow->False,
    CellFrameMargins->8,
    CounterIncrements->"Section",
    CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}},
    FontFamily->"Frutiger 65 Bold",
    FontSize->16,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SubsectionFirst"],
    CellDingbat->None,
    CellMargins->{{27, 27}, {0, 18}},
    CellElementSpacings->{"ClosedGroupTopMargin"->18},
    CellGroupingRules->{"SectionGrouping", 40},
    PageBreakBelow->False,
    FontFamily->"Helvetica",
    FontSize->16,
    FontWeight->"Bold",
    FontColor->RGBColor[0.592157, 0.313726, 0.313726]],
  
  Cell[StyleData["SubsectionFirst", "Presentation"],
    FontSize->24],
  
  Cell[StyleData["SubsectionFirst", "SlideShow"],
    CellDingbat->None,
    CellMargins->{{70, 0}, {4, 6}},
    FontSize->12],
  
  Cell[StyleData["SubsectionFirst", "Printout"],
    CellMargins->{{9, 0}, {5, 6}},
    CellBracketOptions->{"Color"->RGBColor[1, 0, 0]},
    FontSize->12],
  
  Cell[StyleData["SubsectionFirst", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {5, 6}},
    CellBracketOptions->{"Color"->RGBColor[1, 0, 0]},
    FontFamily->"Frutiger 65 Bold",
    FontSize->12,
    FontWeight->"Plain",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["SubsectionFirst", "EnhancedPrintoutNonGray"],
    CellMargins->{{9, 0}, {5, 6}},
    CellBracketOptions->{"Color"->RGBColor[1, 0, 0]},
    FontFamily->"Frutiger 65 Bold",
    FontSize->12,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SubsubsectionFirst"],
    CellMargins->{{27, 27}, {0, 18}},
    CellElementSpacings->{"ClosedGroupTopMargin"->18},
    CellGroupingRules->{"SectionGrouping", 50},
    PageBreakBelow->False,
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold",
    FontColor->RGBColor[0.592157, 0.313726, 0.313726]],
  
  Cell[StyleData["SubsubsectionFirst", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["SubsubsectionFirst", "Printout"],
    CellMargins->{{2, 0}, {3, 3}},
    CellBracketOptions->{"Color"->RGBColor[1, 0, 0]},
    FontSize->10],
  
  Cell[StyleData["SubsubsectionFirst", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {3, 3}},
    CellBracketOptions->{"Color"->RGBColor[1, 0, 0]},
    FontFamily->"Frutiger 65 Bold",
    FontSize->10,
    FontWeight->"Plain",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["SubsubsectionFirst", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {3, 3}},
    CellBracketOptions->{"Color"->RGBColor[1, 0, 0]},
    FontFamily->"Frutiger 65 Bold",
    FontSize->10,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SubsubsubsectionFirst"],
    CellMargins->{{10, 4}, {0, 12}},
    CellElementSpacings->{"ClosedGroupTopMargin"->18},
    StyleMenuListing->None,
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["SubsubsubsectionFirst", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["SubsubsubsectionFirst", "Printout"],
    CellMargins->{{2, 0}, {3, 3}},
    FontSize->10],
  
  Cell[StyleData["SubsubsubsectionFirst", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {3, 3}},
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["SubsubsubsectionFirst", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 0}, {3, 3}},
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell["Spacer Cell", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Spacer"],
    CellMargins->{{10, 10}, {0, 0}},
    CellElementSpacings->{"CellMinHeight"->2,
    "ClosedCellHeight"->1},
    CellOpen->False,
    StyleMenuListing->None],
  
  Cell[StyleData["Spacer", "Printout"],
    CellOpen->True,
    FontSize->3]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DiscretionaryHyphen"],
    StyleMenuListing->None,
    FontSize->0.0625,
    FontColor->GrayLevel[1]],
  
  Cell[StyleData["DiscretionaryHyphen", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["DiscretionaryHyphen", "EnhancedPrintout"],
    FontSize->10,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["DiscretionaryHyphen", "EnhancedPrintoutNonGray"],
    FontSize->10,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureSmaller1"],
    CellMargins->{{10, Inherited}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PictureSmaller1", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PictureSmaller1", "Printout"],
    CellMargins->{{2, Inherited}, {4, 4}},
    Magnification->0.63],
  
  Cell[StyleData["PictureSmaller1", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.63],
  
  Cell[StyleData["PictureSmaller1", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.63]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureSmaller2"],
    CellMargins->{{10, Inherited}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PictureSmaller2", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PictureSmaller2", "Printout"],
    CellMargins->{{2, Inherited}, {4, 4}},
    Magnification->0.61],
  
  Cell[StyleData["PictureSmaller2", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.61],
  
  Cell[StyleData["PictureSmaller2", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.61]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureSmaller3"],
    CellMargins->{{10, Inherited}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PictureSmaller3", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PictureSmaller3", "Printout"],
    CellMargins->{{2, Inherited}, {4, 4}},
    Magnification->0.59],
  
  Cell[StyleData["PictureSmaller3", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.59],
  
  Cell[StyleData["PictureSmaller3", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.59]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureSmaller4"],
    CellMargins->{{10, Inherited}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PictureSmaller4", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PictureSmaller4", "Printout"],
    CellMargins->{{2, Inherited}, {4, 4}},
    Magnification->0.57],
  
  Cell[StyleData["PictureSmaller4", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.57],
  
  Cell[StyleData["PictureSmaller4", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.57]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureSmaller5"],
    CellMargins->{{10, Inherited}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PictureSmaller5", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PictureSmaller5", "Printout"],
    CellMargins->{{2, Inherited}, {4, 4}},
    Magnification->0.55],
  
  Cell[StyleData["PictureSmaller5", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.55],
  
  Cell[StyleData["PictureSmaller5", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.55]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureSmaller6"],
    CellMargins->{{10, Inherited}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PictureSmaller6", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PictureSmaller6", "Printout"],
    CellMargins->{{2, Inherited}, {4, 4}},
    Magnification->0.53],
  
  Cell[StyleData["PictureSmaller6", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.53],
  
  Cell[StyleData["PictureSmaller6", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.53]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemPicture"],
    CellMargins->{{41, Inherited}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemPicture", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemPicture", "Printout"],
    CellMargins->{{55, Inherited}, {8, -4}},
    Magnification->0.65],
  
  Cell[StyleData["ItemPicture", "EnhancedPrintout"],
    CellMargins->{{60, Inherited}, {10, -3}},
    Magnification->0.65],
  
  Cell[StyleData["ItemPicture", "EnhancedPrintoutNonGray"],
    CellMargins->{{60, Inherited}, {10, -3}},
    Magnification->0.65]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemPictureSmaller1"],
    CellMargins->{{41, Inherited}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemPictureSmaller1", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemPictureSmaller1", "Printout"],
    CellMargins->{{56, Inherited}, {9, -3}},
    Magnification->0.63],
  
  Cell[StyleData["ItemPictureSmaller1", "EnhancedPrintout"],
    CellMargins->{{63, Inherited}, {10, -3}},
    Magnification->0.63],
  
  Cell[StyleData["ItemPictureSmaller1", "EnhancedPrintoutNonGray"],
    CellMargins->{{63, Inherited}, {10, -3}},
    Magnification->0.63]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemPictureSmaller2"],
    CellMargins->{{41, Inherited}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemPictureSmaller2", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemPictureSmaller2", "Printout"],
    CellMargins->{{58, Inherited}, {8, -4}},
    Magnification->0.61],
  
  Cell[StyleData["ItemPictureSmaller2", "EnhancedPrintout"],
    CellMargins->{{65, Inherited}, {11, -3}},
    Magnification->0.61],
  
  Cell[StyleData["ItemPictureSmaller2", "EnhancedPrintoutNonGray"],
    CellMargins->{{65, Inherited}, {11, -3}},
    Magnification->0.61]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemPictureSmaller3"],
    CellMargins->{{41, Inherited}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemPictureSmaller3", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemPictureSmaller3", "Printout"],
    CellMargins->{{61, Inherited}, {10, -2}},
    Magnification->0.59],
  
  Cell[StyleData["ItemPictureSmaller3", "EnhancedPrintout"],
    CellMargins->{{67, Inherited}, {11, -3}},
    Magnification->0.59],
  
  Cell[StyleData["ItemPictureSmaller3", "EnhancedPrintoutNonGray"],
    CellMargins->{{67, Inherited}, {11, -3}},
    Magnification->0.59]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemPictureSmaller4"],
    CellMargins->{{41, Inherited}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemPictureSmaller4", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemPictureSmaller4", "Printout"],
    CellMargins->{{63, Inherited}, {10, -2}},
    Magnification->0.57],
  
  Cell[StyleData["ItemPictureSmaller4", "EnhancedPrintout"],
    CellMargins->{{69, Inherited}, {12, -4}},
    Magnification->0.57],
  
  Cell[StyleData["ItemPictureSmaller4", "EnhancedPrintoutNonGray"],
    CellMargins->{{69, Inherited}, {12, -4}},
    Magnification->0.57]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemPictureSmaller5"],
    CellMargins->{{41, Inherited}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemPictureSmaller5", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemPictureSmaller5", "Printout"],
    CellMargins->{{65, Inherited}, {11, -2}},
    Magnification->0.55],
  
  Cell[StyleData["ItemPictureSmaller5", "EnhancedPrintout"],
    CellMargins->{{71, Inherited}, {13, -2}},
    Magnification->0.55],
  
  Cell[StyleData["ItemPictureSmaller5", "EnhancedPrintoutNonGray"],
    CellMargins->{{71, Inherited}, {13, -2}},
    Magnification->0.55]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemPictureSmaller6"],
    CellMargins->{{41, Inherited}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemPictureSmaller6", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemPictureSmaller6", "Printout"],
    CellMargins->{{67, Inherited}, {12, -2}},
    Magnification->0.53],
  
  Cell[StyleData["ItemPictureSmaller6", "EnhancedPrintout"],
    CellMargins->{{74, Inherited}, {13, -3}},
    Magnification->0.53],
  
  Cell[StyleData["ItemPictureSmaller6", "EnhancedPrintoutNonGray"],
    CellMargins->{{74, Inherited}, {13, -3}},
    Magnification->0.53]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureBigger1"],
    CellMargins->{{10, Inherited}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PictureBigger1", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PictureBigger1", "Printout"],
    CellMargins->{{2, Inherited}, {4, 4}},
    Magnification->0.68],
  
  Cell[StyleData["PictureBigger1", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.68],
  
  Cell[StyleData["PictureBigger1", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.68]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureBigger2"],
    CellMargins->{{10, Inherited}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PictureBigger2", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PictureBigger2", "Printout"],
    CellMargins->{{2, Inherited}, {4, 4}},
    Magnification->0.71],
  
  Cell[StyleData["PictureBigger2", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.71],
  
  Cell[StyleData["PictureBigger2", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.71]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureBigger3"],
    CellMargins->{{10, Inherited}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PictureBigger3", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PictureBigger3", "Printout"],
    CellMargins->{{2, Inherited}, {4, 4}},
    Magnification->0.74],
  
  Cell[StyleData["PictureBigger3", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.74],
  
  Cell[StyleData["PictureBigger3", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.74]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureBigger4"],
    CellMargins->{{10, Inherited}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PictureBigger4", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PictureBigger4", "Printout"],
    CellMargins->{{2, Inherited}, {4, 4}},
    Magnification->0.77],
  
  Cell[StyleData["PictureBigger4", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.77],
  
  Cell[StyleData["PictureBigger4", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.77]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureBigger5"],
    CellMargins->{{10, Inherited}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PictureBigger5", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PictureBigger5", "Printout"],
    CellMargins->{{2, Inherited}, {4, 4}},
    Magnification->0.8],
  
  Cell[StyleData["PictureBigger5", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.8],
  
  Cell[StyleData["PictureBigger5", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureBigger6"],
    CellMargins->{{10, Inherited}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PictureBigger6", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PictureBigger6", "Printout"],
    CellMargins->{{2, Inherited}, {4, 4}},
    Magnification->0.83],
  
  Cell[StyleData["PictureBigger6", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.83],
  
  Cell[StyleData["PictureBigger6", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {4, 2}},
    Magnification->0.83]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemPictureBigger1"],
    CellMargins->{{41, Inherited}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemPictureBigger1", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemPictureBigger1", "Printout"],
    CellMargins->{{50, Inherited}, {9, -3}},
    Magnification->0.68],
  
  Cell[StyleData["ItemPictureBigger1", "EnhancedPrintout"],
    CellMargins->{{57, Inherited}, {10, -3}},
    Magnification->0.68],
  
  Cell[StyleData["ItemPictureBigger1", "EnhancedPrintoutNonGray"],
    CellMargins->{{57, Inherited}, {10, -3}},
    Magnification->0.68]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemPictureBigger2"],
    CellMargins->{{41, Inherited}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemPictureBigger2", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemPictureBigger2", "Printout"],
    CellMargins->{{48, Inherited}, {8, -4}},
    Magnification->0.71],
  
  Cell[StyleData["ItemPictureBigger2", "EnhancedPrintout"],
    CellMargins->{{54, Inherited}, {10, -3}},
    Magnification->0.71],
  
  Cell[StyleData["ItemPictureBigger2", "EnhancedPrintoutNonGray"],
    CellMargins->{{54, Inherited}, {10, -3}},
    Magnification->0.71]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemPictureBigger3"],
    CellMargins->{{41, Inherited}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemPictureBigger3", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemPictureBigger3", "Printout"],
    CellMargins->{{46, Inherited}, {10, -2}},
    Magnification->0.74],
  
  Cell[StyleData["ItemPictureBigger3", "EnhancedPrintout"],
    CellMargins->{{52, Inherited}, {10, -3}},
    Magnification->0.74],
  
  Cell[StyleData["ItemPictureBigger3", "EnhancedPrintoutNonGray"],
    CellMargins->{{52, Inherited}, {10, -3}},
    Magnification->0.74]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemPictureBigger4"],
    CellMargins->{{41, Inherited}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemPictureBigger4", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemPictureBigger4", "Printout"],
    CellMargins->{{45, Inherited}, {10, -2}},
    Magnification->0.77],
  
  Cell[StyleData["ItemPictureBigger4", "EnhancedPrintout"],
    CellMargins->{{50, Inherited}, {10, -3}},
    Magnification->0.77],
  
  Cell[StyleData["ItemPictureBigger4", "EnhancedPrintoutNonGray"],
    CellMargins->{{50, Inherited}, {10, -3}},
    Magnification->0.77]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemPictureBigger5"],
    CellMargins->{{41, Inherited}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemPictureBigger5", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemPictureBigger5", "Printout"],
    CellMargins->{{43, Inherited}, {11, -2}},
    Magnification->0.8],
  
  Cell[StyleData["ItemPictureBigger5", "EnhancedPrintout"],
    CellMargins->{{49, Inherited}, {10, -3}},
    Magnification->0.8],
  
  Cell[StyleData["ItemPictureBigger5", "EnhancedPrintoutNonGray"],
    CellMargins->{{49, Inherited}, {10, -3}},
    Magnification->0.8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemPictureBigger6"],
    CellMargins->{{41, Inherited}, {4, 2}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemPictureBigger6", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ItemPictureBigger6", "Printout"],
    CellMargins->{{43, Inherited}, {12, -2}},
    Magnification->0.83],
  
  Cell[StyleData["ItemPictureBigger6", "EnhancedPrintout"],
    CellMargins->{{46, Inherited}, {8, -2}},
    Magnification->0.83],
  
  Cell[StyleData["ItemPictureBigger6", "EnhancedPrintoutNonGray"],
    CellMargins->{{46, Inherited}, {8, -2}},
    Magnification->0.83]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ScreenGraphic"],
    CellMargins->{{12, Inherited}, {0, 8}},
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ScreenGraphic", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ScreenGraphic", "Printout"],
    CellMargins->{{2, Inherited}, {0, 8}}],
  
  Cell[StyleData["ScreenGraphic", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {0, 8}},
    CellElementSpacings->{"CellMinHeight"->2,
    "ClosedCellHeight"->2},
    CellOpen->False],
  
  Cell[StyleData["ScreenGraphic", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {0, 8}},
    CellElementSpacings->{"CellMinHeight"->2,
    "ClosedCellHeight"->2},
    CellOpen->False]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PrintGraphic"],
    CellMargins->{{12, Inherited}, {0, 8}},
    CellElementSpacings->{"CellMinHeight"->2,
    "ClosedCellHeight"->2},
    CellOpen->False,
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PrintGraphic", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["PrintGraphic", "Printout"],
    CellMargins->{{2, Inherited}, {0, 8}},
    CellElementSpacings->{"CellMinHeight"->2,
    "ClosedCellHeight"->2},
    CellOpen->False],
  
  Cell[StyleData["PrintGraphic", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {0, 8}},
    CellElementSpacings->{"CellMinHeight"->12},
    CellOpen->True],
  
  Cell[StyleData["PrintGraphic", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, Inherited}, {0, 8}},
    CellElementSpacings->{"CellMinHeight"->12},
    CellOpen->True]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SmallTextSans"],
    CellMargins->{{10, 4}, {8, 8}},
    TextJustification->1,
    LineSpacing->{1, 2},
    FontFamily->"Helvetica",
    FontSize->9],
  
  Cell[StyleData["SmallTextSans", "Presentation"],
    FontSize->14],
  
  Cell[StyleData["SmallTextSans", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    Hyphenation->True,
    FontSize->7],
  
  Cell[StyleData["SmallTextSans", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {0, 8}},
    Hyphenation->True,
    LineSpacing->{1, 1},
    ParagraphSpacing->{0, -2},
    FontFamily->"Frutiger 55 Roman",
    FontSize->7]
  }, Closed]]
  }, Closed]]
  }, Closed]]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell["AuthorTools", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["BilateralCell"],
    CellMargins->{{27, 4}, {0, 8}},
    StyleMenuListing->None,
    FontSize->12,
    GridBoxOptions->{ColumnWidths->{0.33, 0.6},
    RowAlignments->Top,
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["BilateralCell", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["BilateralCell", "SlideShow"],
    CellMargins->{{36, 24}, {4, 4}},
    Background->GrayLevel[0.900008]],
  
  Cell[StyleData["BilateralCell", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    FontSize->10],
  
  Cell[StyleData["BilateralCell", "EnhancedPrintout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    FontFamily->"Palatino",
    FontSize->10],
  
  Cell[StyleData["BilateralCell", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->1,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["RuledPageBreak"],
    CellFrame->{{0, 0}, {0.25, 0}},
    CellMargins->{{27, 4}, {12, 0}},
    CellFrameMargins->{{0, 0}, {1, 0}},
    FontSize->8],
  
  Cell[StyleData["RuledPageBreak", "Presentation"],
    FontSize->12],
  
  Cell[StyleData["RuledPageBreak", "SlideShow"],
    CellMargins->{{36, 24}, {4, 4}}],
  
  Cell[StyleData["RuledPageBreak", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    PageBreakBelow->True,
    FontSize->1],
  
  Cell[StyleData["RuledPageBreak", "EnhancedPrintout"],
    CellMargins->{{2, 2}, {6, 6}},
    PageBreakBelow->True],
  
  Cell[StyleData["RuledPageBreak", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 2}, {6, 6}},
    PageBreakBelow->True]
  }, Closed]],
  
  Cell[StyleData["PaletteTitle"],
    CellFrame->{{0, 0}, {1, 0}},
    CellMargins->{{4, 0}, {Inherited, 0}},
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->14,
    FontWeight->"Bold",
    FontColor->GrayLevel[1],
    Background->RGBColor[0, 0.32549, 0.537255],
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "AddOns", #2]}]&),
    ButtonEvaluator->None,
    ButtonStyle->"PaletteButton",
    ButtonMargins->3}],
  
  Cell[StyleData["PaletteButton"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold",
    FontColor->GrayLevel[1],
    ButtonBoxOptions->{ButtonEvaluator->"Local",
    Active->True,
    ButtonMargins->6,
    Background->RGBColor[0.329412, 0.584314, 0.694118]}],
  
  Cell[StyleData["PaletteButton2"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold",
    FontColor->GrayLevel[1],
    ButtonBoxOptions->{ButtonEvaluator->"Local",
    Active->True,
    ButtonMargins->4,
    Background->RGBColor[0.537255, 0.72549, 0.843137]}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Outline Styles", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Outline1"],
    CellMargins->{{27, 10}, {7, 7}},
    CellGroupingRules->{"SectionGrouping", 50},
    ParagraphIndent->-38,
    CounterIncrements->"Outline1",
    CounterAssignments->{{"Outline2", 0}, {"Outline3", 0}, {"Outline4", 0}},
    FontSize->18,
    FontWeight->"Bold",
    CounterBoxOptions->{CounterFunction:>CapitalRomanNumeral}],
  
  Cell[StyleData["Outline1", "Presentation"],
    FontSize->27],
  
  Cell[StyleData["Outline1", "Printout"],
    CounterBoxOptions->{CounterFunction:>CapitalRomanNumeral}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Outline2"],
    CellMargins->{{57, 10}, {6, 6}},
    CellGroupingRules->{"SectionGrouping", 60},
    ParagraphIndent->-27,
    CounterIncrements->"Outline2",
    CounterAssignments->{{"Outline3", 0}, {"Outline4", 0}},
    FontSize->15,
    FontWeight->"Bold",
    CounterBoxOptions->{CounterFunction:>(Part[ 
        CharacterRange[ "A", "Z"], #]&)}],
  
  Cell[StyleData["Outline2", "Presentation"],
    FontSize->23],
  
  Cell[StyleData["Outline2", "Printout"],
    CounterBoxOptions->{CounterFunction:>(Part[ 
        CharacterRange[ "A", "Z"], #]&)}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Outline3"],
    CellMargins->{{87, 10}, {5, 5}},
    CellGroupingRules->{"SectionGrouping", 70},
    ParagraphIndent->-21,
    CounterIncrements->"Outline3",
    CounterAssignments->{{"Outline4", 0}},
    FontSize->12,
    CounterBoxOptions->{CounterFunction:>Identity}],
  
  Cell[StyleData["Outline3", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Outline3", "Printout"],
    CounterBoxOptions->{CounterFunction:>Identity}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Outline4"],
    CellMargins->{{117, 10}, {4, 4}},
    CellGroupingRules->{"SectionGrouping", 80},
    ParagraphIndent->-18,
    CounterIncrements->"Outline4",
    FontSize->10,
    CounterBoxOptions->{CounterFunction:>(Part[ 
        CharacterRange[ "a", "z"], #]&)}],
  
  Cell[StyleData["Outline4", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["Outline4", "Printout"]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Slide Show Styles", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SlideShowNavigationBar"],
    Editable->False,
    CellFrame->True,
    CellMargins->{{0, 0}, {3, 3}},
    CellElementSpacings->{"CellMinHeight"->0.8125},
    CellGroupingRules->{"SectionGrouping", 30},
    CellFrameMargins->False,
    CellFrameColor->GrayLevel[1],
    CellFrameLabelMargins->False,
    TextAlignment->Center,
    CounterIncrements->"SlideShowNavigationBar",
    StyleMenuListing->None,
    FontSize->10,
    Background->GrayLevel[0.8],
    Magnification->1,
    GridBoxOptions->{GridBaseline->Center,
    RowSpacings->0,
    ColumnSpacings->0,
    ColumnWidths->{3.5, 3.5, 3.5, 3.5, 13, 5, 4},
    RowAlignments->Baseline,
    ColumnAlignments->{
      Center, Center, Center, Center, Center, Center, Right, Center}}],
  
  Cell[StyleData["SlideShowNavigationBar", "SlideShow"],
    Deletable->False,
    ShowCellBracket->False,
    CellMargins->{{-1, -1}, {-1, -1}},
    PageBreakAbove->True,
    CellFrameMargins->{{1, 1}, {0, 0}}],
  
  Cell[StyleData["SlideShowNavigationBar", "Printout"],
    CellMargins->{{18, 4}, {4, 4}},
    LineSpacing->{1, 3},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SlideShowSection"],
    CellFrame->{{0, 0}, {0, 0.5}},
    CellMargins->{{0, 0}, {10, 0}},
    CellGroupingRules->{"SectionGrouping", 40},
    PageBreakBelow->False,
    CellFrameMargins->{{12, 4}, {6, 12}},
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.35999999999999999, \
-0.10000000000000001}, {0, 0}}, BoxBaselineShift -> -0.20000000000000001], 
                FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.074999999999999997, \
-0.085000000000000006}, {0, 0}}, BoxBaselineShift -> 0.5], "X"}]], 
        "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
        "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.17499999999999999, 0}, {0, 0}}]}], 
            TextForm], Inherited},
    CounterIncrements->"Section",
    CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->18,
    FontWeight->"Plain",
    FontColor->GrayLevel[1],
    Background->RGBColor[0.408011, 0.440726, 0.8]],
  
  Cell[StyleData["SlideShowSection", "Presentation"],
    FontSize->27],
  
  Cell[StyleData["SlideShowSection", "SlideShow"],
    ShowCellBracket->False,
    PageBreakAbove->True],
  
  Cell[StyleData["SlideShowSection", "Printout"],
    CellMargins->{{18, 30}, {0, 30}},
    CellFrameMargins->5,
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SlideHyperlink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontSize->26,
    FontColor->GrayLevel[0.400015],
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #2]}]&),
    Active->True,
    ButtonMinHeight->0.85,
    ButtonMargins->0.5,
    ButtonNote->None}],
  
  Cell[StyleData["SlideHyperlink", "SlideShow"]],
  
  Cell[StyleData["SlideHyperlink", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SlideTOCLink"],
    CellMargins->{{24, Inherited}, {Inherited, Inherited}},
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontFamily->"Helvetica",
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #2]}]&),
    Active->True,
    ButtonMargins->1.5,
    ButtonNote->ButtonData}],
  
  Cell[StyleData["SlideTOCLink", "SlideShow"]],
  
  Cell[StyleData["SlideTOCLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SlideTOC"],
    CellDingbat->"\[Bullet]",
    CellMargins->{{18, Inherited}, {Inherited, Inherited}},
    StyleMenuListing->None,
    FontFamily->"Helvetica"],
  
  Cell[StyleData["SlideTOC", "SlideShow"],
    FontSize->14],
  
  Cell[StyleData["SlideTOC", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Title Page, Contents, and Index", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ContentsTitle"],
    CellMargins->{{21, 4}, {12, 24}},
    FontFamily->"Helvetica",
    FontSize->24,
    FontWeight->"Bold",
    FontColor->RGBColor[0.592157, 0.313726, 0.313726]],
  
  Cell[StyleData["ContentsTitle", "Presentation"],
    FontSize->36],
  
  Cell[StyleData["ContentsTitle", "Printout"],
    CellMargins->{{12, 0}, {102, 89}},
    PageBreakBelow->False,
    FontSize->30.5,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["ContentsTitle", "EnhancedPrintout"],
    CellMargins->{{2, Inherited}, {15, 30}},
    PageBreakBelow->False,
    FontFamily->"Frutiger 65 Bold",
    FontSize->30.5,
    FontWeight->"Plain",
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ContentsSection"],
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{35, 4}, {3, 18}},
    CellGroupingRules->{"SectionGrouping", 70},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["ContentsSection", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["ContentsSection", "Printout"],
    CellMargins->{{20, 0}, {3, 18}},
    PageBreakBelow->False,
    FontSize->11],
  
  Cell[StyleData["ContentsSection", "EnhancedPrintout"],
    CellMargins->{{20, 0}, {3, 18}},
    PageBreakBelow->False,
    FontFamily->"Frutiger 65 Bold",
    FontSize->11,
    FontWeight->"Plain"],
  
  Cell[StyleData["ContentsSection", "EnhancedPrintoutNonGray"],
    CellMargins->{{20, 0}, {3, 18}},
    PageBreakBelow->False,
    FontFamily->"Frutiger 65 Bold",
    FontSize->11,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["IndexSection"],
    CellDingbat->"\[FilledSquare]",
    CellMargins->{{20, 4}, {5, 20}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["IndexSection", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["IndexSection", "Printout"],
    CellMargins->{{12, 0}, {5, 20}},
    PageBreakBelow->False,
    FontSize->12]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Contents"],
    ShowGroupOpenCloseIcon->False,
    CellMargins->{{50, 4}, {0, 5}},
    CellGroupingRules->{"SectionGrouping", 90},
    StyleMenuListing->None],
  
  Cell[StyleData["Contents", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Contents", "Printout"],
    CellMargins->{{40, 4}, {0, 5}},
    FontSize->11],
  
  Cell[StyleData["Contents", "EnhancedPrintout"],
    CellMargins->{{40, 5}, {0, 5}},
    FontFamily->"Palatino",
    FontSize->11],
  
  Cell[StyleData["Contents", "EnhancedPrintoutNonGray"],
    CellMargins->{{40, 5}, {0, 5}},
    FontFamily->"Palatino",
    FontSize->11]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Index"],
    CellMargins->{{21, 4}, {0, 0}},
    ParagraphIndent->-48,
    StyleMenuListing->None],
  
  Cell[StyleData["Index", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["Index", "Printout"],
    CellMargins->{{13, 0}, {0, 0}},
    FontSize->9],
  
  Cell[StyleData["Index", "EnhancedPrintout"],
    CellMargins->{{13, 0}, {0, 0}},
    FontFamily->"Palatino",
    FontSize->9],
  
  Cell[StyleData["Index", "EnhancedPrintoutNonGray"],
    CellMargins->{{13, 0}, {0, 0}},
    FontFamily->"Palatino",
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["IndexSubentry"],
    CellMargins->{{36, 4}, {0, 0}},
    ParagraphIndent->-48],
  
  Cell[StyleData["IndexSubentry", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["IndexSubentry", "Printout"],
    CellMargins->{{24, 0}, {0, 0}},
    FontSize->9],
  
  Cell[StyleData["IndexSubentry", "EnhancedPrintout"],
    CellMargins->{{24, 0}, {0, 0}},
    FontFamily->"Palatino",
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Index2Column"],
    CellMargins->{{21, 4}, {0, 8}},
    ParagraphIndent->-20,
    TabSpacings->1,
    StyleMenuListing->None,
    FontSize->10,
    GridBoxOptions->{ColumnWidths->0.5,
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["Index2Column", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["Index2Column", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    FontSize->8],
  
  Cell[StyleData["Index2Column", "EnhancedPrintout"],
    CellMargins->{{2, 2}, {1, 1}},
    LineSpacing->{1, 0.2},
    FontFamily->"Palatino",
    FontSize->8],
  
  Cell[StyleData["Index2Column", "EnhancedPrintoutNonGray"],
    CellMargins->{{2, 2}, {1, 1}},
    LineSpacing->{1, 0.2},
    FontFamily->"Palatino",
    FontSize->8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Leader"],
    TabFilling->".",
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->12,
    FontWeight->"Plain"],
  
  Cell[StyleData["Leader", "Printout"],
    FontSize->10],
  
  Cell[StyleData["Leader", "EnhancedPrintout"],
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["LeaderNoDots"],
    TabFilling->" ",
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->12,
    FontWeight->"Plain"],
  
  Cell[StyleData["LeaderNoDots", "Printout"],
    FontSize->10],
  
  Cell[StyleData["LeaderNoDots", "EnhancedPrintout"],
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PageLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #2]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["PageLink", "Printout"],
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["PageLink", "EnhancedPrintout"],
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TOCPage"],
    CellSize->{22, Inherited},
    TextAlignment->Right,
    StyleMenuListing->None,
    FontSize->12,
    FontWeight->"Plain"],
  
  Cell[StyleData["TOCPage", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TOCPage", "Printout"],
    FontSize->10],
  
  Cell[StyleData["TOCPage", "EnhancedPrintout"],
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TOCTitle"],
    CellMargins->{{20, 0}, {1, 8}},
    CellGroupingRules->{"SectionGrouping", 70},
    TabSpacings->46,
    CounterIncrements->"TOCTitle",
    CounterAssignments->{{"TOCSection", 0}},
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["TOCTitle", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TOCTitle", "Printout"],
    CellMargins->{{12, 0}, {1, 8}},
    PageBreakBelow->False,
    TabSpacings->47.4,
    FontSize->11],
  
  Cell[StyleData["TOCTitle", "EnhancedPrintout"],
    CellMargins->{{2, 0}, {2, 10}},
    PageBreakBelow->False,
    TabSpacings->49.3,
    FontFamily->"Frutiger 65 Bold",
    FontSize->10,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TOCSection"],
    CellMargins->{{48, 0}, {1, 1}},
    CellGroupingRules->{"SectionGrouping", 75},
    TabSpacings->42.9,
    CounterIncrements->"TOCSection",
    CounterAssignments->{{"TOCSubsection", 0}},
    FontFamily->"Helvetica",
    FontSize->12],
  
  Cell[StyleData["TOCSection", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TOCSection", "Printout"],
    CellMargins->{{30, 0}, {1, 1}},
    PageBreakBelow->False,
    FontSize->12],
  
  Cell[StyleData["TOCSection", "EnhancedPrintout"],
    CellMargins->{{26, 0}, {1, 3}},
    PageBreakBelow->False,
    TabSpacings->46.45,
    FontFamily->"Frutiger",
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TOCSubsection"],
    CellMargins->{{76, 0}, {1, 1}},
    CellGroupingRules->{"SectionGrouping", 80},
    TabSpacings->39.8,
    CounterIncrements->"TOCSubsection",
    CounterAssignments->{{"TOCSubsubsection", 0}},
    FontSize->12],
  
  Cell[StyleData["TOCSubsection", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TOCSubsection", "Printout"],
    CellMargins->{{70, 0}, {1, 1}},
    PageBreakBelow->False,
    FontSize->10],
  
  Cell[StyleData["TOCSubsection", "EnhancedPrintout"],
    CellMargins->{{38, 0}, {1, 1}},
    PageBreakBelow->False,
    TabSpacings->45.15,
    FontFamily->"Palatino",
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TOCSubsubsection"],
    CellMargins->{{104, 0}, {1, 1}},
    CellGroupingRules->{"SectionGrouping", 85},
    TabSpacings->36.7,
    CounterIncrements->"TOCSubsubsection",
    FontSize->12],
  
  Cell[StyleData["TOCSubsubsection", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TOCSubsubsection", "Printout"],
    CellMargins->{{96, 0}, {1, 1}},
    PageBreakBelow->False,
    FontSize->9],
  
  Cell[StyleData["TOCSubsubsection", "EnhancedPrintout"],
    CellMargins->{{96, 0}, {1, 1}},
    PageBreakBelow->False,
    FontFamily->"Palatino",
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TOCTitleDingbat"],
    CellSize->{34, Inherited},
    TextAlignment->Right],
  
  Cell[StyleData["TOCTitleDingbat", "EnhancedPrintout"],
    FontFamily->"Frutiger",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TOCSectionDingbat"],
    CellSize->{38, Inherited},
    TextAlignment->Right],
  
  Cell[StyleData["TOCSectionDingbat", "EnhancedPrintout"],
    FontFamily->"Frutiger",
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TOCSubsectionDingbat"],
    CellSize->{54, Inherited},
    TextAlignment->Right],
  
  Cell[StyleData["TOCSubsectionDingbat", "EnhancedPrintout"],
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TOCTitleCondensed"],
    CellMargins->{{20, 0}, {1, 8}},
    CellGroupingRules->{"SectionGrouping", 70},
    TabSpacings->50.4,
    CounterIncrements->"TOCTitleCondensed",
    CounterAssignments->{{"TOCSectionCondensed", 0}, {
        "TOCSubsectionCondensed", 0}},
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Bold"],
  
  Cell[StyleData["TOCTitleCondensed", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TOCTitleCondensed", "Printout"],
    CellMargins->{{12, 0}, {1, 8}},
    PageBreakBelow->False,
    FontSize->11],
  
  Cell[StyleData["TOCTitleCondensed", "EnhancedPrintout"],
    CellMargins->{{12, 0}, {1, 8}},
    PageBreakBelow->False,
    FontFamily->"Frutiger 65 Bold",
    FontSize->11,
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TOCSectionCondensed"],
    CellMargins->{{48, 0}, {1, 1}},
    CellGroupingRules->{"SectionGrouping", 75},
    TabSpacings->47.4,
    CounterIncrements->"TOCSectionCondensed",
    CounterAssignments->{{"TOCSubsection", 0}},
    FontFamily->"Helvetica",
    FontSize->10,
    FontWeight->"Bold",
    FontColor->GrayLevel[0.2]],
  
  Cell[StyleData["TOCSectionCondensed", "Presentation"],
    FontSize->15],
  
  Cell[StyleData["TOCSectionCondensed", "Printout"],
    CellMargins->{{36, 0}, {1, 1}},
    PageBreakBelow->False,
    FontSize->11],
  
  Cell[StyleData["TOCSectionCondensed", "EnhancedPrintout"],
    CellMargins->{{36, 0}, {1, 1}},
    PageBreakBelow->False,
    FontFamily->"Palatino",
    FontSize->11]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TOCSubsectionCondensed"],
    PageWidth->470,
    CellMargins->{{76, 0}, {1, 1}},
    CellGroupingRules->{"SectionGrouping", 80},
    TextJustification->1,
    FontSize->12],
  
  Cell[StyleData["TOCSubsectionCondensed", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TOCSubsectionCondensed", "Printout"],
    CellMargins->{{72, 0}, {1, 1}},
    PageBreakBelow->False,
    Hyphenation->True,
    FontSize->10],
  
  Cell[StyleData["TOCSubsectionCondensed", "EnhancedPrintout"],
    CellMargins->{{72, 0}, {1, 1}},
    PageBreakBelow->False,
    Hyphenation->True,
    FontFamily->"Palatino",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TOCSubsubsectionCondensed"],
    CellMargins->{{104, 0}, {1, 1}},
    CellGroupingRules->{"SectionGrouping", 85},
    TabSpacings->39.3,
    CounterIncrements->"TOCSubsubsectionCondensed",
    FontSize->12],
  
  Cell[StyleData["TOCSubsubsectionCondensed", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TOCSubsubsectionCondensed", "Printout"],
    CellMargins->{{96, 0}, {1, 1}},
    PageBreakBelow->False,
    FontSize->9],
  
  Cell[StyleData["TOCSubsubsectionCondensed", "EnhancedPrintout"],
    CellMargins->{{96, 0}, {1, 1}},
    PageBreakBelow->False,
    FontFamily->"Palatino",
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TitlePageGraphic"],
    CellMargins->{{0, 0}, {100, 20}},
    Evaluatable->False,
    PageBreakBelow->False,
    TextAlignment->Center],
  
  Cell[StyleData["TitlePageGraphic", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TitlePageGraphic", "Printout"],
    CellMargins->{{0, 0}, {230, 88}}],
  
  Cell[StyleData["TitlePageGraphic", "EnhancedPrintout"],
    CellMargins->{{0, 0}, {230, 88}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TitlePageLogo"],
    CellMargins->{{0, 0}, {0, 0}}],
  
  Cell[StyleData["TitlePageLogo", "Presentation"],
    FontSize->18],
  
  Cell[StyleData["TitlePageLogo", "Printout"]],
  
  Cell[StyleData["TitlePageLogo", "EnhancedPrintout"]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Horizontal Lines", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Line1"],
    CellFrame->{{0, 0}, {0, 0.5}},
    CellMargins->{{10, 4}, {-16, 9}},
    StyleMenuListing->None,
    FontSize->2],
  
  Cell[StyleData["Line1", "Presentation"],
    FontSize->3],
  
  Cell[StyleData["Line1", "Printout"],
    CellMargins->{{2, 0}, {-16, 9}}]
  }, Closed]],
  
  Cell["\<\

The item above is horizontal 0.5 pt line\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ProgramTop"],
    CellFrame->{{0.5, 0.5}, {0, 0.5}},
    CellMargins->{{27, 4}, {-18, 18}},
    LineSpacing->{1, -4},
    StyleMenuListing->None,
    FontSize->4],
  
  Cell[StyleData["ProgramTop", "Presentation"],
    FontSize->6],
  
  Cell[StyleData["ProgramTop", "Printout"],
    CellMargins->{{2, 0}, {-18, 18}}]
  }, Closed]],
  
  Cell["\<\

The item above is a ProgramTop line
\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ProgramBottom"],
    CellFrame->{{0.5, 0.5}, {0.5, 0}},
    CellMargins->{{27, 4}, {-10, -2}},
    LineSpacing->{1, -4},
    StyleMenuListing->None,
    FontSize->4],
  
  Cell[StyleData["ProgramBottom", "Presentation"],
    FontSize->6],
  
  Cell[StyleData["ProgramBottom", "Printout"],
    CellMargins->{{2, 0}, {-10, -2}}]
  }, Closed]],
  
  Cell["\<\

The item above is a ProgramBottom line
\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SessionLabel"],
    CellFrame->{{0.5, 0}, {0, 0.5}},
    CellMargins->{{27, 4}, {-4, 18}},
    LineSpacing->{1, 0},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9],
  
  Cell[StyleData["SessionLabel", "Presentation"],
    FontSize->14],
  
  Cell[StyleData["SessionLabel", "Printout"],
    CellMargins->{{2, 0}, {-4, 18}},
    FontSize->7]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Page Headers and Footers", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PageHeader"],
    CellMargins->{{0, 0}, {2, 0}},
    StyleMenuListing->None,
    FontSize->8,
    FontSlant->"Italic"],
  
  Cell[StyleData["PageHeader", "Printout"]],
  
  Cell[StyleData["PageHeader", "EnhancedPrintout"],
    FontFamily->"Frutiger 55 Roman"],
  
  Cell[StyleData["PageHeader", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 55 Roman"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PageNumber"],
    CellMargins->{{0, 0}, {2, 0}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->8,
    FontWeight->"Bold"],
  
  Cell[StyleData["PageNumber", "Printout"]],
  
  Cell[StyleData["PageNumber", "EnhancedPrintout"],
    FontFamily->"Frutiger 65 Bold",
    FontWeight->"Plain"],
  
  Cell[StyleData["PageNumber", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 65 Bold",
    FontWeight->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PageFooter"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->6],
  
  Cell[StyleData["PageFooter", "Printout"]],
  
  Cell[StyleData["PageFooter", "EnhancedPrintout"],
    FontFamily->"Frutiger 55 Roman"],
  
  Cell[StyleData["PageFooter", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 55 Roman"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["For compatibility", "Subsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Header"],
    CellMargins->{{0, 0}, {2, 0}},
    StyleMenuListing->None,
    FontSize->8,
    FontSlant->"Italic"],
  
  Cell[StyleData["Header", "Printout"]],
  
  Cell[StyleData["Header", "EnhancedPrintout"],
    FontFamily->"Frutiger 55 Roman",
    FontSlant->"Plain"],
  
  Cell[StyleData["Header", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 55 Roman",
    FontSlant->"Plain"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Footer"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->6],
  
  Cell[StyleData["Footer", "Printout"]],
  
  Cell[StyleData["Footer", "EnhancedPrintout"],
    FontFamily->"Frutiger 55 Roman"],
  
  Cell[StyleData["Footer", "EnhancedPrintoutNonGray"],
    FontFamily->"Frutiger 55 Roman"]
  }, Closed]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["FormatType Styles", "Section"],
  
  Cell["\<\
The cells below define styles that are mixed in with the styles \
of most cells.  If a cell's FormatType matches the name of one of the styles \
defined below, then that style is applied between the cell's style and its \
own options. This is particularly true of Input and Output.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["CellExpression"],
    PageWidth->Infinity,
    CellMargins->{{6, Inherited}, {Inherited, Inherited}},
    ShowCellLabel->False,
    ShowSpecialCharacters->False,
    AllowInlineCells->False,
    Hyphenation->False,
    AutoItalicWords->{},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->12,
    Background->GrayLevel[1]],
  
  Cell[StyleData["CellExpression", "EnhancedPrintout"],
    FontFamily->"Courier Std",
    FontSize->10],
  
  Cell[StyleData["CellExpression", "EnhancedPrintoutNonGray"],
    FontFamily->"Courier Std",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["InputForm"],
    InputAutoReplacements->{},
    AllowInlineCells->False,
    Hyphenation->False,
    StyleMenuListing->None,
    FontFamily->"Courier"],
  
  Cell[StyleData["InputForm", "EnhancedPrintout"],
    FontFamily->"Courier Std"],
  
  Cell[StyleData["InputForm", "EnhancedPrintoutNonGray"],
    FontFamily->"Courier Std"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["OutputForm"],
    PageWidth->Infinity,
    TextAlignment->Left,
    LineSpacing->{0.6, 1},
    StyleMenuListing->None,
    FontFamily->"Courier"],
  
  Cell[StyleData["OutputForm", "EnhancedPrintout"],
    FontFamily->"Courier Std"],
  
  Cell[StyleData["OutputForm", "EnhancedPrintoutNonGray"],
    FontFamily->"Courier Std"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["StandardForm"],
    InputAutoReplacements->{
      "->"->"\[Rule]", ":>"->"\[RuleDelayed]", "<="->"\[LessEqual]", 
        ">="->"\[GreaterEqual]", "!="->"\[NotEqual]", "=="->"\[Equal]", 
        Inherited},
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    LineSpacing->{1.25, 0},
    StyleMenuListing->None,
    FontFamily->"Courier"],
  
  Cell[StyleData["StandardForm", "EnhancedPrintout"],
    FontFamily->"Courier Std"],
  
  Cell[StyleData["StandardForm", "EnhancedPrintoutNonGray"],
    FontFamily->"Courier Std"]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Automatic Styles", "Section"],
  
  Cell["\<\
The cells below define styles that are used to affect the display \
of certain types of objects in typeset expressions.  For example, \
\"UnmatchedBracket\" style defines how unmatched bracket, curly bracket, and \
parenthesis characters are displayed (typically by coloring them to make them \
stand out).\
\>", "Text"],
  
  Cell[StyleData["UnmatchedBracket"],
    StyleMenuListing->None]
  }, Closed]]
  }, Open  ]]
  }]
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "LocalInteractions:42"->{
    Cell[1776, 53, 76, 1, 38, "ObjectName",
      CellTags->"LocalInteractions:42"],
    Cell[1855, 56, 312, 12, 48, "Usage",
      CellTags->"LocalInteractions:42"],
    Cell[2192, 72, 69, 1, 38, "ExampleSection",
      CellTags->"LocalInteractions:42"],
    Cell[2264, 75, 361, 8, 90, "Input",
      CellTags->"LocalInteractions:42"],
    Cell[2650, 87, 119, 3, 26, "Input",
      CellTags->"LocalInteractions:42"],
    Cell[2772, 92, 450, 9, 25, "Output",
      CellTags->"LocalInteractions:42"],
    Cell[3259, 106, 111, 3, 26, "Input",
      CellTags->"LocalInteractions:42"],
    Cell[3373, 111, 172547, 3540, 294, 19582, 1646, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->"LocalInteractions:42"],
    Cell[175935, 3654, 145, 4, 24, "Text",
      CellTags->"LocalInteractions:42"],
    Cell[176105, 3662, 178, 4, 58, "Input",
      CellTags->"LocalInteractions:42"],
    Cell[176286, 3668, 162069, 3415, 294, 19265, 1646, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->"LocalInteractions:42"],
    Cell[338370, 7086, 108, 3, 26, "Input",
      CellTags->"LocalInteractions:42"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"LocalInteractions:42", 590792, 15893}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 76, 1, 38, "ObjectName",
  CellTags->"LocalInteractions:42"],
Cell[1855, 56, 312, 12, 48, "Usage",
  CellTags->"LocalInteractions:42"],

Cell[CellGroupData[{
Cell[2192, 72, 69, 1, 38, "ExampleSection",
  CellTags->"LocalInteractions:42"],
Cell[2264, 75, 361, 8, 90, "Input",
  CellTags->"LocalInteractions:42"],

Cell[CellGroupData[{
Cell[2650, 87, 119, 3, 26, "Input",
  CellTags->"LocalInteractions:42"],
Cell[2772, 92, 450, 9, 25, "Output",
  CellTags->"LocalInteractions:42"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3259, 106, 111, 3, 26, "Input",
  CellTags->"LocalInteractions:42"],
Cell[3373, 111, 172547, 3540, 294, 19582, 1646, "GraphicsData", "PostScript", \
"Graphics",
  CellTags->"LocalInteractions:42"]
}, Open  ]],
Cell[175935, 3654, 145, 4, 24, "Text",
  CellTags->"LocalInteractions:42"],

Cell[CellGroupData[{
Cell[176105, 3662, 178, 4, 58, "Input",
  CellTags->"LocalInteractions:42"],
Cell[176286, 3668, 162069, 3415, 294, 19265, 1646, "GraphicsData", \
"PostScript", "Graphics",
  CellTags->"LocalInteractions:42"]
}, Open  ]],
Cell[338370, 7086, 108, 3, 26, "Input",
  CellTags->"LocalInteractions:42"]
}, Closed]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

